webpackJsonp([9],{

/***/ 12:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/. */

const { opacityIncreaseKeyframes, tabFadeInKeyframes } = __webpack_require__(134);

/**
* Use this file when the style you need
* is applied in more than one element, or depends on it
* Use theme.js file to include colors that can be customized
*
* TODO:
* remove unnecessary styles properties (as items get refactored)
* migrate customizable options to theme.js
*/

const defaultFontFamily = `-apple-system, BlinkMacSystemFont, "Segoe UI"` + `, "Helvetica Neue", Roboto, Oxygen, Ubuntu, Cantarell, "Fira Sans"` + `, "Droid Sans", sans-serif`;

const globalStyles = {

  breakpoint: {
    breakpointWideViewport: '1000px',
    breakpointNarrowViewport: '600px',
    breakpointExtensionButtonPadding: '720px',
    breakpointSmallWin32: '650px',
    breakpointTinyWin32: '500px'
  },
  intersection: {
    // whereas 1 === 100%
    noIntersection: 1,
    at75: 0.75,
    at60: 0.6,
    at46: 0.46,
    at40: 0.4,
    at30: 0.3,
    at20: 0.20,
    at12: 0.125
  },
  color: {
    commonTextColor: 'rgb(59, 59, 62)',
    linkColor: '#0099CC',
    highlightBlue: '#37A9FD',
    privateTabBackground: '#665296',
    privateTabBackgroundActive: '#4b3c6e',
    bitcoinOrange: '#f7931a',
    chromePrimary: '#F3F3F3',
    chromeSecondary: '#d3d3d3',
    chromeTertiary: '#c7c7c7',
    chromeText: '#555555',
    navigationBarBackground: 'white',
    chromeControlsBackground: '#bbb',
    chromeControlsBackground2: 'white',
    commonFormBottomWrapperBackground: '#ddd',
    commonFormBackgroundColor: '#f7f7f7',
    toolbarBackground: '#eee',
    toolbarBorderColor: '#ccc',
    menuSelectionColor: '#2F7AFB',
    errorTextColor: '#999',
    progressBarColor: '#3498DB',
    siteInsecureColor: '#C63626',
    siteEVColor: 'green',
    buttonColor: 'rgb(90, 90, 98)',
    braveOrange: 'rgb(255, 80, 0)',
    braveLightOrange: '#FF7A1D',
    braveMediumOrange: 'rgb(232, 72, 0)',
    braveDarkOrange: '#D44600',
    switchBG_off: '#d3d3d3',
    switchBG_off_lrg: '#adadad',
    switchBG_dis: '#e8e8e8',
    switchNubColor: 'white',
    veryLightGray: 'rgb(250, 250, 251)',
    lightGray: 'rgb(236, 236, 239)',
    gray: 'rgb(153, 153, 157)',
    mediumGray: 'rgb(101, 101, 107)',
    darkGray: 'rgb(68, 68, 72)',
    modalVeryLightGray: 'rgb(247, 247, 249)',
    modalLightGray: 'rgb(231, 231, 234)',
    white25: 'rgba(255, 255, 255, 0.25)',
    white50: 'rgba(255, 255, 255, 0.5)',
    white100: 'rgba(255, 255, 255, 1)',
    gray25: 'rgba(116, 116, 130, 0.25)',
    gray50: 'rgba(116, 116, 130, 0.5)',
    black10: 'rgba(0, 0, 0, 0.1)',
    black20: 'rgba(0, 0, 0, 0.2)',
    black25: 'rgba(0, 0, 0, 0.25)',
    black50: 'rgba(0, 0, 0, 0.5)',
    black75: 'rgba(0, 0, 0, 0.75)',
    black100: 'rgba(0, 0, 0, 1)',
    statsYellow: '#ffc000',
    statsOrange: '#f39030',
    statsRed: '#fe521d',
    statsBlue: '#0796fa',
    statsLightGray: '#999999',
    defaultIconBackground: '#F7F7F7',
    notificationItemColor: '#f1e9e5',
    notificationBottomBorderColor: '#ff5500',
    almostInvisible: 'rgba(255,255,255,0.01)',
    urlBarOutline: 'rgb(187, 187, 191)',
    alphaWhite: 'rgba(255,255,255,0.8)'
  },
  typography: {
    // font for titles, labels in *most* cases (it's not a hard rule, consult a designer)
    display: {
      family: 'Poppins, ' + defaultFontFamily,
      // spacing for fonts >= 30px (generally)
      spacingLarge: '-0.4px',
      // spacing for font >= 20px and < 30px
      spacingMedium: '-0.2px',
      // spacing for font < 20px
      spacingRegular: 0
    },
    // font choices for flowing body text
    body: {
      family: `Muli, ` + defaultFontFamily
    },
    // system text
    default: {
      family: defaultFontFamily
    }
  },
  radius: {
    borderRadius: '4px',
    borderRadiusTabs: '4px',
    borderRadiusURL: '4px',
    borderRadiusUIbox: '8px',
    borderRadiusModal: '8px',
    bigBorderRadius: '14px',
    switchRadius: '10px',
    carotRadius: '8px'
  },
  spacing: {
    sentinelSize: '120px',
    navigatorHeight: '48px',
    defaultSpacing: '12px',
    defaultFontSize: '13px',
    contextMenuFontSize: '14px',
    textAreaFontSize: '14.5px',
    dragSpacing: '50px',
    switchHeight: '16px',
    switchWidth: '45px',
    switchNubDiameter: '12px',
    switchNubTopMargin: '2px',
    switchNubLeftMargin: '2px',
    switchNubRightMargin: '2px',
    buttonHeight: '25px',
    buttonWidth: '25px',
    navbarHeight: '36px',
    downloadsBarHeight: '60px',
    // This includes the toolbar's borders
    tabsToolbarHeight: '29px',
    tabPagesHeight: '7px',
    bookmarkHangerMaxWidth: '350px',
    bookmarksToolbarHeight: '24px',
    bookmarksToolbarWithFaviconsHeight: '24px',
    bookmarksFileIconSize: '13px',
    bookmarksFolderIconSize: '15px',
    bookmarksItemMaxWidth: '100px',
    bookmarksItemPadding: '4px',
    bookmarksItemMargin: '4px',
    bookmarksItemChevronMargin: '4px',
    bookmarksItemChevronFontSize: '8px',
    bookmarksToolbarPadding: '10px',
    bookmarksItemFontSize: '11px',
    bookmarksToolbarButtonDraggingMargin: '25px',
    bookmarksToolbarOverflowButtonWidth: '25px',
    navbarMenubarMargin: '7px',
    navbarButtonSpacing: '4px',
    navbarButtonWidth: '20px',
    navbarBraveButtonWidth: '23px',
    navbarBraveButtonMarginLeft: '80px',
    navbarLeftMarginDarwin: '76px',
    sideBarWidth: '190px',
    aboutPageDetailsPageWidth: '704px',
    aboutPageSectionPadding: '24px',
    aboutPageSectionMargin: '10px',
    defaultTabMargin: '10px',
    defaultIconPadding: '2px',
    iconSize: '16px',
    sessionIconSize: '14px',
    closeIconSize: '14px',
    newSessionIconSize: '14px',
    narrowIconSize: '12px',
    dialogWidth: '422px',
    dialogSmallWidth: '350px',
    dialogMediumWidth: '500px',
    dialogLargeWidth: '600px',
    dialogTopOffset: '30px',
    dialogInsideMargin: '18px',
    modalDialogPaddingHorizontal: '50px',
    privateTabPaddingHorizontal: '30px',
    privateTabPadding: '40px',
    settingsListContainerMargin: '2rem',
    modalPanelHeaderMarginBottom: '.5rem',
    overlayButtonMargin: '8px',
    panelMargin: '15px',
    panelItemMargin: '12px',
    panelPadding: '18px',
    addFundsDialogMinHeight: '250px'
  },
  shadow: {
    switchShadow: 'inset 0 1px 4px rgba(0, 0, 0, 0.35)',
    switchNubShadow: '1px 1px 5px -2px black',
    buttonShadow: '0px 1px 5px -1px rgba(0, 0, 0, 1.0)',
    dialogShadow: '0px 8px 22px 0px rgba(0, 0, 0, .5)',
    flyoutDialogBoxShadow: '2px 2px 8px rgba(59, 59, 59, 1.0)',
    softBoxShadow: '0 4px 8px lightGray',
    lightBoxShadow: '0 2px 2px lightGray',
    insetShadow: 'inset -5px 0 15px rgba(0, 0, 0, 0.25)',
    orangeButtonShadow: '0 2px 0 braveDarkOrange',
    bookmarkHangerArrowUpShadow: '-2px 2px 3px 0px rgba(0, 0, 0, 0.1)'
  },
  transition: {
    transitionDuration: '100ms',
    transition: 'all 600ms linear',
    transitionFast: 'all 100ms linear',
    transitionSlow: 'all 1s linear',
    transitionEase: 'all 600ms ease',
    transitionFastEase: 'all 100ms ease',
    transitionSlowEase: 'all 1s ease',
    switchBGTransition: 'background-color 100ms',
    switchNubTransition: 'right 100ms',
    tabBackgroundTransition: 'background-color 100ms linear'
  },
  zindex: {
    zindexWindowNotActive: '900',
    zindexWindow: '1000',
    zindexWindowIsPreview: '1100',
    zindexDownloadsBar: '1000',
    zindexTabs: '1000',
    zindexTabsThumbnail: '1100',
    zindexNavigationBar: '2000',
    zindexUrlbarNotLegend: '2100',
    zindexPopUp: '3000',
    zindexContextMenu: '3000',
    zindexDialogs: '3000',
    zindexModal: '3000',
    zindexPopupWindow: '3000',
    zindexForms: '3000',
    zindexSuggestionText: '3100',
    zindexWindowFullScreen: '4000',
    zindexWindowFullScreenBanner: '4100'
  },
  fontSize: {
    tabIcon: '14px',
    tabTitle: '12px',
    settingItemSubtext: '.95rem',
    flyoutDialog: '13px',
    prefsPanelHeading: '23px'
  },
  appIcons: {
    angleDoubleRight: 'fa fa-angle-double-right',
    clipboard: 'fa fa-clipboard',
    closeTab: 'fa fa-times-circle',
    defaultIcon: 'fa fa-file-o',
    exclude: 'fa fa-ban',
    findNext: 'fa fa-caret-down',
    findPrev: 'fa fa-caret-up',
    loading: 'fa fa-spinner fa-spin',
    lock: 'fa fa-lock',
    moreInfo: 'fa fa-info-circle',
    next: 'fa fa-caret-right',
    openLocation: 'fa fa-folder-open-o',
    pause: 'fa fa-pause',
    prev: 'fa fa-caret-left',
    private: 'fa fa-eye',
    question: 'fa fa-question-circle',
    refresh: 'fa fa-refresh',
    remove: 'fa fa-times',
    resume: 'fa fa-play',
    retry: 'fa fa-repeat',
    search: 'fa fa-search',
    trash: 'fa fa-trash',
    unlock: 'fa fa-unlock',
    user: 'fa fa-user',
    volumeOff: 'fa fa-volume-off',
    volumeOn: 'fa fa-volume-up'
  },
  animations: {
    subtleShowUp: {
      opacity: 0,
      willChange: 'opacity',
      animationName: opacityIncreaseKeyframes,
      animationDelay: '120ms',
      animationTimingFunction: 'linear',
      animationDuration: '120ms',
      animationFillMode: 'forwards'
    },

    tabFadeIn: {
      opacity: 0.5,
      willChange: 'opacity',
      animationName: tabFadeInKeyframes,
      animationDuration: '0.75s',
      animationTimingFunction: 'ease-in-out',
      animationFillMode: 'forwards'
    }
  },

  button: {
    color: 'rgb(90, 90, 98)',

    default: {
      color: '#fff',
      backgroundColor: 'transparent',
      hoverColor: '#000',
      boxShadow: '0px 1px 5px -1px rgba(0, 0, 0, 0.5)'
    },

    primary: {
      gradientColor1: '#FF7A1D',
      gradientColor2: '#ff5000',
      background: 'linear-gradient(#FF7A1D, #ff5000)',
      hoverColor: '#fff',
      borderHoverColor: '#fff'
    },

    secondary: {
      gradientColor1: '#fff',
      gradientColor2: 'rgb(236, 236, 239)',
      background: 'linear-gradient(#fff, rgb(236, 236, 239))',
      color: 'rgb(101, 101, 107)',
      hoverColor: 'rgb(68, 68, 72)',
      borderHoverColor: 'rgb(153, 153, 157)'
    },

    subtle: {
      // cf: https://github.com/brave/browser-laptop/blob/548e11b1c889332fadb379237555625ad2a3c845/less/button.less#L151
      backgroundColor: '#ccc'
    },

    action: {
      backgroundColor: '#4099FF',
      hoverColor: '#000'
    },

    panel: {
      width: '180px'
    }
  },

  braveryPanel: {
    color: 'rgb(59, 59, 62)',

    header: {
      color: '#fff',
      background: 'rgb(128, 128, 133)',
      switchControlTopTextColor: '#d3d3d3',
      border: '1px solid #aaa'
    },

    stats: {
      background: '#f7f7f7'
    },

    body: {
      background: 'rgb(239, 239, 241)',

      hr: {
        background: 'rgb(204, 204, 214)'
      }
    }
  },

  // TODO (Suguru): move them to payment.js after style refactoring is done
  payments: {
    fontSize: {
      regular: '14.5px'
    }
  }
};

globalStyles.color.chromeBorderColor = globalStyles.color.chromePrimary;
globalStyles.color.chromeControlsWarningBackground = globalStyles.color.chromePrimary;
globalStyles.color.audioColor = globalStyles.color.highlightBlue;
globalStyles.color.focusUrlbarOutline = globalStyles.color.highlightBlue;
globalStyles.color.siteSecureColor = globalStyles.color.buttonColor;
globalStyles.color.loadTimeColor = globalStyles.color.highlightBlue;
globalStyles.color.activeTabDefaultColor = globalStyles.color.chromePrimary;
globalStyles.color.switchBG_on = globalStyles.color.braveOrange;

globalStyles.braveryPanel.stats.colorAds = globalStyles.color.statsRed;
globalStyles.braveryPanel.stats.colorRedirected = globalStyles.color.statsBlue;
globalStyles.braveryPanel.stats.colorFp = globalStyles.color.statsYellow;
globalStyles.braveryPanel.stats.colorNoScript = globalStyles.color.chromeText;

module.exports = globalStyles;

/***/ }),

/***/ 124:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const Immutable = __webpack_require__(1);
const appUrlUtil = __webpack_require__(20);
const UrlUtil = __webpack_require__(14);

const normalizeLocation = location => {
  const sourceAboutUrl = appUrlUtil.getSourceAboutUrl(location);
  if (sourceAboutUrl) {
    return sourceAboutUrl;
  }
  return UrlUtil.getLocationIfPDF(location);
};

const generateCache = state => {
  const cache = state.getIn(['cache', 'bookmarkLocation']) || Immutable.Map();
  if (!cache.isEmpty()) {
    return state;
  }

  state = state.setIn(['cache', 'bookmarkLocation'], Immutable.Map());
  const bookmarksState = __webpack_require__(39);
  bookmarksState.getBookmarks(state).forEach((site, siteKey) => {
    state = addCacheKey(state, site.get('location'), siteKey);
  });
  return state;
};

/**
 * Given a location, get matching appState siteKeys based on cache.
 * Loads cache from appState if it hasn't been loaded yet.
 * @param state Application state
 * @param location {string}
 * @return {Immutable.List<string>|null} siteKeys including this location.
 */
const getCacheKey = (state, location) => {
  const normalLocation = normalizeLocation(location);

  if (normalLocation == null) {
    return Immutable.List();
  }

  return state.getIn(['cache', 'bookmarkLocation', normalLocation], Immutable.List());
};

/**
 * Given a location, add appState siteKey to cached siteKeys list.
 * Returns new state.
 * @param state Application state
 * @param location {string}
 * @param siteKey {string}
 */
const addCacheKey = (state, location, siteKey) => {
  if (!siteKey || !location) {
    return state;
  }

  const normalLocation = normalizeLocation(location);
  const cacheKey = ['cache', 'bookmarkLocation', normalLocation];
  const siteKeys = state.getIn(cacheKey);

  if (!siteKeys) {
    return state.setIn(cacheKey, new Immutable.List([siteKey]));
  } else {
    if (siteKeys.includes(siteKey)) {
      return state;
    }
    return state.setIn(cacheKey, siteKeys.push(siteKey));
  }
};

/**
 * Given a location, remove matching appState siteKeys in cache.
 * Loads cache from appState if it hasn't been loaded yet.
 * @param state Application state
 * @param location {string}
 * @param siteKey {string}
 */
const removeCacheKey = (state, location, siteKey) => {
  if (!siteKey || !location) {
    return state;
  }
  const normalLocation = normalizeLocation(location);
  const cacheKey = ['cache', 'bookmarkLocation', normalLocation];
  let siteKeys = state.getIn(cacheKey);
  if (!siteKeys) {
    return state;
  }

  siteKeys = siteKeys.filter(key => key !== siteKey);
  if (siteKeys.size > 0) {
    return state.setIn(cacheKey, siteKeys);
  } else {
    return state.deleteIn(cacheKey);
  }
};

module.exports = {
  generateCache,
  getCacheKey,
  addCacheKey,
  removeCacheKey
};

/***/ }),

/***/ 125:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const Immutable = __webpack_require__(1);
const UrlUtil = __webpack_require__(14);
const { makeImmutable, isList, isMap } = __webpack_require__(16);
const aboutHistoryMaxEntries = 500;

const sortTimeDescending = (left, right) => {
  if (left.get('lastAccessedTime') < right.get('lastAccessedTime')) return 1;
  if (left.get('lastAccessedTime') > right.get('lastAccessedTime')) return -1;
  return 0;
};

const getHistory = sites => {
  if (sites == null) {
    return Immutable.List();
  }

  sites = makeImmutable(sites);

  if (!isList(sites)) {
    if (isMap(sites)) {
      sites = sites.toList();
    } else {
      sites = Immutable.List();
    }
  }

  return sites.sort(sortTimeDescending).slice(0, aboutHistoryMaxEntries);
};

const getDayString = (entry, locale) => {
  if (entry == null) {
    return '';
  }

  const lastAccessedTime = entry.get('lastAccessedTime');
  return lastAccessedTime ? new Date(lastAccessedTime).toLocaleDateString(locale, { weekday: 'long', month: 'long', day: 'numeric', year: 'numeric' }) : '';
};

const groupEntriesByDay = (history, locale) => {
  if (history == null) {
    return Immutable.List();
  }

  const reduced = history.reduce((previousValue, currentValue, currentIndex) => {
    const result = currentIndex === 1 ? [] : previousValue;
    if (currentIndex === 1) {
      const firstDate = getDayString(previousValue, locale);
      result.push({ date: firstDate, entries: [previousValue] });
    }
    const date = getDayString(currentValue, locale);
    const dateIndex = result.findIndex(entryByDate => entryByDate.date === date);
    if (dateIndex !== -1) {
      result[dateIndex].entries.push(currentValue);
    } else {
      result.push({ date: date, entries: [currentValue] });
    }
    return result;
  });

  if (reduced) {
    return Immutable.fromJS(Array.isArray(reduced) ? reduced : [{ date: getDayString(reduced, locale), entries: [reduced] }]);
  }
  return Immutable.List();
};

/**
 * Return an array with ALL entries.
 * Format is expected to be array containing one array per day.
 */
const totalEntries = entriesByDay => {
  if (entriesByDay == null) {
    return Immutable.List();
  }

  entriesByDay = makeImmutable(entriesByDay);

  return entriesByDay.map(entry => {
    return entry.get('entries');
  });
};

const prepareHistoryEntry = siteDetail => {
  if (siteDetail == null) {
    return Immutable.Map();
  }

  const time = siteDetail.has('lastAccessedTime') ? siteDetail.get('lastAccessedTime') : new Date().getTime();

  return makeImmutable({
    lastAccessedTime: time,
    objectId: siteDetail.get('objectId', null),
    title: siteDetail.get('title'),
    location: siteDetail.get('location'),
    partitionNumber: Number(siteDetail.get('partitionNumber', 0)),
    count: 1,
    themeColor: siteDetail.get('themeColor'),
    favicon: siteDetail.get('favicon', siteDetail.get('icon')),
    key: module.exports.getKey(siteDetail),
    skipSync: siteDetail.get('skipSync', null)
  });
};

const mergeSiteDetails = (oldDetail, newDetail) => {
  if (newDetail == null) {
    return Immutable.Map();
  }

  if (oldDetail == null) {
    oldDetail = Immutable.Map();
  }

  newDetail = makeImmutable(newDetail);
  oldDetail = makeImmutable(oldDetail);

  const objectId = newDetail.has('objectId') ? newDetail.get('objectId') : oldDetail.get('objectId') || undefined;
  const time = newDetail.has('lastAccessedTime') ? newDetail.get('lastAccessedTime') : new Date().getTime();

  let site = makeImmutable({
    lastAccessedTime: time,
    objectId,
    title: newDetail.get('title'),
    location: newDetail.get('location'),
    partitionNumber: Number(newDetail.get('partitionNumber', 0)),
    count: Number(oldDetail.get('count', 0)) + 1
  });

  const themeColor = newDetail.has('themeColor') ? newDetail.get('themeColor') : oldDetail.get('themeColor');
  if (themeColor) {
    site = site.set('themeColor', themeColor);
  }

  // we need to have a fallback to icon, because frame has icon for it
  const favicon = newDetail.has('favicon') || newDetail.has('icon') ? newDetail.get('favicon', newDetail.get('icon')) : oldDetail.get('favicon');
  if (favicon) {
    site = site.set('favicon', favicon);
  }

  site = site.set('key', module.exports.getKey(site));

  return site;
};

const getDetailFromFrame = frame => {
  if (frame == null || !frame.has('location')) {
    return null;
  }

  return makeImmutable({
    location: frame.get('location'),
    title: frame.get('title'),
    partitionNumber: frame.get('partitionNumber') || 0,
    favicon: frame.get('icon'),
    themeColor: frame.get('themeColor') || frame.get('computedThemeColor')
  });
};

const getKey = siteDetail => {
  if (!siteDetail) {
    return null;
  }

  let location = siteDetail.get('location');

  if (location) {
    location = UrlUtil.getLocationIfPDF(location);
    return location + '|' + (siteDetail.get('partitionNumber') || 0);
  }

  return null;
};

module.exports = {
  maxEntries: aboutHistoryMaxEntries,
  getHistory,
  groupEntriesByDay,
  totalEntries,
  prepareHistoryEntry,
  mergeSiteDetails,
  getDetailFromFrame,
  getKey
};

/***/ }),

/***/ 130:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {// Unique ID creation requires a high quality random # generator.  In the
// browser this is a little complicated due to unknown quality of Math.random()
// and inconsistent support for the `crypto` API.  We do the best we can via
// feature-detection
var rng;

var crypto = global.crypto || global.msCrypto; // for IE 11
if (crypto && crypto.getRandomValues) {
  // WHATWG crypto RNG - http://wiki.whatwg.org/wiki/Crypto
  var rnds8 = new Uint8Array(16); // eslint-disable-line no-undef
  rng = function whatwgRNG() {
    crypto.getRandomValues(rnds8);
    return rnds8;
  };
}

if (!rng) {
  // Math.random()-based (RNG)
  //
  // If all else fails, use Math.random().  It's fast, but is of unspecified
  // quality.
  var rnds = new Array(16);
  rng = function() {
    for (var i = 0, r; i < 16; i++) {
      if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
      rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
    }

    return rnds;
  };
}

module.exports = rng;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(31)))

/***/ }),

/***/ 131:
/***/ (function(module, exports) {

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex;
  return bth[buf[i++]] + bth[buf[i++]] +
          bth[buf[i++]] + bth[buf[i++]] + '-' +
          bth[buf[i++]] + bth[buf[i++]] + '-' +
          bth[buf[i++]] + bth[buf[i++]] + '-' +
          bth[buf[i++]] + bth[buf[i++]] + '-' +
          bth[buf[i++]] + bth[buf[i++]] +
          bth[buf[i++]] + bth[buf[i++]] +
          bth[buf[i++]] + bth[buf[i++]];
}

module.exports = bytesToUuid;


/***/ }),

/***/ 132:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


const Immutable = __webpack_require__(1);
const siteTags = __webpack_require__(38);
const bookmarkFoldersUtil = __webpack_require__(56);

const setOrder = (cache, key, tag, destinationKey, append = true) => {
  let newCache = Immutable.List();
  let i = 0;

  for (let item of cache) {
    if (item.get('key') === destinationKey) {
      if (append) {
        newCache = newCache.push(item.set('order', i));
        i++;
        newCache = newCache.push(Immutable.fromJS({
          key: key,
          order: i,
          type: tag
        }));
      } else {
        newCache = newCache.push(Immutable.fromJS({
          key: key,
          order: i,
          type: tag
        }));
        i++;
        newCache = newCache.push(item.set('order', i));
      }
    } else if (item.get('key') === key) {
      continue;
    } else {
      newCache = newCache.push(item.set('order', i));
    }
    i++;
  }

  return newCache;
};

const addCacheItem = (state, parentId = 0, key, destinationKey, tag, append) => {
  if (key == null) {
    return state;
  }

  parentId = parentId.toString();
  key = key.toString();

  // cache with this parentId doesn't exist yet
  if (!state.hasIn(['cache', 'bookmarkOrder', parentId])) {
    return state.setIn(['cache', 'bookmarkOrder', parentId], Immutable.fromJS([{
      key: key,
      order: 0,
      type: tag
    }]));
  }

  const cache = state.getIn(['cache', 'bookmarkOrder', parentId]);
  // destination key is not provided
  if (destinationKey == null || parentId === destinationKey) {
    const keyExist = cache.some(item => item.get('key') === key);
    if (keyExist) {
      return state;
    }

    return state.setIn(['cache', 'bookmarkOrder', parentId], cache.push(Immutable.fromJS({
      key: key,
      order: cache.size,
      type: tag
    })));
  }

  // destination key is given
  const newCache = setOrder(cache, key, tag, destinationKey, append);
  return state.setIn(['cache', 'bookmarkOrder', parentId], newCache);
};

const addBookmarkToCache = (state, parentId, key, destinationKey, append) => {
  return addCacheItem(state, parentId, key, destinationKey, siteTags.BOOKMARK, append);
};

const addFolderToCache = (state, parentId, key, destinationKey, append) => {
  return addCacheItem(state, parentId, key, destinationKey, siteTags.BOOKMARK_FOLDER, append);
};

const getFoldersByParentId = (state, parentId = 0) => {
  return state.getIn(['cache', 'bookmarkOrder', parentId.toString()], Immutable.List()).filter(item => bookmarkFoldersUtil.isFolder(item));
};

const getBookmarksByParentId = (state, parentId = 0) => {
  const bookmarkUtil = __webpack_require__(40);
  return state.getIn(['cache', 'bookmarkOrder', parentId.toString()], Immutable.List()).filter(item => bookmarkUtil.isBookmark(item));
};

const getBookmarksWithFolders = (state, parentId = 0) => {
  return state.getIn(['cache', 'bookmarkOrder', parentId.toString()], Immutable.List());
};

const removeCacheKey = (state, parentId, key) => {
  if (parentId == null || key == null) {
    return state;
  }

  parentId = parentId.toString();
  key = key.toString();
  const cache = state.getIn(['cache', 'bookmarkOrder', parentId]);

  if (cache == null) {
    return state;
  }

  let newCache = Immutable.List();
  let i = 0;

  for (let item of cache) {
    if (item.get('key') !== key) {
      newCache = newCache.push(item.set('order', i));
      i++;
    }
  }

  if (newCache.size > 0) {
    state = state.setIn(['cache', 'bookmarkOrder', parentId], newCache);
  } else {
    state = state.deleteIn(['cache', 'bookmarkOrder', parentId]);
  }

  return state;
};

const removeCacheParent = (state, parentId) => {
  if (parentId == null) {
    return state;
  }

  return state.deleteIn(['cache', 'bookmarkOrder', parentId.toString()]);
};

const getOrderCache = state => {
  return state.getIn(['cache', 'bookmarkOrder'], Immutable.Map());
};

module.exports = {
  addBookmarkToCache,
  addFolderToCache,
  removeCacheKey,
  getFoldersByParentId,
  getBookmarksByParentId,
  getBookmarksWithFolders,
  removeCacheParent,
  getOrderCache
};

/***/ }),

/***/ 133:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const appDispatcher = __webpack_require__(76);
const syncConstants = __webpack_require__(206);

const syncActions = {
  addSites: function (items) {
    appDispatcher.dispatch({
      actionType: syncConstants.SYNC_ADD_SITES,
      items
    });
  },

  removeSites: function (items) {
    appDispatcher.dispatch({
      actionType: syncConstants.SYNC_REMOVE_SITES,
      items
    });
  },

  clearHistory: function () {
    appDispatcher.dispatch({
      actionType: syncConstants.SYNC_CLEAR_HISTORY
    });
  },

  clearSiteSettings: function () {
    appDispatcher.dispatch({
      actionType: syncConstants.SYNC_CLEAR_SITE_SETTINGS
    });
  }
};

module.exports = syncActions;

/***/ }),

/***/ 134:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const spinKeyframes = {
  'from': {
    transform: 'rotate(0deg)'
  },

  'to': {
    transform: 'rotate(360deg)'
  }
};

const opacityIncreaseKeyframes = {
  'from': {
    opacity: 0
  },

  'to': {
    opacity: 1
  }
};

const opacityIncreaseElementKeyframes = {
  opacity: [0, 1]

  // TODO: this could be a function with param included
  // to which property should be changed
};const widthIncreaseKeyframes = (start, end) => ({
  'from': {
    width: start
  },

  'to': {
    width: end
  }
});

const widthIncreaseElementKeyframes = (start, end) => ({
  width: [start, end]
});

const tabFadeInKeyframes = {
  '0%': {
    opacity: 0.5
  },

  '50%': {
    opacity: 0.6
  },

  '100%': {
    opacity: 0.5
  }
};

module.exports = {
  spinKeyframes,
  opacityIncreaseKeyframes,
  opacityIncreaseElementKeyframes,
  widthIncreaseKeyframes,
  widthIncreaseElementKeyframes,
  tabFadeInKeyframes
};

/***/ }),

/***/ 135:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const frameStateUtil = __webpack_require__(8);
const urlParse = __webpack_require__(29);

function braveShieldsEnabled(frame) {
  const lastCommittedURL = frameStateUtil.getLastCommittedURL(frame);
  if (!lastCommittedURL) {
    return false;
  }

  const parsedUrl = urlParse(lastCommittedURL);
  return !(parsedUrl.protocol !== 'https:' && parsedUrl.protocol !== 'http:');
}

module.exports = {
  braveShieldsEnabled
};

/***/ }),

/***/ 136:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const assert = __webpack_require__(25);
const Immutable = __webpack_require__(1);
const { STATE_SITES } = __webpack_require__(95);
const historyUtil = __webpack_require__(125);
const urlUtil = __webpack_require__(14);
const { makeImmutable, isMap } = __webpack_require__(16);
const shouldLogWarnings = "development" !== 'production';

const validateState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  assert.ok(isMap(state.get(STATE_SITES.HISTORY_SITES)), 'state must contain an Immutable.Map of historySites');
  return state;
};

const historyState = {
  getSites: state => {
    state = validateState(state);
    return state.get(STATE_SITES.HISTORY_SITES, Immutable.Map());
  },

  getSite: (state, key) => {
    state = validateState(state);
    return state.getIn([STATE_SITES.HISTORY_SITES, key], Immutable.Map());
  },

  hasSite: (state, key) => {
    state = validateState(state);
    return state.hasIn([STATE_SITES.HISTORY_SITES, key], Immutable.Map());
  },

  addSite: (state, siteDetail) => {
    if (!siteDetail) {
      if (shouldLogWarnings) {
        console.error('historyState:addSite siteDetail was null');
      }
      return state;
    }
    let sites = historyState.getSites(state);
    let siteKey = historyUtil.getKey(siteDetail);
    if (!siteKey) {
      if (shouldLogWarnings) {
        console.log('historyState:addSite siteKey was null for siteDetail:', siteDetail && siteDetail.toJS ? siteDetail.toJS() : siteDetail);
      }
      return state;
    }
    siteDetail = makeImmutable(siteDetail);

    const oldSite = sites.get(siteKey);
    let site;
    if (oldSite) {
      site = historyUtil.mergeSiteDetails(oldSite, siteDetail);
    } else {
      let location;
      if (siteDetail.has('location')) {
        location = urlUtil.getLocationIfPDF(siteDetail.get('location'));
        siteDetail = siteDetail.set('location', location);
      }

      siteKey = historyUtil.getKey(siteDetail);
      site = historyUtil.prepareHistoryEntry(siteDetail);
    }

    state = state.setIn([STATE_SITES.HISTORY_SITES, siteKey], site);
    return state;
  },

  removeSite: (state, siteKey) => {
    return state.deleteIn([STATE_SITES.HISTORY_SITES, siteKey]);
  },

  clearSites: state => {
    return state.set(STATE_SITES.HISTORY_SITES, Immutable.Map());
  },

  updateFavicon: (state, siteDetails, favIcon) => {
    const historyKey = historyUtil.getKey(siteDetails);
    if (historyKey == null) {
      return state;
    }

    let historyItem = historyState.getSite(state, historyKey);
    if (historyItem.isEmpty()) {
      return state;
    }

    historyItem = historyItem.set('favicon', favIcon);

    return state.setIn([STATE_SITES.HISTORY_SITES, historyKey], historyItem);
  }
};

module.exports = historyState;

/***/ }),

/***/ 15:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(508);


/***/ }),

/***/ 16:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const Immutable = __webpack_require__(1);

const api = {
  isImmutable: obj => {
    return obj && obj.toJS;
  },

  isMap: obj => {
    return Immutable.Map.isMap(obj);
  },

  isList: obj => {
    return Immutable.List.isList(obj);
  },

  isSameHashCode: (first, second) => {
    if (first == null && second == null) {
      return true;
    } else if (first == null || second == null) {
      return false;
    }

    return first.hashCode() === second.hashCode();
  },

  makeImmutable: obj => {
    return api.isImmutable(obj) ? obj : Immutable.fromJS(obj);
  },

  deleteImmutablePaths: (obj, paths) => {
    return paths.reduce((result, path) => {
      if (path.constructor === Array) {
        return result.deleteIn(path);
      }
      return result.delete(path);
    }, obj);
  },

  makeJS: (obj, defaultValue) => {
    if (obj == null && defaultValue !== undefined) {
      return defaultValue;
    }
    return api.isImmutable(obj) ? obj.toJS() : obj;
  },

  findNullKeyPaths(state, pathToState = []) {
    let nullKeys = [];
    if (!Immutable.Map.isMap(state) && !Immutable.List.isList(state)) {
      return nullKeys;
    }
    for (const key of state.keySeq()) {
      const keyPath = [...pathToState, key];
      if (key === null) {
        nullKeys.push(keyPath);
      }
      // recursive, to find deep keys
      nullKeys.push(...api.findNullKeyPaths(state.get(key), keyPath));
    }
    return nullKeys;
  }
};

module.exports = api;

/***/ }),

/***/ 183:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// returns a style object with a single concated prefixed value string

exports.default = function (property, value) {
  var replacer = arguments.length <= 2 || arguments[2] === undefined ? function (prefix, value) {
    return prefix + value;
  } : arguments[2];
  return _defineProperty({}, property, ['-webkit-', '-moz-', ''].map(function (prefix) {
    return replacer(prefix, value);
  }));
};

module.exports = exports['default'];

/***/ }),

/***/ 184:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const getSetting = __webpack_require__(13).getSetting;
const settings = __webpack_require__(11);

module.exports.shouldDisplayDialog = state => {
  return !getSetting(settings.IS_DEFAULT_BROWSER) && !state.get('defaultBrowserCheckComplete') && getSetting(settings.CHECK_DEFAULT_ON_STARTUP);
};

/***/ }),

/***/ 192:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (value) {
  if (Array.isArray(value)) value = value.join(',');

  return value.match(/-webkit-|-moz-|-ms-/) !== null;
};

module.exports = exports['default'];

/***/ }),

/***/ 193:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
// {K1: V1, K2: V2, ...} -> [[K1, V1], [K2, V2]]


Object.defineProperty(exports, '__esModule', {
    value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var objectToPairs = function objectToPairs(obj) {
    return Object.keys(obj).map(function (key) {
        return [key, obj[key]];
    });
};

exports.objectToPairs = objectToPairs;
// [[K1, V1], [K2, V2]] -> {K1: V1, K2: V2, ...}
var pairsToObject = function pairsToObject(pairs) {
    var result = {};
    pairs.forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2);

        var key = _ref2[0];
        var val = _ref2[1];

        result[key] = val;
    });
    return result;
};

var mapObj = function mapObj(obj, fn) {
    return pairsToObject(objectToPairs(obj).map(fn));
};

exports.mapObj = mapObj;
// Flattens an array one level
// [[A], [B, C, [D]]] -> [A, B, C, [D]]
var flatten = function flatten(list) {
    return list.reduce(function (memo, x) {
        return memo.concat(x);
    }, []);
};

exports.flatten = flatten;
var flattenDeep = function flattenDeep(list) {
    return list.reduce(function (memo, x) {
        return memo.concat(Array.isArray(x) ? flattenDeep(x) : x);
    }, []);
};

exports.flattenDeep = flattenDeep;
var UPPERCASE_RE = /([A-Z])/g;
var MS_RE = /^ms-/;

var kebabify = function kebabify(string) {
    return string.replace(UPPERCASE_RE, '-$1').toLowerCase();
};
var kebabifyStyleName = function kebabifyStyleName(string) {
    return kebabify(string).replace(MS_RE, '-ms-');
};

exports.kebabifyStyleName = kebabifyStyleName;
var recursiveMerge = function recursiveMerge(a, b) {
    // TODO(jlfwong): Handle malformed input where a and b are not the same
    // type.

    if (typeof a !== 'object') {
        return b;
    }

    var ret = _extends({}, a);

    Object.keys(b).forEach(function (key) {
        if (ret.hasOwnProperty(key)) {
            ret[key] = recursiveMerge(a[key], b[key]);
        } else {
            ret[key] = b[key];
        }
    });

    return ret;
};

exports.recursiveMerge = recursiveMerge;
/**
 * CSS properties which accept numbers but are not in units of "px".
 * Taken from React's CSSProperty.js
 */
var isUnitlessNumber = {
    animationIterationCount: true,
    borderImageOutset: true,
    borderImageSlice: true,
    borderImageWidth: true,
    boxFlex: true,
    boxFlexGroup: true,
    boxOrdinalGroup: true,
    columnCount: true,
    flex: true,
    flexGrow: true,
    flexPositive: true,
    flexShrink: true,
    flexNegative: true,
    flexOrder: true,
    gridRow: true,
    gridColumn: true,
    fontWeight: true,
    lineClamp: true,
    lineHeight: true,
    opacity: true,
    order: true,
    orphans: true,
    tabSize: true,
    widows: true,
    zIndex: true,
    zoom: true,

    // SVG-related properties
    fillOpacity: true,
    floodOpacity: true,
    stopOpacity: true,
    strokeDasharray: true,
    strokeDashoffset: true,
    strokeMiterlimit: true,
    strokeOpacity: true,
    strokeWidth: true
};

/**
 * Taken from React's CSSProperty.js
 *
 * @param {string} prefix vendor-specific prefix, eg: Webkit
 * @param {string} key style name, eg: transitionDuration
 * @return {string} style name prefixed with `prefix`, properly camelCased, eg:
 * WebkitTransitionDuration
 */
function prefixKey(prefix, key) {
    return prefix + key.charAt(0).toUpperCase() + key.substring(1);
}

/**
 * Support style names that may come passed in prefixed by adding permutations
 * of vendor prefixes.
 * Taken from React's CSSProperty.js
 */
var prefixes = ['Webkit', 'ms', 'Moz', 'O'];

// Using Object.keys here, or else the vanilla for-in loop makes IE8 go into an
// infinite loop, because it iterates over the newly added props too.
// Taken from React's CSSProperty.js
Object.keys(isUnitlessNumber).forEach(function (prop) {
    prefixes.forEach(function (prefix) {
        isUnitlessNumber[prefixKey(prefix, prop)] = isUnitlessNumber[prop];
    });
});

var stringifyValue = function stringifyValue(key, prop) {
    if (typeof prop === "number") {
        if (isUnitlessNumber[key]) {
            return "" + prop;
        } else {
            return prop + "px";
        }
    } else {
        return prop;
    }
};

exports.stringifyValue = stringifyValue;
/**
 * JS Implementation of MurmurHash2
 *
 * @author <a href="mailto:gary.court@gmail.com">Gary Court</a>
 * @see http://github.com/garycourt/murmurhash-js
 * @author <a href="mailto:aappleby@gmail.com">Austin Appleby</a>
 * @see http://sites.google.com/site/murmurhash/
 *
 * @param {string} str ASCII only
 * @return {string} Base 36 encoded hash result
 */
function murmurhash2_32_gc(str) {
    var l = str.length;
    var h = l;
    var i = 0;
    var k = undefined;

    while (l >= 4) {
        k = str.charCodeAt(i) & 0xff | (str.charCodeAt(++i) & 0xff) << 8 | (str.charCodeAt(++i) & 0xff) << 16 | (str.charCodeAt(++i) & 0xff) << 24;

        k = (k & 0xffff) * 0x5bd1e995 + (((k >>> 16) * 0x5bd1e995 & 0xffff) << 16);
        k ^= k >>> 24;
        k = (k & 0xffff) * 0x5bd1e995 + (((k >>> 16) * 0x5bd1e995 & 0xffff) << 16);

        h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16) ^ k;

        l -= 4;
        ++i;
    }

    /* eslint-disable no-fallthrough */ // forgive existing code
    switch (l) {
        case 3:
            h ^= (str.charCodeAt(i + 2) & 0xff) << 16;
        case 2:
            h ^= (str.charCodeAt(i + 1) & 0xff) << 8;
        case 1:
            h ^= str.charCodeAt(i) & 0xff;
            h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16);
    }
    /* eslint-enable no-fallthrough */

    h ^= h >>> 13;
    h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16);
    h ^= h >>> 15;

    return (h >>> 0).toString(36);
}

// Hash a javascript object using JSON.stringify. This is very fast, about 3
// microseconds on my computer for a sample object:
// http://jsperf.com/test-hashfnv32a-hash/5
//
// Note that this uses JSON.stringify to stringify the objects so in order for
// this to produce consistent hashes browsers need to have a consistent
// ordering of objects. Ben Alpert says that Facebook depends on this, so we
// can probably depend on this too.
var hashObject = function hashObject(object) {
    return murmurhash2_32_gc(JSON.stringify(object));
};

exports.hashObject = hashObject;
var IMPORTANT_RE = /^([^:]+:.*?)( !important)?;$/;

// Given a single style rule string like "a: b;", adds !important to generate
// "a: b !important;".
var importantify = function importantify(string) {
    return string.replace(IMPORTANT_RE, function (_, base) {
        return base + " !important;";
    });
};
exports.importantify = importantify;

/***/ }),

/***/ 194:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, '__esModule', {
    value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _inlineStylePrefixerStatic = __webpack_require__(493);

var _inlineStylePrefixerStatic2 = _interopRequireDefault(_inlineStylePrefixerStatic);

var _util = __webpack_require__(193);

/**
 * `selectorHandlers` are functions which handle special selectors which act
 * differently than normal style definitions. These functions look at the
 * current selector and can generate CSS for the styles in their subtree by
 * calling the callback with a new selector.
 *
 * For example, when generating styles with a base selector of '.foo' and the
 * following styles object:
 *
 *   {
 *     ':nth-child(2n)': {
 *       ':hover': {
 *         color: 'red'
 *       }
 *     }
 *   }
 *
 * when we reach the ':hover' style, we would call our selector handlers like
 *
 *   handler(':hover', '.foo:nth-child(2n)', callback)
 *
 * Since our `pseudoSelectors` handles ':hover' styles, that handler would call
 * the callback like
 *
 *   callback('.foo:nth-child(2n):hover')
 *
 * to generate its subtree `{ color: 'red' }` styles with a
 * '.foo:nth-child(2n):hover' selector. The callback would return CSS like
 *
 *   '.foo:nth-child(2n):hover{color:red !important;}'
 *
 * and the handler would then return that resulting CSS.
 *
 * `defaultSelectorHandlers` is the list of default handlers used in a call to
 * `generateCSS`.
 *
 * @name SelectorHandler
 * @function
 * @param {string} selector: The currently inspected selector. ':hover' in the
 *     example above.
 * @param {string} baseSelector: The selector of the parent styles.
 *     '.foo:nth-child(2n)' in the example above.
 * @param {function} generateSubtreeStyles: A function which can be called to
 *     generate CSS for the subtree of styles corresponding to the selector.
 *     Accepts a new baseSelector to use for generating those styles.
 * @returns {?string} The generated CSS for this selector, or null if we don't
 *     handle this selector.
 */
var defaultSelectorHandlers = [
// Handle pseudo-selectors, like :hover and :nth-child(3n)
function pseudoSelectors(selector, baseSelector, generateSubtreeStyles) {
    if (selector[0] !== ":") {
        return null;
    }
    return generateSubtreeStyles(baseSelector + selector);
},

// Handle media queries (or font-faces)
function mediaQueries(selector, baseSelector, generateSubtreeStyles) {
    if (selector[0] !== "@") {
        return null;
    }
    // Generate the styles normally, and then wrap them in the media query.
    var generated = generateSubtreeStyles(baseSelector);
    return selector + '{' + generated + '}';
}];

exports.defaultSelectorHandlers = defaultSelectorHandlers;
/**
 * Generate CSS for a selector and some styles.
 *
 * This function handles the media queries, pseudo selectors, and descendant
 * styles that can be used in aphrodite styles.
 *
 * @param {string} selector: A base CSS selector for the styles to be generated
 *     with.
 * @param {Object} styleTypes: A list of properties of the return type of
 *     StyleSheet.create, e.g. [styles.red, styles.blue].
 * @param {Array.<SelectorHandler>} selectorHandlers: A list of selector
 *     handlers to use for handling special selectors. See
 *     `defaultSelectorHandlers`.
 * @param stringHandlers: See `generateCSSRuleset`
 * @param useImportant: See `generateCSSRuleset`
 *
 * To actually generate the CSS special-construct-less styles are passed to
 * `generateCSSRuleset`.
 *
 * For instance, a call to
 *
 *     generateCSS(".foo", {
 *       color: "red",
 *       "@media screen": {
 *         height: 20,
 *         ":hover": {
 *           backgroundColor: "black"
 *         }
 *       },
 *       ":active": {
 *         fontWeight: "bold",
 *         ">>bar": {
 *           _names: { "foo_bar": true },
 *           height: 10,
 *         }
 *       }
 *     });
 *
 * with the default `selectorHandlers` will make 5 calls to
 * `generateCSSRuleset`:
 *
 *     generateCSSRuleset(".foo", { color: "red" }, ...)
 *     generateCSSRuleset(".foo:active", { fontWeight: "bold" }, ...)
 *     generateCSSRuleset(".foo:active .foo_bar", { height: 10 }, ...)
 *     // These 2 will be wrapped in @media screen {}
 *     generateCSSRuleset(".foo", { height: 20 }, ...)
 *     generateCSSRuleset(".foo:hover", { backgroundColor: "black" }, ...)
 */
var generateCSS = function generateCSS(selector, styleTypes) {
    var selectorHandlers = arguments.length <= 2 || arguments[2] === undefined ? [] : arguments[2];
    var stringHandlers = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];
    var useImportant = arguments.length <= 4 || arguments[4] === undefined ? true : arguments[4];

    var merged = styleTypes.reduce(_util.recursiveMerge);

    var plainDeclarations = {};
    var generatedStyles = "";

    Object.keys(merged).forEach(function (key) {
        // For each key, see if one of the selector handlers will handle these
        // styles.
        var foundHandler = selectorHandlers.some(function (handler) {
            var result = handler(key, selector, function (newSelector) {
                return generateCSS(newSelector, [merged[key]], selectorHandlers, stringHandlers, useImportant);
            });
            if (result != null) {
                // If the handler returned something, add it to the generated
                // CSS and stop looking for another handler.
                generatedStyles += result;
                return true;
            }
        });
        // If none of the handlers handled it, add it to the list of plain
        // style declarations.
        if (!foundHandler) {
            plainDeclarations[key] = merged[key];
        }
    });

    return generateCSSRuleset(selector, plainDeclarations, stringHandlers, useImportant, selectorHandlers) + generatedStyles;
};

exports.generateCSS = generateCSS;
/**
 * Helper method of generateCSSRuleset to facilitate custom handling of certain
 * CSS properties. Used for e.g. font families.
 *
 * See generateCSSRuleset for usage and documentation of paramater types.
 */
var runStringHandlers = function runStringHandlers(declarations, stringHandlers, selectorHandlers) {
    var result = {};

    Object.keys(declarations).forEach(function (key) {
        // If a handler exists for this particular key, let it interpret
        // that value first before continuing
        if (stringHandlers && stringHandlers.hasOwnProperty(key)) {
            // TODO(emily): Pass in a callback which generates CSS, similar to
            // how our selector handlers work, instead of passing in
            // `selectorHandlers` and have them make calls to `generateCSS`
            // themselves. Right now, this is impractical because our string
            // handlers are very specialized and do complex things.
            result[key] = stringHandlers[key](declarations[key], selectorHandlers);
        } else {
            result[key] = declarations[key];
        }
    });

    return result;
};

/**
 * Generate a CSS ruleset with the selector and containing the declarations.
 *
 * This function assumes that the given declarations don't contain any special
 * children (such as media queries, pseudo-selectors, or descendant styles).
 *
 * Note that this method does not deal with nesting used for e.g.
 * psuedo-selectors or media queries. That responsibility is left to  the
 * `generateCSS` function.
 *
 * @param {string} selector: the selector associated with the ruleset
 * @param {Object} declarations: a map from camelCased CSS property name to CSS
 *     property value.
 * @param {Object.<string, function>} stringHandlers: a map from camelCased CSS
 *     property name to a function which will map the given value to the value
 *     that is output.
 * @param {bool} useImportant: A boolean saying whether to append "!important"
 *     to each of the CSS declarations.
 * @returns {string} A string of raw CSS.
 *
 * Examples:
 *
 *    generateCSSRuleset(".blah", { color: "red" })
 *    -> ".blah{color: red !important;}"
 *    generateCSSRuleset(".blah", { color: "red" }, {}, false)
 *    -> ".blah{color: red}"
 *    generateCSSRuleset(".blah", { color: "red" }, {color: c => c.toUpperCase})
 *    -> ".blah{color: RED}"
 *    generateCSSRuleset(".blah:hover", { color: "red" })
 *    -> ".blah:hover{color: red}"
 */
var generateCSSRuleset = function generateCSSRuleset(selector, declarations, stringHandlers, useImportant, selectorHandlers) {
    var handledDeclarations = runStringHandlers(declarations, stringHandlers, selectorHandlers);

    var prefixedDeclarations = (0, _inlineStylePrefixerStatic2['default'])(handledDeclarations);

    var prefixedRules = (0, _util.flatten)((0, _util.objectToPairs)(prefixedDeclarations).map(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2);

        var key = _ref2[0];
        var value = _ref2[1];

        if (Array.isArray(value)) {
            var _ret = (function () {
                // inline-style-prefix-all returns an array when there should be
                // multiple rules, we will flatten to single rules

                var prefixedValues = [];
                var unprefixedValues = [];

                value.forEach(function (v) {
                    if (v.indexOf('-') === 0) {
                        prefixedValues.push(v);
                    } else {
                        unprefixedValues.push(v);
                    }
                });

                prefixedValues.sort();
                unprefixedValues.sort();

                return {
                    v: prefixedValues.concat(unprefixedValues).map(function (v) {
                        return [key, v];
                    })
                };
            })();

            if (typeof _ret === 'object') return _ret.v;
        }
        return [[key, value]];
    }));

    var rules = prefixedRules.map(function (_ref3) {
        var _ref32 = _slicedToArray(_ref3, 2);

        var key = _ref32[0];
        var value = _ref32[1];

        var stringValue = (0, _util.stringifyValue)(key, value);
        var ret = (0, _util.kebabifyStyleName)(key) + ':' + stringValue + ';';
        return useImportant === false ? ret : (0, _util.importantify)(ret);
    }).join("");

    if (rules) {
        return selector + '{' + rules + '}';
    } else {
        return "";
    }
};
exports.generateCSSRuleset = generateCSSRuleset;

/***/ }),

/***/ 196:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {(function (global, undefined) {
    "use strict";

    if (global.setImmediate) {
        return;
    }

    var nextHandle = 1; // Spec says greater than zero
    var tasksByHandle = {};
    var currentlyRunningATask = false;
    var doc = global.document;
    var registerImmediate;

    function setImmediate(callback) {
      // Callback can either be a function or a string
      if (typeof callback !== "function") {
        callback = new Function("" + callback);
      }
      // Copy function arguments
      var args = new Array(arguments.length - 1);
      for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i + 1];
      }
      // Store and register the task
      var task = { callback: callback, args: args };
      tasksByHandle[nextHandle] = task;
      registerImmediate(nextHandle);
      return nextHandle++;
    }

    function clearImmediate(handle) {
        delete tasksByHandle[handle];
    }

    function run(task) {
        var callback = task.callback;
        var args = task.args;
        switch (args.length) {
        case 0:
            callback();
            break;
        case 1:
            callback(args[0]);
            break;
        case 2:
            callback(args[0], args[1]);
            break;
        case 3:
            callback(args[0], args[1], args[2]);
            break;
        default:
            callback.apply(undefined, args);
            break;
        }
    }

    function runIfPresent(handle) {
        // From the spec: "Wait until any invocations of this algorithm started before this one have completed."
        // So if we're currently running a task, we'll need to delay this invocation.
        if (currentlyRunningATask) {
            // Delay by doing a setTimeout. setImmediate was tried instead, but in Firefox 7 it generated a
            // "too much recursion" error.
            setTimeout(runIfPresent, 0, handle);
        } else {
            var task = tasksByHandle[handle];
            if (task) {
                currentlyRunningATask = true;
                try {
                    run(task);
                } finally {
                    clearImmediate(handle);
                    currentlyRunningATask = false;
                }
            }
        }
    }

    function installNextTickImplementation() {
        registerImmediate = function(handle) {
            process.nextTick(function () { runIfPresent(handle); });
        };
    }

    function canUsePostMessage() {
        // The test against `importScripts` prevents this implementation from being installed inside a web worker,
        // where `global.postMessage` means something completely different and can't be used for this purpose.
        if (global.postMessage && !global.importScripts) {
            var postMessageIsAsynchronous = true;
            var oldOnMessage = global.onmessage;
            global.onmessage = function() {
                postMessageIsAsynchronous = false;
            };
            global.postMessage("", "*");
            global.onmessage = oldOnMessage;
            return postMessageIsAsynchronous;
        }
    }

    function installPostMessageImplementation() {
        // Installs an event handler on `global` for the `message` event: see
        // * https://developer.mozilla.org/en/DOM/window.postMessage
        // * http://www.whatwg.org/specs/web-apps/current-work/multipage/comms.html#crossDocumentMessages

        var messagePrefix = "setImmediate$" + Math.random() + "$";
        var onGlobalMessage = function(event) {
            if (event.source === global &&
                typeof event.data === "string" &&
                event.data.indexOf(messagePrefix) === 0) {
                runIfPresent(+event.data.slice(messagePrefix.length));
            }
        };

        if (global.addEventListener) {
            global.addEventListener("message", onGlobalMessage, false);
        } else {
            global.attachEvent("onmessage", onGlobalMessage);
        }

        registerImmediate = function(handle) {
            global.postMessage(messagePrefix + handle, "*");
        };
    }

    function installMessageChannelImplementation() {
        var channel = new MessageChannel();
        channel.port1.onmessage = function(event) {
            var handle = event.data;
            runIfPresent(handle);
        };

        registerImmediate = function(handle) {
            channel.port2.postMessage(handle);
        };
    }

    function installReadyStateChangeImplementation() {
        var html = doc.documentElement;
        registerImmediate = function(handle) {
            // Create a <script> element; its readystatechange event will be fired asynchronously once it is inserted
            // into the document. Do so, thus queuing up the task. Remember to clean up once it's been called.
            var script = doc.createElement("script");
            script.onreadystatechange = function () {
                runIfPresent(handle);
                script.onreadystatechange = null;
                html.removeChild(script);
                script = null;
            };
            html.appendChild(script);
        };
    }

    function installSetTimeoutImplementation() {
        registerImmediate = function(handle) {
            setTimeout(runIfPresent, 0, handle);
        };
    }

    // If supported, we should attach to the prototype of global, since that is where setTimeout et al. live.
    var attachTo = Object.getPrototypeOf && Object.getPrototypeOf(global);
    attachTo = attachTo && attachTo.setTimeout ? attachTo : global;

    // Don't get fooled by e.g. browserify environments.
    if ({}.toString.call(global.process) === "[object process]") {
        // For Node.js before 0.9
        installNextTickImplementation();

    } else if (canUsePostMessage()) {
        // For non-IE10 modern browsers
        installPostMessageImplementation();

    } else if (global.MessageChannel) {
        // For web workers, where supported
        installMessageChannelImplementation();

    } else if (doc && "onreadystatechange" in doc.createElement("script")) {
        // For IE 6–8
        installReadyStateChangeImplementation();

    } else {
        // For older browsers
        installSetTimeoutImplementation();
    }

    attachTo.setImmediate = setImmediate;
    attachTo.clearImmediate = clearImmediate;
}(typeof self === "undefined" ? typeof global === "undefined" ? this : global : self));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(31)))

/***/ }),

/***/ 197:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(setImmediate, global, module) {(function (global, factory) {
   true ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (factory((global.async = global.async || {})));
}(this, (function (exports) { 'use strict';

function slice(arrayLike, start) {
    start = start|0;
    var newLen = Math.max(arrayLike.length - start, 0);
    var newArr = Array(newLen);
    for(var idx = 0; idx < newLen; idx++)  {
        newArr[idx] = arrayLike[start + idx];
    }
    return newArr;
}

/**
 * Creates a continuation function with some arguments already applied.
 *
 * Useful as a shorthand when combined with other control flow functions. Any
 * arguments passed to the returned function are added to the arguments
 * originally passed to apply.
 *
 * @name apply
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {Function} fn - The function you want to eventually apply all
 * arguments to. Invokes with (arguments...).
 * @param {...*} arguments... - Any number of arguments to automatically apply
 * when the continuation is called.
 * @returns {Function} the partially-applied function
 * @example
 *
 * // using apply
 * async.parallel([
 *     async.apply(fs.writeFile, 'testfile1', 'test1'),
 *     async.apply(fs.writeFile, 'testfile2', 'test2')
 * ]);
 *
 *
 * // the same process without using apply
 * async.parallel([
 *     function(callback) {
 *         fs.writeFile('testfile1', 'test1', callback);
 *     },
 *     function(callback) {
 *         fs.writeFile('testfile2', 'test2', callback);
 *     }
 * ]);
 *
 * // It's possible to pass any number of additional arguments when calling the
 * // continuation:
 *
 * node> var fn = async.apply(sys.puts, 'one');
 * node> fn('two', 'three');
 * one
 * two
 * three
 */
var apply = function(fn/*, ...args*/) {
    var args = slice(arguments, 1);
    return function(/*callArgs*/) {
        var callArgs = slice(arguments);
        return fn.apply(null, args.concat(callArgs));
    };
};

var initialParams = function (fn) {
    return function (/*...args, callback*/) {
        var args = slice(arguments);
        var callback = args.pop();
        fn.call(this, args, callback);
    };
};

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

var hasSetImmediate = typeof setImmediate === 'function' && setImmediate;
var hasNextTick = typeof process === 'object' && typeof process.nextTick === 'function';

function fallback(fn) {
    setTimeout(fn, 0);
}

function wrap(defer) {
    return function (fn/*, ...args*/) {
        var args = slice(arguments, 1);
        defer(function () {
            fn.apply(null, args);
        });
    };
}

var _defer;

if (hasSetImmediate) {
    _defer = setImmediate;
} else if (hasNextTick) {
    _defer = process.nextTick;
} else {
    _defer = fallback;
}

var setImmediate$1 = wrap(_defer);

/**
 * Take a sync function and make it async, passing its return value to a
 * callback. This is useful for plugging sync functions into a waterfall,
 * series, or other async functions. Any arguments passed to the generated
 * function will be passed to the wrapped function (except for the final
 * callback argument). Errors thrown will be passed to the callback.
 *
 * If the function passed to `asyncify` returns a Promise, that promises's
 * resolved/rejected state will be used to call the callback, rather than simply
 * the synchronous return value.
 *
 * This also means you can asyncify ES2017 `async` functions.
 *
 * @name asyncify
 * @static
 * @memberOf module:Utils
 * @method
 * @alias wrapSync
 * @category Util
 * @param {Function} func - The synchronous function, or Promise-returning
 * function to convert to an {@link AsyncFunction}.
 * @returns {AsyncFunction} An asynchronous wrapper of the `func`. To be
 * invoked with `(args..., callback)`.
 * @example
 *
 * // passing a regular synchronous function
 * async.waterfall([
 *     async.apply(fs.readFile, filename, "utf8"),
 *     async.asyncify(JSON.parse),
 *     function (data, next) {
 *         // data is the result of parsing the text.
 *         // If there was a parsing error, it would have been caught.
 *     }
 * ], callback);
 *
 * // passing a function returning a promise
 * async.waterfall([
 *     async.apply(fs.readFile, filename, "utf8"),
 *     async.asyncify(function (contents) {
 *         return db.model.create(contents);
 *     }),
 *     function (model, next) {
 *         // `model` is the instantiated model object.
 *         // If there was an error, this function would be skipped.
 *     }
 * ], callback);
 *
 * // es2017 example, though `asyncify` is not needed if your JS environment
 * // supports async functions out of the box
 * var q = async.queue(async.asyncify(async function(file) {
 *     var intermediateStep = await processFile(file);
 *     return await somePromise(intermediateStep)
 * }));
 *
 * q.push(files);
 */
function asyncify(func) {
    return initialParams(function (args, callback) {
        var result;
        try {
            result = func.apply(this, args);
        } catch (e) {
            return callback(e);
        }
        // if result is Promise object
        if (isObject(result) && typeof result.then === 'function') {
            result.then(function(value) {
                invokeCallback(callback, null, value);
            }, function(err) {
                invokeCallback(callback, err.message ? err : new Error(err));
            });
        } else {
            callback(null, result);
        }
    });
}

function invokeCallback(callback, error, value) {
    try {
        callback(error, value);
    } catch (e) {
        setImmediate$1(rethrow, e);
    }
}

function rethrow(error) {
    throw error;
}

var supportsSymbol = typeof Symbol === 'function';

function isAsync(fn) {
    return supportsSymbol && fn[Symbol.toStringTag] === 'AsyncFunction';
}

function wrapAsync(asyncFn) {
    return isAsync(asyncFn) ? asyncify(asyncFn) : asyncFn;
}

function applyEach$1(eachfn) {
    return function(fns/*, ...args*/) {
        var args = slice(arguments, 1);
        var go = initialParams(function(args, callback) {
            var that = this;
            return eachfn(fns, function (fn, cb) {
                wrapAsync(fn).apply(that, args.concat(cb));
            }, callback);
        });
        if (args.length) {
            return go.apply(this, args);
        }
        else {
            return go;
        }
    };
}

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Built-in value references. */
var Symbol$1 = root.Symbol;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/** Built-in value references. */
var symToStringTag$1 = Symbol$1 ? Symbol$1.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag$1),
      tag = value[symToStringTag$1];

  try {
    value[symToStringTag$1] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString$1 = objectProto$1.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString$1.call(value);
}

/** `Object#toString` result references. */
var nullTag = '[object Null]';
var undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol$1 ? Symbol$1.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]';
var funcTag = '[object Function]';
var genTag = '[object GeneratorFunction]';
var proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

// A temporary value used to identify if the loop should be broken.
// See #1064, #1293
var breakLoop = {};

/**
 * This method returns `undefined`.
 *
 * @static
 * @memberOf _
 * @since 2.3.0
 * @category Util
 * @example
 *
 * _.times(2, _.noop);
 * // => [undefined, undefined]
 */
function noop() {
  // No operation performed.
}

function once(fn) {
    return function () {
        if (fn === null) return;
        var callFn = fn;
        fn = null;
        callFn.apply(this, arguments);
    };
}

var iteratorSymbol = typeof Symbol === 'function' && Symbol.iterator;

var getIterator = function (coll) {
    return iteratorSymbol && coll[iteratorSymbol] && coll[iteratorSymbol]();
};

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

/** `Object#toString` result references. */
var argsTag = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag;
}

/** Used for built-in method references. */
var objectProto$3 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$2 = objectProto$3.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable = objectProto$3.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty$2.call(value, 'callee') &&
    !propertyIsEnumerable.call(value, 'callee');
};

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

/** Detect free variable `exports`. */
var freeExports = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer = nativeIsBuffer || stubFalse;

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER$1 = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER$1 : length;
  return !!length &&
    (typeof value == 'number' || reIsUint.test(value)) &&
    (value > -1 && value % 1 == 0 && value < length);
}

/** `Object#toString` result references. */
var argsTag$1 = '[object Arguments]';
var arrayTag = '[object Array]';
var boolTag = '[object Boolean]';
var dateTag = '[object Date]';
var errorTag = '[object Error]';
var funcTag$1 = '[object Function]';
var mapTag = '[object Map]';
var numberTag = '[object Number]';
var objectTag = '[object Object]';
var regexpTag = '[object RegExp]';
var setTag = '[object Set]';
var stringTag = '[object String]';
var weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]';
var dataViewTag = '[object DataView]';
var float32Tag = '[object Float32Array]';
var float64Tag = '[object Float64Array]';
var int8Tag = '[object Int8Array]';
var int16Tag = '[object Int16Array]';
var int32Tag = '[object Int32Array]';
var uint8Tag = '[object Uint8Array]';
var uint8ClampedTag = '[object Uint8ClampedArray]';
var uint16Tag = '[object Uint16Array]';
var uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag$1] =
typedArrayTags[mapTag] = typedArrayTags[numberTag] =
typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
typedArrayTags[setTag] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

/** Detect free variable `exports`. */
var freeExports$1 = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule$1 = freeExports$1 && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports$1 && freeGlobal.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    return freeProcess && freeProcess.binding && freeProcess.binding('util');
  } catch (e) {}
}());

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

/** Used for built-in method references. */
var objectProto$2 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$1 = objectProto$2.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  var isArr = isArray(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty$1.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

/** Used for built-in method references. */
var objectProto$5 = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$5;

  return value === proto;
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

/** Used for built-in method references. */
var objectProto$4 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$3 = objectProto$4.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$3.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

function createArrayIterator(coll) {
    var i = -1;
    var len = coll.length;
    return function next() {
        return ++i < len ? {value: coll[i], key: i} : null;
    }
}

function createES2015Iterator(iterator) {
    var i = -1;
    return function next() {
        var item = iterator.next();
        if (item.done)
            return null;
        i++;
        return {value: item.value, key: i};
    }
}

function createObjectIterator(obj) {
    var okeys = keys(obj);
    var i = -1;
    var len = okeys.length;
    return function next() {
        var key = okeys[++i];
        return i < len ? {value: obj[key], key: key} : null;
    };
}

function iterator(coll) {
    if (isArrayLike(coll)) {
        return createArrayIterator(coll);
    }

    var iterator = getIterator(coll);
    return iterator ? createES2015Iterator(iterator) : createObjectIterator(coll);
}

function onlyOnce(fn) {
    return function() {
        if (fn === null) throw new Error("Callback was already called.");
        var callFn = fn;
        fn = null;
        callFn.apply(this, arguments);
    };
}

function _eachOfLimit(limit) {
    return function (obj, iteratee, callback) {
        callback = once(callback || noop);
        if (limit <= 0 || !obj) {
            return callback(null);
        }
        var nextElem = iterator(obj);
        var done = false;
        var running = 0;

        function iterateeCallback(err, value) {
            running -= 1;
            if (err) {
                done = true;
                callback(err);
            }
            else if (value === breakLoop || (done && running <= 0)) {
                done = true;
                return callback(null);
            }
            else {
                replenish();
            }
        }

        function replenish () {
            while (running < limit && !done) {
                var elem = nextElem();
                if (elem === null) {
                    done = true;
                    if (running <= 0) {
                        callback(null);
                    }
                    return;
                }
                running += 1;
                iteratee(elem.value, elem.key, onlyOnce(iterateeCallback));
            }
        }

        replenish();
    };
}

/**
 * The same as [`eachOf`]{@link module:Collections.eachOf} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name eachOfLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.eachOf]{@link module:Collections.eachOf}
 * @alias forEachOfLimit
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async function to apply to each
 * item in `coll`. The `key` is the item's key, or index in the case of an
 * array.
 * Invoked with (item, key, callback).
 * @param {Function} [callback] - A callback which is called when all
 * `iteratee` functions have finished, or an error occurs. Invoked with (err).
 */
function eachOfLimit(coll, limit, iteratee, callback) {
    _eachOfLimit(limit)(coll, wrapAsync(iteratee), callback);
}

function doLimit(fn, limit) {
    return function (iterable, iteratee, callback) {
        return fn(iterable, limit, iteratee, callback);
    };
}

// eachOf implementation optimized for array-likes
function eachOfArrayLike(coll, iteratee, callback) {
    callback = once(callback || noop);
    var index = 0,
        completed = 0,
        length = coll.length;
    if (length === 0) {
        callback(null);
    }

    function iteratorCallback(err, value) {
        if (err) {
            callback(err);
        } else if ((++completed === length) || value === breakLoop) {
            callback(null);
        }
    }

    for (; index < length; index++) {
        iteratee(coll[index], index, onlyOnce(iteratorCallback));
    }
}

// a generic version of eachOf which can handle array, object, and iterator cases.
var eachOfGeneric = doLimit(eachOfLimit, Infinity);

/**
 * Like [`each`]{@link module:Collections.each}, except that it passes the key (or index) as the second argument
 * to the iteratee.
 *
 * @name eachOf
 * @static
 * @memberOf module:Collections
 * @method
 * @alias forEachOf
 * @category Collection
 * @see [async.each]{@link module:Collections.each}
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A function to apply to each
 * item in `coll`.
 * The `key` is the item's key, or index in the case of an array.
 * Invoked with (item, key, callback).
 * @param {Function} [callback] - A callback which is called when all
 * `iteratee` functions have finished, or an error occurs. Invoked with (err).
 * @example
 *
 * var obj = {dev: "/dev.json", test: "/test.json", prod: "/prod.json"};
 * var configs = {};
 *
 * async.forEachOf(obj, function (value, key, callback) {
 *     fs.readFile(__dirname + value, "utf8", function (err, data) {
 *         if (err) return callback(err);
 *         try {
 *             configs[key] = JSON.parse(data);
 *         } catch (e) {
 *             return callback(e);
 *         }
 *         callback();
 *     });
 * }, function (err) {
 *     if (err) console.error(err.message);
 *     // configs is now a map of JSON data
 *     doSomethingWith(configs);
 * });
 */
var eachOf = function(coll, iteratee, callback) {
    var eachOfImplementation = isArrayLike(coll) ? eachOfArrayLike : eachOfGeneric;
    eachOfImplementation(coll, wrapAsync(iteratee), callback);
};

function doParallel(fn) {
    return function (obj, iteratee, callback) {
        return fn(eachOf, obj, wrapAsync(iteratee), callback);
    };
}

function _asyncMap(eachfn, arr, iteratee, callback) {
    callback = callback || noop;
    arr = arr || [];
    var results = [];
    var counter = 0;
    var _iteratee = wrapAsync(iteratee);

    eachfn(arr, function (value, _, callback) {
        var index = counter++;
        _iteratee(value, function (err, v) {
            results[index] = v;
            callback(err);
        });
    }, function (err) {
        callback(err, results);
    });
}

/**
 * Produces a new collection of values by mapping each value in `coll` through
 * the `iteratee` function. The `iteratee` is called with an item from `coll`
 * and a callback for when it has finished processing. Each of these callback
 * takes 2 arguments: an `error`, and the transformed item from `coll`. If
 * `iteratee` passes an error to its callback, the main `callback` (for the
 * `map` function) is immediately called with the error.
 *
 * Note, that since this function applies the `iteratee` to each item in
 * parallel, there is no guarantee that the `iteratee` functions will complete
 * in order. However, the results array will be in the same order as the
 * original `coll`.
 *
 * If `map` is passed an Object, the results will be an Array.  The results
 * will roughly be in the order of the original Objects' keys (but this can
 * vary across JavaScript engines).
 *
 * @name map
 * @static
 * @memberOf module:Collections
 * @method
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with the transformed item.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Results is an Array of the
 * transformed items from the `coll`. Invoked with (err, results).
 * @example
 *
 * async.map(['file1','file2','file3'], fs.stat, function(err, results) {
 *     // results is now an array of stats for each file
 * });
 */
var map = doParallel(_asyncMap);

/**
 * Applies the provided arguments to each function in the array, calling
 * `callback` after all functions have completed. If you only provide the first
 * argument, `fns`, then it will return a function which lets you pass in the
 * arguments as if it were a single function call. If more arguments are
 * provided, `callback` is required while `args` is still optional.
 *
 * @name applyEach
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Array|Iterable|Object} fns - A collection of {@link AsyncFunction}s
 * to all call with the same arguments
 * @param {...*} [args] - any number of separate arguments to pass to the
 * function.
 * @param {Function} [callback] - the final argument should be the callback,
 * called when all functions have completed processing.
 * @returns {Function} - If only the first argument, `fns`, is provided, it will
 * return a function which lets you pass in the arguments as if it were a single
 * function call. The signature is `(..args, callback)`. If invoked with any
 * arguments, `callback` is required.
 * @example
 *
 * async.applyEach([enableSearch, updateSchema], 'bucket', callback);
 *
 * // partial application example:
 * async.each(
 *     buckets,
 *     async.applyEach([enableSearch, updateSchema]),
 *     callback
 * );
 */
var applyEach = applyEach$1(map);

function doParallelLimit(fn) {
    return function (obj, limit, iteratee, callback) {
        return fn(_eachOfLimit(limit), obj, wrapAsync(iteratee), callback);
    };
}

/**
 * The same as [`map`]{@link module:Collections.map} but runs a maximum of `limit` async operations at a time.
 *
 * @name mapLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.map]{@link module:Collections.map}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with the transformed item.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Results is an array of the
 * transformed items from the `coll`. Invoked with (err, results).
 */
var mapLimit = doParallelLimit(_asyncMap);

/**
 * The same as [`map`]{@link module:Collections.map} but runs only a single async operation at a time.
 *
 * @name mapSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.map]{@link module:Collections.map}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with the transformed item.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Results is an array of the
 * transformed items from the `coll`. Invoked with (err, results).
 */
var mapSeries = doLimit(mapLimit, 1);

/**
 * The same as [`applyEach`]{@link module:ControlFlow.applyEach} but runs only a single async operation at a time.
 *
 * @name applyEachSeries
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.applyEach]{@link module:ControlFlow.applyEach}
 * @category Control Flow
 * @param {Array|Iterable|Object} fns - A collection of {@link AsyncFunction}s to all
 * call with the same arguments
 * @param {...*} [args] - any number of separate arguments to pass to the
 * function.
 * @param {Function} [callback] - the final argument should be the callback,
 * called when all functions have completed processing.
 * @returns {Function} - If only the first argument is provided, it will return
 * a function which lets you pass in the arguments as if it were a single
 * function call.
 */
var applyEachSeries = applyEach$1(mapSeries);

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */
function arrayEach(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor = createBaseFor();

/**
 * The base implementation of `_.forOwn` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Object} Returns `object`.
 */
function baseForOwn(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}

/**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);

  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}

/**
 * The base implementation of `_.isNaN` without support for number objects.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
 */
function baseIsNaN(value) {
  return value !== value;
}

/**
 * A specialized version of `_.indexOf` which performs strict equality
 * comparisons of values, i.e. `===`.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1,
      length = array.length;

  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}

/**
 * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseIndexOf(array, value, fromIndex) {
  return value === value
    ? strictIndexOf(array, value, fromIndex)
    : baseFindIndex(array, baseIsNaN, fromIndex);
}

/**
 * Determines the best order for running the {@link AsyncFunction}s in `tasks`, based on
 * their requirements. Each function can optionally depend on other functions
 * being completed first, and each function is run as soon as its requirements
 * are satisfied.
 *
 * If any of the {@link AsyncFunction}s pass an error to their callback, the `auto` sequence
 * will stop. Further tasks will not execute (so any other functions depending
 * on it will not run), and the main `callback` is immediately called with the
 * error.
 *
 * {@link AsyncFunction}s also receive an object containing the results of functions which
 * have completed so far as the first argument, if they have dependencies. If a
 * task function has no dependencies, it will only be passed a callback.
 *
 * @name auto
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Object} tasks - An object. Each of its properties is either a
 * function or an array of requirements, with the {@link AsyncFunction} itself the last item
 * in the array. The object's key of a property serves as the name of the task
 * defined by that property, i.e. can be used when specifying requirements for
 * other tasks. The function receives one or two arguments:
 * * a `results` object, containing the results of the previously executed
 *   functions, only passed if the task has any dependencies,
 * * a `callback(err, result)` function, which must be called when finished,
 *   passing an `error` (which can be `null`) and the result of the function's
 *   execution.
 * @param {number} [concurrency=Infinity] - An optional `integer` for
 * determining the maximum number of tasks that can be run in parallel. By
 * default, as many as possible.
 * @param {Function} [callback] - An optional callback which is called when all
 * the tasks have been completed. It receives the `err` argument if any `tasks`
 * pass an error to their callback. Results are always returned; however, if an
 * error occurs, no further `tasks` will be performed, and the results object
 * will only contain partial results. Invoked with (err, results).
 * @returns undefined
 * @example
 *
 * async.auto({
 *     // this function will just be passed a callback
 *     readData: async.apply(fs.readFile, 'data.txt', 'utf-8'),
 *     showData: ['readData', function(results, cb) {
 *         // results.readData is the file's contents
 *         // ...
 *     }]
 * }, callback);
 *
 * async.auto({
 *     get_data: function(callback) {
 *         console.log('in get_data');
 *         // async code to get some data
 *         callback(null, 'data', 'converted to array');
 *     },
 *     make_folder: function(callback) {
 *         console.log('in make_folder');
 *         // async code to create a directory to store a file in
 *         // this is run at the same time as getting the data
 *         callback(null, 'folder');
 *     },
 *     write_file: ['get_data', 'make_folder', function(results, callback) {
 *         console.log('in write_file', JSON.stringify(results));
 *         // once there is some data and the directory exists,
 *         // write the data to a file in the directory
 *         callback(null, 'filename');
 *     }],
 *     email_link: ['write_file', function(results, callback) {
 *         console.log('in email_link', JSON.stringify(results));
 *         // once the file is written let's email a link to it...
 *         // results.write_file contains the filename returned by write_file.
 *         callback(null, {'file':results.write_file, 'email':'user@example.com'});
 *     }]
 * }, function(err, results) {
 *     console.log('err = ', err);
 *     console.log('results = ', results);
 * });
 */
var auto = function (tasks, concurrency, callback) {
    if (typeof concurrency === 'function') {
        // concurrency is optional, shift the args.
        callback = concurrency;
        concurrency = null;
    }
    callback = once(callback || noop);
    var keys$$1 = keys(tasks);
    var numTasks = keys$$1.length;
    if (!numTasks) {
        return callback(null);
    }
    if (!concurrency) {
        concurrency = numTasks;
    }

    var results = {};
    var runningTasks = 0;
    var hasError = false;

    var listeners = Object.create(null);

    var readyTasks = [];

    // for cycle detection:
    var readyToCheck = []; // tasks that have been identified as reachable
    // without the possibility of returning to an ancestor task
    var uncheckedDependencies = {};

    baseForOwn(tasks, function (task, key) {
        if (!isArray(task)) {
            // no dependencies
            enqueueTask(key, [task]);
            readyToCheck.push(key);
            return;
        }

        var dependencies = task.slice(0, task.length - 1);
        var remainingDependencies = dependencies.length;
        if (remainingDependencies === 0) {
            enqueueTask(key, task);
            readyToCheck.push(key);
            return;
        }
        uncheckedDependencies[key] = remainingDependencies;

        arrayEach(dependencies, function (dependencyName) {
            if (!tasks[dependencyName]) {
                throw new Error('async.auto task `' + key +
                    '` has a non-existent dependency `' +
                    dependencyName + '` in ' +
                    dependencies.join(', '));
            }
            addListener(dependencyName, function () {
                remainingDependencies--;
                if (remainingDependencies === 0) {
                    enqueueTask(key, task);
                }
            });
        });
    });

    checkForDeadlocks();
    processQueue();

    function enqueueTask(key, task) {
        readyTasks.push(function () {
            runTask(key, task);
        });
    }

    function processQueue() {
        if (readyTasks.length === 0 && runningTasks === 0) {
            return callback(null, results);
        }
        while(readyTasks.length && runningTasks < concurrency) {
            var run = readyTasks.shift();
            run();
        }

    }

    function addListener(taskName, fn) {
        var taskListeners = listeners[taskName];
        if (!taskListeners) {
            taskListeners = listeners[taskName] = [];
        }

        taskListeners.push(fn);
    }

    function taskComplete(taskName) {
        var taskListeners = listeners[taskName] || [];
        arrayEach(taskListeners, function (fn) {
            fn();
        });
        processQueue();
    }


    function runTask(key, task) {
        if (hasError) return;

        var taskCallback = onlyOnce(function(err, result) {
            runningTasks--;
            if (arguments.length > 2) {
                result = slice(arguments, 1);
            }
            if (err) {
                var safeResults = {};
                baseForOwn(results, function(val, rkey) {
                    safeResults[rkey] = val;
                });
                safeResults[key] = result;
                hasError = true;
                listeners = Object.create(null);

                callback(err, safeResults);
            } else {
                results[key] = result;
                taskComplete(key);
            }
        });

        runningTasks++;
        var taskFn = wrapAsync(task[task.length - 1]);
        if (task.length > 1) {
            taskFn(results, taskCallback);
        } else {
            taskFn(taskCallback);
        }
    }

    function checkForDeadlocks() {
        // Kahn's algorithm
        // https://en.wikipedia.org/wiki/Topological_sorting#Kahn.27s_algorithm
        // http://connalle.blogspot.com/2013/10/topological-sortingkahn-algorithm.html
        var currentTask;
        var counter = 0;
        while (readyToCheck.length) {
            currentTask = readyToCheck.pop();
            counter++;
            arrayEach(getDependents(currentTask), function (dependent) {
                if (--uncheckedDependencies[dependent] === 0) {
                    readyToCheck.push(dependent);
                }
            });
        }

        if (counter !== numTasks) {
            throw new Error(
                'async.auto cannot execute tasks due to a recursive dependency'
            );
        }
    }

    function getDependents(taskName) {
        var result = [];
        baseForOwn(tasks, function (task, key) {
            if (isArray(task) && baseIndexOf(task, taskName, 0) >= 0) {
                result.push(key);
            }
        });
        return result;
    }
};

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && baseGetTag(value) == symbolTag);
}

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol$1 ? Symbol$1.prototype : undefined;
var symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isArray(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return arrayMap(value, baseToString) + '';
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

/**
 * The base implementation of `_.slice` without an iteratee call guard.
 *
 * @private
 * @param {Array} array The array to slice.
 * @param {number} [start=0] The start position.
 * @param {number} [end=array.length] The end position.
 * @returns {Array} Returns the slice of `array`.
 */
function baseSlice(array, start, end) {
  var index = -1,
      length = array.length;

  if (start < 0) {
    start = -start > length ? 0 : (length + start);
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : ((end - start) >>> 0);
  start >>>= 0;

  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}

/**
 * Casts `array` to a slice if it's needed.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {number} start The start position.
 * @param {number} [end=array.length] The end position.
 * @returns {Array} Returns the cast slice.
 */
function castSlice(array, start, end) {
  var length = array.length;
  end = end === undefined ? length : end;
  return (!start && end >= length) ? array : baseSlice(array, start, end);
}

/**
 * Used by `_.trim` and `_.trimEnd` to get the index of the last string symbol
 * that is not found in the character symbols.
 *
 * @private
 * @param {Array} strSymbols The string symbols to inspect.
 * @param {Array} chrSymbols The character symbols to find.
 * @returns {number} Returns the index of the last unmatched string symbol.
 */
function charsEndIndex(strSymbols, chrSymbols) {
  var index = strSymbols.length;

  while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
  return index;
}

/**
 * Used by `_.trim` and `_.trimStart` to get the index of the first string symbol
 * that is not found in the character symbols.
 *
 * @private
 * @param {Array} strSymbols The string symbols to inspect.
 * @param {Array} chrSymbols The character symbols to find.
 * @returns {number} Returns the index of the first unmatched string symbol.
 */
function charsStartIndex(strSymbols, chrSymbols) {
  var index = -1,
      length = strSymbols.length;

  while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
  return index;
}

/**
 * Converts an ASCII `string` to an array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the converted array.
 */
function asciiToArray(string) {
  return string.split('');
}

/** Used to compose unicode character classes. */
var rsAstralRange = '\\ud800-\\udfff';
var rsComboMarksRange = '\\u0300-\\u036f';
var reComboHalfMarksRange = '\\ufe20-\\ufe2f';
var rsComboSymbolsRange = '\\u20d0-\\u20ff';
var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
var rsVarRange = '\\ufe0e\\ufe0f';

/** Used to compose unicode capture groups. */
var rsZWJ = '\\u200d';

/** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');

/**
 * Checks if `string` contains Unicode symbols.
 *
 * @private
 * @param {string} string The string to inspect.
 * @returns {boolean} Returns `true` if a symbol is found, else `false`.
 */
function hasUnicode(string) {
  return reHasUnicode.test(string);
}

/** Used to compose unicode character classes. */
var rsAstralRange$1 = '\\ud800-\\udfff';
var rsComboMarksRange$1 = '\\u0300-\\u036f';
var reComboHalfMarksRange$1 = '\\ufe20-\\ufe2f';
var rsComboSymbolsRange$1 = '\\u20d0-\\u20ff';
var rsComboRange$1 = rsComboMarksRange$1 + reComboHalfMarksRange$1 + rsComboSymbolsRange$1;
var rsVarRange$1 = '\\ufe0e\\ufe0f';

/** Used to compose unicode capture groups. */
var rsAstral = '[' + rsAstralRange$1 + ']';
var rsCombo = '[' + rsComboRange$1 + ']';
var rsFitz = '\\ud83c[\\udffb-\\udfff]';
var rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')';
var rsNonAstral = '[^' + rsAstralRange$1 + ']';
var rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}';
var rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]';
var rsZWJ$1 = '\\u200d';

/** Used to compose unicode regexes. */
var reOptMod = rsModifier + '?';
var rsOptVar = '[' + rsVarRange$1 + ']?';
var rsOptJoin = '(?:' + rsZWJ$1 + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*';
var rsSeq = rsOptVar + reOptMod + rsOptJoin;
var rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

/** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

/**
 * Converts a Unicode `string` to an array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the converted array.
 */
function unicodeToArray(string) {
  return string.match(reUnicode) || [];
}

/**
 * Converts `string` to an array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the converted array.
 */
function stringToArray(string) {
  return hasUnicode(string)
    ? unicodeToArray(string)
    : asciiToArray(string);
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/**
 * Removes leading and trailing whitespace or specified characters from `string`.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category String
 * @param {string} [string=''] The string to trim.
 * @param {string} [chars=whitespace] The characters to trim.
 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
 * @returns {string} Returns the trimmed string.
 * @example
 *
 * _.trim('  abc  ');
 * // => 'abc'
 *
 * _.trim('-_-abc-_-', '_-');
 * // => 'abc'
 *
 * _.map(['  foo  ', '  bar  '], _.trim);
 * // => ['foo', 'bar']
 */
function trim(string, chars, guard) {
  string = toString(string);
  if (string && (guard || chars === undefined)) {
    return string.replace(reTrim, '');
  }
  if (!string || !(chars = baseToString(chars))) {
    return string;
  }
  var strSymbols = stringToArray(string),
      chrSymbols = stringToArray(chars),
      start = charsStartIndex(strSymbols, chrSymbols),
      end = charsEndIndex(strSymbols, chrSymbols) + 1;

  return castSlice(strSymbols, start, end).join('');
}

var FN_ARGS = /^(?:async\s+)?(function)?\s*[^\(]*\(\s*([^\)]*)\)/m;
var FN_ARG_SPLIT = /,/;
var FN_ARG = /(=.+)?(\s*)$/;
var STRIP_COMMENTS = /((\/\/.*$)|(\/\*[\s\S]*?\*\/))/mg;

function parseParams(func) {
    func = func.toString().replace(STRIP_COMMENTS, '');
    func = func.match(FN_ARGS)[2].replace(' ', '');
    func = func ? func.split(FN_ARG_SPLIT) : [];
    func = func.map(function (arg){
        return trim(arg.replace(FN_ARG, ''));
    });
    return func;
}

/**
 * A dependency-injected version of the [async.auto]{@link module:ControlFlow.auto} function. Dependent
 * tasks are specified as parameters to the function, after the usual callback
 * parameter, with the parameter names matching the names of the tasks it
 * depends on. This can provide even more readable task graphs which can be
 * easier to maintain.
 *
 * If a final callback is specified, the task results are similarly injected,
 * specified as named parameters after the initial error parameter.
 *
 * The autoInject function is purely syntactic sugar and its semantics are
 * otherwise equivalent to [async.auto]{@link module:ControlFlow.auto}.
 *
 * @name autoInject
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.auto]{@link module:ControlFlow.auto}
 * @category Control Flow
 * @param {Object} tasks - An object, each of whose properties is an {@link AsyncFunction} of
 * the form 'func([dependencies...], callback). The object's key of a property
 * serves as the name of the task defined by that property, i.e. can be used
 * when specifying requirements for other tasks.
 * * The `callback` parameter is a `callback(err, result)` which must be called
 *   when finished, passing an `error` (which can be `null`) and the result of
 *   the function's execution. The remaining parameters name other tasks on
 *   which the task is dependent, and the results from those tasks are the
 *   arguments of those parameters.
 * @param {Function} [callback] - An optional callback which is called when all
 * the tasks have been completed. It receives the `err` argument if any `tasks`
 * pass an error to their callback, and a `results` object with any completed
 * task results, similar to `auto`.
 * @example
 *
 * //  The example from `auto` can be rewritten as follows:
 * async.autoInject({
 *     get_data: function(callback) {
 *         // async code to get some data
 *         callback(null, 'data', 'converted to array');
 *     },
 *     make_folder: function(callback) {
 *         // async code to create a directory to store a file in
 *         // this is run at the same time as getting the data
 *         callback(null, 'folder');
 *     },
 *     write_file: function(get_data, make_folder, callback) {
 *         // once there is some data and the directory exists,
 *         // write the data to a file in the directory
 *         callback(null, 'filename');
 *     },
 *     email_link: function(write_file, callback) {
 *         // once the file is written let's email a link to it...
 *         // write_file contains the filename returned by write_file.
 *         callback(null, {'file':write_file, 'email':'user@example.com'});
 *     }
 * }, function(err, results) {
 *     console.log('err = ', err);
 *     console.log('email_link = ', results.email_link);
 * });
 *
 * // If you are using a JS minifier that mangles parameter names, `autoInject`
 * // will not work with plain functions, since the parameter names will be
 * // collapsed to a single letter identifier.  To work around this, you can
 * // explicitly specify the names of the parameters your task function needs
 * // in an array, similar to Angular.js dependency injection.
 *
 * // This still has an advantage over plain `auto`, since the results a task
 * // depends on are still spread into arguments.
 * async.autoInject({
 *     //...
 *     write_file: ['get_data', 'make_folder', function(get_data, make_folder, callback) {
 *         callback(null, 'filename');
 *     }],
 *     email_link: ['write_file', function(write_file, callback) {
 *         callback(null, {'file':write_file, 'email':'user@example.com'});
 *     }]
 *     //...
 * }, function(err, results) {
 *     console.log('err = ', err);
 *     console.log('email_link = ', results.email_link);
 * });
 */
function autoInject(tasks, callback) {
    var newTasks = {};

    baseForOwn(tasks, function (taskFn, key) {
        var params;
        var fnIsAsync = isAsync(taskFn);
        var hasNoDeps =
            (!fnIsAsync && taskFn.length === 1) ||
            (fnIsAsync && taskFn.length === 0);

        if (isArray(taskFn)) {
            params = taskFn.slice(0, -1);
            taskFn = taskFn[taskFn.length - 1];

            newTasks[key] = params.concat(params.length > 0 ? newTask : taskFn);
        } else if (hasNoDeps) {
            // no dependencies, use the function as-is
            newTasks[key] = taskFn;
        } else {
            params = parseParams(taskFn);
            if (taskFn.length === 0 && !fnIsAsync && params.length === 0) {
                throw new Error("autoInject task functions require explicit parameters.");
            }

            // remove callback param
            if (!fnIsAsync) params.pop();

            newTasks[key] = params.concat(newTask);
        }

        function newTask(results, taskCb) {
            var newArgs = arrayMap(params, function (name) {
                return results[name];
            });
            newArgs.push(taskCb);
            wrapAsync(taskFn).apply(null, newArgs);
        }
    });

    auto(newTasks, callback);
}

// Simple doubly linked list (https://en.wikipedia.org/wiki/Doubly_linked_list) implementation
// used for queues. This implementation assumes that the node provided by the user can be modified
// to adjust the next and last properties. We implement only the minimal functionality
// for queue support.
function DLL() {
    this.head = this.tail = null;
    this.length = 0;
}

function setInitial(dll, node) {
    dll.length = 1;
    dll.head = dll.tail = node;
}

DLL.prototype.removeLink = function(node) {
    if (node.prev) node.prev.next = node.next;
    else this.head = node.next;
    if (node.next) node.next.prev = node.prev;
    else this.tail = node.prev;

    node.prev = node.next = null;
    this.length -= 1;
    return node;
};

DLL.prototype.empty = function () {
    while(this.head) this.shift();
    return this;
};

DLL.prototype.insertAfter = function(node, newNode) {
    newNode.prev = node;
    newNode.next = node.next;
    if (node.next) node.next.prev = newNode;
    else this.tail = newNode;
    node.next = newNode;
    this.length += 1;
};

DLL.prototype.insertBefore = function(node, newNode) {
    newNode.prev = node.prev;
    newNode.next = node;
    if (node.prev) node.prev.next = newNode;
    else this.head = newNode;
    node.prev = newNode;
    this.length += 1;
};

DLL.prototype.unshift = function(node) {
    if (this.head) this.insertBefore(this.head, node);
    else setInitial(this, node);
};

DLL.prototype.push = function(node) {
    if (this.tail) this.insertAfter(this.tail, node);
    else setInitial(this, node);
};

DLL.prototype.shift = function() {
    return this.head && this.removeLink(this.head);
};

DLL.prototype.pop = function() {
    return this.tail && this.removeLink(this.tail);
};

DLL.prototype.toArray = function () {
    var arr = Array(this.length);
    var curr = this.head;
    for(var idx = 0; idx < this.length; idx++) {
        arr[idx] = curr.data;
        curr = curr.next;
    }
    return arr;
};

DLL.prototype.remove = function (testFn) {
    var curr = this.head;
    while(!!curr) {
        var next = curr.next;
        if (testFn(curr)) {
            this.removeLink(curr);
        }
        curr = next;
    }
    return this;
};

function queue(worker, concurrency, payload) {
    if (concurrency == null) {
        concurrency = 1;
    }
    else if(concurrency === 0) {
        throw new Error('Concurrency must not be zero');
    }

    var _worker = wrapAsync(worker);
    var numRunning = 0;
    var workersList = [];

    var processingScheduled = false;
    function _insert(data, insertAtFront, callback) {
        if (callback != null && typeof callback !== 'function') {
            throw new Error('task callback must be a function');
        }
        q.started = true;
        if (!isArray(data)) {
            data = [data];
        }
        if (data.length === 0 && q.idle()) {
            // call drain immediately if there are no tasks
            return setImmediate$1(function() {
                q.drain();
            });
        }

        for (var i = 0, l = data.length; i < l; i++) {
            var item = {
                data: data[i],
                callback: callback || noop
            };

            if (insertAtFront) {
                q._tasks.unshift(item);
            } else {
                q._tasks.push(item);
            }
        }

        if (!processingScheduled) {
            processingScheduled = true;
            setImmediate$1(function() {
                processingScheduled = false;
                q.process();
            });
        }
    }

    function _next(tasks) {
        return function(err){
            numRunning -= 1;

            for (var i = 0, l = tasks.length; i < l; i++) {
                var task = tasks[i];

                var index = baseIndexOf(workersList, task, 0);
                if (index === 0) {
                    workersList.shift();
                } else if (index > 0) {
                    workersList.splice(index, 1);
                }

                task.callback.apply(task, arguments);

                if (err != null) {
                    q.error(err, task.data);
                }
            }

            if (numRunning <= (q.concurrency - q.buffer) ) {
                q.unsaturated();
            }

            if (q.idle()) {
                q.drain();
            }
            q.process();
        };
    }

    var isProcessing = false;
    var q = {
        _tasks: new DLL(),
        concurrency: concurrency,
        payload: payload,
        saturated: noop,
        unsaturated:noop,
        buffer: concurrency / 4,
        empty: noop,
        drain: noop,
        error: noop,
        started: false,
        paused: false,
        push: function (data, callback) {
            _insert(data, false, callback);
        },
        kill: function () {
            q.drain = noop;
            q._tasks.empty();
        },
        unshift: function (data, callback) {
            _insert(data, true, callback);
        },
        remove: function (testFn) {
            q._tasks.remove(testFn);
        },
        process: function () {
            // Avoid trying to start too many processing operations. This can occur
            // when callbacks resolve synchronously (#1267).
            if (isProcessing) {
                return;
            }
            isProcessing = true;
            while(!q.paused && numRunning < q.concurrency && q._tasks.length){
                var tasks = [], data = [];
                var l = q._tasks.length;
                if (q.payload) l = Math.min(l, q.payload);
                for (var i = 0; i < l; i++) {
                    var node = q._tasks.shift();
                    tasks.push(node);
                    workersList.push(node);
                    data.push(node.data);
                }

                numRunning += 1;

                if (q._tasks.length === 0) {
                    q.empty();
                }

                if (numRunning === q.concurrency) {
                    q.saturated();
                }

                var cb = onlyOnce(_next(tasks));
                _worker(data, cb);
            }
            isProcessing = false;
        },
        length: function () {
            return q._tasks.length;
        },
        running: function () {
            return numRunning;
        },
        workersList: function () {
            return workersList;
        },
        idle: function() {
            return q._tasks.length + numRunning === 0;
        },
        pause: function () {
            q.paused = true;
        },
        resume: function () {
            if (q.paused === false) { return; }
            q.paused = false;
            setImmediate$1(q.process);
        }
    };
    return q;
}

/**
 * A cargo of tasks for the worker function to complete. Cargo inherits all of
 * the same methods and event callbacks as [`queue`]{@link module:ControlFlow.queue}.
 * @typedef {Object} CargoObject
 * @memberOf module:ControlFlow
 * @property {Function} length - A function returning the number of items
 * waiting to be processed. Invoke like `cargo.length()`.
 * @property {number} payload - An `integer` for determining how many tasks
 * should be process per round. This property can be changed after a `cargo` is
 * created to alter the payload on-the-fly.
 * @property {Function} push - Adds `task` to the `queue`. The callback is
 * called once the `worker` has finished processing the task. Instead of a
 * single task, an array of `tasks` can be submitted. The respective callback is
 * used for every task in the list. Invoke like `cargo.push(task, [callback])`.
 * @property {Function} saturated - A callback that is called when the
 * `queue.length()` hits the concurrency and further tasks will be queued.
 * @property {Function} empty - A callback that is called when the last item
 * from the `queue` is given to a `worker`.
 * @property {Function} drain - A callback that is called when the last item
 * from the `queue` has returned from the `worker`.
 * @property {Function} idle - a function returning false if there are items
 * waiting or being processed, or true if not. Invoke like `cargo.idle()`.
 * @property {Function} pause - a function that pauses the processing of tasks
 * until `resume()` is called. Invoke like `cargo.pause()`.
 * @property {Function} resume - a function that resumes the processing of
 * queued tasks when the queue is paused. Invoke like `cargo.resume()`.
 * @property {Function} kill - a function that removes the `drain` callback and
 * empties remaining tasks from the queue forcing it to go idle. Invoke like `cargo.kill()`.
 */

/**
 * Creates a `cargo` object with the specified payload. Tasks added to the
 * cargo will be processed altogether (up to the `payload` limit). If the
 * `worker` is in progress, the task is queued until it becomes available. Once
 * the `worker` has completed some tasks, each callback of those tasks is
 * called. Check out [these](https://camo.githubusercontent.com/6bbd36f4cf5b35a0f11a96dcd2e97711ffc2fb37/68747470733a2f2f662e636c6f75642e6769746875622e636f6d2f6173736574732f313637363837312f36383130382f62626330636662302d356632392d313165322d393734662d3333393763363464633835382e676966) [animations](https://camo.githubusercontent.com/f4810e00e1c5f5f8addbe3e9f49064fd5d102699/68747470733a2f2f662e636c6f75642e6769746875622e636f6d2f6173736574732f313637363837312f36383130312f38346339323036362d356632392d313165322d383134662d3964336430323431336266642e676966)
 * for how `cargo` and `queue` work.
 *
 * While [`queue`]{@link module:ControlFlow.queue} passes only one task to one of a group of workers
 * at a time, cargo passes an array of tasks to a single worker, repeating
 * when the worker is finished.
 *
 * @name cargo
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.queue]{@link module:ControlFlow.queue}
 * @category Control Flow
 * @param {AsyncFunction} worker - An asynchronous function for processing an array
 * of queued tasks. Invoked with `(tasks, callback)`.
 * @param {number} [payload=Infinity] - An optional `integer` for determining
 * how many tasks should be processed per round; if omitted, the default is
 * unlimited.
 * @returns {module:ControlFlow.CargoObject} A cargo object to manage the tasks. Callbacks can
 * attached as certain properties to listen for specific events during the
 * lifecycle of the cargo and inner queue.
 * @example
 *
 * // create a cargo object with payload 2
 * var cargo = async.cargo(function(tasks, callback) {
 *     for (var i=0; i<tasks.length; i++) {
 *         console.log('hello ' + tasks[i].name);
 *     }
 *     callback();
 * }, 2);
 *
 * // add some items
 * cargo.push({name: 'foo'}, function(err) {
 *     console.log('finished processing foo');
 * });
 * cargo.push({name: 'bar'}, function(err) {
 *     console.log('finished processing bar');
 * });
 * cargo.push({name: 'baz'}, function(err) {
 *     console.log('finished processing baz');
 * });
 */
function cargo(worker, payload) {
    return queue(worker, 1, payload);
}

/**
 * The same as [`eachOf`]{@link module:Collections.eachOf} but runs only a single async operation at a time.
 *
 * @name eachOfSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.eachOf]{@link module:Collections.eachOf}
 * @alias forEachOfSeries
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * Invoked with (item, key, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Invoked with (err).
 */
var eachOfSeries = doLimit(eachOfLimit, 1);

/**
 * Reduces `coll` into a single value using an async `iteratee` to return each
 * successive step. `memo` is the initial state of the reduction. This function
 * only operates in series.
 *
 * For performance reasons, it may make sense to split a call to this function
 * into a parallel map, and then use the normal `Array.prototype.reduce` on the
 * results. This function is for situations where each step in the reduction
 * needs to be async; if you can get the data before reducing it, then it's
 * probably a good idea to do so.
 *
 * @name reduce
 * @static
 * @memberOf module:Collections
 * @method
 * @alias inject
 * @alias foldl
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {*} memo - The initial state of the reduction.
 * @param {AsyncFunction} iteratee - A function applied to each item in the
 * array to produce the next step in the reduction.
 * The `iteratee` should complete with the next state of the reduction.
 * If the iteratee complete with an error, the reduction is stopped and the
 * main `callback` is immediately called with the error.
 * Invoked with (memo, item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Result is the reduced value. Invoked with
 * (err, result).
 * @example
 *
 * async.reduce([1,2,3], 0, function(memo, item, callback) {
 *     // pointless async:
 *     process.nextTick(function() {
 *         callback(null, memo + item)
 *     });
 * }, function(err, result) {
 *     // result is now equal to the last value of memo, which is 6
 * });
 */
function reduce(coll, memo, iteratee, callback) {
    callback = once(callback || noop);
    var _iteratee = wrapAsync(iteratee);
    eachOfSeries(coll, function(x, i, callback) {
        _iteratee(memo, x, function(err, v) {
            memo = v;
            callback(err);
        });
    }, function(err) {
        callback(err, memo);
    });
}

/**
 * Version of the compose function that is more natural to read. Each function
 * consumes the return value of the previous function. It is the equivalent of
 * [compose]{@link module:ControlFlow.compose} with the arguments reversed.
 *
 * Each function is executed with the `this` binding of the composed function.
 *
 * @name seq
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.compose]{@link module:ControlFlow.compose}
 * @category Control Flow
 * @param {...AsyncFunction} functions - the asynchronous functions to compose
 * @returns {Function} a function that composes the `functions` in order
 * @example
 *
 * // Requires lodash (or underscore), express3 and dresende's orm2.
 * // Part of an app, that fetches cats of the logged user.
 * // This example uses `seq` function to avoid overnesting and error
 * // handling clutter.
 * app.get('/cats', function(request, response) {
 *     var User = request.models.User;
 *     async.seq(
 *         _.bind(User.get, User),  // 'User.get' has signature (id, callback(err, data))
 *         function(user, fn) {
 *             user.getCats(fn);      // 'getCats' has signature (callback(err, data))
 *         }
 *     )(req.session.user_id, function (err, cats) {
 *         if (err) {
 *             console.error(err);
 *             response.json({ status: 'error', message: err.message });
 *         } else {
 *             response.json({ status: 'ok', message: 'Cats found', data: cats });
 *         }
 *     });
 * });
 */
function seq(/*...functions*/) {
    var _functions = arrayMap(arguments, wrapAsync);
    return function(/*...args*/) {
        var args = slice(arguments);
        var that = this;

        var cb = args[args.length - 1];
        if (typeof cb == 'function') {
            args.pop();
        } else {
            cb = noop;
        }

        reduce(_functions, args, function(newargs, fn, cb) {
            fn.apply(that, newargs.concat(function(err/*, ...nextargs*/) {
                var nextargs = slice(arguments, 1);
                cb(err, nextargs);
            }));
        },
        function(err, results) {
            cb.apply(that, [err].concat(results));
        });
    };
}

/**
 * Creates a function which is a composition of the passed asynchronous
 * functions. Each function consumes the return value of the function that
 * follows. Composing functions `f()`, `g()`, and `h()` would produce the result
 * of `f(g(h()))`, only this version uses callbacks to obtain the return values.
 *
 * Each function is executed with the `this` binding of the composed function.
 *
 * @name compose
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {...AsyncFunction} functions - the asynchronous functions to compose
 * @returns {Function} an asynchronous function that is the composed
 * asynchronous `functions`
 * @example
 *
 * function add1(n, callback) {
 *     setTimeout(function () {
 *         callback(null, n + 1);
 *     }, 10);
 * }
 *
 * function mul3(n, callback) {
 *     setTimeout(function () {
 *         callback(null, n * 3);
 *     }, 10);
 * }
 *
 * var add1mul3 = async.compose(mul3, add1);
 * add1mul3(4, function (err, result) {
 *     // result now equals 15
 * });
 */
var compose = function(/*...args*/) {
    return seq.apply(null, slice(arguments).reverse());
};

var _concat = Array.prototype.concat;

/**
 * The same as [`concat`]{@link module:Collections.concat} but runs a maximum of `limit` async operations at a time.
 *
 * @name concatLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.concat]{@link module:Collections.concat}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - A function to apply to each item in `coll`,
 * which should use an array as its result. Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished, or an error occurs. Results is an array
 * containing the concatenated results of the `iteratee` function. Invoked with
 * (err, results).
 */
var concatLimit = function(coll, limit, iteratee, callback) {
    callback = callback || noop;
    var _iteratee = wrapAsync(iteratee);
    mapLimit(coll, limit, function(val, callback) {
        _iteratee(val, function(err /*, ...args*/) {
            if (err) return callback(err);
            return callback(null, slice(arguments, 1));
        });
    }, function(err, mapResults) {
        var result = [];
        for (var i = 0; i < mapResults.length; i++) {
            if (mapResults[i]) {
                result = _concat.apply(result, mapResults[i]);
            }
        }

        return callback(err, result);
    });
};

/**
 * Applies `iteratee` to each item in `coll`, concatenating the results. Returns
 * the concatenated list. The `iteratee`s are called in parallel, and the
 * results are concatenated as they return. There is no guarantee that the
 * results array will be returned in the original order of `coll` passed to the
 * `iteratee` function.
 *
 * @name concat
 * @static
 * @memberOf module:Collections
 * @method
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A function to apply to each item in `coll`,
 * which should use an array as its result. Invoked with (item, callback).
 * @param {Function} [callback(err)] - A callback which is called after all the
 * `iteratee` functions have finished, or an error occurs. Results is an array
 * containing the concatenated results of the `iteratee` function. Invoked with
 * (err, results).
 * @example
 *
 * async.concat(['dir1','dir2','dir3'], fs.readdir, function(err, files) {
 *     // files is now a list of filenames that exist in the 3 directories
 * });
 */
var concat = doLimit(concatLimit, Infinity);

/**
 * The same as [`concat`]{@link module:Collections.concat} but runs only a single async operation at a time.
 *
 * @name concatSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.concat]{@link module:Collections.concat}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A function to apply to each item in `coll`.
 * The iteratee should complete with an array an array of results.
 * Invoked with (item, callback).
 * @param {Function} [callback(err)] - A callback which is called after all the
 * `iteratee` functions have finished, or an error occurs. Results is an array
 * containing the concatenated results of the `iteratee` function. Invoked with
 * (err, results).
 */
var concatSeries = doLimit(concatLimit, 1);

/**
 * Returns a function that when called, calls-back with the values provided.
 * Useful as the first function in a [`waterfall`]{@link module:ControlFlow.waterfall}, or for plugging values in to
 * [`auto`]{@link module:ControlFlow.auto}.
 *
 * @name constant
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {...*} arguments... - Any number of arguments to automatically invoke
 * callback with.
 * @returns {AsyncFunction} Returns a function that when invoked, automatically
 * invokes the callback with the previous given arguments.
 * @example
 *
 * async.waterfall([
 *     async.constant(42),
 *     function (value, next) {
 *         // value === 42
 *     },
 *     //...
 * ], callback);
 *
 * async.waterfall([
 *     async.constant(filename, "utf8"),
 *     fs.readFile,
 *     function (fileData, next) {
 *         //...
 *     }
 *     //...
 * ], callback);
 *
 * async.auto({
 *     hostname: async.constant("https://server.net/"),
 *     port: findFreePort,
 *     launchServer: ["hostname", "port", function (options, cb) {
 *         startServer(options, cb);
 *     }],
 *     //...
 * }, callback);
 */
var constant = function(/*...values*/) {
    var values = slice(arguments);
    var args = [null].concat(values);
    return function (/*...ignoredArgs, callback*/) {
        var callback = arguments[arguments.length - 1];
        return callback.apply(this, args);
    };
};

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

function _createTester(check, getResult) {
    return function(eachfn, arr, iteratee, cb) {
        cb = cb || noop;
        var testPassed = false;
        var testResult;
        eachfn(arr, function(value, _, callback) {
            iteratee(value, function(err, result) {
                if (err) {
                    callback(err);
                } else if (check(result) && !testResult) {
                    testPassed = true;
                    testResult = getResult(true, value);
                    callback(null, breakLoop);
                } else {
                    callback();
                }
            });
        }, function(err) {
            if (err) {
                cb(err);
            } else {
                cb(null, testPassed ? testResult : getResult(false));
            }
        });
    };
}

function _findGetResult(v, x) {
    return x;
}

/**
 * Returns the first value in `coll` that passes an async truth test. The
 * `iteratee` is applied in parallel, meaning the first iteratee to return
 * `true` will fire the detect `callback` with that result. That means the
 * result might not be the first item in the original `coll` (in terms of order)
 * that passes the test.

 * If order within the original `coll` is important, then look at
 * [`detectSeries`]{@link module:Collections.detectSeries}.
 *
 * @name detect
 * @static
 * @memberOf module:Collections
 * @method
 * @alias find
 * @category Collections
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A truth test to apply to each item in `coll`.
 * The iteratee must complete with a boolean value as its result.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called as soon as any
 * iteratee returns `true`, or after all the `iteratee` functions have finished.
 * Result will be the first item in the array that passes the truth test
 * (iteratee) or the value `undefined` if none passed. Invoked with
 * (err, result).
 * @example
 *
 * async.detect(['file1','file2','file3'], function(filePath, callback) {
 *     fs.access(filePath, function(err) {
 *         callback(null, !err)
 *     });
 * }, function(err, result) {
 *     // result now equals the first file in the list that exists
 * });
 */
var detect = doParallel(_createTester(identity, _findGetResult));

/**
 * The same as [`detect`]{@link module:Collections.detect} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name detectLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.detect]{@link module:Collections.detect}
 * @alias findLimit
 * @category Collections
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - A truth test to apply to each item in `coll`.
 * The iteratee must complete with a boolean value as its result.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called as soon as any
 * iteratee returns `true`, or after all the `iteratee` functions have finished.
 * Result will be the first item in the array that passes the truth test
 * (iteratee) or the value `undefined` if none passed. Invoked with
 * (err, result).
 */
var detectLimit = doParallelLimit(_createTester(identity, _findGetResult));

/**
 * The same as [`detect`]{@link module:Collections.detect} but runs only a single async operation at a time.
 *
 * @name detectSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.detect]{@link module:Collections.detect}
 * @alias findSeries
 * @category Collections
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A truth test to apply to each item in `coll`.
 * The iteratee must complete with a boolean value as its result.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called as soon as any
 * iteratee returns `true`, or after all the `iteratee` functions have finished.
 * Result will be the first item in the array that passes the truth test
 * (iteratee) or the value `undefined` if none passed. Invoked with
 * (err, result).
 */
var detectSeries = doLimit(detectLimit, 1);

function consoleFunc(name) {
    return function (fn/*, ...args*/) {
        var args = slice(arguments, 1);
        args.push(function (err/*, ...args*/) {
            var args = slice(arguments, 1);
            if (typeof console === 'object') {
                if (err) {
                    if (console.error) {
                        console.error(err);
                    }
                } else if (console[name]) {
                    arrayEach(args, function (x) {
                        console[name](x);
                    });
                }
            }
        });
        wrapAsync(fn).apply(null, args);
    };
}

/**
 * Logs the result of an [`async` function]{@link AsyncFunction} to the
 * `console` using `console.dir` to display the properties of the resulting object.
 * Only works in Node.js or in browsers that support `console.dir` and
 * `console.error` (such as FF and Chrome).
 * If multiple arguments are returned from the async function,
 * `console.dir` is called on each argument in order.
 *
 * @name dir
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {AsyncFunction} function - The function you want to eventually apply
 * all arguments to.
 * @param {...*} arguments... - Any number of arguments to apply to the function.
 * @example
 *
 * // in a module
 * var hello = function(name, callback) {
 *     setTimeout(function() {
 *         callback(null, {hello: name});
 *     }, 1000);
 * };
 *
 * // in the node repl
 * node> async.dir(hello, 'world');
 * {hello: 'world'}
 */
var dir = consoleFunc('dir');

/**
 * The post-check version of [`during`]{@link module:ControlFlow.during}. To reflect the difference in
 * the order of operations, the arguments `test` and `fn` are switched.
 *
 * Also a version of [`doWhilst`]{@link module:ControlFlow.doWhilst} with asynchronous `test` function.
 * @name doDuring
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.during]{@link module:ControlFlow.during}
 * @category Control Flow
 * @param {AsyncFunction} fn - An async function which is called each time
 * `test` passes. Invoked with (callback).
 * @param {AsyncFunction} test - asynchronous truth test to perform before each
 * execution of `fn`. Invoked with (...args, callback), where `...args` are the
 * non-error args from the previous callback of `fn`.
 * @param {Function} [callback] - A callback which is called after the test
 * function has failed and repeated execution of `fn` has stopped. `callback`
 * will be passed an error if one occurred, otherwise `null`.
 */
function doDuring(fn, test, callback) {
    callback = onlyOnce(callback || noop);
    var _fn = wrapAsync(fn);
    var _test = wrapAsync(test);

    function next(err/*, ...args*/) {
        if (err) return callback(err);
        var args = slice(arguments, 1);
        args.push(check);
        _test.apply(this, args);
    }

    function check(err, truth) {
        if (err) return callback(err);
        if (!truth) return callback(null);
        _fn(next);
    }

    check(null, true);

}

/**
 * The post-check version of [`whilst`]{@link module:ControlFlow.whilst}. To reflect the difference in
 * the order of operations, the arguments `test` and `iteratee` are switched.
 *
 * `doWhilst` is to `whilst` as `do while` is to `while` in plain JavaScript.
 *
 * @name doWhilst
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.whilst]{@link module:ControlFlow.whilst}
 * @category Control Flow
 * @param {AsyncFunction} iteratee - A function which is called each time `test`
 * passes. Invoked with (callback).
 * @param {Function} test - synchronous truth test to perform after each
 * execution of `iteratee`. Invoked with any non-error callback results of
 * `iteratee`.
 * @param {Function} [callback] - A callback which is called after the test
 * function has failed and repeated execution of `iteratee` has stopped.
 * `callback` will be passed an error and any arguments passed to the final
 * `iteratee`'s callback. Invoked with (err, [results]);
 */
function doWhilst(iteratee, test, callback) {
    callback = onlyOnce(callback || noop);
    var _iteratee = wrapAsync(iteratee);
    var next = function(err/*, ...args*/) {
        if (err) return callback(err);
        var args = slice(arguments, 1);
        if (test.apply(this, args)) return _iteratee(next);
        callback.apply(null, [null].concat(args));
    };
    _iteratee(next);
}

/**
 * Like ['doWhilst']{@link module:ControlFlow.doWhilst}, except the `test` is inverted. Note the
 * argument ordering differs from `until`.
 *
 * @name doUntil
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.doWhilst]{@link module:ControlFlow.doWhilst}
 * @category Control Flow
 * @param {AsyncFunction} iteratee - An async function which is called each time
 * `test` fails. Invoked with (callback).
 * @param {Function} test - synchronous truth test to perform after each
 * execution of `iteratee`. Invoked with any non-error callback results of
 * `iteratee`.
 * @param {Function} [callback] - A callback which is called after the test
 * function has passed and repeated execution of `iteratee` has stopped. `callback`
 * will be passed an error and any arguments passed to the final `iteratee`'s
 * callback. Invoked with (err, [results]);
 */
function doUntil(iteratee, test, callback) {
    doWhilst(iteratee, function() {
        return !test.apply(this, arguments);
    }, callback);
}

/**
 * Like [`whilst`]{@link module:ControlFlow.whilst}, except the `test` is an asynchronous function that
 * is passed a callback in the form of `function (err, truth)`. If error is
 * passed to `test` or `fn`, the main callback is immediately called with the
 * value of the error.
 *
 * @name during
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.whilst]{@link module:ControlFlow.whilst}
 * @category Control Flow
 * @param {AsyncFunction} test - asynchronous truth test to perform before each
 * execution of `fn`. Invoked with (callback).
 * @param {AsyncFunction} fn - An async function which is called each time
 * `test` passes. Invoked with (callback).
 * @param {Function} [callback] - A callback which is called after the test
 * function has failed and repeated execution of `fn` has stopped. `callback`
 * will be passed an error, if one occurred, otherwise `null`.
 * @example
 *
 * var count = 0;
 *
 * async.during(
 *     function (callback) {
 *         return callback(null, count < 5);
 *     },
 *     function (callback) {
 *         count++;
 *         setTimeout(callback, 1000);
 *     },
 *     function (err) {
 *         // 5 seconds have passed
 *     }
 * );
 */
function during(test, fn, callback) {
    callback = onlyOnce(callback || noop);
    var _fn = wrapAsync(fn);
    var _test = wrapAsync(test);

    function next(err) {
        if (err) return callback(err);
        _test(check);
    }

    function check(err, truth) {
        if (err) return callback(err);
        if (!truth) return callback(null);
        _fn(next);
    }

    _test(check);
}

function _withoutIndex(iteratee) {
    return function (value, index, callback) {
        return iteratee(value, callback);
    };
}

/**
 * Applies the function `iteratee` to each item in `coll`, in parallel.
 * The `iteratee` is called with an item from the list, and a callback for when
 * it has finished. If the `iteratee` passes an error to its `callback`, the
 * main `callback` (for the `each` function) is immediately called with the
 * error.
 *
 * Note, that since this function applies `iteratee` to each item in parallel,
 * there is no guarantee that the iteratee functions will complete in order.
 *
 * @name each
 * @static
 * @memberOf module:Collections
 * @method
 * @alias forEach
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to
 * each item in `coll`. Invoked with (item, callback).
 * The array index is not passed to the iteratee.
 * If you need the index, use `eachOf`.
 * @param {Function} [callback] - A callback which is called when all
 * `iteratee` functions have finished, or an error occurs. Invoked with (err).
 * @example
 *
 * // assuming openFiles is an array of file names and saveFile is a function
 * // to save the modified contents of that file:
 *
 * async.each(openFiles, saveFile, function(err){
 *   // if any of the saves produced an error, err would equal that error
 * });
 *
 * // assuming openFiles is an array of file names
 * async.each(openFiles, function(file, callback) {
 *
 *     // Perform operation on file here.
 *     console.log('Processing file ' + file);
 *
 *     if( file.length > 32 ) {
 *       console.log('This file name is too long');
 *       callback('File name too long');
 *     } else {
 *       // Do work to process file here
 *       console.log('File processed');
 *       callback();
 *     }
 * }, function(err) {
 *     // if any of the file processing produced an error, err would equal that error
 *     if( err ) {
 *       // One of the iterations produced an error.
 *       // All processing will now stop.
 *       console.log('A file failed to process');
 *     } else {
 *       console.log('All files have been processed successfully');
 *     }
 * });
 */
function eachLimit(coll, iteratee, callback) {
    eachOf(coll, _withoutIndex(wrapAsync(iteratee)), callback);
}

/**
 * The same as [`each`]{@link module:Collections.each} but runs a maximum of `limit` async operations at a time.
 *
 * @name eachLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.each]{@link module:Collections.each}
 * @alias forEachLimit
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The array index is not passed to the iteratee.
 * If you need the index, use `eachOfLimit`.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called when all
 * `iteratee` functions have finished, or an error occurs. Invoked with (err).
 */
function eachLimit$1(coll, limit, iteratee, callback) {
    _eachOfLimit(limit)(coll, _withoutIndex(wrapAsync(iteratee)), callback);
}

/**
 * The same as [`each`]{@link module:Collections.each} but runs only a single async operation at a time.
 *
 * @name eachSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.each]{@link module:Collections.each}
 * @alias forEachSeries
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to each
 * item in `coll`.
 * The array index is not passed to the iteratee.
 * If you need the index, use `eachOfSeries`.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called when all
 * `iteratee` functions have finished, or an error occurs. Invoked with (err).
 */
var eachSeries = doLimit(eachLimit$1, 1);

/**
 * Wrap an async function and ensure it calls its callback on a later tick of
 * the event loop.  If the function already calls its callback on a next tick,
 * no extra deferral is added. This is useful for preventing stack overflows
 * (`RangeError: Maximum call stack size exceeded`) and generally keeping
 * [Zalgo](http://blog.izs.me/post/59142742143/designing-apis-for-asynchrony)
 * contained. ES2017 `async` functions are returned as-is -- they are immune
 * to Zalgo's corrupting influences, as they always resolve on a later tick.
 *
 * @name ensureAsync
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {AsyncFunction} fn - an async function, one that expects a node-style
 * callback as its last argument.
 * @returns {AsyncFunction} Returns a wrapped function with the exact same call
 * signature as the function passed in.
 * @example
 *
 * function sometimesAsync(arg, callback) {
 *     if (cache[arg]) {
 *         return callback(null, cache[arg]); // this would be synchronous!!
 *     } else {
 *         doSomeIO(arg, callback); // this IO would be asynchronous
 *     }
 * }
 *
 * // this has a risk of stack overflows if many results are cached in a row
 * async.mapSeries(args, sometimesAsync, done);
 *
 * // this will defer sometimesAsync's callback if necessary,
 * // preventing stack overflows
 * async.mapSeries(args, async.ensureAsync(sometimesAsync), done);
 */
function ensureAsync(fn) {
    if (isAsync(fn)) return fn;
    return initialParams(function (args, callback) {
        var sync = true;
        args.push(function () {
            var innerArgs = arguments;
            if (sync) {
                setImmediate$1(function () {
                    callback.apply(null, innerArgs);
                });
            } else {
                callback.apply(null, innerArgs);
            }
        });
        fn.apply(this, args);
        sync = false;
    });
}

function notId(v) {
    return !v;
}

/**
 * Returns `true` if every element in `coll` satisfies an async test. If any
 * iteratee call returns `false`, the main `callback` is immediately called.
 *
 * @name every
 * @static
 * @memberOf module:Collections
 * @method
 * @alias all
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async truth test to apply to each item
 * in the collection in parallel.
 * The iteratee must complete with a boolean result value.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Result will be either `true` or `false`
 * depending on the values of the async tests. Invoked with (err, result).
 * @example
 *
 * async.every(['file1','file2','file3'], function(filePath, callback) {
 *     fs.access(filePath, function(err) {
 *         callback(null, !err)
 *     });
 * }, function(err, result) {
 *     // if result is true then every file exists
 * });
 */
var every = doParallel(_createTester(notId, notId));

/**
 * The same as [`every`]{@link module:Collections.every} but runs a maximum of `limit` async operations at a time.
 *
 * @name everyLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.every]{@link module:Collections.every}
 * @alias allLimit
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async truth test to apply to each item
 * in the collection in parallel.
 * The iteratee must complete with a boolean result value.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Result will be either `true` or `false`
 * depending on the values of the async tests. Invoked with (err, result).
 */
var everyLimit = doParallelLimit(_createTester(notId, notId));

/**
 * The same as [`every`]{@link module:Collections.every} but runs only a single async operation at a time.
 *
 * @name everySeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.every]{@link module:Collections.every}
 * @alias allSeries
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async truth test to apply to each item
 * in the collection in series.
 * The iteratee must complete with a boolean result value.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Result will be either `true` or `false`
 * depending on the values of the async tests. Invoked with (err, result).
 */
var everySeries = doLimit(everyLimit, 1);

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

function filterArray(eachfn, arr, iteratee, callback) {
    var truthValues = new Array(arr.length);
    eachfn(arr, function (x, index, callback) {
        iteratee(x, function (err, v) {
            truthValues[index] = !!v;
            callback(err);
        });
    }, function (err) {
        if (err) return callback(err);
        var results = [];
        for (var i = 0; i < arr.length; i++) {
            if (truthValues[i]) results.push(arr[i]);
        }
        callback(null, results);
    });
}

function filterGeneric(eachfn, coll, iteratee, callback) {
    var results = [];
    eachfn(coll, function (x, index, callback) {
        iteratee(x, function (err, v) {
            if (err) {
                callback(err);
            } else {
                if (v) {
                    results.push({index: index, value: x});
                }
                callback();
            }
        });
    }, function (err) {
        if (err) {
            callback(err);
        } else {
            callback(null, arrayMap(results.sort(function (a, b) {
                return a.index - b.index;
            }), baseProperty('value')));
        }
    });
}

function _filter(eachfn, coll, iteratee, callback) {
    var filter = isArrayLike(coll) ? filterArray : filterGeneric;
    filter(eachfn, coll, wrapAsync(iteratee), callback || noop);
}

/**
 * Returns a new array of all the values in `coll` which pass an async truth
 * test. This operation is performed in parallel, but the results array will be
 * in the same order as the original.
 *
 * @name filter
 * @static
 * @memberOf module:Collections
 * @method
 * @alias select
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {Function} iteratee - A truth test to apply to each item in `coll`.
 * The `iteratee` is passed a `callback(err, truthValue)`, which must be called
 * with a boolean argument once it has completed. Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Invoked with (err, results).
 * @example
 *
 * async.filter(['file1','file2','file3'], function(filePath, callback) {
 *     fs.access(filePath, function(err) {
 *         callback(null, !err)
 *     });
 * }, function(err, results) {
 *     // results now equals an array of the existing files
 * });
 */
var filter = doParallel(_filter);

/**
 * The same as [`filter`]{@link module:Collections.filter} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name filterLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.filter]{@link module:Collections.filter}
 * @alias selectLimit
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {Function} iteratee - A truth test to apply to each item in `coll`.
 * The `iteratee` is passed a `callback(err, truthValue)`, which must be called
 * with a boolean argument once it has completed. Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Invoked with (err, results).
 */
var filterLimit = doParallelLimit(_filter);

/**
 * The same as [`filter`]{@link module:Collections.filter} but runs only a single async operation at a time.
 *
 * @name filterSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.filter]{@link module:Collections.filter}
 * @alias selectSeries
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {Function} iteratee - A truth test to apply to each item in `coll`.
 * The `iteratee` is passed a `callback(err, truthValue)`, which must be called
 * with a boolean argument once it has completed. Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Invoked with (err, results)
 */
var filterSeries = doLimit(filterLimit, 1);

/**
 * Calls the asynchronous function `fn` with a callback parameter that allows it
 * to call itself again, in series, indefinitely.

 * If an error is passed to the callback then `errback` is called with the
 * error, and execution stops, otherwise it will never be called.
 *
 * @name forever
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {AsyncFunction} fn - an async function to call repeatedly.
 * Invoked with (next).
 * @param {Function} [errback] - when `fn` passes an error to it's callback,
 * this function will be called, and execution stops. Invoked with (err).
 * @example
 *
 * async.forever(
 *     function(next) {
 *         // next is suitable for passing to things that need a callback(err [, whatever]);
 *         // it will result in this function being called again.
 *     },
 *     function(err) {
 *         // if next is called with a value in its first parameter, it will appear
 *         // in here as 'err', and execution will stop.
 *     }
 * );
 */
function forever(fn, errback) {
    var done = onlyOnce(errback || noop);
    var task = wrapAsync(ensureAsync(fn));

    function next(err) {
        if (err) return done(err);
        task(next);
    }
    next();
}

/**
 * The same as [`groupBy`]{@link module:Collections.groupBy} but runs a maximum of `limit` async operations at a time.
 *
 * @name groupByLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.groupBy]{@link module:Collections.groupBy}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with a `key` to group the value under.
 * Invoked with (value, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Result is an `Object` whoses
 * properties are arrays of values which returned the corresponding key.
 */
var groupByLimit = function(coll, limit, iteratee, callback) {
    callback = callback || noop;
    var _iteratee = wrapAsync(iteratee);
    mapLimit(coll, limit, function(val, callback) {
        _iteratee(val, function(err, key) {
            if (err) return callback(err);
            return callback(null, {key: key, val: val});
        });
    }, function(err, mapResults) {
        var result = {};
        // from MDN, handle object having an `hasOwnProperty` prop
        var hasOwnProperty = Object.prototype.hasOwnProperty;

        for (var i = 0; i < mapResults.length; i++) {
            if (mapResults[i]) {
                var key = mapResults[i].key;
                var val = mapResults[i].val;

                if (hasOwnProperty.call(result, key)) {
                    result[key].push(val);
                } else {
                    result[key] = [val];
                }
            }
        }

        return callback(err, result);
    });
};

/**
 * Returns a new object, where each value corresponds to an array of items, from
 * `coll`, that returned the corresponding key. That is, the keys of the object
 * correspond to the values passed to the `iteratee` callback.
 *
 * Note: Since this function applies the `iteratee` to each item in parallel,
 * there is no guarantee that the `iteratee` functions will complete in order.
 * However, the values for each key in the `result` will be in the same order as
 * the original `coll`. For Objects, the values will roughly be in the order of
 * the original Objects' keys (but this can vary across JavaScript engines).
 *
 * @name groupBy
 * @static
 * @memberOf module:Collections
 * @method
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with a `key` to group the value under.
 * Invoked with (value, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Result is an `Object` whoses
 * properties are arrays of values which returned the corresponding key.
 * @example
 *
 * async.groupBy(['userId1', 'userId2', 'userId3'], function(userId, callback) {
 *     db.findById(userId, function(err, user) {
 *         if (err) return callback(err);
 *         return callback(null, user.age);
 *     });
 * }, function(err, result) {
 *     // result is object containing the userIds grouped by age
 *     // e.g. { 30: ['userId1', 'userId3'], 42: ['userId2']};
 * });
 */
var groupBy = doLimit(groupByLimit, Infinity);

/**
 * The same as [`groupBy`]{@link module:Collections.groupBy} but runs only a single async operation at a time.
 *
 * @name groupBySeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.groupBy]{@link module:Collections.groupBy}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with a `key` to group the value under.
 * Invoked with (value, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. Result is an `Object` whoses
 * properties are arrays of values which returned the corresponding key.
 */
var groupBySeries = doLimit(groupByLimit, 1);

/**
 * Logs the result of an `async` function to the `console`. Only works in
 * Node.js or in browsers that support `console.log` and `console.error` (such
 * as FF and Chrome). If multiple arguments are returned from the async
 * function, `console.log` is called on each argument in order.
 *
 * @name log
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {AsyncFunction} function - The function you want to eventually apply
 * all arguments to.
 * @param {...*} arguments... - Any number of arguments to apply to the function.
 * @example
 *
 * // in a module
 * var hello = function(name, callback) {
 *     setTimeout(function() {
 *         callback(null, 'hello ' + name);
 *     }, 1000);
 * };
 *
 * // in the node repl
 * node> async.log(hello, 'world');
 * 'hello world'
 */
var log = consoleFunc('log');

/**
 * The same as [`mapValues`]{@link module:Collections.mapValues} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name mapValuesLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.mapValues]{@link module:Collections.mapValues}
 * @category Collection
 * @param {Object} obj - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - A function to apply to each value and key
 * in `coll`.
 * The iteratee should complete with the transformed value as its result.
 * Invoked with (value, key, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. `result` is a new object consisting
 * of each key from `obj`, with each transformed value on the right-hand side.
 * Invoked with (err, result).
 */
function mapValuesLimit(obj, limit, iteratee, callback) {
    callback = once(callback || noop);
    var newObj = {};
    var _iteratee = wrapAsync(iteratee);
    eachOfLimit(obj, limit, function(val, key, next) {
        _iteratee(val, key, function (err, result) {
            if (err) return next(err);
            newObj[key] = result;
            next();
        });
    }, function (err) {
        callback(err, newObj);
    });
}

/**
 * A relative of [`map`]{@link module:Collections.map}, designed for use with objects.
 *
 * Produces a new Object by mapping each value of `obj` through the `iteratee`
 * function. The `iteratee` is called each `value` and `key` from `obj` and a
 * callback for when it has finished processing. Each of these callbacks takes
 * two arguments: an `error`, and the transformed item from `obj`. If `iteratee`
 * passes an error to its callback, the main `callback` (for the `mapValues`
 * function) is immediately called with the error.
 *
 * Note, the order of the keys in the result is not guaranteed.  The keys will
 * be roughly in the order they complete, (but this is very engine-specific)
 *
 * @name mapValues
 * @static
 * @memberOf module:Collections
 * @method
 * @category Collection
 * @param {Object} obj - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A function to apply to each value and key
 * in `coll`.
 * The iteratee should complete with the transformed value as its result.
 * Invoked with (value, key, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. `result` is a new object consisting
 * of each key from `obj`, with each transformed value on the right-hand side.
 * Invoked with (err, result).
 * @example
 *
 * async.mapValues({
 *     f1: 'file1',
 *     f2: 'file2',
 *     f3: 'file3'
 * }, function (file, key, callback) {
 *   fs.stat(file, callback);
 * }, function(err, result) {
 *     // result is now a map of stats for each file, e.g.
 *     // {
 *     //     f1: [stats for file1],
 *     //     f2: [stats for file2],
 *     //     f3: [stats for file3]
 *     // }
 * });
 */

var mapValues = doLimit(mapValuesLimit, Infinity);

/**
 * The same as [`mapValues`]{@link module:Collections.mapValues} but runs only a single async operation at a time.
 *
 * @name mapValuesSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.mapValues]{@link module:Collections.mapValues}
 * @category Collection
 * @param {Object} obj - A collection to iterate over.
 * @param {AsyncFunction} iteratee - A function to apply to each value and key
 * in `coll`.
 * The iteratee should complete with the transformed value as its result.
 * Invoked with (value, key, callback).
 * @param {Function} [callback] - A callback which is called when all `iteratee`
 * functions have finished, or an error occurs. `result` is a new object consisting
 * of each key from `obj`, with each transformed value on the right-hand side.
 * Invoked with (err, result).
 */
var mapValuesSeries = doLimit(mapValuesLimit, 1);

function has(obj, key) {
    return key in obj;
}

/**
 * Caches the results of an async function. When creating a hash to store
 * function results against, the callback is omitted from the hash and an
 * optional hash function can be used.
 *
 * If no hash function is specified, the first argument is used as a hash key,
 * which may work reasonably if it is a string or a data type that converts to a
 * distinct string. Note that objects and arrays will not behave reasonably.
 * Neither will cases where the other arguments are significant. In such cases,
 * specify your own hash function.
 *
 * The cache of results is exposed as the `memo` property of the function
 * returned by `memoize`.
 *
 * @name memoize
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {AsyncFunction} fn - The async function to proxy and cache results from.
 * @param {Function} hasher - An optional function for generating a custom hash
 * for storing results. It has all the arguments applied to it apart from the
 * callback, and must be synchronous.
 * @returns {AsyncFunction} a memoized version of `fn`
 * @example
 *
 * var slow_fn = function(name, callback) {
 *     // do something
 *     callback(null, result);
 * };
 * var fn = async.memoize(slow_fn);
 *
 * // fn can now be used as if it were slow_fn
 * fn('some name', function() {
 *     // callback
 * });
 */
function memoize(fn, hasher) {
    var memo = Object.create(null);
    var queues = Object.create(null);
    hasher = hasher || identity;
    var _fn = wrapAsync(fn);
    var memoized = initialParams(function memoized(args, callback) {
        var key = hasher.apply(null, args);
        if (has(memo, key)) {
            setImmediate$1(function() {
                callback.apply(null, memo[key]);
            });
        } else if (has(queues, key)) {
            queues[key].push(callback);
        } else {
            queues[key] = [callback];
            _fn.apply(null, args.concat(function(/*args*/) {
                var args = slice(arguments);
                memo[key] = args;
                var q = queues[key];
                delete queues[key];
                for (var i = 0, l = q.length; i < l; i++) {
                    q[i].apply(null, args);
                }
            }));
        }
    });
    memoized.memo = memo;
    memoized.unmemoized = fn;
    return memoized;
}

/**
 * Calls `callback` on a later loop around the event loop. In Node.js this just
 * calls `process.nextTicl`.  In the browser it will use `setImmediate` if
 * available, otherwise `setTimeout(callback, 0)`, which means other higher
 * priority events may precede the execution of `callback`.
 *
 * This is used internally for browser-compatibility purposes.
 *
 * @name nextTick
 * @static
 * @memberOf module:Utils
 * @method
 * @see [async.setImmediate]{@link module:Utils.setImmediate}
 * @category Util
 * @param {Function} callback - The function to call on a later loop around
 * the event loop. Invoked with (args...).
 * @param {...*} args... - any number of additional arguments to pass to the
 * callback on the next tick.
 * @example
 *
 * var call_order = [];
 * async.nextTick(function() {
 *     call_order.push('two');
 *     // call_order now equals ['one','two']
 * });
 * call_order.push('one');
 *
 * async.setImmediate(function (a, b, c) {
 *     // a, b, and c equal 1, 2, and 3
 * }, 1, 2, 3);
 */
var _defer$1;

if (hasNextTick) {
    _defer$1 = process.nextTick;
} else if (hasSetImmediate) {
    _defer$1 = setImmediate;
} else {
    _defer$1 = fallback;
}

var nextTick = wrap(_defer$1);

function _parallel(eachfn, tasks, callback) {
    callback = callback || noop;
    var results = isArrayLike(tasks) ? [] : {};

    eachfn(tasks, function (task, key, callback) {
        wrapAsync(task)(function (err, result) {
            if (arguments.length > 2) {
                result = slice(arguments, 1);
            }
            results[key] = result;
            callback(err);
        });
    }, function (err) {
        callback(err, results);
    });
}

/**
 * Run the `tasks` collection of functions in parallel, without waiting until
 * the previous function has completed. If any of the functions pass an error to
 * its callback, the main `callback` is immediately called with the value of the
 * error. Once the `tasks` have completed, the results are passed to the final
 * `callback` as an array.
 *
 * **Note:** `parallel` is about kicking-off I/O tasks in parallel, not about
 * parallel execution of code.  If your tasks do not use any timers or perform
 * any I/O, they will actually be executed in series.  Any synchronous setup
 * sections for each task will happen one after the other.  JavaScript remains
 * single-threaded.
 *
 * **Hint:** Use [`reflect`]{@link module:Utils.reflect} to continue the
 * execution of other tasks when a task fails.
 *
 * It is also possible to use an object instead of an array. Each property will
 * be run as a function and the results will be passed to the final `callback`
 * as an object instead of an array. This can be a more readable way of handling
 * results from {@link async.parallel}.
 *
 * @name parallel
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Array|Iterable|Object} tasks - A collection of
 * [async functions]{@link AsyncFunction} to run.
 * Each async function can complete with any number of optional `result` values.
 * @param {Function} [callback] - An optional callback to run once all the
 * functions have completed successfully. This function gets a results array
 * (or object) containing all the result arguments passed to the task callbacks.
 * Invoked with (err, results).
 *
 * @example
 * async.parallel([
 *     function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'one');
 *         }, 200);
 *     },
 *     function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'two');
 *         }, 100);
 *     }
 * ],
 * // optional callback
 * function(err, results) {
 *     // the results array will equal ['one','two'] even though
 *     // the second function had a shorter timeout.
 * });
 *
 * // an example using an object instead of an array
 * async.parallel({
 *     one: function(callback) {
 *         setTimeout(function() {
 *             callback(null, 1);
 *         }, 200);
 *     },
 *     two: function(callback) {
 *         setTimeout(function() {
 *             callback(null, 2);
 *         }, 100);
 *     }
 * }, function(err, results) {
 *     // results is now equals to: {one: 1, two: 2}
 * });
 */
function parallelLimit(tasks, callback) {
    _parallel(eachOf, tasks, callback);
}

/**
 * The same as [`parallel`]{@link module:ControlFlow.parallel} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name parallelLimit
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.parallel]{@link module:ControlFlow.parallel}
 * @category Control Flow
 * @param {Array|Iterable|Object} tasks - A collection of
 * [async functions]{@link AsyncFunction} to run.
 * Each async function can complete with any number of optional `result` values.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {Function} [callback] - An optional callback to run once all the
 * functions have completed successfully. This function gets a results array
 * (or object) containing all the result arguments passed to the task callbacks.
 * Invoked with (err, results).
 */
function parallelLimit$1(tasks, limit, callback) {
    _parallel(_eachOfLimit(limit), tasks, callback);
}

/**
 * A queue of tasks for the worker function to complete.
 * @typedef {Object} QueueObject
 * @memberOf module:ControlFlow
 * @property {Function} length - a function returning the number of items
 * waiting to be processed. Invoke with `queue.length()`.
 * @property {boolean} started - a boolean indicating whether or not any
 * items have been pushed and processed by the queue.
 * @property {Function} running - a function returning the number of items
 * currently being processed. Invoke with `queue.running()`.
 * @property {Function} workersList - a function returning the array of items
 * currently being processed. Invoke with `queue.workersList()`.
 * @property {Function} idle - a function returning false if there are items
 * waiting or being processed, or true if not. Invoke with `queue.idle()`.
 * @property {number} concurrency - an integer for determining how many `worker`
 * functions should be run in parallel. This property can be changed after a
 * `queue` is created to alter the concurrency on-the-fly.
 * @property {Function} push - add a new task to the `queue`. Calls `callback`
 * once the `worker` has finished processing the task. Instead of a single task,
 * a `tasks` array can be submitted. The respective callback is used for every
 * task in the list. Invoke with `queue.push(task, [callback])`,
 * @property {Function} unshift - add a new task to the front of the `queue`.
 * Invoke with `queue.unshift(task, [callback])`.
 * @property {Function} remove - remove items from the queue that match a test
 * function.  The test function will be passed an object with a `data` property,
 * and a `priority` property, if this is a
 * [priorityQueue]{@link module:ControlFlow.priorityQueue} object.
 * Invoked with `queue.remove(testFn)`, where `testFn` is of the form
 * `function ({data, priority}) {}` and returns a Boolean.
 * @property {Function} saturated - a callback that is called when the number of
 * running workers hits the `concurrency` limit, and further tasks will be
 * queued.
 * @property {Function} unsaturated - a callback that is called when the number
 * of running workers is less than the `concurrency` & `buffer` limits, and
 * further tasks will not be queued.
 * @property {number} buffer - A minimum threshold buffer in order to say that
 * the `queue` is `unsaturated`.
 * @property {Function} empty - a callback that is called when the last item
 * from the `queue` is given to a `worker`.
 * @property {Function} drain - a callback that is called when the last item
 * from the `queue` has returned from the `worker`.
 * @property {Function} error - a callback that is called when a task errors.
 * Has the signature `function(error, task)`.
 * @property {boolean} paused - a boolean for determining whether the queue is
 * in a paused state.
 * @property {Function} pause - a function that pauses the processing of tasks
 * until `resume()` is called. Invoke with `queue.pause()`.
 * @property {Function} resume - a function that resumes the processing of
 * queued tasks when the queue is paused. Invoke with `queue.resume()`.
 * @property {Function} kill - a function that removes the `drain` callback and
 * empties remaining tasks from the queue forcing it to go idle. No more tasks
 * should be pushed to the queue after calling this function. Invoke with `queue.kill()`.
 */

/**
 * Creates a `queue` object with the specified `concurrency`. Tasks added to the
 * `queue` are processed in parallel (up to the `concurrency` limit). If all
 * `worker`s are in progress, the task is queued until one becomes available.
 * Once a `worker` completes a `task`, that `task`'s callback is called.
 *
 * @name queue
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {AsyncFunction} worker - An async function for processing a queued task.
 * If you want to handle errors from an individual task, pass a callback to
 * `q.push()`. Invoked with (task, callback).
 * @param {number} [concurrency=1] - An `integer` for determining how many
 * `worker` functions should be run in parallel.  If omitted, the concurrency
 * defaults to `1`.  If the concurrency is `0`, an error is thrown.
 * @returns {module:ControlFlow.QueueObject} A queue object to manage the tasks. Callbacks can
 * attached as certain properties to listen for specific events during the
 * lifecycle of the queue.
 * @example
 *
 * // create a queue object with concurrency 2
 * var q = async.queue(function(task, callback) {
 *     console.log('hello ' + task.name);
 *     callback();
 * }, 2);
 *
 * // assign a callback
 * q.drain = function() {
 *     console.log('all items have been processed');
 * };
 *
 * // add some items to the queue
 * q.push({name: 'foo'}, function(err) {
 *     console.log('finished processing foo');
 * });
 * q.push({name: 'bar'}, function (err) {
 *     console.log('finished processing bar');
 * });
 *
 * // add some items to the queue (batch-wise)
 * q.push([{name: 'baz'},{name: 'bay'},{name: 'bax'}], function(err) {
 *     console.log('finished processing item');
 * });
 *
 * // add some items to the front of the queue
 * q.unshift({name: 'bar'}, function (err) {
 *     console.log('finished processing bar');
 * });
 */
var queue$1 = function (worker, concurrency) {
    var _worker = wrapAsync(worker);
    return queue(function (items, cb) {
        _worker(items[0], cb);
    }, concurrency, 1);
};

/**
 * The same as [async.queue]{@link module:ControlFlow.queue} only tasks are assigned a priority and
 * completed in ascending priority order.
 *
 * @name priorityQueue
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.queue]{@link module:ControlFlow.queue}
 * @category Control Flow
 * @param {AsyncFunction} worker - An async function for processing a queued task.
 * If you want to handle errors from an individual task, pass a callback to
 * `q.push()`.
 * Invoked with (task, callback).
 * @param {number} concurrency - An `integer` for determining how many `worker`
 * functions should be run in parallel.  If omitted, the concurrency defaults to
 * `1`.  If the concurrency is `0`, an error is thrown.
 * @returns {module:ControlFlow.QueueObject} A priorityQueue object to manage the tasks. There are two
 * differences between `queue` and `priorityQueue` objects:
 * * `push(task, priority, [callback])` - `priority` should be a number. If an
 *   array of `tasks` is given, all tasks will be assigned the same priority.
 * * The `unshift` method was removed.
 */
var priorityQueue = function(worker, concurrency) {
    // Start with a normal queue
    var q = queue$1(worker, concurrency);

    // Override push to accept second parameter representing priority
    q.push = function(data, priority, callback) {
        if (callback == null) callback = noop;
        if (typeof callback !== 'function') {
            throw new Error('task callback must be a function');
        }
        q.started = true;
        if (!isArray(data)) {
            data = [data];
        }
        if (data.length === 0) {
            // call drain immediately if there are no tasks
            return setImmediate$1(function() {
                q.drain();
            });
        }

        priority = priority || 0;
        var nextNode = q._tasks.head;
        while (nextNode && priority >= nextNode.priority) {
            nextNode = nextNode.next;
        }

        for (var i = 0, l = data.length; i < l; i++) {
            var item = {
                data: data[i],
                priority: priority,
                callback: callback
            };

            if (nextNode) {
                q._tasks.insertBefore(nextNode, item);
            } else {
                q._tasks.push(item);
            }
        }
        setImmediate$1(q.process);
    };

    // Remove unshift function
    delete q.unshift;

    return q;
};

/**
 * Runs the `tasks` array of functions in parallel, without waiting until the
 * previous function has completed. Once any of the `tasks` complete or pass an
 * error to its callback, the main `callback` is immediately called. It's
 * equivalent to `Promise.race()`.
 *
 * @name race
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Array} tasks - An array containing [async functions]{@link AsyncFunction}
 * to run. Each function can complete with an optional `result` value.
 * @param {Function} callback - A callback to run once any of the functions have
 * completed. This function gets an error or result from the first function that
 * completed. Invoked with (err, result).
 * @returns undefined
 * @example
 *
 * async.race([
 *     function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'one');
 *         }, 200);
 *     },
 *     function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'two');
 *         }, 100);
 *     }
 * ],
 * // main callback
 * function(err, result) {
 *     // the result will be equal to 'two' as it finishes earlier
 * });
 */
function race(tasks, callback) {
    callback = once(callback || noop);
    if (!isArray(tasks)) return callback(new TypeError('First argument to race must be an array of functions'));
    if (!tasks.length) return callback();
    for (var i = 0, l = tasks.length; i < l; i++) {
        wrapAsync(tasks[i])(callback);
    }
}

/**
 * Same as [`reduce`]{@link module:Collections.reduce}, only operates on `array` in reverse order.
 *
 * @name reduceRight
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.reduce]{@link module:Collections.reduce}
 * @alias foldr
 * @category Collection
 * @param {Array} array - A collection to iterate over.
 * @param {*} memo - The initial state of the reduction.
 * @param {AsyncFunction} iteratee - A function applied to each item in the
 * array to produce the next step in the reduction.
 * The `iteratee` should complete with the next state of the reduction.
 * If the iteratee complete with an error, the reduction is stopped and the
 * main `callback` is immediately called with the error.
 * Invoked with (memo, item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Result is the reduced value. Invoked with
 * (err, result).
 */
function reduceRight (array, memo, iteratee, callback) {
    var reversed = slice(array).reverse();
    reduce(reversed, memo, iteratee, callback);
}

/**
 * Wraps the async function in another function that always completes with a
 * result object, even when it errors.
 *
 * The result object has either the property `error` or `value`.
 *
 * @name reflect
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {AsyncFunction} fn - The async function you want to wrap
 * @returns {Function} - A function that always passes null to it's callback as
 * the error. The second argument to the callback will be an `object` with
 * either an `error` or a `value` property.
 * @example
 *
 * async.parallel([
 *     async.reflect(function(callback) {
 *         // do some stuff ...
 *         callback(null, 'one');
 *     }),
 *     async.reflect(function(callback) {
 *         // do some more stuff but error ...
 *         callback('bad stuff happened');
 *     }),
 *     async.reflect(function(callback) {
 *         // do some more stuff ...
 *         callback(null, 'two');
 *     })
 * ],
 * // optional callback
 * function(err, results) {
 *     // values
 *     // results[0].value = 'one'
 *     // results[1].error = 'bad stuff happened'
 *     // results[2].value = 'two'
 * });
 */
function reflect(fn) {
    var _fn = wrapAsync(fn);
    return initialParams(function reflectOn(args, reflectCallback) {
        args.push(function callback(error, cbArg) {
            if (error) {
                reflectCallback(null, { error: error });
            } else {
                var value;
                if (arguments.length <= 2) {
                    value = cbArg;
                } else {
                    value = slice(arguments, 1);
                }
                reflectCallback(null, { value: value });
            }
        });

        return _fn.apply(this, args);
    });
}

/**
 * A helper function that wraps an array or an object of functions with `reflect`.
 *
 * @name reflectAll
 * @static
 * @memberOf module:Utils
 * @method
 * @see [async.reflect]{@link module:Utils.reflect}
 * @category Util
 * @param {Array|Object|Iterable} tasks - The collection of
 * [async functions]{@link AsyncFunction} to wrap in `async.reflect`.
 * @returns {Array} Returns an array of async functions, each wrapped in
 * `async.reflect`
 * @example
 *
 * let tasks = [
 *     function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'one');
 *         }, 200);
 *     },
 *     function(callback) {
 *         // do some more stuff but error ...
 *         callback(new Error('bad stuff happened'));
 *     },
 *     function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'two');
 *         }, 100);
 *     }
 * ];
 *
 * async.parallel(async.reflectAll(tasks),
 * // optional callback
 * function(err, results) {
 *     // values
 *     // results[0].value = 'one'
 *     // results[1].error = Error('bad stuff happened')
 *     // results[2].value = 'two'
 * });
 *
 * // an example using an object instead of an array
 * let tasks = {
 *     one: function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'one');
 *         }, 200);
 *     },
 *     two: function(callback) {
 *         callback('two');
 *     },
 *     three: function(callback) {
 *         setTimeout(function() {
 *             callback(null, 'three');
 *         }, 100);
 *     }
 * };
 *
 * async.parallel(async.reflectAll(tasks),
 * // optional callback
 * function(err, results) {
 *     // values
 *     // results.one.value = 'one'
 *     // results.two.error = 'two'
 *     // results.three.value = 'three'
 * });
 */
function reflectAll(tasks) {
    var results;
    if (isArray(tasks)) {
        results = arrayMap(tasks, reflect);
    } else {
        results = {};
        baseForOwn(tasks, function(task, key) {
            results[key] = reflect.call(this, task);
        });
    }
    return results;
}

function reject$1(eachfn, arr, iteratee, callback) {
    _filter(eachfn, arr, function(value, cb) {
        iteratee(value, function(err, v) {
            cb(err, !v);
        });
    }, callback);
}

/**
 * The opposite of [`filter`]{@link module:Collections.filter}. Removes values that pass an `async` truth test.
 *
 * @name reject
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.filter]{@link module:Collections.filter}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {Function} iteratee - An async truth test to apply to each item in
 * `coll`.
 * The should complete with a boolean value as its `result`.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Invoked with (err, results).
 * @example
 *
 * async.reject(['file1','file2','file3'], function(filePath, callback) {
 *     fs.access(filePath, function(err) {
 *         callback(null, !err)
 *     });
 * }, function(err, results) {
 *     // results now equals an array of missing files
 *     createFiles(results);
 * });
 */
var reject = doParallel(reject$1);

/**
 * The same as [`reject`]{@link module:Collections.reject} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name rejectLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.reject]{@link module:Collections.reject}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {Function} iteratee - An async truth test to apply to each item in
 * `coll`.
 * The should complete with a boolean value as its `result`.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Invoked with (err, results).
 */
var rejectLimit = doParallelLimit(reject$1);

/**
 * The same as [`reject`]{@link module:Collections.reject} but runs only a single async operation at a time.
 *
 * @name rejectSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.reject]{@link module:Collections.reject}
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {Function} iteratee - An async truth test to apply to each item in
 * `coll`.
 * The should complete with a boolean value as its `result`.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Invoked with (err, results).
 */
var rejectSeries = doLimit(rejectLimit, 1);

/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant$1(value) {
  return function() {
    return value;
  };
}

/**
 * Attempts to get a successful response from `task` no more than `times` times
 * before returning an error. If the task is successful, the `callback` will be
 * passed the result of the successful task. If all attempts fail, the callback
 * will be passed the error and result (if any) of the final attempt.
 *
 * @name retry
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @see [async.retryable]{@link module:ControlFlow.retryable}
 * @param {Object|number} [opts = {times: 5, interval: 0}| 5] - Can be either an
 * object with `times` and `interval` or a number.
 * * `times` - The number of attempts to make before giving up.  The default
 *   is `5`.
 * * `interval` - The time to wait between retries, in milliseconds.  The
 *   default is `0`. The interval may also be specified as a function of the
 *   retry count (see example).
 * * `errorFilter` - An optional synchronous function that is invoked on
 *   erroneous result. If it returns `true` the retry attempts will continue;
 *   if the function returns `false` the retry flow is aborted with the current
 *   attempt's error and result being returned to the final callback.
 *   Invoked with (err).
 * * If `opts` is a number, the number specifies the number of times to retry,
 *   with the default interval of `0`.
 * @param {AsyncFunction} task - An async function to retry.
 * Invoked with (callback).
 * @param {Function} [callback] - An optional callback which is called when the
 * task has succeeded, or after the final failed attempt. It receives the `err`
 * and `result` arguments of the last attempt at completing the `task`. Invoked
 * with (err, results).
 *
 * @example
 *
 * // The `retry` function can be used as a stand-alone control flow by passing
 * // a callback, as shown below:
 *
 * // try calling apiMethod 3 times
 * async.retry(3, apiMethod, function(err, result) {
 *     // do something with the result
 * });
 *
 * // try calling apiMethod 3 times, waiting 200 ms between each retry
 * async.retry({times: 3, interval: 200}, apiMethod, function(err, result) {
 *     // do something with the result
 * });
 *
 * // try calling apiMethod 10 times with exponential backoff
 * // (i.e. intervals of 100, 200, 400, 800, 1600, ... milliseconds)
 * async.retry({
 *   times: 10,
 *   interval: function(retryCount) {
 *     return 50 * Math.pow(2, retryCount);
 *   }
 * }, apiMethod, function(err, result) {
 *     // do something with the result
 * });
 *
 * // try calling apiMethod the default 5 times no delay between each retry
 * async.retry(apiMethod, function(err, result) {
 *     // do something with the result
 * });
 *
 * // try calling apiMethod only when error condition satisfies, all other
 * // errors will abort the retry control flow and return to final callback
 * async.retry({
 *   errorFilter: function(err) {
 *     return err.message === 'Temporary error'; // only retry on a specific error
 *   }
 * }, apiMethod, function(err, result) {
 *     // do something with the result
 * });
 *
 * // to retry individual methods that are not as reliable within other
 * // control flow functions, use the `retryable` wrapper:
 * async.auto({
 *     users: api.getUsers.bind(api),
 *     payments: async.retryable(3, api.getPayments.bind(api))
 * }, function(err, results) {
 *     // do something with the results
 * });
 *
 */
function retry(opts, task, callback) {
    var DEFAULT_TIMES = 5;
    var DEFAULT_INTERVAL = 0;

    var options = {
        times: DEFAULT_TIMES,
        intervalFunc: constant$1(DEFAULT_INTERVAL)
    };

    function parseTimes(acc, t) {
        if (typeof t === 'object') {
            acc.times = +t.times || DEFAULT_TIMES;

            acc.intervalFunc = typeof t.interval === 'function' ?
                t.interval :
                constant$1(+t.interval || DEFAULT_INTERVAL);

            acc.errorFilter = t.errorFilter;
        } else if (typeof t === 'number' || typeof t === 'string') {
            acc.times = +t || DEFAULT_TIMES;
        } else {
            throw new Error("Invalid arguments for async.retry");
        }
    }

    if (arguments.length < 3 && typeof opts === 'function') {
        callback = task || noop;
        task = opts;
    } else {
        parseTimes(options, opts);
        callback = callback || noop;
    }

    if (typeof task !== 'function') {
        throw new Error("Invalid arguments for async.retry");
    }

    var _task = wrapAsync(task);

    var attempt = 1;
    function retryAttempt() {
        _task(function(err) {
            if (err && attempt++ < options.times &&
                (typeof options.errorFilter != 'function' ||
                    options.errorFilter(err))) {
                setTimeout(retryAttempt, options.intervalFunc(attempt));
            } else {
                callback.apply(null, arguments);
            }
        });
    }

    retryAttempt();
}

/**
 * A close relative of [`retry`]{@link module:ControlFlow.retry}.  This method
 * wraps a task and makes it retryable, rather than immediately calling it
 * with retries.
 *
 * @name retryable
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.retry]{@link module:ControlFlow.retry}
 * @category Control Flow
 * @param {Object|number} [opts = {times: 5, interval: 0}| 5] - optional
 * options, exactly the same as from `retry`
 * @param {AsyncFunction} task - the asynchronous function to wrap.
 * This function will be passed any arguments passed to the returned wrapper.
 * Invoked with (...args, callback).
 * @returns {AsyncFunction} The wrapped function, which when invoked, will
 * retry on an error, based on the parameters specified in `opts`.
 * This function will accept the same parameters as `task`.
 * @example
 *
 * async.auto({
 *     dep1: async.retryable(3, getFromFlakyService),
 *     process: ["dep1", async.retryable(3, function (results, cb) {
 *         maybeProcessData(results.dep1, cb);
 *     })]
 * }, callback);
 */
var retryable = function (opts, task) {
    if (!task) {
        task = opts;
        opts = null;
    }
    var _task = wrapAsync(task);
    return initialParams(function (args, callback) {
        function taskFn(cb) {
            _task.apply(null, args.concat(cb));
        }

        if (opts) retry(opts, taskFn, callback);
        else retry(taskFn, callback);

    });
};

/**
 * Run the functions in the `tasks` collection in series, each one running once
 * the previous function has completed. If any functions in the series pass an
 * error to its callback, no more functions are run, and `callback` is
 * immediately called with the value of the error. Otherwise, `callback`
 * receives an array of results when `tasks` have completed.
 *
 * It is also possible to use an object instead of an array. Each property will
 * be run as a function, and the results will be passed to the final `callback`
 * as an object instead of an array. This can be a more readable way of handling
 *  results from {@link async.series}.
 *
 * **Note** that while many implementations preserve the order of object
 * properties, the [ECMAScript Language Specification](http://www.ecma-international.org/ecma-262/5.1/#sec-8.6)
 * explicitly states that
 *
 * > The mechanics and order of enumerating the properties is not specified.
 *
 * So if you rely on the order in which your series of functions are executed,
 * and want this to work on all platforms, consider using an array.
 *
 * @name series
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Array|Iterable|Object} tasks - A collection containing
 * [async functions]{@link AsyncFunction} to run in series.
 * Each function can complete with any number of optional `result` values.
 * @param {Function} [callback] - An optional callback to run once all the
 * functions have completed. This function gets a results array (or object)
 * containing all the result arguments passed to the `task` callbacks. Invoked
 * with (err, result).
 * @example
 * async.series([
 *     function(callback) {
 *         // do some stuff ...
 *         callback(null, 'one');
 *     },
 *     function(callback) {
 *         // do some more stuff ...
 *         callback(null, 'two');
 *     }
 * ],
 * // optional callback
 * function(err, results) {
 *     // results is now equal to ['one', 'two']
 * });
 *
 * async.series({
 *     one: function(callback) {
 *         setTimeout(function() {
 *             callback(null, 1);
 *         }, 200);
 *     },
 *     two: function(callback){
 *         setTimeout(function() {
 *             callback(null, 2);
 *         }, 100);
 *     }
 * }, function(err, results) {
 *     // results is now equal to: {one: 1, two: 2}
 * });
 */
function series(tasks, callback) {
    _parallel(eachOfSeries, tasks, callback);
}

/**
 * Returns `true` if at least one element in the `coll` satisfies an async test.
 * If any iteratee call returns `true`, the main `callback` is immediately
 * called.
 *
 * @name some
 * @static
 * @memberOf module:Collections
 * @method
 * @alias any
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async truth test to apply to each item
 * in the collections in parallel.
 * The iteratee should complete with a boolean `result` value.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called as soon as any
 * iteratee returns `true`, or after all the iteratee functions have finished.
 * Result will be either `true` or `false` depending on the values of the async
 * tests. Invoked with (err, result).
 * @example
 *
 * async.some(['file1','file2','file3'], function(filePath, callback) {
 *     fs.access(filePath, function(err) {
 *         callback(null, !err)
 *     });
 * }, function(err, result) {
 *     // if result is true then at least one of the files exists
 * });
 */
var some = doParallel(_createTester(Boolean, identity));

/**
 * The same as [`some`]{@link module:Collections.some} but runs a maximum of `limit` async operations at a time.
 *
 * @name someLimit
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.some]{@link module:Collections.some}
 * @alias anyLimit
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - An async truth test to apply to each item
 * in the collections in parallel.
 * The iteratee should complete with a boolean `result` value.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called as soon as any
 * iteratee returns `true`, or after all the iteratee functions have finished.
 * Result will be either `true` or `false` depending on the values of the async
 * tests. Invoked with (err, result).
 */
var someLimit = doParallelLimit(_createTester(Boolean, identity));

/**
 * The same as [`some`]{@link module:Collections.some} but runs only a single async operation at a time.
 *
 * @name someSeries
 * @static
 * @memberOf module:Collections
 * @method
 * @see [async.some]{@link module:Collections.some}
 * @alias anySeries
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async truth test to apply to each item
 * in the collections in series.
 * The iteratee should complete with a boolean `result` value.
 * Invoked with (item, callback).
 * @param {Function} [callback] - A callback which is called as soon as any
 * iteratee returns `true`, or after all the iteratee functions have finished.
 * Result will be either `true` or `false` depending on the values of the async
 * tests. Invoked with (err, result).
 */
var someSeries = doLimit(someLimit, 1);

/**
 * Sorts a list by the results of running each `coll` value through an async
 * `iteratee`.
 *
 * @name sortBy
 * @static
 * @memberOf module:Collections
 * @method
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {AsyncFunction} iteratee - An async function to apply to each item in
 * `coll`.
 * The iteratee should complete with a value to use as the sort criteria as
 * its `result`.
 * Invoked with (item, callback).
 * @param {Function} callback - A callback which is called after all the
 * `iteratee` functions have finished, or an error occurs. Results is the items
 * from the original `coll` sorted by the values returned by the `iteratee`
 * calls. Invoked with (err, results).
 * @example
 *
 * async.sortBy(['file1','file2','file3'], function(file, callback) {
 *     fs.stat(file, function(err, stats) {
 *         callback(err, stats.mtime);
 *     });
 * }, function(err, results) {
 *     // results is now the original array of files sorted by
 *     // modified date
 * });
 *
 * // By modifying the callback parameter the
 * // sorting order can be influenced:
 *
 * // ascending order
 * async.sortBy([1,9,3,5], function(x, callback) {
 *     callback(null, x);
 * }, function(err,result) {
 *     // result callback
 * });
 *
 * // descending order
 * async.sortBy([1,9,3,5], function(x, callback) {
 *     callback(null, x*-1);    //<- x*-1 instead of x, turns the order around
 * }, function(err,result) {
 *     // result callback
 * });
 */
function sortBy (coll, iteratee, callback) {
    var _iteratee = wrapAsync(iteratee);
    map(coll, function (x, callback) {
        _iteratee(x, function (err, criteria) {
            if (err) return callback(err);
            callback(null, {value: x, criteria: criteria});
        });
    }, function (err, results) {
        if (err) return callback(err);
        callback(null, arrayMap(results.sort(comparator), baseProperty('value')));
    });

    function comparator(left, right) {
        var a = left.criteria, b = right.criteria;
        return a < b ? -1 : a > b ? 1 : 0;
    }
}

/**
 * Sets a time limit on an asynchronous function. If the function does not call
 * its callback within the specified milliseconds, it will be called with a
 * timeout error. The code property for the error object will be `'ETIMEDOUT'`.
 *
 * @name timeout
 * @static
 * @memberOf module:Utils
 * @method
 * @category Util
 * @param {AsyncFunction} asyncFn - The async function to limit in time.
 * @param {number} milliseconds - The specified time limit.
 * @param {*} [info] - Any variable you want attached (`string`, `object`, etc)
 * to timeout Error for more information..
 * @returns {AsyncFunction} Returns a wrapped function that can be used with any
 * of the control flow functions.
 * Invoke this function with the same parameters as you would `asyncFunc`.
 * @example
 *
 * function myFunction(foo, callback) {
 *     doAsyncTask(foo, function(err, data) {
 *         // handle errors
 *         if (err) return callback(err);
 *
 *         // do some stuff ...
 *
 *         // return processed data
 *         return callback(null, data);
 *     });
 * }
 *
 * var wrapped = async.timeout(myFunction, 1000);
 *
 * // call `wrapped` as you would `myFunction`
 * wrapped({ bar: 'bar' }, function(err, data) {
 *     // if `myFunction` takes < 1000 ms to execute, `err`
 *     // and `data` will have their expected values
 *
 *     // else `err` will be an Error with the code 'ETIMEDOUT'
 * });
 */
function timeout(asyncFn, milliseconds, info) {
    var fn = wrapAsync(asyncFn);

    return initialParams(function (args, callback) {
        var timedOut = false;
        var timer;

        function timeoutCallback() {
            var name = asyncFn.name || 'anonymous';
            var error  = new Error('Callback function "' + name + '" timed out.');
            error.code = 'ETIMEDOUT';
            if (info) {
                error.info = info;
            }
            timedOut = true;
            callback(error);
        }

        args.push(function () {
            if (!timedOut) {
                callback.apply(null, arguments);
                clearTimeout(timer);
            }
        });

        // setup timer and call original function
        timer = setTimeout(timeoutCallback, milliseconds);
        fn.apply(null, args);
    });
}

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeCeil = Math.ceil;
var nativeMax = Math.max;

/**
 * The base implementation of `_.range` and `_.rangeRight` which doesn't
 * coerce arguments.
 *
 * @private
 * @param {number} start The start of the range.
 * @param {number} end The end of the range.
 * @param {number} step The value to increment or decrement by.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Array} Returns the range of numbers.
 */
function baseRange(start, end, step, fromRight) {
  var index = -1,
      length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
      result = Array(length);

  while (length--) {
    result[fromRight ? length : ++index] = start;
    start += step;
  }
  return result;
}

/**
 * The same as [times]{@link module:ControlFlow.times} but runs a maximum of `limit` async operations at a
 * time.
 *
 * @name timesLimit
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.times]{@link module:ControlFlow.times}
 * @category Control Flow
 * @param {number} count - The number of times to run the function.
 * @param {number} limit - The maximum number of async operations at a time.
 * @param {AsyncFunction} iteratee - The async function to call `n` times.
 * Invoked with the iteration index and a callback: (n, next).
 * @param {Function} callback - see [async.map]{@link module:Collections.map}.
 */
function timeLimit(count, limit, iteratee, callback) {
    var _iteratee = wrapAsync(iteratee);
    mapLimit(baseRange(0, count, 1), limit, _iteratee, callback);
}

/**
 * Calls the `iteratee` function `n` times, and accumulates results in the same
 * manner you would use with [map]{@link module:Collections.map}.
 *
 * @name times
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.map]{@link module:Collections.map}
 * @category Control Flow
 * @param {number} n - The number of times to run the function.
 * @param {AsyncFunction} iteratee - The async function to call `n` times.
 * Invoked with the iteration index and a callback: (n, next).
 * @param {Function} callback - see {@link module:Collections.map}.
 * @example
 *
 * // Pretend this is some complicated async factory
 * var createUser = function(id, callback) {
 *     callback(null, {
 *         id: 'user' + id
 *     });
 * };
 *
 * // generate 5 users
 * async.times(5, function(n, next) {
 *     createUser(n, function(err, user) {
 *         next(err, user);
 *     });
 * }, function(err, users) {
 *     // we should now have 5 users
 * });
 */
var times = doLimit(timeLimit, Infinity);

/**
 * The same as [times]{@link module:ControlFlow.times} but runs only a single async operation at a time.
 *
 * @name timesSeries
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.times]{@link module:ControlFlow.times}
 * @category Control Flow
 * @param {number} n - The number of times to run the function.
 * @param {AsyncFunction} iteratee - The async function to call `n` times.
 * Invoked with the iteration index and a callback: (n, next).
 * @param {Function} callback - see {@link module:Collections.map}.
 */
var timesSeries = doLimit(timeLimit, 1);

/**
 * A relative of `reduce`.  Takes an Object or Array, and iterates over each
 * element in series, each step potentially mutating an `accumulator` value.
 * The type of the accumulator defaults to the type of collection passed in.
 *
 * @name transform
 * @static
 * @memberOf module:Collections
 * @method
 * @category Collection
 * @param {Array|Iterable|Object} coll - A collection to iterate over.
 * @param {*} [accumulator] - The initial state of the transform.  If omitted,
 * it will default to an empty Object or Array, depending on the type of `coll`
 * @param {AsyncFunction} iteratee - A function applied to each item in the
 * collection that potentially modifies the accumulator.
 * Invoked with (accumulator, item, key, callback).
 * @param {Function} [callback] - A callback which is called after all the
 * `iteratee` functions have finished. Result is the transformed accumulator.
 * Invoked with (err, result).
 * @example
 *
 * async.transform([1,2,3], function(acc, item, index, callback) {
 *     // pointless async:
 *     process.nextTick(function() {
 *         acc.push(item * 2)
 *         callback(null)
 *     });
 * }, function(err, result) {
 *     // result is now equal to [2, 4, 6]
 * });
 *
 * @example
 *
 * async.transform({a: 1, b: 2, c: 3}, function (obj, val, key, callback) {
 *     setImmediate(function () {
 *         obj[key] = val * 2;
 *         callback();
 *     })
 * }, function (err, result) {
 *     // result is equal to {a: 2, b: 4, c: 6}
 * })
 */
function transform (coll, accumulator, iteratee, callback) {
    if (arguments.length <= 3) {
        callback = iteratee;
        iteratee = accumulator;
        accumulator = isArray(coll) ? [] : {};
    }
    callback = once(callback || noop);
    var _iteratee = wrapAsync(iteratee);

    eachOf(coll, function(v, k, cb) {
        _iteratee(accumulator, v, k, cb);
    }, function(err) {
        callback(err, accumulator);
    });
}

/**
 * It runs each task in series but stops whenever any of the functions were
 * successful. If one of the tasks were successful, the `callback` will be
 * passed the result of the successful task. If all tasks fail, the callback
 * will be passed the error and result (if any) of the final attempt.
 *
 * @name tryEach
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Array|Iterable|Object} tasks - A collection containing functions to
 * run, each function is passed a `callback(err, result)` it must call on
 * completion with an error `err` (which can be `null`) and an optional `result`
 * value.
 * @param {Function} [callback] - An optional callback which is called when one
 * of the tasks has succeeded, or all have failed. It receives the `err` and
 * `result` arguments of the last attempt at completing the `task`. Invoked with
 * (err, results).
 * @example
 * async.tryEach([
 *     function getDataFromFirstWebsite(callback) {
 *         // Try getting the data from the first website
 *         callback(err, data);
 *     },
 *     function getDataFromSecondWebsite(callback) {
 *         // First website failed,
 *         // Try getting the data from the backup website
 *         callback(err, data);
 *     }
 * ],
 * // optional callback
 * function(err, results) {
 *     Now do something with the data.
 * });
 *
 */
function tryEach(tasks, callback) {
    var error = null;
    var result;
    callback = callback || noop;
    eachSeries(tasks, function(task, callback) {
        wrapAsync(task)(function (err, res/*, ...args*/) {
            if (arguments.length > 2) {
                result = slice(arguments, 1);
            } else {
                result = res;
            }
            error = err;
            callback(!err);
        });
    }, function () {
        callback(error, result);
    });
}

/**
 * Undoes a [memoize]{@link module:Utils.memoize}d function, reverting it to the original,
 * unmemoized form. Handy for testing.
 *
 * @name unmemoize
 * @static
 * @memberOf module:Utils
 * @method
 * @see [async.memoize]{@link module:Utils.memoize}
 * @category Util
 * @param {AsyncFunction} fn - the memoized function
 * @returns {AsyncFunction} a function that calls the original unmemoized function
 */
function unmemoize(fn) {
    return function () {
        return (fn.unmemoized || fn).apply(null, arguments);
    };
}

/**
 * Repeatedly call `iteratee`, while `test` returns `true`. Calls `callback` when
 * stopped, or an error occurs.
 *
 * @name whilst
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Function} test - synchronous truth test to perform before each
 * execution of `iteratee`. Invoked with ().
 * @param {AsyncFunction} iteratee - An async function which is called each time
 * `test` passes. Invoked with (callback).
 * @param {Function} [callback] - A callback which is called after the test
 * function has failed and repeated execution of `iteratee` has stopped. `callback`
 * will be passed an error and any arguments passed to the final `iteratee`'s
 * callback. Invoked with (err, [results]);
 * @returns undefined
 * @example
 *
 * var count = 0;
 * async.whilst(
 *     function() { return count < 5; },
 *     function(callback) {
 *         count++;
 *         setTimeout(function() {
 *             callback(null, count);
 *         }, 1000);
 *     },
 *     function (err, n) {
 *         // 5 seconds have passed, n = 5
 *     }
 * );
 */
function whilst(test, iteratee, callback) {
    callback = onlyOnce(callback || noop);
    var _iteratee = wrapAsync(iteratee);
    if (!test()) return callback(null);
    var next = function(err/*, ...args*/) {
        if (err) return callback(err);
        if (test()) return _iteratee(next);
        var args = slice(arguments, 1);
        callback.apply(null, [null].concat(args));
    };
    _iteratee(next);
}

/**
 * Repeatedly call `iteratee` until `test` returns `true`. Calls `callback` when
 * stopped, or an error occurs. `callback` will be passed an error and any
 * arguments passed to the final `iteratee`'s callback.
 *
 * The inverse of [whilst]{@link module:ControlFlow.whilst}.
 *
 * @name until
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @see [async.whilst]{@link module:ControlFlow.whilst}
 * @category Control Flow
 * @param {Function} test - synchronous truth test to perform before each
 * execution of `iteratee`. Invoked with ().
 * @param {AsyncFunction} iteratee - An async function which is called each time
 * `test` fails. Invoked with (callback).
 * @param {Function} [callback] - A callback which is called after the test
 * function has passed and repeated execution of `iteratee` has stopped. `callback`
 * will be passed an error and any arguments passed to the final `iteratee`'s
 * callback. Invoked with (err, [results]);
 */
function until(test, iteratee, callback) {
    whilst(function() {
        return !test.apply(this, arguments);
    }, iteratee, callback);
}

/**
 * Runs the `tasks` array of functions in series, each passing their results to
 * the next in the array. However, if any of the `tasks` pass an error to their
 * own callback, the next function is not executed, and the main `callback` is
 * immediately called with the error.
 *
 * @name waterfall
 * @static
 * @memberOf module:ControlFlow
 * @method
 * @category Control Flow
 * @param {Array} tasks - An array of [async functions]{@link AsyncFunction}
 * to run.
 * Each function should complete with any number of `result` values.
 * The `result` values will be passed as arguments, in order, to the next task.
 * @param {Function} [callback] - An optional callback to run once all the
 * functions have completed. This will be passed the results of the last task's
 * callback. Invoked with (err, [results]).
 * @returns undefined
 * @example
 *
 * async.waterfall([
 *     function(callback) {
 *         callback(null, 'one', 'two');
 *     },
 *     function(arg1, arg2, callback) {
 *         // arg1 now equals 'one' and arg2 now equals 'two'
 *         callback(null, 'three');
 *     },
 *     function(arg1, callback) {
 *         // arg1 now equals 'three'
 *         callback(null, 'done');
 *     }
 * ], function (err, result) {
 *     // result now equals 'done'
 * });
 *
 * // Or, with named functions:
 * async.waterfall([
 *     myFirstFunction,
 *     mySecondFunction,
 *     myLastFunction,
 * ], function (err, result) {
 *     // result now equals 'done'
 * });
 * function myFirstFunction(callback) {
 *     callback(null, 'one', 'two');
 * }
 * function mySecondFunction(arg1, arg2, callback) {
 *     // arg1 now equals 'one' and arg2 now equals 'two'
 *     callback(null, 'three');
 * }
 * function myLastFunction(arg1, callback) {
 *     // arg1 now equals 'three'
 *     callback(null, 'done');
 * }
 */
var waterfall = function(tasks, callback) {
    callback = once(callback || noop);
    if (!isArray(tasks)) return callback(new Error('First argument to waterfall must be an array of functions'));
    if (!tasks.length) return callback();
    var taskIndex = 0;

    function nextTask(args) {
        var task = wrapAsync(tasks[taskIndex++]);
        args.push(onlyOnce(next));
        task.apply(null, args);
    }

    function next(err/*, ...args*/) {
        if (err || taskIndex === tasks.length) {
            return callback.apply(null, arguments);
        }
        nextTask(slice(arguments, 1));
    }

    nextTask([]);
};

/**
 * An "async function" in the context of Async is an asynchronous function with
 * a variable number of parameters, with the final parameter being a callback.
 * (`function (arg1, arg2, ..., callback) {}`)
 * The final callback is of the form `callback(err, results...)`, which must be
 * called once the function is completed.  The callback should be called with a
 * Error as its first argument to signal that an error occurred.
 * Otherwise, if no error occurred, it should be called with `null` as the first
 * argument, and any additional `result` arguments that may apply, to signal
 * successful completion.
 * The callback must be called exactly once, ideally on a later tick of the
 * JavaScript event loop.
 *
 * This type of function is also referred to as a "Node-style async function",
 * or a "continuation passing-style function" (CPS). Most of the methods of this
 * library are themselves CPS/Node-style async functions, or functions that
 * return CPS/Node-style async functions.
 *
 * Wherever we accept a Node-style async function, we also directly accept an
 * [ES2017 `async` function]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/async_function}.
 * In this case, the `async` function will not be passed a final callback
 * argument, and any thrown error will be used as the `err` argument of the
 * implicit callback, and the return value will be used as the `result` value.
 * (i.e. a `rejected` of the returned Promise becomes the `err` callback
 * argument, and a `resolved` value becomes the `result`.)
 *
 * Note, due to JavaScript limitations, we can only detect native `async`
 * functions and not transpilied implementations.
 * Your environment must have `async`/`await` support for this to work.
 * (e.g. Node > v7.6, or a recent version of a modern browser).
 * If you are using `async` functions through a transpiler (e.g. Babel), you
 * must still wrap the function with [asyncify]{@link module:Utils.asyncify},
 * because the `async function` will be compiled to an ordinary function that
 * returns a promise.
 *
 * @typedef {Function} AsyncFunction
 * @static
 */

/**
 * Async is a utility module which provides straight-forward, powerful functions
 * for working with asynchronous JavaScript. Although originally designed for
 * use with [Node.js](http://nodejs.org) and installable via
 * `npm install --save async`, it can also be used directly in the browser.
 * @module async
 * @see AsyncFunction
 */


/**
 * A collection of `async` functions for manipulating collections, such as
 * arrays and objects.
 * @module Collections
 */

/**
 * A collection of `async` functions for controlling the flow through a script.
 * @module ControlFlow
 */

/**
 * A collection of `async` utility functions.
 * @module Utils
 */

var index = {
    apply: apply,
    applyEach: applyEach,
    applyEachSeries: applyEachSeries,
    asyncify: asyncify,
    auto: auto,
    autoInject: autoInject,
    cargo: cargo,
    compose: compose,
    concat: concat,
    concatLimit: concatLimit,
    concatSeries: concatSeries,
    constant: constant,
    detect: detect,
    detectLimit: detectLimit,
    detectSeries: detectSeries,
    dir: dir,
    doDuring: doDuring,
    doUntil: doUntil,
    doWhilst: doWhilst,
    during: during,
    each: eachLimit,
    eachLimit: eachLimit$1,
    eachOf: eachOf,
    eachOfLimit: eachOfLimit,
    eachOfSeries: eachOfSeries,
    eachSeries: eachSeries,
    ensureAsync: ensureAsync,
    every: every,
    everyLimit: everyLimit,
    everySeries: everySeries,
    filter: filter,
    filterLimit: filterLimit,
    filterSeries: filterSeries,
    forever: forever,
    groupBy: groupBy,
    groupByLimit: groupByLimit,
    groupBySeries: groupBySeries,
    log: log,
    map: map,
    mapLimit: mapLimit,
    mapSeries: mapSeries,
    mapValues: mapValues,
    mapValuesLimit: mapValuesLimit,
    mapValuesSeries: mapValuesSeries,
    memoize: memoize,
    nextTick: nextTick,
    parallel: parallelLimit,
    parallelLimit: parallelLimit$1,
    priorityQueue: priorityQueue,
    queue: queue$1,
    race: race,
    reduce: reduce,
    reduceRight: reduceRight,
    reflect: reflect,
    reflectAll: reflectAll,
    reject: reject,
    rejectLimit: rejectLimit,
    rejectSeries: rejectSeries,
    retry: retry,
    retryable: retryable,
    seq: seq,
    series: series,
    setImmediate: setImmediate$1,
    some: some,
    someLimit: someLimit,
    someSeries: someSeries,
    sortBy: sortBy,
    timeout: timeout,
    times: times,
    timesLimit: timeLimit,
    timesSeries: timesSeries,
    transform: transform,
    tryEach: tryEach,
    unmemoize: unmemoize,
    until: until,
    waterfall: waterfall,
    whilst: whilst,

    // aliases
    all: every,
    allLimit: everyLimit,
    allSeries: everySeries,
    any: some,
    anyLimit: someLimit,
    anySeries: someSeries,
    find: detect,
    findLimit: detectLimit,
    findSeries: detectSeries,
    forEach: eachLimit,
    forEachSeries: eachSeries,
    forEachLimit: eachLimit$1,
    forEachOf: eachOf,
    forEachOfSeries: eachOfSeries,
    forEachOfLimit: eachOfLimit,
    inject: reduce,
    foldl: reduce,
    foldr: reduceRight,
    select: filter,
    selectLimit: filterLimit,
    selectSeries: filterSeries,
    wrapSync: asyncify
};

exports['default'] = index;
exports.apply = apply;
exports.applyEach = applyEach;
exports.applyEachSeries = applyEachSeries;
exports.asyncify = asyncify;
exports.auto = auto;
exports.autoInject = autoInject;
exports.cargo = cargo;
exports.compose = compose;
exports.concat = concat;
exports.concatLimit = concatLimit;
exports.concatSeries = concatSeries;
exports.constant = constant;
exports.detect = detect;
exports.detectLimit = detectLimit;
exports.detectSeries = detectSeries;
exports.dir = dir;
exports.doDuring = doDuring;
exports.doUntil = doUntil;
exports.doWhilst = doWhilst;
exports.during = during;
exports.each = eachLimit;
exports.eachLimit = eachLimit$1;
exports.eachOf = eachOf;
exports.eachOfLimit = eachOfLimit;
exports.eachOfSeries = eachOfSeries;
exports.eachSeries = eachSeries;
exports.ensureAsync = ensureAsync;
exports.every = every;
exports.everyLimit = everyLimit;
exports.everySeries = everySeries;
exports.filter = filter;
exports.filterLimit = filterLimit;
exports.filterSeries = filterSeries;
exports.forever = forever;
exports.groupBy = groupBy;
exports.groupByLimit = groupByLimit;
exports.groupBySeries = groupBySeries;
exports.log = log;
exports.map = map;
exports.mapLimit = mapLimit;
exports.mapSeries = mapSeries;
exports.mapValues = mapValues;
exports.mapValuesLimit = mapValuesLimit;
exports.mapValuesSeries = mapValuesSeries;
exports.memoize = memoize;
exports.nextTick = nextTick;
exports.parallel = parallelLimit;
exports.parallelLimit = parallelLimit$1;
exports.priorityQueue = priorityQueue;
exports.queue = queue$1;
exports.race = race;
exports.reduce = reduce;
exports.reduceRight = reduceRight;
exports.reflect = reflect;
exports.reflectAll = reflectAll;
exports.reject = reject;
exports.rejectLimit = rejectLimit;
exports.rejectSeries = rejectSeries;
exports.retry = retry;
exports.retryable = retryable;
exports.seq = seq;
exports.series = series;
exports.setImmediate = setImmediate$1;
exports.some = some;
exports.someLimit = someLimit;
exports.someSeries = someSeries;
exports.sortBy = sortBy;
exports.timeout = timeout;
exports.times = times;
exports.timesLimit = timeLimit;
exports.timesSeries = timesSeries;
exports.transform = transform;
exports.tryEach = tryEach;
exports.unmemoize = unmemoize;
exports.until = until;
exports.waterfall = waterfall;
exports.whilst = whilst;
exports.all = every;
exports.allLimit = everyLimit;
exports.allSeries = everySeries;
exports.any = some;
exports.anyLimit = someLimit;
exports.anySeries = someSeries;
exports.find = detect;
exports.findLimit = detectLimit;
exports.findSeries = detectSeries;
exports.forEach = eachLimit;
exports.forEachSeries = eachSeries;
exports.forEachLimit = eachLimit$1;
exports.forEachOf = eachOf;
exports.forEachOfSeries = eachOfSeries;
exports.forEachOfLimit = eachOfLimit;
exports.inject = reduce;
exports.foldl = reduce;
exports.foldr = reduceRight;
exports.select = filter;
exports.selectLimit = filterLimit;
exports.selectSeries = filterSeries;
exports.wrapSync = asyncify;

Object.defineProperty(exports, '__esModule', { value: true });

})));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(57).setImmediate, __webpack_require__(31), __webpack_require__(65)(module)))

/***/ }),

/***/ 198:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const Immutable = __webpack_require__(1);

const deserializeAction = action => {
  for (let property in action) {
    if (action.hasOwnProperty(property) && action[property] instanceof Object) {
      action[property] = Immutable.fromJS(action[property]);
    }
  }
  return action;
};

/**
 * Converts an action in place to a serializable equivalent which is safe
 * to communicate across processes.  This basically just remoes all of the
 * Immutable JS.
 */
module.exports.serialize = action => {
  if (Array.isArray(action)) {
    return JSON.stringify(action);
  } else {
    return JSON.stringify([action]);
  }
};

/**
 * Converts a serialized action in place to one using ImmutableJS where possible.
 */
module.exports.deserialize = action => {
  let payload = JSON.parse(action);
  for (var i = 0; i < payload.length; i++) {
    payload[i] = deserializeAction(payload[i]);
  }
  return payload;
};

/***/ }),

/***/ 199:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};


// Mark that a method should not be used.
// Returns a modified function which warns once by default.
// If --no-deprecation is set, then it is a no-op.
exports.deprecate = function(fn, msg) {
  // Allow for deprecating things in the process of starting up.
  if (isUndefined(global.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = Object({"NODE_ENV":"development","BRAVE_PORT":8080}).NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};


/**
 * Echos the value of a value. Trys to print the value out
 * in the best way possible given the different types.
 *
 * @param {Object} obj The object to print out.
 * @param {Object} opts Optional options object that alters the output.
 */
/* legacy: obj, showHidden, depth, colors*/
function inspect(obj, opts) {
  // default options
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  // legacy...
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    // legacy...
    ctx.showHidden = opts;
  } else if (opts) {
    // got an "options" object
    exports._extend(ctx, opts);
  }
  // set default options
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;


// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};

// Don't use 'blue' not visible on cmd.exe
inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  // "name": intentionally not styling
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  // Provide a hook for user-specified inspect functions.
  // Check that value is an object with an inspect function on it
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      // Filter out the util module, it's inspect function is special
      value.inspect !== exports.inspect &&
      // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  // Primitive types cannot have properties
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  // Look up the keys of the object.
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  // IE doesn't make error fields non-enumerable
  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
  if (isError(value)
      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
    return formatError(value);
  }

  // Some type of object without properties can be shortcutted.
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  // Make Array say that they are Array
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  // Make functions say that they are functions
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  // Make RegExps say that they are RegExps
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  // Make dates with properties first say the date
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  // Make error with message first say the error
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  if (keys.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value))
    return ctx.stylize('' + value, 'number');
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var numLinesEst = 0;
  var length = output.reduce(function(prev, cur) {
    numLinesEst++;
    if (cur.indexOf('\n') >= 0) numLinesEst++;
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
function isArray(ar) {
  return Array.isArray(ar);
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = __webpack_require__(200);

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = __webpack_require__(201);

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(31)))

/***/ }),

/***/ 200:
/***/ (function(module, exports) {

module.exports = function isBuffer(arg) {
  return arg && typeof arg === 'object'
    && typeof arg.copy === 'function'
    && typeof arg.fill === 'function'
    && typeof arg.readUInt8 === 'function';
}

/***/ }),

/***/ 201:
/***/ (function(module, exports) {

if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    ctor.prototype = Object.create(superCtor.prototype, {
      constructor: {
        value: ctor,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    var TempCtor = function () {}
    TempCtor.prototype = superCtor.prototype
    ctor.prototype = new TempCtor()
    ctor.prototype.constructor = ctor
  }
}


/***/ }),

/***/ 202:
/***/ (function(module, exports, __webpack_require__) {

var v1 = __webpack_require__(203);
var v4 = __webpack_require__(204);

var uuid = v4;
uuid.v1 = v1;
uuid.v4 = v4;

module.exports = uuid;


/***/ }),

/***/ 203:
/***/ (function(module, exports, __webpack_require__) {

var rng = __webpack_require__(130);
var bytesToUuid = __webpack_require__(131);

// **`v1()` - Generate time-based UUID**
//
// Inspired by https://github.com/LiosK/UUID.js
// and http://docs.python.org/library/uuid.html

// random #'s we need to init node and clockseq
var _seedBytes = rng();

// Per 4.5, create and 48-bit node id, (47 random bits + multicast bit = 1)
var _nodeId = [
  _seedBytes[0] | 0x01,
  _seedBytes[1], _seedBytes[2], _seedBytes[3], _seedBytes[4], _seedBytes[5]
];

// Per 4.2.2, randomize (14 bit) clockseq
var _clockseq = (_seedBytes[6] << 8 | _seedBytes[7]) & 0x3fff;

// Previous uuid creation time
var _lastMSecs = 0, _lastNSecs = 0;

// See https://github.com/broofa/node-uuid for API details
function v1(options, buf, offset) {
  var i = buf && offset || 0;
  var b = buf || [];

  options = options || {};

  var clockseq = options.clockseq !== undefined ? options.clockseq : _clockseq;

  // UUID timestamps are 100 nano-second units since the Gregorian epoch,
  // (1582-10-15 00:00).  JSNumbers aren't precise enough for this, so
  // time is handled internally as 'msecs' (integer milliseconds) and 'nsecs'
  // (100-nanoseconds offset from msecs) since unix epoch, 1970-01-01 00:00.
  var msecs = options.msecs !== undefined ? options.msecs : new Date().getTime();

  // Per 4.2.1.2, use count of uuid's generated during the current clock
  // cycle to simulate higher resolution clock
  var nsecs = options.nsecs !== undefined ? options.nsecs : _lastNSecs + 1;

  // Time since last uuid creation (in msecs)
  var dt = (msecs - _lastMSecs) + (nsecs - _lastNSecs)/10000;

  // Per 4.2.1.2, Bump clockseq on clock regression
  if (dt < 0 && options.clockseq === undefined) {
    clockseq = clockseq + 1 & 0x3fff;
  }

  // Reset nsecs if clock regresses (new clockseq) or we've moved onto a new
  // time interval
  if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === undefined) {
    nsecs = 0;
  }

  // Per 4.2.1.2 Throw error if too many uuids are requested
  if (nsecs >= 10000) {
    throw new Error('uuid.v1(): Can\'t create more than 10M uuids/sec');
  }

  _lastMSecs = msecs;
  _lastNSecs = nsecs;
  _clockseq = clockseq;

  // Per 4.1.4 - Convert from unix epoch to Gregorian epoch
  msecs += 12219292800000;

  // `time_low`
  var tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
  b[i++] = tl >>> 24 & 0xff;
  b[i++] = tl >>> 16 & 0xff;
  b[i++] = tl >>> 8 & 0xff;
  b[i++] = tl & 0xff;

  // `time_mid`
  var tmh = (msecs / 0x100000000 * 10000) & 0xfffffff;
  b[i++] = tmh >>> 8 & 0xff;
  b[i++] = tmh & 0xff;

  // `time_high_and_version`
  b[i++] = tmh >>> 24 & 0xf | 0x10; // include version
  b[i++] = tmh >>> 16 & 0xff;

  // `clock_seq_hi_and_reserved` (Per 4.2.2 - include variant)
  b[i++] = clockseq >>> 8 | 0x80;

  // `clock_seq_low`
  b[i++] = clockseq & 0xff;

  // `node`
  var node = options.node || _nodeId;
  for (var n = 0; n < 6; ++n) {
    b[i + n] = node[n];
  }

  return buf ? buf : bytesToUuid(b);
}

module.exports = v1;


/***/ }),

/***/ 204:
/***/ (function(module, exports, __webpack_require__) {

var rng = __webpack_require__(130);
var bytesToUuid = __webpack_require__(131);

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof(options) == 'string') {
    buf = options == 'binary' ? new Array(16) : null;
    options = null;
  }
  options = options || {};

  var rnds = options.random || (options.rng || rng)();

  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
  rnds[6] = (rnds[6] & 0x0f) | 0x40;
  rnds[8] = (rnds[8] & 0x3f) | 0x80;

  // Copy bytes to buffer, if provided
  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid(rnds);
}

module.exports = v4;


/***/ }),

/***/ 205:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const { makeImmutable, isMap } = __webpack_require__(16);
const assert = __webpack_require__(25);

const validateId = function (propName, id) {
  assert.ok(id, `${propName} cannot be null`);
  id = parseInt(id);
  assert.ok(id === -1 || id > 0, `${propName} must be positive`);
  return id;
};

const validateAppState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  return state;
};

const api = {
  getPathByFrameKey: (state, frameKey) => {
    state = validateAppState(state);
    frameKey = validateId('frameKey', frameKey);
    let path = makeImmutable([]);
    const currentWindow = state.get('currentWindow');
    if (currentWindow) {
      state = currentWindow;
      // in ReduxComponent
      path = path.push('currentWindow');
    }

    if (state.get('frames')) {
      // in WindowState
      const index = state.get('frames').findIndex(frame => frame.get('key') === frameKey);
      if (index === -1) {
        return null;
      }
      return path.concat(['frames', index]);
    } else {
      // in AppState
      const index = state.get('tabs').findIndex(tab => tab.getIn(['frame', 'key']) === frameKey);
      if (index === -1) {
        return null;
      }
      return makeImmutable(['tabs', index, 'frame']);
    }
  },

  getPathByTabId: (state, tabId) => {
    state = validateAppState(state);
    tabId = validateId('tabId', tabId);
    let path = makeImmutable([]);
    const currentWindow = state.get('currentWindow');
    if (currentWindow) {
      // in ReduxComponent
      path = path.push('currentWindow');
      state = currentWindow;
    }

    // in WindowState
    const index = state.get('frames').findIndex(frame => frame.get('tabId') === tabId);
    if (index === -1) {
      return null;
    }
    return path.concat(['frames', index]);
  },

  getByFrameKey: (state, frameKey) => {
    const path = api.getPathByFrameKey(state, frameKey);
    if (path == null) {
      return null;
    }
    return state.getIn(path);
  },

  getByTabId: (state, tabId) => {
    const path = api.getPathByTabId(state, tabId);
    if (path == null) {
      return null;
    }
    return state.getIn(path);
  },

  getTabIdByFrameKey: (state, frameKey) => {
    const path = api.getPathByFrameKey(state, frameKey);
    if (path == null) {
      return null;
    }
    return state.getIn(path.concat('tabId')) || -1;
  }
};

module.exports = api;

/***/ }),

/***/ 206:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const mapValuesByKeys = __webpack_require__(35).mapValuesByKeys;

const _ = null;
const syncConstants = {
  SYNC_ADD_SITES: _, /** @param {Array.<Object>} items */
  SYNC_REMOVE_SITES: _, /** @param {Array.<Object>} items */
  SYNC_CLEAR_HISTORY: _,
  SYNC_CLEAR_SITE_SETTINGS: _
};

module.exports = mapValuesByKeys(syncConstants);

/***/ }),

/***/ 207:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const { getBraveExtUrl } = __webpack_require__(20);
const iconPath = getBraveExtUrl('img/newtab/defaultTopSitesIcon');

module.exports.pinnedTopSites = [{
  'key': 'https://twitter.com/brave/|0',
  'count': 0,
  'favicon': `${iconPath}/twitter.png`,
  'location': 'https://twitter.com/brave/',
  'themeColor': 'rgb(255, 255, 255)',
  'title': 'Brave Software (@brave) | Twitter'
}];

module.exports.topSites = [{
  'key': 'https://twitter.com/brave/|0',
  'count': 0,
  'favicon': `${iconPath}/twitter.png`,
  'location': 'https://twitter.com/brave',
  'themeColor': 'rgb(255, 255, 255)',
  'title': 'Brave Software (@brave) | Twitter'
}, {
  'key': 'https://www.facebook.com/BraveSoftware/|0',
  'count': 0,
  'favicon': `${iconPath}/facebook.png`,
  'location': 'https://www.facebook.com/BraveSoftware/',
  'themeColor': 'rgb(59, 89, 152)',
  'title': 'Brave Software | Facebook'
}, {
  'key': 'https://www.youtube.com/bravesoftware/|0',
  'count': 0,
  'favicon': `${iconPath}/youtube.png`,
  'location': 'https://www.youtube.com/bravesoftware/',
  'themeColor': '#E62117',
  'title': 'Brave Browser - YouTube'
}, {
  'key': 'https://brave.com/|0',
  'count': 0,
  'favicon': `${iconPath}/brave.ico`,
  'location': 'https://brave.com/',
  'themeColor': 'rgb(255, 255, 255)',
  'title': 'Brave Software | Building a Better Web'
}, {
  'key': 'https://itunes.apple.com/app/brave-web-browser/id1052879175?mt=8|0',
  'count': 0,
  'favicon': `${iconPath}/appstore.png`,
  'location': 'https://itunes.apple.com/app/brave-web-browser/id1052879175?mt=8',
  'themeColor': 'rgba(255, 255, 255, 1)',
  'title': 'Brave Web Browser: Fast with built-in adblock on the App Store'
}, {
  'key': 'https://play.google.com/store/apps/details?id=com.brave.browser|0',
  'count': 0,
  'favicon': `${iconPath}/playstore.png`,
  'location': 'https://play.google.com/store/apps/details?id=com.brave.browser',
  'themeColor': 'rgb(241, 241, 241)',
  'title': 'Brave Browser: Fast AdBlock – Apps para Android no Google Play'
}];

/***/ }),

/***/ 21:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const Immutable = __webpack_require__(1);
const assert = __webpack_require__(25);

// State
const frameState = __webpack_require__(205);
const windowState = __webpack_require__(63);

// utils
const { makeImmutable, isMap, isList } = __webpack_require__(16);
// this file should eventually replace frameStateUtil
const frameStateUtil = __webpack_require__(8);

const validateId = function (propName, id) {
  assert.ok(id, `${propName} cannot be null`);
  id = parseInt(id);
  assert.ok(id >= -2, `${propName} must be a valid`);
  return id;
};

const validateIndex = function (index) {
  index = parseInt(index);
  assert.ok(index >= -1);
  return index;
};

const validateTabs = function (tabs) {
  tabs = makeImmutable(tabs);
  assert.ok(isList(tabs), 'tabs must be an Immutable.List');
  tabs.forEach(tab => validateTabValue(tab));
  return tabs;
};

const validateState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  assert.ok(isList(state.get('tabs')), 'state must contain an Immutable.List of tabs');
  return state;
};

const validateWindowValue = function (windowValue) {
  windowValue = makeImmutable(windowValue);
  assert.ok(isMap(windowValue), 'windowValue must be an Immutable.Map');
  assert.ok(windowValue.get('windowId'), 'window must have a windowId');
  return windowValue;
};

const validateTabValue = function (tabValue) {
  tabValue = makeImmutable(tabValue);
  assert.ok(isMap(tabValue), 'tabValue must be an Immutable.Map');
  assert.ok(tabValue.get('tabId'), 'tab must have a tabId');
  return tabValue;
};

const validateAction = function (action) {
  action = makeImmutable(action);
  assert.ok(isMap(action), 'action must be an Immutable.Map');
  return action;
};

const matchTab = function (queryInfo, tab) {
  queryInfo = queryInfo.toJS ? queryInfo.toJS() : queryInfo;
  return !Object.keys(queryInfo).map(queryKey => tab.get(queryKey) === queryInfo[queryKey]).includes(false);
};

const updateLastActive = (state, oldTabValue, newTabValue) => {
  if (!newTabValue.get('active')) {
    return state;
  }

  const oldTabId = validateId('tabId', oldTabValue.get('tabId'));
  const oldWindowId = validateId('windowId', oldTabValue.get('windowId'));

  const tabId = validateId('tabId', newTabValue.get('tabId'));
  const windowId = validateId('windowId', newTabValue.get('windowId'));

  if (oldWindowId !== -1 && oldTabId !== tabState.TAB_ID_NONE) {
    let oldActiveList = state.getIn(['tabsInternal', 'lastActive', oldWindowId.toString()], Immutable.OrderedSet());
    oldActiveList = oldActiveList.remove(oldTabId);
    state = state.setIn(['tabsInternal', 'lastActive', oldWindowId.toString()], oldActiveList);
  }

  if (windowId !== -1 && tabId !== tabState.TAB_ID_NONE) {
    let activeList = state.getIn(['tabsInternal', 'lastActive', windowId.toString()], Immutable.OrderedSet());
    activeList = activeList.add(tabId);
    state = state.setIn(['tabsInternal', 'lastActive', windowId.toString()], activeList);
  }

  return state;
};

// index for looking up tabIds by their display index
const getTabIdByDisplayIndex = (state, windowId, index) => {
  index = validateIndex(index);
  windowId = validateId('windowId', windowId);
  const tabValue = tabState.queryTab(state, { windowId, index });
  if (!tabValue) {
    return tabState.TAB_ID_NONE;
  }
  return tabValue.get('tabId');
};

// The internal index is the location of the tabId in the tabs array
const getTabInternalIndexByTabId = (state, tabId) => {
  tabId = validateId('tabId', tabId);
  state = validateState(state);

  const index = state.getIn(['tabsInternal', 'index', tabId.toString()]);
  return index == null ? -1 : index;
};

const deleteTabsInternalIndex = (state, tabValue) => {
  const tabId = validateId('tabId', tabValue.get('tabId'));
  if (tabId === tabState.TAB_ID_NONE) {
    return state;
  }
  const windowId = validateId('windowId', tabValue.get('windowId'));
  if (windowId !== windowState.WINDOW_ID_NONE) {
    let activeList = state.getIn(['tabsInternal', 'lastActive', windowId.toString()], Immutable.OrderedSet());
    activeList = activeList.remove(tabId);
    state = state.setIn(['tabsInternal', 'lastActive', windowId.toString()], activeList);
  }
  return state.deleteIn(['tabsInternal', 'index', tabId.toString()]);
};

const updateTabsInternalIndex = (state, fromIndex) => {
  fromIndex = validateIndex(fromIndex);
  let tabsInternal = state.get('tabsInternal') || Immutable.Map();
  state.get('tabs').slice(fromIndex).forEach((tab, idx) => {
    const tabId = validateId('tabId', tab.get('tabId')).toString();
    if (tabId !== tabState.TAB_ID_NONE) {
      tabsInternal = tabsInternal.setIn(['index', tabId], (idx + fromIndex).toString());
    }
  });
  return state.set('tabsInternal', tabsInternal);
};

const tabState = {
  queryTab: (state, queryInfo) => {
    state = validateState(state);
    return state.get('tabs').filter(matchTab.bind(null, queryInfo)).get(0);
  },

  TAB_ID_NONE: -1,
  TAB_ID_ACTIVE: -2,

  validateTabId: tabId => {
    validateId('tabId', tabId);
  },

  removeTabByTabId: (state, tabId) => {
    tabId = validateId('tabId', tabId);
    state = validateState(state);

    let index = getTabInternalIndexByTabId(state, tabId);
    if (index === tabState.TAB_ID_NONE) {
      return state;
    }
    return tabState.removeTabByIndex(state, index);
  },

  removeTabByIndex: (state, index) => {
    index = parseInt(index);
    assert.ok(index >= 0, 'index must be positive');
    state = validateState(state);
    const tabValue = state.getIn(['tabs', index]);
    if (!tabValue) {
      return state;
    }
    state = deleteTabsInternalIndex(state, tabValue);
    state = state.set('tabs', state.get('tabs').delete(index));
    return updateTabsInternalIndex(state, index);
  },

  removeTab: (state, tabValue) => {
    state = validateState(state);
    tabValue = makeImmutable(tabValue);
    tabValue = validateTabValue(tabValue);
    let tabId = validateId('tabId', tabValue.get('tabId'));
    return tabState.removeTabByTabId(state, tabId);
  },

  insertTab: (state, action) => {
    action = validateAction(action);
    state = validateState(state);
    let tabValue = validateTabValue(action.get('tabValue'));
    assert.ok(!tabState.getTab(state, tabValue), 'Tab already exists');
    state = state.set('tabs', state.get('tabs').push(tabValue));
    state = updateLastActive(state, tabValue, tabValue);
    return updateTabsInternalIndex(state, state.get('tabs').size - 1);
  },

  maybeCreateTab: (state, action) => {
    action = validateAction(action);
    state = validateState(state);
    let tabValue = validateTabValue(action.get('tabValue'));

    if (tabState.getTab(state, tabValue)) {
      return tabState.updateTab(state, action);
    } else {
      return tabState.insertTab(state, action);
    }
  },

  getTabsByWindowId: (state, windowId) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return state.get('tabs').filter(tab => tab.get('windowId') === windowId);
  },

  getPinnedTabs: state => {
    state = validateState(state);
    return state.get('tabs').filter(tab => !!tab.get('pinned'));
  },

  isTabPinned: (state, tabId) => {
    state = validateState(state);
    tabId = validateId('tabId', tabId);
    const tab = tabState.getByTabId(state, tabId);
    return tab != null ? !!tab.get('pinned') : false;
  },

  getNonPinnedTabs: state => {
    state = validateState(state);
    return state.get('tabs').filter(tab => !tab.get('pinned'));
  },

  getPinnedTabsByWindowId: (state, windowId) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return tabState.getPinnedTabs(state).filter(tab => tab.get('windowId') === windowId);
  },

  getNonPinnedTabsByWindowId: (state, windowId) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return tabState.getNonPinnedTabs(state).filter(tab => tab.get('windowId') === windowId);
  },

  getMatchingTab: (state, createProperties) => {
    state = validateState(state);
    const windowId = validateId('windowId', createProperties.get('windowId'));
    return state.get('tabs').find(tab => tab.get('windowId') === windowId && tab.get('url') === createProperties.get('url') && (tab.get('partition') || 'persist:default') === (createProperties.get('partition') || 'persist:default'));
  },

  getTabsByWindow: (state, windowValue) => {
    state = validateState(state);
    windowValue = validateWindowValue(windowValue);
    let windowId = validateId('windowId', windowValue.get('windowId'));
    return state.get('tabs').filter(tab => tab.get('windowId') === windowId);
  },

  getPathByTabId: (state, tabId) => {
    tabId = tabState.resolveTabId(state, tabId);
    state = validateState(state);

    const index = getTabInternalIndexByTabId(state, tabId);
    if (index === tabState.TAB_ID_NONE) {
      return null;
    }
    return ['tabs', index];
  },

  getByTabId: (state, tabId) => {
    if (tabId === tabState.TAB_ID_NONE) {
      return null;
    }

    const path = tabState.getPathByTabId(state, tabId);
    if (path == null) {
      return null;
    }
    return state.getIn(path);
  },

  getTabIdByIndex: (state, windowId, index) => {
    if (index === -1) {
      return tabState.TAB_ID_NONE;
    }

    return getTabIdByDisplayIndex(state, windowId, index);
  },

  getNextTabIdByIndex: (state, windowId, index, includePinned = false) => {
    index = validateIndex(index);
    windowId = validateId('windowId', windowId);
    state = validateState(state);

    let nextTab = null;
    let done = false;
    let nextIndex = index + 1;
    // first look for any tabs after the index
    do {
      nextTab = tabState.getTabByIndex(state, windowId, nextIndex++);
      if (nextTab) {
        if (!includePinned && nextTab.get('pinned')) {
          nextTab = null;
        } else {
          done = true;
        }
      } else {
        done = true;
      }
    } while (!done);

    // if nothing after then check before
    if (!nextTab) {
      done = false;
    }
    let previousIndex = index - 1;
    while (previousIndex >= 0 && !done) {
      nextTab = tabState.getTabByIndex(state, windowId, previousIndex--);
      if (nextTab) {
        if (!includePinned && nextTab.get('pinned')) {
          nextTab = null;
        } else {
          done = true;
        }
      } else {
        done = true;
      }
    }

    return nextTab ? nextTab.get('tabId') : tabState.TAB_ID_NONE;
  },

  getTabByIndex: (state, windowId, index) => {
    const tabId = tabState.getTabIdByIndex(state, windowId, index);
    if (tabId === tabState.TAB_ID_NONE) {
      return null;
    }

    return tabState.getByTabId(state, tabId);
  },

  getTab: (state, tabValue) => {
    state = validateState(state);
    tabValue = validateTabValue(tabValue);
    let tabId = validateId('tabId', tabValue.get('tabId'));
    return tabState.getByTabId(state, tabId);
  },

  updateTab: (state, action) => {
    state = validateState(state);
    action = validateAction(action);
    return tabState.updateTabValue(state, action.get('tabValue'), action.get('replace'));
  },

  getTabs: state => {
    state = validateState(state);
    return state.get('tabs');
  },

  getLastActiveTabId: (state, windowId) => {
    const tabId = tabState.getTabsByLastActivated(state, windowId).slice(-2).first();
    if (tabId == null) {
      return tabState.TAB_ID_NONE;
    }
    return tabId;
  },

  getTabsByLastActivated: (state, windowId) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return state.getIn(['tabsInternal', 'lastActive', windowId.toString()], Immutable.OrderedSet());
  },

  setTabs: (state, tabs) => {
    state = validateState(state);
    tabs = validateTabs(tabs);
    return state.set('tabs', tabs);
  },

  updateTabValue: (state, tabValue, replace = false) => {
    tabValue = validateTabValue(tabValue);
    const tabs = state.get('tabs');
    const index = getTabInternalIndexByTabId(state, tabValue.get('tabId'));
    if (index === tabState.TAB_ID_NONE) {
      return state;
    }

    let currentTabValue = tabs.get(index);

    let tabId = tabValue.get('tabId');
    if (tabId) {
      tabId = validateId('tabId', tabId);
      let currentTabId = currentTabValue.get('tabId');
      if (currentTabId) {
        assert.ok(tabId === currentTabId, 'Changing a tabId is not allowed');
      }
    }
    if (!replace) {
      tabValue = currentTabValue.mergeDeep(tabValue);
    }

    state = updateLastActive(state, currentTabValue, tabValue);
    return state.set('tabs', tabs.delete(index).insert(index, tabValue));
  },

  replaceTabValue: (state, tabId, newTabValue) => {
    state = validateState(state);
    newTabValue = makeImmutable(newTabValue);
    // update tab
    const index = getTabInternalIndexByTabId(state, tabId);
    const oldTabValue = state.getIn(['tabs', index]);
    if (index == null || index === -1) {
      console.error(`tabState: cannot replace tab ${tabId} as tab's index did not exist in state`, { index });
      return state;
    }
    let mergedTabValue = oldTabValue.mergeDeep(newTabValue);
    if (mergedTabValue.has('frame')) {
      mergedTabValue = mergedTabValue.mergeIn(['frame'], {
        tabId: newTabValue.get('tabId'),
        guestInstanceId: newTabValue.get('guestInstanceId')
      });
    }
    mergedTabValue = mergedTabValue.set('windowId', oldTabValue.get('windowId'));
    state = state.set('tabs', state.get('tabs').delete(index).insert(index, mergedTabValue));
    // update tabId at tabsInternal index
    state = deleteTabsInternalIndex(state, oldTabValue);
    state = updateTabsInternalIndex(state, 0);
    return state;
  },

  removeTabField: (state, field) => {
    state = makeImmutable(state);

    let tabs = state.get('tabs');
    if (!tabs) {
      return state;
    }
    for (let i = 0; i < tabs.size; i++) {
      tabs = tabs.deleteIn([i, field]);
    }
    return state.set('tabs', tabs);
  },

  updateFrame: (state, action, shouldDebugTabEvents = false) => {
    state = validateState(state);
    action = validateAction(action);
    const tabId = action.getIn(['frame', 'tabId']);

    if (!tabId) {
      if (shouldDebugTabEvents) {
        console.log(`Tab [${tabId}] frame changed for tab - no tabId provided!`);
      }
      return state;
    }

    let tabValue = tabState.getByTabId(state, tabId);
    if (!tabValue) {
      if (shouldDebugTabEvents) {
        console.log(`Tab [${tabId}] frame changed for tab - tab not found in state, probably a temporary frame`);
      }
      return state;
    }

    if (shouldDebugTabEvents) {
      console.log(`Tab [${tabId}] frame changed for tab`);
    }

    const bookmarkUtil = __webpack_require__(40);
    const frameLocation = action.getIn(['frame', 'location']);
    const frameBookmarked = bookmarkUtil.isLocationBookmarked(state, frameLocation);
    const frameValue = action.get('frame').set('bookmarked', frameBookmarked);
    tabValue = tabValue.set('frame', makeImmutable(frameValue));
    return tabState.updateTabValue(state, tabValue);
  },

  getTabPropertyByTabId: (state, tabId, property, defaultValue = null) => {
    state = validateState(state);
    tabId = validateId('tabId', tabId);
    if (tabId === tabState.TAB_ID_NONE) {
      return defaultValue;
    }
    const tab = tabState.getByTabId(state, tabId);
    assert.ok(tab, `Could not find tab for ${tabId}`);
    const val = tab.get(property);
    return val == null ? defaultValue : val;
  },

  getWindowId: (state, tabId) => {
    return tabState.getTabPropertyByTabId(state, tabId, 'windowId', windowState.WINDOW_ID_NONE);
  },

  isIncognito: (state, tabId) => {
    return tabState.getTabPropertyByTabId(state, tabId, 'incognito', false);
  },

  canGoForward: (state, tabId) => {
    try {
      return tabState.getTabPropertyByTabId(state, tabId, 'canGoForward', false);
    } catch (e) {
      return false;
    }
  },

  canGoBack: (state, tabId) => {
    try {
      return tabState.getTabPropertyByTabId(state, tabId, 'canGoBack', false);
    } catch (e) {
      return false;
    }
  },

  isShowingMessageBox: (state, tabId) => {
    try {
      return tabState.getTabPropertyByTabId(state, tabId, 'messageBoxDetail', false);
    } catch (e) {
      return false;
    }
  },

  getTitle: (state, tabId) => {
    return tabState.getTabPropertyByTabId(state, tabId, 'title', '');
  },

  getOpenerTabId: (state, tabId) => {
    const openerTabId = tabState.getTabPropertyByTabId(state, tabId, 'openerTabId', tabState.TAB_ID_NONE);
    if (openerTabId !== tabState.TAB_ID_NONE) {
      // Validate that tab exists
      const tab = tabState.getByTabId(state, openerTabId);
      if (tab) {
        return openerTabId;
      }
    }
    return tabState.TAB_ID_NONE;
  },

  getIndex: (state, tabId) => {
    return tabState.getTabPropertyByTabId(state, tabId, 'index', -1);
  },

  isActive: (state, tabId) => {
    return tabState.getTabPropertyByTabId(state, tabId, 'active', false);
  },

  // TOOD(bridiver) - make everything work with TAB_ID_ACTIVE
  resolveTabId: (state, tabId) => {
    if (tabId == null) {
      tabId = tabState.TAB_ID_NONE;
    }
    if (tabId === tabState.TAB_ID_ACTIVE) {
      tabId = tabState.getActiveTabId(state);
    }
    return validateId('tabId', tabId);
  },

  getFramePathByTabId: (state, tabId) => {
    tabId = tabState.resolveTabId(state, tabId);
    state = makeImmutable(state);

    if (tabId === tabState.TAB_ID_NONE) {
      return null;
    }

    if (state.get('tabs') && !state.get('frames')) {
      const path = tabState.getPathByTabId(state, tabId);
      if (path == null) {
        return null;
      }
      return path.concat(['frame']);
    } else {
      return frameState.getPathByTabId(state, tabId);
    }
  },

  getActiveTab: (state, windowId = windowState.getActiveWindowId(state)) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return state.get('tabs').find(tab => tab.get('active') === true && tab.get('windowId') === windowId);
  },

  getActiveTabId: (state, windowId = windowState.getActiveWindowId(state)) => {
    const tab = tabState.getActiveTab(state, windowId);
    return tab ? tab.get('tabId') : tabState.TAB_ID_NONE;
  },

  getFrameByTabId: (state, tabId) => {
    const path = tabState.getFramePathByTabId(state, tabId);
    if (path == null) {
      return null;
    }
    return state.getIn(tabState.getFramePathByTabId(state, tabId));
  },

  isSecure: (state, tabId) => {
    const frame = tabState.getFrameByTabId(state, tabId);
    return frame ? frameStateUtil.isFrameSecure(frame) : null;
  },

  isLoading: (state, tabId) => {
    const frame = tabState.getFrameByTabId(state, tabId);
    return frame ? frameStateUtil.isFrameLoading(frame) : null;
  },

  startLoadTime: (state, tabId) => {
    const frame = tabState.getFrameByTabId(state, tabId);
    return frame ? frameStateUtil.startLoadTime(frame) : null;
  },

  endLoadTime: (state, tabId) => {
    const frame = tabState.getFrameByTabId(state, tabId);
    return frame ? frameStateUtil.endLoadTime(frame) : null;
  },

  getHistory: (state, tabId) => {
    const frame = tabState.getFrameByTabId(state, tabId);
    return frame ? frameStateUtil.getHistory(frame) : null;
  },

  getLocation: (state, tabId) => {
    const frame = tabState.getFrameByTabId(state, tabId);
    return frame && frame.get('location') || '';
  },

  getPersistentState: state => {
    state = makeImmutable(state);

    state = tabState.removeTabField(state, 'messageBoxDetail');
    state = tabState.removeTabField(state, 'frame');
    state = state.delete('tabsInternal');
    return state.set('tabs', Immutable.List());
  },

  setNavigationState: (state, tabId, navigationState) => {
    const tabValue = tabState.getByTabId(state, tabId);
    if (!tabValue) {
      return state;
    }
    const path = tabState.getPathByTabId(state, tabId);
    return path ? state.setIn(path.concat(['navigationState']), navigationState) : state;
  },

  getNavigationState: (state, tabId) => {
    const path = tabState.getPathByTabId(state, tabId);
    return path ? state.getIn(path.concat(['navigationState']), Immutable.Map()) : null;
  },

  getVisibleEntry: (state, tabId) => {
    const navigationState = tabState.getNavigationState(state, tabId);
    return navigationState ? navigationState.get('visibleEntry', '') : null;
  },

  getVisibleURL: (state, tabId) => {
    const entry = tabState.getVisibleEntry(state, tabId);
    return entry ? entry.get('url') : '';
  },

  getVisibleOrigin: (state, tabId) => {
    const entry = tabState.getVisibleEntry(state, tabId);
    const origin = entry ? entry.get('origin') : '';
    // TODO(bridiver) - all origins in browser-laptop should be changed to have a trailing slash to match chromium
    return (origin || '').replace(/\/$/, '');
  },

  getVisibleVirtualURL: (state, tabId) => {
    const entry = tabState.getVisibleEntry(state, tabId);
    return entry ? entry.get('virtualURL') : '';
  }
};

module.exports = tabState;

/***/ }),

/***/ 211:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(73)(false);
// imports


// module
exports.push([module.i, "/* This Source Code Form is subject to the terms of the Mozilla Public\n * License, v. 2.0. If a copy of the MPL was not distributed with this file,\n * You can obtain one at http://mozilla.org/MPL/2.0/. */\n:root {\n  --navbar-height: 36px;\n  --downloads-bar-height: 60px;\n}\n.switchControl {\n  display: flex;\n  align-items: center;\n  padding: 5px;\n}\n.switchControl.disabled .switchBackground {\n  opacity: 0.3;\n}\n.switchControl.disabled .switchControlRightText,\n.switchControl.disabled .switchControlLeftText {\n  opacity: 0.3;\n}\n.switchControl:not(.disabled) .switchBackground.switchedOn {\n  background-color: #ff6000;\n}\n.switchControl:not(.disabled) .switchBackground.switchedOn .switchIndicator {\n  right: 2px;\n}\n.switchControl.large .switchBackground {\n  height: 26px;\n  width: 60px;\n  background-color: #adadad;\n}\n.switchControl.large .switchBackground .switchIndicator {\n  height: 22px;\n  width: 22px;\n  right: calc(36px);\n}\n.switchControl.small .switchBackground {\n  height: 12px;\n  width: 30px;\n}\n.switchControl.small .switchBackground .switchIndicator {\n  height: 10px;\n  width: 10px;\n  top: 1px;\n  right: calc(18px);\n}\n.switchControl .switchControlText {\n  margin: auto 0;\n}\n.switchControl .switchControlTopText {\n  margin: 0 auto 5px auto;\n  color: #bbbbbe;\n}\n.switchControl .switchControlRight {\n  display: flex;\n}\n.switchControl .switchMiddle {\n  display: flex;\n  flex-direction: column;\n}\n.switchControl .switchBackground {\n  background-color: #ccc;\n  border-radius: 12px;\n  height: 16px;\n  position: relative;\n  width: 45px;\n  box-shadow: inset 0 1px 4px rgba(0, 0, 0, 0.35);\n  transition: background-color 100ms;\n}\n.switchControl .switchBackground .switchIndicator {\n  background-color: white;\n  border-radius: 100%;\n  height: 12px;\n  right: calc(31px);\n  position: absolute;\n  top: 2px;\n  width: 12px;\n  box-shadow: 1px 1px 5px -2px black;\n  transition: right 100ms;\n}\n", ""]);

// exports


/***/ }),

/***/ 22:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

/**
 * Converts an object with boolean properties to a CSS string.
 * Only the property names with truthy values are included.
 */
module.exports = obj => Object.keys(obj).filter(prop => obj[prop]).join(' ');

/***/ }),

/***/ 25:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {

// compare and isBuffer taken from https://github.com/feross/buffer/blob/680e9e5e488f22aac27599a57dc844a6315928dd/index.js
// original notice:

/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 * @license  MIT
 */
function compare(a, b) {
  if (a === b) {
    return 0;
  }

  var x = a.length;
  var y = b.length;

  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
    if (a[i] !== b[i]) {
      x = a[i];
      y = b[i];
      break;
    }
  }

  if (x < y) {
    return -1;
  }
  if (y < x) {
    return 1;
  }
  return 0;
}
function isBuffer(b) {
  if (global.Buffer && typeof global.Buffer.isBuffer === 'function') {
    return global.Buffer.isBuffer(b);
  }
  return !!(b != null && b._isBuffer);
}

// based on node assert, original notice:

// http://wiki.commonjs.org/wiki/Unit_Testing/1.0
//
// THIS IS NOT TESTED NOR LIKELY TO WORK OUTSIDE V8!
//
// Originally from narwhal.js (http://narwhaljs.org)
// Copyright (c) 2009 Thomas Robinson <280north.com>
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the 'Software'), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

var util = __webpack_require__(199);
var hasOwn = Object.prototype.hasOwnProperty;
var pSlice = Array.prototype.slice;
var functionsHaveNames = (function () {
  return function foo() {}.name === 'foo';
}());
function pToString (obj) {
  return Object.prototype.toString.call(obj);
}
function isView(arrbuf) {
  if (isBuffer(arrbuf)) {
    return false;
  }
  if (typeof global.ArrayBuffer !== 'function') {
    return false;
  }
  if (typeof ArrayBuffer.isView === 'function') {
    return ArrayBuffer.isView(arrbuf);
  }
  if (!arrbuf) {
    return false;
  }
  if (arrbuf instanceof DataView) {
    return true;
  }
  if (arrbuf.buffer && arrbuf.buffer instanceof ArrayBuffer) {
    return true;
  }
  return false;
}
// 1. The assert module provides functions that throw
// AssertionError's when particular conditions are not met. The
// assert module must conform to the following interface.

var assert = module.exports = ok;

// 2. The AssertionError is defined in assert.
// new assert.AssertionError({ message: message,
//                             actual: actual,
//                             expected: expected })

var regex = /\s*function\s+([^\(\s]*)\s*/;
// based on https://github.com/ljharb/function.prototype.name/blob/adeeeec8bfcc6068b187d7d9fb3d5bb1d3a30899/implementation.js
function getName(func) {
  if (!util.isFunction(func)) {
    return;
  }
  if (functionsHaveNames) {
    return func.name;
  }
  var str = func.toString();
  var match = str.match(regex);
  return match && match[1];
}
assert.AssertionError = function AssertionError(options) {
  this.name = 'AssertionError';
  this.actual = options.actual;
  this.expected = options.expected;
  this.operator = options.operator;
  if (options.message) {
    this.message = options.message;
    this.generatedMessage = false;
  } else {
    this.message = getMessage(this);
    this.generatedMessage = true;
  }
  var stackStartFunction = options.stackStartFunction || fail;
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, stackStartFunction);
  } else {
    // non v8 browsers so we can have a stacktrace
    var err = new Error();
    if (err.stack) {
      var out = err.stack;

      // try to strip useless frames
      var fn_name = getName(stackStartFunction);
      var idx = out.indexOf('\n' + fn_name);
      if (idx >= 0) {
        // once we have located the function frame
        // we need to strip out everything before it (and its line)
        var next_line = out.indexOf('\n', idx + 1);
        out = out.substring(next_line + 1);
      }

      this.stack = out;
    }
  }
};

// assert.AssertionError instanceof Error
util.inherits(assert.AssertionError, Error);

function truncate(s, n) {
  if (typeof s === 'string') {
    return s.length < n ? s : s.slice(0, n);
  } else {
    return s;
  }
}
function inspect(something) {
  if (functionsHaveNames || !util.isFunction(something)) {
    return util.inspect(something);
  }
  var rawname = getName(something);
  var name = rawname ? ': ' + rawname : '';
  return '[Function' +  name + ']';
}
function getMessage(self) {
  return truncate(inspect(self.actual), 128) + ' ' +
         self.operator + ' ' +
         truncate(inspect(self.expected), 128);
}

// At present only the three keys mentioned above are used and
// understood by the spec. Implementations or sub modules can pass
// other keys to the AssertionError's constructor - they will be
// ignored.

// 3. All of the following functions must throw an AssertionError
// when a corresponding condition is not met, with a message that
// may be undefined if not provided.  All assertion methods provide
// both the actual and expected values to the assertion error for
// display purposes.

function fail(actual, expected, message, operator, stackStartFunction) {
  throw new assert.AssertionError({
    message: message,
    actual: actual,
    expected: expected,
    operator: operator,
    stackStartFunction: stackStartFunction
  });
}

// EXTENSION! allows for well behaved errors defined elsewhere.
assert.fail = fail;

// 4. Pure assertion tests whether a value is truthy, as determined
// by !!guard.
// assert.ok(guard, message_opt);
// This statement is equivalent to assert.equal(true, !!guard,
// message_opt);. To test strictly for the value true, use
// assert.strictEqual(true, guard, message_opt);.

function ok(value, message) {
  if (!value) fail(value, true, message, '==', assert.ok);
}
assert.ok = ok;

// 5. The equality assertion tests shallow, coercive equality with
// ==.
// assert.equal(actual, expected, message_opt);

assert.equal = function equal(actual, expected, message) {
  if (actual != expected) fail(actual, expected, message, '==', assert.equal);
};

// 6. The non-equality assertion tests for whether two objects are not equal
// with != assert.notEqual(actual, expected, message_opt);

assert.notEqual = function notEqual(actual, expected, message) {
  if (actual == expected) {
    fail(actual, expected, message, '!=', assert.notEqual);
  }
};

// 7. The equivalence assertion tests a deep equality relation.
// assert.deepEqual(actual, expected, message_opt);

assert.deepEqual = function deepEqual(actual, expected, message) {
  if (!_deepEqual(actual, expected, false)) {
    fail(actual, expected, message, 'deepEqual', assert.deepEqual);
  }
};

assert.deepStrictEqual = function deepStrictEqual(actual, expected, message) {
  if (!_deepEqual(actual, expected, true)) {
    fail(actual, expected, message, 'deepStrictEqual', assert.deepStrictEqual);
  }
};

function _deepEqual(actual, expected, strict, memos) {
  // 7.1. All identical values are equivalent, as determined by ===.
  if (actual === expected) {
    return true;
  } else if (isBuffer(actual) && isBuffer(expected)) {
    return compare(actual, expected) === 0;

  // 7.2. If the expected value is a Date object, the actual value is
  // equivalent if it is also a Date object that refers to the same time.
  } else if (util.isDate(actual) && util.isDate(expected)) {
    return actual.getTime() === expected.getTime();

  // 7.3 If the expected value is a RegExp object, the actual value is
  // equivalent if it is also a RegExp object with the same source and
  // properties (`global`, `multiline`, `lastIndex`, `ignoreCase`).
  } else if (util.isRegExp(actual) && util.isRegExp(expected)) {
    return actual.source === expected.source &&
           actual.global === expected.global &&
           actual.multiline === expected.multiline &&
           actual.lastIndex === expected.lastIndex &&
           actual.ignoreCase === expected.ignoreCase;

  // 7.4. Other pairs that do not both pass typeof value == 'object',
  // equivalence is determined by ==.
  } else if ((actual === null || typeof actual !== 'object') &&
             (expected === null || typeof expected !== 'object')) {
    return strict ? actual === expected : actual == expected;

  // If both values are instances of typed arrays, wrap their underlying
  // ArrayBuffers in a Buffer each to increase performance
  // This optimization requires the arrays to have the same type as checked by
  // Object.prototype.toString (aka pToString). Never perform binary
  // comparisons for Float*Arrays, though, since e.g. +0 === -0 but their
  // bit patterns are not identical.
  } else if (isView(actual) && isView(expected) &&
             pToString(actual) === pToString(expected) &&
             !(actual instanceof Float32Array ||
               actual instanceof Float64Array)) {
    return compare(new Uint8Array(actual.buffer),
                   new Uint8Array(expected.buffer)) === 0;

  // 7.5 For all other Object pairs, including Array objects, equivalence is
  // determined by having the same number of owned properties (as verified
  // with Object.prototype.hasOwnProperty.call), the same set of keys
  // (although not necessarily the same order), equivalent values for every
  // corresponding key, and an identical 'prototype' property. Note: this
  // accounts for both named and indexed properties on Arrays.
  } else if (isBuffer(actual) !== isBuffer(expected)) {
    return false;
  } else {
    memos = memos || {actual: [], expected: []};

    var actualIndex = memos.actual.indexOf(actual);
    if (actualIndex !== -1) {
      if (actualIndex === memos.expected.indexOf(expected)) {
        return true;
      }
    }

    memos.actual.push(actual);
    memos.expected.push(expected);

    return objEquiv(actual, expected, strict, memos);
  }
}

function isArguments(object) {
  return Object.prototype.toString.call(object) == '[object Arguments]';
}

function objEquiv(a, b, strict, actualVisitedObjects) {
  if (a === null || a === undefined || b === null || b === undefined)
    return false;
  // if one is a primitive, the other must be same
  if (util.isPrimitive(a) || util.isPrimitive(b))
    return a === b;
  if (strict && Object.getPrototypeOf(a) !== Object.getPrototypeOf(b))
    return false;
  var aIsArgs = isArguments(a);
  var bIsArgs = isArguments(b);
  if ((aIsArgs && !bIsArgs) || (!aIsArgs && bIsArgs))
    return false;
  if (aIsArgs) {
    a = pSlice.call(a);
    b = pSlice.call(b);
    return _deepEqual(a, b, strict);
  }
  var ka = objectKeys(a);
  var kb = objectKeys(b);
  var key, i;
  // having the same number of owned properties (keys incorporates
  // hasOwnProperty)
  if (ka.length !== kb.length)
    return false;
  //the same set of keys (although not necessarily the same order),
  ka.sort();
  kb.sort();
  //~~~cheap key test
  for (i = ka.length - 1; i >= 0; i--) {
    if (ka[i] !== kb[i])
      return false;
  }
  //equivalent values for every corresponding key, and
  //~~~possibly expensive deep test
  for (i = ka.length - 1; i >= 0; i--) {
    key = ka[i];
    if (!_deepEqual(a[key], b[key], strict, actualVisitedObjects))
      return false;
  }
  return true;
}

// 8. The non-equivalence assertion tests for any deep inequality.
// assert.notDeepEqual(actual, expected, message_opt);

assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
  if (_deepEqual(actual, expected, false)) {
    fail(actual, expected, message, 'notDeepEqual', assert.notDeepEqual);
  }
};

assert.notDeepStrictEqual = notDeepStrictEqual;
function notDeepStrictEqual(actual, expected, message) {
  if (_deepEqual(actual, expected, true)) {
    fail(actual, expected, message, 'notDeepStrictEqual', notDeepStrictEqual);
  }
}


// 9. The strict equality assertion tests strict equality, as determined by ===.
// assert.strictEqual(actual, expected, message_opt);

assert.strictEqual = function strictEqual(actual, expected, message) {
  if (actual !== expected) {
    fail(actual, expected, message, '===', assert.strictEqual);
  }
};

// 10. The strict non-equality assertion tests for strict inequality, as
// determined by !==.  assert.notStrictEqual(actual, expected, message_opt);

assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
  if (actual === expected) {
    fail(actual, expected, message, '!==', assert.notStrictEqual);
  }
};

function expectedException(actual, expected) {
  if (!actual || !expected) {
    return false;
  }

  if (Object.prototype.toString.call(expected) == '[object RegExp]') {
    return expected.test(actual);
  }

  try {
    if (actual instanceof expected) {
      return true;
    }
  } catch (e) {
    // Ignore.  The instanceof check doesn't work for arrow functions.
  }

  if (Error.isPrototypeOf(expected)) {
    return false;
  }

  return expected.call({}, actual) === true;
}

function _tryBlock(block) {
  var error;
  try {
    block();
  } catch (e) {
    error = e;
  }
  return error;
}

function _throws(shouldThrow, block, expected, message) {
  var actual;

  if (typeof block !== 'function') {
    throw new TypeError('"block" argument must be a function');
  }

  if (typeof expected === 'string') {
    message = expected;
    expected = null;
  }

  actual = _tryBlock(block);

  message = (expected && expected.name ? ' (' + expected.name + ').' : '.') +
            (message ? ' ' + message : '.');

  if (shouldThrow && !actual) {
    fail(actual, expected, 'Missing expected exception' + message);
  }

  var userProvidedMessage = typeof message === 'string';
  var isUnwantedException = !shouldThrow && util.isError(actual);
  var isUnexpectedException = !shouldThrow && actual && !expected;

  if ((isUnwantedException &&
      userProvidedMessage &&
      expectedException(actual, expected)) ||
      isUnexpectedException) {
    fail(actual, expected, 'Got unwanted exception' + message);
  }

  if ((shouldThrow && actual && expected &&
      !expectedException(actual, expected)) || (!shouldThrow && actual)) {
    throw actual;
  }
}

// 11. Expected to throw an error:
// assert.throws(block, Error_opt, message_opt);

assert.throws = function(block, /*optional*/error, /*optional*/message) {
  _throws(true, block, error, message);
};

// EXTENSION! This is annoying to write outside this module.
assert.doesNotThrow = function(block, /*optional*/error, /*optional*/message) {
  _throws(false, block, error, message);
};

assert.ifError = function(err) { if (err) throw err; };

var objectKeys = Object.keys || function (obj) {
  var keys = [];
  for (var key in obj) {
    if (hasOwn.call(obj, key)) keys.push(key);
  }
  return keys;
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(31)))

/***/ }),

/***/ 28:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const React = __webpack_require__(3);

class ImmutableComponent extends React.Component {
  shouldComponentUpdate(nextProps) {
    return Object.keys(nextProps).some(prop => nextProps[prop] !== this.props[prop]);
  }
}

module.exports = ImmutableComponent;

/***/ }),

/***/ 3:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = __webpack_require__(59);


/***/ }),

/***/ 32:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const windowState = __webpack_require__(63);
let currentWindowId = -1;
let currentWindow = null;

const isMaximized = state => {
  const win = windowState.getByWindowId(state, currentWindowId);
  return win && win.get('state') === 'maximized' || false;
};

const isFullScreen = state => {
  const win = windowState.getByWindowId(state, currentWindowId);
  return win && win.get('state') === 'fullscreen' || false;
};

const isFocused = state => {
  const win = windowState.getByWindowId(state, currentWindowId);
  return win && win.get('focused') || false;
};

module.exports = {
  getCurrentWindowId: () => {
    return currentWindowId;
  },
  setWindowId: windowId => {
    currentWindowId = windowId;
  },
  // lazy load this
  getCurrentWindow: () => {
    return currentWindow || (currentWindow = __webpack_require__(18).remote.getCurrentWindow());
  },
  isMaximized,
  isFocused,
  isFullScreen
};

/***/ }),

/***/ 354:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = { "Webkit": { "transform": true, "transformOrigin": true, "transformOriginX": true, "transformOriginY": true, "backfaceVisibility": true, "perspective": true, "perspectiveOrigin": true, "transformStyle": true, "transformOriginZ": true, "animation": true, "animationDelay": true, "animationDirection": true, "animationFillMode": true, "animationDuration": true, "animationIterationCount": true, "animationName": true, "animationPlayState": true, "animationTimingFunction": true, "appearance": true, "userSelect": true, "fontKerning": true, "textEmphasisPosition": true, "textEmphasis": true, "textEmphasisStyle": true, "textEmphasisColor": true, "boxDecorationBreak": true, "clipPath": true, "maskImage": true, "maskMode": true, "maskRepeat": true, "maskPosition": true, "maskClip": true, "maskOrigin": true, "maskSize": true, "maskComposite": true, "mask": true, "maskBorderSource": true, "maskBorderMode": true, "maskBorderSlice": true, "maskBorderWidth": true, "maskBorderOutset": true, "maskBorderRepeat": true, "maskBorder": true, "maskType": true, "textDecorationStyle": true, "textDecorationSkip": true, "textDecorationLine": true, "textDecorationColor": true, "filter": true, "fontFeatureSettings": true, "breakAfter": true, "breakBefore": true, "breakInside": true, "columnCount": true, "columnFill": true, "columnGap": true, "columnRule": true, "columnRuleColor": true, "columnRuleStyle": true, "columnRuleWidth": true, "columns": true, "columnSpan": true, "columnWidth": true, "flex": true, "flexBasis": true, "flexDirection": true, "flexGrow": true, "flexFlow": true, "flexShrink": true, "flexWrap": true, "alignContent": true, "alignItems": true, "alignSelf": true, "justifyContent": true, "order": true, "transition": true, "transitionDelay": true, "transitionDuration": true, "transitionProperty": true, "transitionTimingFunction": true, "backdropFilter": true, "scrollSnapType": true, "scrollSnapPointsX": true, "scrollSnapPointsY": true, "scrollSnapDestination": true, "scrollSnapCoordinate": true, "shapeImageThreshold": true, "shapeImageMargin": true, "shapeImageOutside": true, "hyphens": true, "flowInto": true, "flowFrom": true, "regionFragment": true, "textSizeAdjust": true }, "Moz": { "appearance": true, "userSelect": true, "boxSizing": true, "textAlignLast": true, "textDecorationStyle": true, "textDecorationSkip": true, "textDecorationLine": true, "textDecorationColor": true, "tabSize": true, "hyphens": true, "fontFeatureSettings": true, "breakAfter": true, "breakBefore": true, "breakInside": true, "columnCount": true, "columnFill": true, "columnGap": true, "columnRule": true, "columnRuleColor": true, "columnRuleStyle": true, "columnRuleWidth": true, "columns": true, "columnSpan": true, "columnWidth": true }, "ms": { "flex": true, "flexBasis": false, "flexDirection": true, "flexGrow": false, "flexFlow": true, "flexShrink": false, "flexWrap": true, "alignContent": false, "alignItems": false, "alignSelf": false, "justifyContent": false, "order": false, "transform": true, "transformOrigin": true, "transformOriginX": true, "transformOriginY": true, "userSelect": true, "wrapFlow": true, "wrapThrough": true, "wrapMargin": true, "scrollSnapType": true, "scrollSnapPointsX": true, "scrollSnapPointsY": true, "scrollSnapDestination": true, "scrollSnapCoordinate": true, "touchAction": true, "hyphens": true, "flowInto": true, "flowFrom": true, "breakBefore": true, "breakAfter": true, "breakInside": true, "regionFragment": true, "gridTemplateColumns": true, "gridTemplateRows": true, "gridTemplateAreas": true, "gridTemplate": true, "gridAutoColumns": true, "gridAutoRows": true, "gridAutoFlow": true, "grid": true, "gridRowStart": true, "gridColumnStart": true, "gridRowEnd": true, "gridRow": true, "gridColumn": true, "gridColumnEnd": true, "gridColumnGap": true, "gridRowGap": true, "gridArea": true, "gridGap": true, "textSizeAdjust": true } };
module.exports = exports["default"];

/***/ }),

/***/ 355:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// helper to capitalize strings

exports.default = function (str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
};

module.exports = exports["default"];

/***/ }),

/***/ 356:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _util = __webpack_require__(193);

var _inject = __webpack_require__(357);

var StyleSheet = {
    create: function create(sheetDefinition) {
        return (0, _util.mapObj)(sheetDefinition, function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2);

            var key = _ref2[0];
            var val = _ref2[1];

            return [key, {
                // TODO(emily): Make a 'production' mode which doesn't prepend
                // the class name here, to make the generated CSS smaller.
                _name: key + '_' + (0, _util.hashObject)(val),
                _definition: val
            }];
        });
    },

    rehydrate: function rehydrate() {
        var renderedClassNames = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];

        (0, _inject.addRenderedClassNames)(renderedClassNames);
    }
};

/**
 * Utilities for using Aphrodite server-side.
 */
var StyleSheetServer = {
    renderStatic: function renderStatic(renderFunc) {
        (0, _inject.reset)();
        (0, _inject.startBuffering)();
        var html = renderFunc();
        var cssContent = (0, _inject.flushToString)();

        return {
            html: html,
            css: {
                content: cssContent,
                renderedClassNames: (0, _inject.getRenderedClassNames)()
            }
        };
    }
};

/**
 * Utilities for using Aphrodite in tests.
 *
 * Not meant to be used in production.
 */
var StyleSheetTestUtils = {
    /**
     * Prevent styles from being injected into the DOM.
     *
     * This is useful in situations where you'd like to test rendering UI
     * components which use Aphrodite without any of the side-effects of
     * Aphrodite happening. Particularly useful for testing the output of
     * components when you have no DOM, e.g. testing in Node without a fake DOM.
     *
     * Should be paired with a subsequent call to
     * clearBufferAndResumeStyleInjection.
     */
    suppressStyleInjection: function suppressStyleInjection() {
        (0, _inject.reset)();
        (0, _inject.startBuffering)();
    },

    /**
     * Opposite method of preventStyleInject.
     */
    clearBufferAndResumeStyleInjection: function clearBufferAndResumeStyleInjection() {
        (0, _inject.reset)();
    }
};

/**
 * Generate the Aphrodite API exports, with given `selectorHandlers` and
 * `useImportant` state.
 */
var makeExports = function makeExports(useImportant, selectorHandlers) {
    return {
        StyleSheet: _extends({}, StyleSheet, {

            /**
             * Returns a version of the exports of Aphrodite (i.e. an object
             * with `css` and `StyleSheet` properties) which have some
             * extensions included.
             *
             * @param {Array.<Object>} extensions: An array of extensions to
             *     add to this instance of Aphrodite. Each object should have a
             *     single property on it, defining which kind of extension to
             *     add.
             * @param {SelectorHandler} [extensions[].selectorHandler]: A
             *     selector handler extension. See `defaultSelectorHandlers` in
             *     generate.js.
             *
             * @returns {Object} An object containing the exports of the new
             *     instance of Aphrodite.
             */
            extend: function extend(extensions) {
                var extensionSelectorHandlers = extensions
                // Pull out extensions with a selectorHandler property
                .map(function (extension) {
                    return extension.selectorHandler;
                })
                // Remove nulls (i.e. extensions without a selectorHandler
                // property).
                .filter(function (handler) {
                    return handler;
                });

                return makeExports(useImportant, selectorHandlers.concat(extensionSelectorHandlers));
            }
        }),

        StyleSheetServer: StyleSheetServer,
        StyleSheetTestUtils: StyleSheetTestUtils,

        css: function css() {
            for (var _len = arguments.length, styleDefinitions = Array(_len), _key = 0; _key < _len; _key++) {
                styleDefinitions[_key] = arguments[_key];
            }

            return (0, _inject.injectAndGetClassName)(useImportant, styleDefinitions, selectorHandlers);
        }
    };
};

module.exports = makeExports;

/***/ }),

/***/ 357:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _asap = __webpack_require__(492);

var _asap2 = _interopRequireDefault(_asap);

var _generate = __webpack_require__(194);

var _util = __webpack_require__(193);

// The current <style> tag we are inserting into, or null if we haven't
// inserted anything yet. We could find this each time using
// `document.querySelector("style[data-aphrodite"])`, but holding onto it is
// faster.
var styleTag = null;

// Inject a string of styles into a <style> tag in the head of the document. This
// will automatically create a style tag and then continue to use it for
// multiple injections. It will also use a style tag with the `data-aphrodite`
// tag on it if that exists in the DOM. This could be used for e.g. reusing the
// same style tag that server-side rendering inserts.
var injectStyleTag = function injectStyleTag(cssContents) {
    if (styleTag == null) {
        // Try to find a style tag with the `data-aphrodite` attribute first.
        styleTag = document.querySelector("style[data-aphrodite]");

        // If that doesn't work, generate a new style tag.
        if (styleTag == null) {
            // Taken from
            // http://stackoverflow.com/questions/524696/how-to-create-a-style-tag-with-javascript
            var head = document.head || document.getElementsByTagName('head')[0];
            styleTag = document.createElement('style');

            styleTag.type = 'text/css';
            styleTag.setAttribute("data-aphrodite", "");
            head.appendChild(styleTag);
        }
    }

    if (styleTag.styleSheet) {
        styleTag.styleSheet.cssText += cssContents;
    } else {
        styleTag.appendChild(document.createTextNode(cssContents));
    }
};

// Custom handlers for stringifying CSS values that have side effects
// (such as fontFamily, which can cause @font-face rules to be injected)
var stringHandlers = {
    // With fontFamily we look for objects that are passed in and interpret
    // them as @font-face rules that we need to inject. The value of fontFamily
    // can either be a string (as normal), an object (a single font face), or
    // an array of objects and strings.
    fontFamily: function fontFamily(val) {
        if (Array.isArray(val)) {
            return val.map(fontFamily).join(",");
        } else if (typeof val === "object") {
            injectStyleOnce(val.src, "@font-face", [val], false);
            return '"' + val.fontFamily + '"';
        } else {
            return val;
        }
    },

    // With animationName we look for an object that contains keyframes and
    // inject them as an `@keyframes` block, returning a uniquely generated
    // name. The keyframes object should look like
    //  animationName: {
    //    from: {
    //      left: 0,
    //      top: 0,
    //    },
    //    '50%': {
    //      left: 15,
    //      top: 5,
    //    },
    //    to: {
    //      left: 20,
    //      top: 20,
    //    }
    //  }
    // TODO(emily): `stringHandlers` doesn't let us rename the key, so I have
    // to use `animationName` here. Improve that so we can call this
    // `animation` instead of `animationName`.
    animationName: function animationName(val, selectorHandlers) {
        if (Array.isArray(val)) {
            return val.map(function (v) {
                return animationName(v, selectorHandlers);
            }).join(",");
        } else if (typeof val === "object") {
            // Generate a unique name based on the hash of the object. We can't
            // just use the hash because the name can't start with a number.
            // TODO(emily): this probably makes debugging hard, allow a custom
            // name?
            var _name = 'keyframe_' + (0, _util.hashObject)(val);

            // Since keyframes need 3 layers of nesting, we use `generateCSS` to
            // build the inner layers and wrap it in `@keyframes` ourselves.
            var finalVal = '@keyframes ' + _name + '{';
            Object.keys(val).forEach(function (key) {
                finalVal += (0, _generate.generateCSS)(key, [val[key]], selectorHandlers, stringHandlers, false);
            });
            finalVal += '}';

            injectGeneratedCSSOnce(_name, finalVal);

            return _name;
        } else {
            return val;
        }
    }
};

// This is a map from Aphrodite's generated class names to `true` (acting as a
// set of class names)
var alreadyInjected = {};

// This is the buffer of styles which have not yet been flushed.
var injectionBuffer = "";

// A flag to tell if we are already buffering styles. This could happen either
// because we scheduled a flush call already, so newly added styles will
// already be flushed, or because we are statically buffering on the server.
var isBuffering = false;

var injectGeneratedCSSOnce = function injectGeneratedCSSOnce(key, generatedCSS) {
    if (!alreadyInjected[key]) {
        if (!isBuffering) {
            // We should never be automatically buffering on the server (or any
            // place without a document), so guard against that.
            if (typeof document === "undefined") {
                throw new Error("Cannot automatically buffer without a document");
            }

            // If we're not already buffering, schedule a call to flush the
            // current styles.
            isBuffering = true;
            (0, _asap2['default'])(flushToStyleTag);
        }

        injectionBuffer += generatedCSS;
        alreadyInjected[key] = true;
    }
};

var injectStyleOnce = function injectStyleOnce(key, selector, definitions, useImportant, selectorHandlers) {
    if (!alreadyInjected[key]) {
        var generated = (0, _generate.generateCSS)(selector, definitions, selectorHandlers, stringHandlers, useImportant);

        injectGeneratedCSSOnce(key, generated);
    }
};

exports.injectStyleOnce = injectStyleOnce;
var reset = function reset() {
    injectionBuffer = "";
    alreadyInjected = {};
    isBuffering = false;
    styleTag = null;
};

exports.reset = reset;
var startBuffering = function startBuffering() {
    if (isBuffering) {
        throw new Error("Cannot buffer while already buffering");
    }
    isBuffering = true;
};

exports.startBuffering = startBuffering;
var flushToString = function flushToString() {
    isBuffering = false;
    var ret = injectionBuffer;
    injectionBuffer = "";
    return ret;
};

exports.flushToString = flushToString;
var flushToStyleTag = function flushToStyleTag() {
    var cssContent = flushToString();
    if (cssContent.length > 0) {
        injectStyleTag(cssContent);
    }
};

exports.flushToStyleTag = flushToStyleTag;
var getRenderedClassNames = function getRenderedClassNames() {
    return Object.keys(alreadyInjected);
};

exports.getRenderedClassNames = getRenderedClassNames;
var addRenderedClassNames = function addRenderedClassNames(classNames) {
    classNames.forEach(function (className) {
        alreadyInjected[className] = true;
    });
};

exports.addRenderedClassNames = addRenderedClassNames;
/**
 * Inject styles associated with the passed style definition objects, and return
 * an associated CSS class name.
 *
 * @param {boolean} useImportant If true, will append !important to generated
 *     CSS output. e.g. {color: red} -> "color: red !important".
 * @param {(Object|Object[])[]} styleDefinitions style definition objects, or
 *     arbitrarily nested arrays of them, as returned as properties of the
 *     return value of StyleSheet.create().
 */
var injectAndGetClassName = function injectAndGetClassName(useImportant, styleDefinitions, selectorHandlers) {
    styleDefinitions = (0, _util.flattenDeep)(styleDefinitions);

    // Filter out falsy values from the input, to allow for
    // `css(a, test && c)`
    var validDefinitions = styleDefinitions.filter(function (def) {
        return def;
    });

    // Break if there aren't any valid styles.
    if (validDefinitions.length === 0) {
        return "";
    }

    var className = validDefinitions.map(function (s) {
        return s._name;
    }).join("-o_O-");
    injectStyleOnce(className, '.' + className, validDefinitions.map(function (d) {
        return d._definition;
    }), useImportant, selectorHandlers);

    return className;
};
exports.injectAndGetClassName = injectAndGetClassName;

/***/ }),

/***/ 38:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const mapValuesByKeys = __webpack_require__(35).mapValuesByKeys;

const _ = null;
const siteTags = {
  BOOKMARK: _,
  BOOKMARK_FOLDER: _,
  HISTORY: _
};

module.exports = mapValuesByKeys(siteTags);

/***/ }),

/***/ 39:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const assert = __webpack_require__(25);
const Immutable = __webpack_require__(1);

// Constants
const settings = __webpack_require__(11);
const siteTags = __webpack_require__(38);
const { STATE_SITES } = __webpack_require__(95);

// State
const bookmarkOrderCache = __webpack_require__(132);
const bookmarkFoldersState = __webpack_require__(98);

// Actions
const syncActions = __webpack_require__(133);

// Utils
const UrlUtil = __webpack_require__(14);
const bookmarkLocationCache = __webpack_require__(124);
const { getSetting } = __webpack_require__(13);
const { makeImmutable, isMap } = __webpack_require__(16);

const validateState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  assert.ok(isMap(state.get(STATE_SITES.BOOKMARKS)), 'state must contain an Immutable.Map of bookmarks');
  return state;
};

const bookmarksState = {
  getBookmarks: state => {
    state = validateState(state);
    return state.get(STATE_SITES.BOOKMARKS) || Immutable.Map();
  },

  getBookmark: (state, key) => {
    state = validateState(state);

    if (key == null) {
      return Immutable.Map();
    }

    return state.getIn([STATE_SITES.BOOKMARKS, key], Immutable.Map());
  },

  /**
   * Use this function if you only have a key and don't know if key is for folder or regular bookmark
   * @param state
   * @param key
   */
  findBookmark: (state, key) => {
    state = validateState(state);

    if (key == null) {
      return Immutable.Map();
    }

    let bookmark = bookmarksState.getBookmark(state, key);
    if (bookmark.isEmpty()) {
      bookmark = bookmarkFoldersState.getFolder(state, key);
    }

    return bookmark;
  },

  getBookmarksWithFolders: (state, parentFolderId = 0) => {
    state = validateState(state);

    const cache = bookmarkOrderCache.getBookmarksWithFolders(state, parentFolderId);
    let bookmarks = Immutable.List();

    for (let item of cache) {
      if (item.get('type') === siteTags.BOOKMARK) {
        bookmarks = bookmarks.push(bookmarksState.getBookmark(state, item.get('key')));
      } else {
        bookmarks = bookmarks.push(bookmarkFoldersState.getFolder(state, item.get('key')));
      }
    }

    return bookmarks;
  },

  addBookmark: (state, bookmarkDetail, destinationKey, isLeftSide) => {
    state = validateState(state);

    if (bookmarkDetail == null) {
      return state;
    }

    bookmarkDetail = makeImmutable(bookmarkDetail);

    const key = bookmarkDetail.get('key');
    if (key == null) {
      return state;
    }

    if (!state.hasIn([STATE_SITES.BOOKMARKS, key])) {
      state = bookmarkLocationCache.addCacheKey(state, bookmarkDetail.get('location'), key);
      state = bookmarkOrderCache.addBookmarkToCache(state, bookmarkDetail.get('parentFolderId'), key, destinationKey, isLeftSide);
    }

    state = state.setIn([STATE_SITES.BOOKMARKS, key], bookmarkDetail);
    return state;
  },

  editBookmark: (state, oldBookmark, bookmarkDetail) => {
    state = validateState(state);

    if (oldBookmark == null || bookmarkDetail == null) {
      return state;
    }

    bookmarkDetail = makeImmutable(bookmarkDetail);
    oldBookmark = makeImmutable(oldBookmark);

    const newKey = bookmarkDetail.get('key');
    const editKey = oldBookmark.get('key');

    if (editKey !== newKey) {
      state = state.deleteIn([STATE_SITES.BOOKMARKS, editKey]);
      state = bookmarkOrderCache.removeCacheKey(state, oldBookmark.get('parentFolderId'), editKey);
      state = bookmarkOrderCache.addBookmarkToCache(state, bookmarkDetail.get('parentFolderId'), newKey);
      bookmarkDetail = bookmarkDetail.set('key', newKey);
    }

    state = state.setIn([STATE_SITES.BOOKMARKS, newKey], bookmarkDetail);
    state = bookmarkLocationCache.removeCacheKey(state, oldBookmark.get('location'), editKey);
    state = bookmarkLocationCache.addCacheKey(state, bookmarkDetail.get('location'), newKey);
    return state;
  },

  removeBookmark: (state, bookmarkKey) => {
    state = validateState(state);

    if (bookmarkKey == null) {
      return state;
    }

    const bookmark = bookmarksState.getBookmark(state, bookmarkKey);

    if (bookmark.isEmpty()) {
      return state;
    }

    if (getSetting(settings.SYNC_ENABLED) === true) {
      syncActions.removeSites([bookmark.toJS()]);
    }

    state = bookmarkLocationCache.removeCacheKey(state, bookmark.get('location'), bookmarkKey);
    state = bookmarkOrderCache.removeCacheKey(state, bookmark.get('parentFolderId'), bookmarkKey);

    return state.deleteIn([STATE_SITES.BOOKMARKS, bookmarkKey]);
  },

  /**
   * Removes bookmarks based on the parent ID
   * Cache is cleared in the function that is calling this one
   * @param state - App state
   * @param parentFolderId - parent id of the folder that we are deleting
   */
  removeBookmarksByParentId: (state, parentFolderId) => {
    state = validateState(state);

    if (parentFolderId == null) {
      return state;
    }

    parentFolderId = Number(parentFolderId);

    const syncEnabled = getSetting(settings.SYNC_ENABLED) === true;
    const removedBookmarks = [];
    const bookmarks = bookmarksState.getBookmarks(state).filter(bookmark => {
      if (bookmark.get('parentFolderId') !== parentFolderId) {
        return true;
      }

      if (syncEnabled) {
        removedBookmarks.push(bookmark.toJS());
      }

      state = bookmarkLocationCache.removeCacheKey(state, bookmark.get('location'), bookmark.get('key'));
      state = bookmarkOrderCache.removeCacheKey(state, bookmark.get('parentFolderId'), bookmark.get('key'));
      return false;
    });

    if (syncEnabled && removedBookmarks.length) {
      syncActions.removeSites(removedBookmarks);
    }

    return state.set(STATE_SITES.BOOKMARKS, bookmarks);
  },

  /**
   * Update the favicon URL for all entries in the state sites
   * which match a given location. Currently, there should only be
   * one match, but this will handle multiple.
   *
   * @param state The application state
   * @param location URL for the entry needing an update
   * @param favicon favicon URL
   */
  updateFavicon: (state, location, favicon) => {
    state = validateState(state);

    if (UrlUtil.isNotURL(location)) {
      return state;
    }

    const siteKeys = bookmarkLocationCache.getCacheKey(state, location);
    if (siteKeys.isEmpty()) {
      return state;
    }

    siteKeys.forEach(siteKey => {
      if (state.getIn([STATE_SITES.BOOKMARKS, siteKey])) {
        state = state.setIn([STATE_SITES.BOOKMARKS, siteKey, 'favicon'], favicon);
      }
    });
    return state;
  },

  moveBookmark: (state, bookmarkKey, destinationKey, append, moveIntoParent) => {
    state = validateState(state);

    const bookmarkUtil = __webpack_require__(40);
    let bookmark = bookmarksState.getBookmark(state, bookmarkKey);
    if (bookmark.isEmpty()) {
      return state;
    }

    let destinationItem = bookmarksState.findBookmark(state, destinationKey);
    const numKey = Number(destinationKey);
    if (destinationItem.isEmpty() && numKey !== -1 && numKey !== 0) {
      return state;
    }

    // move bookmark into a new folder
    if (moveIntoParent || destinationItem.get('parentFolderId') !== bookmark.get('parentFolderId')) {
      let parentFolderId = destinationItem.get('type') === siteTags.BOOKMARK ? destinationItem.get('parentFolderId') : destinationItem.get('folderId');

      // always use parent ID when we are not moving into the folder
      if (!moveIntoParent) {
        parentFolderId = destinationItem.get('parentFolderId');
      }

      if (parentFolderId == null) {
        parentFolderId = destinationKey;
      }

      state = bookmarkOrderCache.removeCacheKey(state, bookmark.get('parentFolderId'), bookmarkKey);
      state = bookmarkLocationCache.removeCacheKey(state, bookmark.get('location'), bookmarkKey);
      bookmark = bookmark.set('parentFolderId', Number(parentFolderId));
      const newKey = bookmarkUtil.getKey(bookmark);

      state = state.deleteIn([STATE_SITES.BOOKMARKS, bookmarkKey]);
      state = bookmarkOrderCache.addBookmarkToCache(state, bookmark.get('parentFolderId'), newKey);
      state = bookmarkLocationCache.addCacheKey(state, bookmark.get('location'), newKey);

      bookmark = bookmark.set('key', newKey);
      return state.setIn([STATE_SITES.BOOKMARKS, newKey], bookmark);
    }

    // move bookmark to another place
    state = bookmarkOrderCache.removeCacheKey(state, bookmark.get('parentFolderId'), bookmarkKey);
    state = bookmarkOrderCache.addBookmarkToCache(state, bookmark.get('parentFolderId'), bookmarkKey, destinationKey, append);
    return state;
  },

  /**
   * Get bookmarks relative to a parent folder
   * @param state - The application state
   * @param folderKey The folder key to filter to
   */
  getBookmarksByParentId: (state, folderKey) => {
    if (folderKey == null) {
      return Immutable.List();
    }

    const cache = bookmarkOrderCache.getBookmarksByParentId(state, folderKey);
    return cache.map(item => bookmarksState.getBookmark(state, item.get('key')));
  },

  setWidth: (state, key, width) => {
    width = parseFloat(width);

    if (key == null || isNaN(width)) {
      return state;
    }

    return state.setIn([STATE_SITES.BOOKMARKS, key, 'width'], width);
  }
};

module.exports = bookmarksState;

/***/ }),

/***/ 40:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const Immutable = __webpack_require__(1);

// State
const bookmarksState = __webpack_require__(39);
const tabState = __webpack_require__(21);
const historyState = __webpack_require__(136);

// Constants
const dragTypes = __webpack_require__(58);
const { bookmarksToolbarMode } = __webpack_require__(52);
const settings = __webpack_require__(11);
const siteTags = __webpack_require__(38);
const newTabData = __webpack_require__(207);

// Utils
const bookmarkLocationCache = __webpack_require__(124);
const { getSetting } = __webpack_require__(13);
const UrlUtil = __webpack_require__(14);
const { makeImmutable } = __webpack_require__(16);

const bookmarkHangerHeading = (editMode, isAdded) => {
  if (isAdded) {
    return 'bookmarkAdded';
  }

  return editMode ? 'bookmarkEdit' : 'bookmarkCreateNew';
};

const isBookmarkNameValid = location => {
  return location != null && location.trim().length > 0;
};

const showOnlyText = () => {
  const btbMode = getSetting(settings.BOOKMARKS_TOOLBAR_MODE);
  return btbMode === bookmarksToolbarMode.TEXT_ONLY;
};

const showTextAndFavicon = () => {
  const btbMode = getSetting(settings.BOOKMARKS_TOOLBAR_MODE);
  return btbMode === bookmarksToolbarMode.TEXT_AND_FAVICONS;
};

const showOnlyFavicon = () => {
  const btbMode = getSetting(settings.BOOKMARKS_TOOLBAR_MODE);
  return btbMode === bookmarksToolbarMode.FAVICONS_ONLY;
};

const showFavicon = () => {
  const btbMode = getSetting(settings.BOOKMARKS_TOOLBAR_MODE);
  return btbMode === bookmarksToolbarMode.TEXT_AND_FAVICONS || btbMode === bookmarksToolbarMode.FAVICONS_ONLY;
};

const getDNDBookmarkData = (state, bookmarkKey) => {
  const data = state.getIn(['dragData', 'dragOverData', 'draggingOverType']) === dragTypes.BOOKMARK && state.getIn(['dragData', 'dragOverData'], Immutable.Map()) || Immutable.Map();

  return data.get('draggingOverKey') === bookmarkKey ? data : Immutable.Map();
};

const getDetailFromFrame = frame => {
  if (frame == null) {
    return null;
  }

  return Immutable.fromJS({
    location: frame.get('location'),
    title: frame.get('title'),
    partitionNumber: frame.get('partitionNumber'),
    favicon: frame.get('icon'),
    themeColor: frame.get('themeColor') || frame.get('computedThemeColor')
  });
};

/**
 * Checks if a location is bookmarked.
 *
 * @param state The application state Immutable map
 * @param {string} location
 * @return {boolean}
 */
const isLocationBookmarked = (state, location) => {
  const bookmarks = bookmarksState.getBookmarks(state);
  const siteKeys = bookmarkLocationCache.getCacheKey(state, location);

  if (siteKeys.isEmpty() || bookmarks.isEmpty()) {
    return false;
  }

  return siteKeys.some(key => bookmarks.has(key));
};

/**
 * Converts a siteDetail to createProperties format
 * @param {Object} bookmark - A bookmark detail as per app state
 * @return {Object} A createProperties plain JS object, not ImmutableJS
 */
const toCreateProperties = bookmark => {
  if (bookmark == null) {
    return null;
  }

  return {
    url: bookmark.get('location'),
    partitionNumber: bookmark.get('partitionNumber')
  };
};

const isBookmark = bookmark => {
  if (bookmark == null) {
    return false;
  }

  return bookmark.get('type') === siteTags.BOOKMARK;
};

const updateTabBookmarked = (state, tabValue) => {
  if (!tabValue || !tabValue.has('tabId')) {
    return state;
  }

  const bookmarked = isLocationBookmarked(state, tabValue.get('url'));
  return tabState.updateTabValue(state, tabValue.set('bookmarked', bookmarked));
};

const updateActiveTabBookmarked = state => {
  const tab = tabState.getActiveTab(state);
  if (!tab) {
    return state;
  }

  return module.exports.updateTabBookmarked(state, tab);
};

const getKey = siteDetail => {
  if (!siteDetail) {
    return null;
  }

  let location = siteDetail.get('location');

  if (location) {
    location = UrlUtil.getLocationIfPDF(location);
    return location + '|' + (siteDetail.get('partitionNumber') || 0) + '|' + (siteDetail.get('parentFolderId') || 0);
  }
  return null;
};

const buildBookmark = (state, bookmarkDetail) => {
  bookmarkDetail = makeImmutable(bookmarkDetail);
  let location;
  if (bookmarkDetail.has('location')) {
    location = UrlUtil.getLocationIfPDF(bookmarkDetail.get('location'));
    bookmarkDetail = bookmarkDetail.set('location', location);
  }

  const key = getKey(bookmarkDetail);
  const historyKey = key.slice(0, -2);
  let dataItem = historyState.getSite(state, historyKey);

  if (dataItem.isEmpty()) {
    // check if we have data in tabs
    const tab = tabState.getActiveTab(state) || Immutable.Map();
    const activeLocation = tab.get('url') || tab.getIn(['frame', 'location']);

    if (!tab.isEmpty() && bookmarkDetail.get('location') === activeLocation) {
      dataItem = makeImmutable({
        partitionNumber: tab.getIn(['frame', 'partitionNumber'], 0),
        favicon: tab.getIn(['frame', 'icon']),
        themeColor: tab.getIn(['frame', 'themeColor'])
      });
    } else {
      // check if bookmark is in top sites
      const topSites = Immutable.fromJS(newTabData.topSites.concat(newTabData.pinnedTopSites));
      const topSite = topSites.find(site => site.get('location') === bookmarkDetail.get('location')) || Immutable.Map();

      if (!topSite.isEmpty()) {
        dataItem = topSite;
      }
    }
  }

  return makeImmutable({
    title: bookmarkDetail.get('title', ''),
    location: bookmarkDetail.get('location'),
    parentFolderId: Number(bookmarkDetail.get('parentFolderId', 0)),
    partitionNumber: Number(dataItem.get('partitionNumber', 0)),
    objectId: bookmarkDetail.get('objectId', null),
    favicon: dataItem.get('favicon'),
    themeColor: dataItem.get('themeColor'),
    type: siteTags.BOOKMARK,
    key: key,
    skipSync: bookmarkDetail.get('skipSync', null),
    width: 0
  });
};

const buildEditBookmark = (oldBookmark, bookmarkDetail) => {
  let newBookmark = oldBookmark.merge(bookmarkDetail);

  let location;
  if (newBookmark.has('location')) {
    location = UrlUtil.getLocationIfPDF(newBookmark.get('location'));
    newBookmark = newBookmark.set('location', location);
  }

  const newKey = getKey(newBookmark);
  if (newKey === null) {
    return oldBookmark;
  }

  return newBookmark.set('key', newKey);
};

module.exports = {
  bookmarkHangerHeading,
  isBookmarkNameValid,
  showOnlyFavicon,
  showFavicon,
  getDNDBookmarkData,
  getDetailFromFrame,
  isLocationBookmarked,
  toCreateProperties,
  isBookmark,
  updateTabBookmarked,
  updateActiveTabBookmarked,
  getKey,
  showOnlyText,
  showTextAndFavicon,
  buildBookmark,
  buildEditBookmark
};

/***/ }),

/***/ 41:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const { StyleSheet } = __webpack_require__(96);
const globalStyles = __webpack_require__(12);
const { theme } = __webpack_require__(64);

const styles = StyleSheet.create({
  formControl: {
    background: '#fff',
    border: `solid 1px ${globalStyles.color.black20}`,
    borderRadius: globalStyles.radius.borderRadius,
    boxShadow: `inset 0 1px 1px ${globalStyles.color.black10}`,
    boxSizing: 'border-box',
    display: 'block',
    color: globalStyles.color.darkGray,
    fontSize: globalStyles.spacing.textAreaFontSize,
    height: '2.25em',
    outline: 'none',
    padding: '0.4em',
    width: '100%'
  },

  // Textbox -- copied from textbox.js
  textbox: {
    boxSizing: 'border-box',
    width: 'auto'
  },
  textbox__outlineable: {
    ':focus': {
      outlineColor: globalStyles.color.statsBlue,
      outlineOffset: '-4px',
      outlineStyle: 'solid',
      outlineWidth: '1px'
    }
  },
  textbox__isSettings: {
    width: '280px'
  },

  // TextArea -- copied from textbox.js
  textArea: {
    padding: '5px'
  },
  textArea__isDefault: {
    fontSize: globalStyles.spacing.textAreaFontSize
  },

  // Dialogs
  flyoutDialog: {
    background: globalStyles.color.toolbarBackground,
    borderRadius: globalStyles.radius.borderRadius,
    boxShadow: globalStyles.shadow.flyoutDialogBoxShadow,
    color: '#000',
    fontSize: '13px',
    // Issue #7949
    padding: `${globalStyles.spacing.dialogInsideMargin} 30px`,
    position: 'absolute',
    top: globalStyles.spacing.dialogTopOffset,
    // Issue #7930
    boxSizing: 'border-box',
    maxWidth: '600px',
    maxHeight: `calc(80vh - ${globalStyles.spacing.downloadsBarHeight})`
  },

  // itemList.less
  listItem: {
    cursor: 'default',
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    padding: '8px 12px',
    userSelect: 'none',

    ':hover': {
      backgroundColor: globalStyles.color.lightGray
    }
  },
  aboutListItem: {
    display: 'flex'
  },
  aboutItemSeparator: {
    color: '#aaa',
    padding: '0 4px'
  },
  aboutItemTitle: {
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap'
  },
  aboutItemLocation: {
    color: '#aaa',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap'
  },

  // margin/padding
  noMargin: {
    margin: 0
  },
  noMarginTop: {
    marginTop: 0
  },
  noMarginBottom: {
    marginBottom: 0
  },
  noMarginLeft: {
    marginLeft: 0
  },
  noMarginRight: {
    marginRight: 0
  },
  noPadding: {
    padding: 0
  },
  noPaddingTop: {
    paddingTop: 0
  },
  noPaddingBottom: {
    paddingBottom: 0
  },
  noPaddingLeft: {
    paddingLeft: 0
  },
  noPaddingRight: {
    paddingRight: 0
  },
  requiresRestart: {
    fontStyle: 'italic',
    marginBottom: '2em'
  },

  // User select
  userSelect: {
    cursor: 'text',

    // #11641
    userSelect: 'text'
  },
  userSelectNone: {
    userSelect: 'none',
    cursor: 'default'
  },

  // notificationBar
  notificationBar: {
    '-webkit-app-region': 'no-drag',
    display: 'inline-block',
    boxSizing: 'border-box',
    width: '100%',
    cursor: 'default',
    userSelect: 'none',
    // if there's more than one notification per site,
    // ensure border is on the last only
    ':last-child': {
      borderBottom: `5px solid ${globalStyles.color.notificationBottomBorderColor}`
    },
    // last-child will always be orange, but others can be gray
    ':not(:last-child)': {
      borderBottom: `1px solid ${theme.tabsToolbar.border.color}`
    }
  },
  notificationBar__notificationItem: {
    backgroundColor: globalStyles.color.notificationItemColor,
    boxSizing: 'border-box',
    boxShadow: `0 -1px 0 ${theme.tabsToolbar.border.color}`,
    lineHeight: '24px',
    padding: '8px 20px'
  },
  notificationBar__greetingStyle: {
    backgroundColor: '#fff',
    padding: '8px 20px',
    width: '100%'
  },
  notificationItem__greeting: {
    color: globalStyles.color.braveOrange,
    fontSize: '16px',
    margin: 'auto 10px auto 0',
    userSelect: 'none'
  },
  notificationItem__message: {
    color: '#000',
    fontSize: '15px',
    margin: 'auto 6px auto 0',
    userSelect: 'none',
    cursor: 'default'
  },
  notificationItem__secondaryMessage: {
    color: '#888',
    fontSize: '14px',
    padding: '0',
    margin: 'auto 0 auto 10px'
  },

  siteDetailsPageContent: {
    /* TODO: refactor siteDetails.less */
    marginTop: '0 !important',
    marginLeft: globalStyles.spacing.aboutPageSectionPadding
  },

  isCommonForm: {
    fontSize: globalStyles.fontSize.flyoutDialog,
    width: '100%'
  },

  linkText: {
    display: 'inline-block',
    textDecoration: 'underline',
    color: globalStyles.color.braveOrange,
    cursor: 'pointer',
    margin: '0',

    ':hover': {
      color: '#000'
    }
  },

  linkText_small: {
    fontSize: '14px'
  }
});

module.exports = styles;

/***/ }),

/***/ 492:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


// rawAsap provides everything we need except exception management.
var rawAsap = __webpack_require__(507);
// RawTasks are recycled to reduce GC churn.
var freeTasks = [];
// We queue errors to ensure they are thrown in right order (FIFO).
// Array-as-queue is good enough here, since we are just dealing with exceptions.
var pendingErrors = [];
var requestErrorThrow = rawAsap.makeRequestCallFromTimer(throwFirstError);

function throwFirstError() {
    if (pendingErrors.length) {
        throw pendingErrors.shift();
    }
}

/**
 * Calls a task as soon as possible after returning, in its own event, with priority
 * over other events like animation, reflow, and repaint. An error thrown from an
 * event will not interrupt, nor even substantially slow down the processing of
 * other events, but will be rather postponed to a lower priority event.
 * @param {{call}} task A callable object, typically a function that takes no
 * arguments.
 */
module.exports = asap;
function asap(task) {
    var rawTask;
    if (freeTasks.length) {
        rawTask = freeTasks.pop();
    } else {
        rawTask = new RawTask();
    }
    rawTask.task = task;
    rawAsap(rawTask);
}

// We wrap tasks with recyclable task objects.  A task object implements
// `call`, just like a function.
function RawTask() {
    this.task = null;
}

// The sole purpose of wrapping the task is to catch the exception and recycle
// the task object after its single use.
RawTask.prototype.call = function () {
    try {
        this.task.call();
    } catch (error) {
        if (asap.onerror) {
            // This hook exists purely for testing purposes.
            // Its name will be periodically randomized to break any code that
            // depends on its existence.
            asap.onerror(error);
        } else {
            // In a web browser, exceptions are not fatal. However, to avoid
            // slowing down the queue of pending tasks, we rethrow the error in a
            // lower priority turn.
            pendingErrors.push(error);
            requestErrorThrow();
        }
    } finally {
        this.task = null;
        freeTasks[freeTasks.length] = this;
    }
};


/***/ }),

/***/ 493:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(494)


/***/ }),

/***/ 494:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prefixAll;

var _prefixProps = __webpack_require__(354);

var _prefixProps2 = _interopRequireDefault(_prefixProps);

var _capitalizeString = __webpack_require__(355);

var _capitalizeString2 = _interopRequireDefault(_capitalizeString);

var _sortPrefixedStyle = __webpack_require__(495);

var _sortPrefixedStyle2 = _interopRequireDefault(_sortPrefixedStyle);

var _position = __webpack_require__(497);

var _position2 = _interopRequireDefault(_position);

var _calc = __webpack_require__(498);

var _calc2 = _interopRequireDefault(_calc);

var _cursor = __webpack_require__(499);

var _cursor2 = _interopRequireDefault(_cursor);

var _flex = __webpack_require__(500);

var _flex2 = _interopRequireDefault(_flex);

var _sizing = __webpack_require__(501);

var _sizing2 = _interopRequireDefault(_sizing);

var _gradient = __webpack_require__(502);

var _gradient2 = _interopRequireDefault(_gradient);

var _transition = __webpack_require__(503);

var _transition2 = _interopRequireDefault(_transition);

var _flexboxIE = __webpack_require__(505);

var _flexboxIE2 = _interopRequireDefault(_flexboxIE);

var _flexboxOld = __webpack_require__(506);

var _flexboxOld2 = _interopRequireDefault(_flexboxOld);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// special flexbox specifications


var plugins = [_position2.default, _calc2.default, _cursor2.default, _sizing2.default, _gradient2.default, _transition2.default, _flexboxIE2.default, _flexboxOld2.default, _flex2.default];

/**
 * Returns a prefixed version of the style object using all vendor prefixes
 * @param {Object} styles - Style object that gets prefixed properties added
 * @returns {Object} - Style object with prefixed properties and values
 */
function prefixAll(styles) {
  Object.keys(styles).forEach(function (property) {
    var value = styles[property];
    if (value instanceof Object && !Array.isArray(value)) {
      // recurse through nested style objects
      styles[property] = prefixAll(value);
    } else {
      Object.keys(_prefixProps2.default).forEach(function (prefix) {
        var properties = _prefixProps2.default[prefix];
        // add prefixes if needed
        if (properties[property]) {
          styles[prefix + (0, _capitalizeString2.default)(property)] = value;
        }
      });
    }
  });

  Object.keys(styles).forEach(function (property) {
    [].concat(styles[property]).forEach(function (value, index) {
      // resolve every special plugins
      plugins.forEach(function (plugin) {
        return assignStyles(styles, plugin(property, value));
      });
    });
  });

  return (0, _sortPrefixedStyle2.default)(styles);
}

function assignStyles(base) {
  var extend = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  Object.keys(extend).forEach(function (property) {
    var baseValue = base[property];
    if (Array.isArray(baseValue)) {
      [].concat(extend[property]).forEach(function (value) {
        var valueIndex = baseValue.indexOf(value);
        if (valueIndex > -1) {
          base[property].splice(valueIndex, 1);
        }
        base[property].push(value);
      });
    } else {
      base[property] = extend[property];
    }
  });
}
module.exports = exports['default'];

/***/ }),

/***/ 495:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = sortPrefixedStyle;

var _isPrefixedProperty = __webpack_require__(496);

var _isPrefixedProperty2 = _interopRequireDefault(_isPrefixedProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function sortPrefixedStyle(style) {
  return Object.keys(style).sort(function (left, right) {
    if ((0, _isPrefixedProperty2.default)(left) && !(0, _isPrefixedProperty2.default)(right)) {
      return -1;
    } else if (!(0, _isPrefixedProperty2.default)(left) && (0, _isPrefixedProperty2.default)(right)) {
      return 1;
    }
    return 0;
  }).reduce(function (sortedStyle, prop) {
    sortedStyle[prop] = style[prop];
    return sortedStyle;
  }, {});
}
module.exports = exports['default'];

/***/ }),

/***/ 496:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (property) {
  return property.match(/^(Webkit|Moz|O|ms)/) !== null;
};

module.exports = exports["default"];

/***/ }),

/***/ 497:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = position;
function position(property, value) {
  if (property === 'position' && value === 'sticky') {
    return { position: ['-webkit-sticky', 'sticky'] };
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 498:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = calc;

var _joinPrefixedValue = __webpack_require__(183);

var _joinPrefixedValue2 = _interopRequireDefault(_joinPrefixedValue);

var _isPrefixedValue = __webpack_require__(192);

var _isPrefixedValue2 = _interopRequireDefault(_isPrefixedValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function calc(property, value) {
  if (typeof value === 'string' && !(0, _isPrefixedValue2.default)(value) && value.indexOf('calc(') > -1) {
    return (0, _joinPrefixedValue2.default)(property, value, function (prefix, value) {
      return value.replace(/calc\(/g, prefix + 'calc(');
    });
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 499:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = cursor;

var _joinPrefixedValue = __webpack_require__(183);

var _joinPrefixedValue2 = _interopRequireDefault(_joinPrefixedValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var values = {
  'zoom-in': true,
  'zoom-out': true,
  grab: true,
  grabbing: true
};

function cursor(property, value) {
  if (property === 'cursor' && values[value]) {
    return (0, _joinPrefixedValue2.default)(property, value);
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 500:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = flex;
var values = { flex: true, 'inline-flex': true };

function flex(property, value) {
  if (property === 'display' && values[value]) {
    return {
      display: ['-webkit-box', '-moz-box', '-ms-' + value + 'box', '-webkit-' + value, value]
    };
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 501:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = sizing;

var _joinPrefixedValue = __webpack_require__(183);

var _joinPrefixedValue2 = _interopRequireDefault(_joinPrefixedValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var properties = {
  maxHeight: true,
  maxWidth: true,
  width: true,
  height: true,
  columnWidth: true,
  minWidth: true,
  minHeight: true
};
var values = {
  'min-content': true,
  'max-content': true,
  'fill-available': true,
  'fit-content': true,
  'contain-floats': true
};

function sizing(property, value) {
  if (properties[property] && values[value]) {
    return (0, _joinPrefixedValue2.default)(property, value);
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 502:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = gradient;

var _joinPrefixedValue = __webpack_require__(183);

var _joinPrefixedValue2 = _interopRequireDefault(_joinPrefixedValue);

var _isPrefixedValue = __webpack_require__(192);

var _isPrefixedValue2 = _interopRequireDefault(_isPrefixedValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var values = /linear-gradient|radial-gradient|repeating-linear-gradient|repeating-radial-gradient/;

function gradient(property, value) {
  if (typeof value === 'string' && !(0, _isPrefixedValue2.default)(value) && value.match(values) !== null) {
    return (0, _joinPrefixedValue2.default)(property, value);
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 503:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = transition;

var _hyphenateStyleName = __webpack_require__(504);

var _hyphenateStyleName2 = _interopRequireDefault(_hyphenateStyleName);

var _capitalizeString = __webpack_require__(355);

var _capitalizeString2 = _interopRequireDefault(_capitalizeString);

var _isPrefixedValue = __webpack_require__(192);

var _isPrefixedValue2 = _interopRequireDefault(_isPrefixedValue);

var _prefixProps = __webpack_require__(354);

var _prefixProps2 = _interopRequireDefault(_prefixProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var properties = {
  transition: true,
  transitionProperty: true,
  WebkitTransition: true,
  WebkitTransitionProperty: true
};

function transition(property, value) {
  // also check for already prefixed transitions
  if (typeof value === 'string' && properties[property]) {
    var _ref2;

    var outputValue = prefixValue(value);
    var webkitOutput = outputValue.split(/,(?![^()]*(?:\([^()]*\))?\))/g).filter(function (value) {
      return value.match(/-moz-|-ms-/) === null;
    }).join(',');

    // if the property is already prefixed
    if (property.indexOf('Webkit') > -1) {
      return _defineProperty({}, property, webkitOutput);
    }

    return _ref2 = {}, _defineProperty(_ref2, 'Webkit' + (0, _capitalizeString2.default)(property), webkitOutput), _defineProperty(_ref2, property, outputValue), _ref2;
  }
}

function prefixValue(value) {
  if ((0, _isPrefixedValue2.default)(value)) {
    return value;
  }

  // only split multi values, not cubic beziers
  var multipleValues = value.split(/,(?![^()]*(?:\([^()]*\))?\))/g);

  // iterate each single value and check for transitioned properties
  // that need to be prefixed as well
  multipleValues.forEach(function (val, index) {
    multipleValues[index] = Object.keys(_prefixProps2.default).reduce(function (out, prefix) {
      var dashCasePrefix = '-' + prefix.toLowerCase() + '-';

      Object.keys(_prefixProps2.default[prefix]).forEach(function (prop) {
        var dashCaseProperty = (0, _hyphenateStyleName2.default)(prop);

        if (val.indexOf(dashCaseProperty) > -1 && dashCaseProperty !== 'order') {
          // join all prefixes and create a new value
          out = val.replace(dashCaseProperty, dashCasePrefix + dashCaseProperty) + ',' + out;
        }
      });
      return out;
    }, val);
  });

  return multipleValues.join(',');
}
module.exports = exports['default'];

/***/ }),

/***/ 504:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var uppercasePattern = /[A-Z]/g;
var msPattern = /^ms-/;
var cache = {};

function hyphenateStyleName(string) {
    return string in cache
    ? cache[string]
    : cache[string] = string
      .replace(uppercasePattern, '-$&')
      .toLowerCase()
      .replace(msPattern, '-ms-');
}

module.exports = hyphenateStyleName;


/***/ }),

/***/ 505:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = flexboxIE;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var alternativeValues = {
  'space-around': 'distribute',
  'space-between': 'justify',
  'flex-start': 'start',
  'flex-end': 'end'
};
var alternativeProps = {
  alignContent: 'msFlexLinePack',
  alignSelf: 'msFlexItemAlign',
  alignItems: 'msFlexAlign',
  justifyContent: 'msFlexPack',
  order: 'msFlexOrder',
  flexGrow: 'msFlexPositive',
  flexShrink: 'msFlexNegative',
  flexBasis: 'msPreferredSize'
};

function flexboxIE(property, value) {
  if (alternativeProps[property]) {
    return _defineProperty({}, alternativeProps[property], alternativeValues[value] || value);
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 506:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = flexboxOld;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var alternativeValues = {
  'space-around': 'justify',
  'space-between': 'justify',
  'flex-start': 'start',
  'flex-end': 'end',
  'wrap-reverse': 'multiple',
  wrap: 'multiple'
};

var alternativeProps = {
  alignItems: 'WebkitBoxAlign',
  justifyContent: 'WebkitBoxPack',
  flexWrap: 'WebkitBoxLines'
};

function flexboxOld(property, value) {
  if (property === 'flexDirection' && typeof value === 'string') {
    return {
      WebkitBoxOrient: value.indexOf('column') > -1 ? 'vertical' : 'horizontal',
      WebkitBoxDirection: value.indexOf('reverse') > -1 ? 'reverse' : 'normal'
    };
  }
  if (alternativeProps[property]) {
    return _defineProperty({}, alternativeProps[property], alternativeValues[value] || value);
  }
}
module.exports = exports['default'];

/***/ }),

/***/ 507:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {

// Use the fastest means possible to execute a task in its own turn, with
// priority over other events including IO, animation, reflow, and redraw
// events in browsers.
//
// An exception thrown by a task will permanently interrupt the processing of
// subsequent tasks. The higher level `asap` function ensures that if an
// exception is thrown by a task, that the task queue will continue flushing as
// soon as possible, but if you use `rawAsap` directly, you are responsible to
// either ensure that no exceptions are thrown from your task, or to manually
// call `rawAsap.requestFlush` if an exception is thrown.
module.exports = rawAsap;
function rawAsap(task) {
    if (!queue.length) {
        requestFlush();
        flushing = true;
    }
    // Equivalent to push, but avoids a function call.
    queue[queue.length] = task;
}

var queue = [];
// Once a flush has been requested, no further calls to `requestFlush` are
// necessary until the next `flush` completes.
var flushing = false;
// `requestFlush` is an implementation-specific method that attempts to kick
// off a `flush` event as quickly as possible. `flush` will attempt to exhaust
// the event queue before yielding to the browser's own event loop.
var requestFlush;
// The position of the next task to execute in the task queue. This is
// preserved between calls to `flush` so that it can be resumed if
// a task throws an exception.
var index = 0;
// If a task schedules additional tasks recursively, the task queue can grow
// unbounded. To prevent memory exhaustion, the task queue will periodically
// truncate already-completed tasks.
var capacity = 1024;

// The flush function processes all tasks that have been scheduled with
// `rawAsap` unless and until one of those tasks throws an exception.
// If a task throws an exception, `flush` ensures that its state will remain
// consistent and will resume where it left off when called again.
// However, `flush` does not make any arrangements to be called again if an
// exception is thrown.
function flush() {
    while (index < queue.length) {
        var currentIndex = index;
        // Advance the index before calling the task. This ensures that we will
        // begin flushing on the next task the task throws an error.
        index = index + 1;
        queue[currentIndex].call();
        // Prevent leaking memory for long chains of recursive calls to `asap`.
        // If we call `asap` within tasks scheduled by `asap`, the queue will
        // grow, but to avoid an O(n) walk for every task we execute, we don't
        // shift tasks off the queue after they have been executed.
        // Instead, we periodically shift 1024 tasks off the queue.
        if (index > capacity) {
            // Manually shift all values starting at the index back to the
            // beginning of the queue.
            for (var scan = 0, newLength = queue.length - index; scan < newLength; scan++) {
                queue[scan] = queue[scan + index];
            }
            queue.length -= index;
            index = 0;
        }
    }
    queue.length = 0;
    index = 0;
    flushing = false;
}

// `requestFlush` is implemented using a strategy based on data collected from
// every available SauceLabs Selenium web driver worker at time of writing.
// https://docs.google.com/spreadsheets/d/1mG-5UYGup5qxGdEMWkhP6BWCz053NUb2E1QoUTU16uA/edit#gid=783724593

// Safari 6 and 6.1 for desktop, iPad, and iPhone are the only browsers that
// have WebKitMutationObserver but not un-prefixed MutationObserver.
// Must use `global` or `self` instead of `window` to work in both frames and web
// workers. `global` is a provision of Browserify, Mr, Mrs, or Mop.

/* globals self */
var scope = typeof global !== "undefined" ? global : self;
var BrowserMutationObserver = scope.MutationObserver || scope.WebKitMutationObserver;

// MutationObservers are desirable because they have high priority and work
// reliably everywhere they are implemented.
// They are implemented in all modern browsers.
//
// - Android 4-4.3
// - Chrome 26-34
// - Firefox 14-29
// - Internet Explorer 11
// - iPad Safari 6-7.1
// - iPhone Safari 7-7.1
// - Safari 6-7
if (typeof BrowserMutationObserver === "function") {
    requestFlush = makeRequestCallFromMutationObserver(flush);

// MessageChannels are desirable because they give direct access to the HTML
// task queue, are implemented in Internet Explorer 10, Safari 5.0-1, and Opera
// 11-12, and in web workers in many engines.
// Although message channels yield to any queued rendering and IO tasks, they
// would be better than imposing the 4ms delay of timers.
// However, they do not work reliably in Internet Explorer or Safari.

// Internet Explorer 10 is the only browser that has setImmediate but does
// not have MutationObservers.
// Although setImmediate yields to the browser's renderer, it would be
// preferrable to falling back to setTimeout since it does not have
// the minimum 4ms penalty.
// Unfortunately there appears to be a bug in Internet Explorer 10 Mobile (and
// Desktop to a lesser extent) that renders both setImmediate and
// MessageChannel useless for the purposes of ASAP.
// https://github.com/kriskowal/q/issues/396

// Timers are implemented universally.
// We fall back to timers in workers in most engines, and in foreground
// contexts in the following browsers.
// However, note that even this simple case requires nuances to operate in a
// broad spectrum of browsers.
//
// - Firefox 3-13
// - Internet Explorer 6-9
// - iPad Safari 4.3
// - Lynx 2.8.7
} else {
    requestFlush = makeRequestCallFromTimer(flush);
}

// `requestFlush` requests that the high priority event queue be flushed as
// soon as possible.
// This is useful to prevent an error thrown in a task from stalling the event
// queue if the exception handled by Node.js’s
// `process.on("uncaughtException")` or by a domain.
rawAsap.requestFlush = requestFlush;

// To request a high priority event, we induce a mutation observer by toggling
// the text of a text node between "1" and "-1".
function makeRequestCallFromMutationObserver(callback) {
    var toggle = 1;
    var observer = new BrowserMutationObserver(callback);
    var node = document.createTextNode("");
    observer.observe(node, {characterData: true});
    return function requestCall() {
        toggle = -toggle;
        node.data = toggle;
    };
}

// The message channel technique was discovered by Malte Ubl and was the
// original foundation for this library.
// http://www.nonblocking.io/2011/06/windownexttick.html

// Safari 6.0.5 (at least) intermittently fails to create message ports on a
// page's first load. Thankfully, this version of Safari supports
// MutationObservers, so we don't need to fall back in that case.

// function makeRequestCallFromMessageChannel(callback) {
//     var channel = new MessageChannel();
//     channel.port1.onmessage = callback;
//     return function requestCall() {
//         channel.port2.postMessage(0);
//     };
// }

// For reasons explained above, we are also unable to use `setImmediate`
// under any circumstances.
// Even if we were, there is another bug in Internet Explorer 10.
// It is not sufficient to assign `setImmediate` to `requestFlush` because
// `setImmediate` must be called *by name* and therefore must be wrapped in a
// closure.
// Never forget.

// function makeRequestCallFromSetImmediate(callback) {
//     return function requestCall() {
//         setImmediate(callback);
//     };
// }

// Safari 6.0 has a problem where timers will get lost while the user is
// scrolling. This problem does not impact ASAP because Safari 6.0 supports
// mutation observers, so that implementation is used instead.
// However, if we ever elect to use timers in Safari, the prevalent work-around
// is to add a scroll event listener that calls for a flush.

// `setTimeout` does not call the passed callback if the delay is less than
// approximately 7 in web workers in Firefox 8 through 18, and sometimes not
// even then.

function makeRequestCallFromTimer(callback) {
    return function requestCall() {
        // We dispatch a timeout with a specified delay of 0 for engines that
        // can reliably accommodate that request. This will usually be snapped
        // to a 4 milisecond delay, but once we're flushing, there's no delay
        // between events.
        var timeoutHandle = setTimeout(handleTimer, 0);
        // However, since this timer gets frequently dropped in Firefox
        // workers, we enlist an interval handle that will try to fire
        // an event 20 times per second until it succeeds.
        var intervalHandle = setInterval(handleTimer, 50);

        function handleTimer() {
            // Whichever timer succeeds will cancel both timers and
            // execute the callback.
            clearTimeout(timeoutHandle);
            clearInterval(intervalHandle);
            callback();
        }
    };
}

// This is for `asap.js` only.
// Its name will be periodically randomized to break any code that depends on
// its existence.
rawAsap.makeRequestCallFromTimer = makeRequestCallFromTimer;

// ASAP was originally a nextTick shim included in Q. This was factored out
// into this ASAP package. It was later adapted to RSVP which made further
// amendments. These decisions, particularly to marginalize MessageChannel and
// to capture the MutationObserver implementation in a closure, were integrated
// back into ASAP proper.
// https://github.com/tildeio/rsvp.js/blob/cddf7232546a9cf858524b75cde6f9edf72620a7/lib/rsvp/asap.js

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(31)))

/***/ }),

/***/ 508:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
// Module with the same interface as the core aphrodite module,
// except that styles injected do not automatically have !important
// appended to them.


Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _generate = __webpack_require__(194);

var _exports2 = __webpack_require__(356);

var _exports3 = _interopRequireDefault(_exports2);

var useImportant = false; // Don't add !important to style definitions
exports['default'] = (0, _exports3['default'])(useImportant, _generate.defaultSelectorHandlers);
module.exports = exports['default'];

/***/ }),

/***/ 509:
/***/ (function(module, exports) {


/**
 * When source maps are enabled, `style-loader` uses a link element with a data-uri to
 * embed the css on the page. This breaks all relative urls because now they are relative to a
 * bundle instead of the current page.
 *
 * One solution is to only use full urls, but that may be impossible.
 *
 * Instead, this function "fixes" the relative urls to be absolute according to the current page location.
 *
 * A rudimentary test suite is located at `test/fixUrls.js` and can be run via the `npm test` command.
 *
 */

module.exports = function (css) {
  // get current location
  var location = typeof window !== "undefined" && window.location;

  if (!location) {
    throw new Error("fixUrls requires window.location");
  }

	// blank or null?
	if (!css || typeof css !== "string") {
	  return css;
  }

  var baseUrl = location.protocol + "//" + location.host;
  var currentDir = baseUrl + location.pathname.replace(/\/[^\/]*$/, "/");

	// convert each url(...)
	/*
	This regular expression is just a way to recursively match brackets within
	a string.

	 /url\s*\(  = Match on the word "url" with any whitespace after it and then a parens
	   (  = Start a capturing group
	     (?:  = Start a non-capturing group
	         [^)(]  = Match anything that isn't a parentheses
	         |  = OR
	         \(  = Match a start parentheses
	             (?:  = Start another non-capturing groups
	                 [^)(]+  = Match anything that isn't a parentheses
	                 |  = OR
	                 \(  = Match a start parentheses
	                     [^)(]*  = Match anything that isn't a parentheses
	                 \)  = Match a end parentheses
	             )  = End Group
              *\) = Match anything and then a close parens
          )  = Close non-capturing group
          *  = Match anything
       )  = Close capturing group
	 \)  = Match a close parens

	 /gi  = Get all matches, not the first.  Be case insensitive.
	 */
	var fixedCss = css.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi, function(fullMatch, origUrl) {
		// strip quotes (if they exist)
		var unquotedOrigUrl = origUrl
			.trim()
			.replace(/^"(.*)"$/, function(o, $1){ return $1; })
			.replace(/^'(.*)'$/, function(o, $1){ return $1; });

		// already a full url? no change
		if (/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/)/i.test(unquotedOrigUrl)) {
		  return fullMatch;
		}

		// convert the url to a full url
		var newUrl;

		if (unquotedOrigUrl.indexOf("//") === 0) {
		  	//TODO: should we add protocol?
			newUrl = unquotedOrigUrl;
		} else if (unquotedOrigUrl.indexOf("/") === 0) {
			// path should be relative to the base url
			newUrl = baseUrl + unquotedOrigUrl; // already starts with '/'
		} else {
			// path should be relative to current directory
			newUrl = currentDir + unquotedOrigUrl.replace(/^\.\//, ""); // Strip leading './'
		}

		// send back the fixed url(...)
		return "url(" + JSON.stringify(newUrl) + ")";
	});

	// send back the fixed css
	return fixedCss;
};


/***/ }),

/***/ 510:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const mapValuesByKeys = __webpack_require__(35).mapValuesByKeys;

const _ = null;
const ExtensionConstants = {
  BROWSER_ACTION_REGISTERED: _,
  BROWSER_ACTION_UPDATED: _,
  EXTENSION_INSTALLED: _,
  EXTENSION_UNINSTALLED: _,
  EXTENSION_ENABLED: _,
  EXTENSION_DISABLED: _,
  CONTEXT_MENU_CREATED: _,
  CONTEXT_MENU_ALL_REMOVED: _,
  CONTEXT_MENU_CLICKED: _
};

module.exports = mapValuesByKeys(ExtensionConstants);

/***/ }),

/***/ 518:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const React = __webpack_require__(3);
const ImmutableComponent = __webpack_require__(28);
const { StyleSheet, css } = __webpack_require__(15);

const globalStyles = __webpack_require__(12);
const commonStyles = __webpack_require__(41);

// Textbox
class Textbox extends ImmutableComponent {
  render() {
    const className = css(this.props['data-isFormControl'] && commonStyles.formControl, styles.textbox, this.props.readonly || this.props.readOnly ? styles.readOnly : styles.outlineable, this.props['data-isCommonForm'] && commonStyles.isCommonForm, this.props['data-isSettings'] && styles.isSettings);

    return React.createElement('input', _extends({ type: 'text', className: className }, this.props));
  }
}

class FormTextbox extends ImmutableComponent {
  render() {
    return React.createElement(Textbox, _extends({ 'data-isFormControl': 'true' }, this.props));
  }
}

class GroupedFormTextbox extends ImmutableComponent {
  render() {
    return _jsx('div', {
      className: css(styles.groupedFormTextBox)
    }, void 0, React.createElement('input', {
      'data-l10n-id': this.props.l10nId,
      ref: this.props.inputRef,
      type: this.props.type,
      readOnly: this.props.readOnly,
      defaultValue: this.props.value,
      className: css(styles.groupedFormTextBox__firstGroupedItem, this.props.custom)
    }), _jsx('div', {
      className: css(styles.groupedFormTextBox__lastGroupedItem)
    }, void 0, this.props.groupedItem));
  }
}

class SettingTextbox extends ImmutableComponent {
  render() {
    return React.createElement(FormTextbox, _extends({ 'data-isSettings': 'true' }, this.props));
  }
}

// TextArea
class TextArea extends ImmutableComponent {
  render() {
    const className = css(styles.textArea, this.props['data-isDefault'] && styles.isDefault);

    return React.createElement('textarea', _extends({ className: className }, this.props));
  }
}

class DefaultTextArea extends ImmutableComponent {
  render() {
    return React.createElement(TextArea, _extends({ 'data-isDefault': 'true' }, this.props));
  }
}

const styles = StyleSheet.create({
  // Textbox
  textbox: {
    boxSizing: 'border-box',
    width: 'auto'
  },
  outlineable: {
    ':focus': {
      outlineColor: globalStyles.color.statsBlue,
      outlineOffset: '-4px',
      outlineStyle: 'solid',
      outlineWidth: '1px'
    }
  },
  isSettings: {
    width: '280px'
  },
  readOnly: {
    background: globalStyles.color.lightGray,
    boxShadow: 'none',
    outline: 'none'
  },
  recoveryKeys: {
    marginBottom: '20px'
  },

  // TextArea
  textArea: {
    padding: '5px'
  },
  isDefault: {
    fontSize: globalStyles.spacing.textAreaFontSize // Issue #6851
  },

  groupedFormTextBox: {
    display: 'flex',
    flex: 1
  },

  groupedFormTextBox__firstGroupedItem: {
    boxSizing: 'border-box',
    background: '#fff',
    borderTopLeftRadius: '4px',
    borderBottomLeftRadius: '4px',
    borderTopRightRadius: 0,
    borderBottomRightRadius: 0,
    boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.1)',
    display: 'block',
    border: 'solid 1px rgba(0, 0, 0, 0.2)',
    fontSize: '14.5px',
    height: '2.25em',
    outline: 'none',
    padding: '0.4em',
    width: '100%',
    color: 'rgb(68, 68, 68)'
  },

  groupedFormTextBox__lastGroupedItem: {
    border: 'solid 1px rgba(0, 0, 0, 0.2)',
    borderTopLeftRadius: 0,
    borderBottomLeftRadius: 0,
    borderTopRightRadius: '4px',
    borderBottomRightRadius: '4px',
    width: '30px',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center'
  }
});

module.exports = {
  Textbox,
  FormTextbox,
  GroupedFormTextbox,
  SettingTextbox,
  TextArea,
  DefaultTextArea
};

/***/ }),

/***/ 522:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(211);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(74)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(true) {
	// When the styles change, update the <style> tags
	if(!content.locals) {
		module.hot.accept(211, function() {
			var newContent = __webpack_require__(211);
			if(typeof newContent === 'string') newContent = [[module.i, newContent, '']];
			update(newContent);
		});
	}
	// When the module is disposed, remove the <style> tags
	module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 56:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const siteTags = __webpack_require__(38);
const { makeImmutable } = __webpack_require__(16);

const isFolderNameValid = title => {
  return title != null && title.trim().length > 0;
};

const getNextFolderIdItem = folders => {
  return folders.max((folderA, folderB) => {
    const folderIdA = folderA.get('folderId');
    const folderIdB = folderB.get('folderId');

    if (folderIdA === folderIdB) {
      return 0;
    }
    if (folderIdA === undefined) {
      return false;
    }
    if (folderIdB === undefined) {
      return true;
    }
    return folderIdA > folderIdB;
  });
};

const getNextFolderId = folders => {
  const defaultFolderId = 1;
  if (!folders) {
    return defaultFolderId;
  }

  const maxIdItem = getNextFolderIdItem(folders);
  return (maxIdItem ? maxIdItem.get('folderId') || 0 : 0) + 1;
};

const getNextFolderName = (folders, name) => {
  if (!folders) {
    return name;
  }
  const exist = folders.some(site => site.get('title') === name);
  if (!exist) {
    return name;
  }
  const filenameFormat = /(.*) \((\d+)\)/;
  let result = filenameFormat.exec(name);
  if (!result) {
    return getNextFolderName(folders, name + ' (1)');
  }

  const nextNum = parseInt(result[2]) + 1;
  return getNextFolderName(folders, result[1] + ' (' + nextNum + ')');
};

const isFolder = folder => {
  if (folder == null) {
    return false;
  }

  return folder.get('type') === siteTags.BOOKMARK_FOLDER || typeof folder.get('folderId') === 'number';
};

const getKey = folderDetails => {
  if (!folderDetails) {
    return null;
  }

  const folderId = folderDetails.get('folderId');
  if (folderId != null) {
    return folderId.toString();
  }

  return null;
};

/**
 * Called by isMoveAllowed
 * Trace a folder's ancestory, collecting all parent folderIds until reaching Bookmarks Toolbar (folderId=0)
 */
const getAncestorFolderIds = (parentFolderIds, bookmarkFolder, allBookmarks) => {
  if (bookmarkFolder.get('parentFolderId')) {
    parentFolderIds.push(bookmarkFolder.get('parentFolderId'));
    const nextItem = allBookmarks.find(item => item.get('folderId') === bookmarkFolder.get('parentFolderId'));
    if (nextItem) {
      getAncestorFolderIds(parentFolderIds, nextItem, allBookmarks);
    }
  }
};

/**
 * Determine if a proposed move is valid
 *
 * @param folderList The application state's Immutable folderList list
 * @param sourceDetail The site detail to move
 * @param destinationDetail The site detail to move to
 */
const isMoveAllowed = (folderList, sourceDetail, destinationDetail) => {
  if (destinationDetail == null || sourceDetail == null) {
    return false;
  }

  if (typeof destinationDetail.get('parentFolderId') === 'number' && typeof sourceDetail.get('folderId') === 'number') {
    // Folder can't be its own parent
    if (sourceDetail.get('folderId') === destinationDetail.get('folderId')) {
      return false;
    }
    // Ancestor folder can't be moved into a descendant
    let ancestorFolderIds = [];
    getAncestorFolderIds(ancestorFolderIds, destinationDetail, folderList);
    if (ancestorFolderIds.includes(sourceDetail.get('folderId'))) {
      return false;
    }
  }

  return true;
};

const buildFolder = (folderDetails, folders) => {
  folderDetails = makeImmutable(folderDetails);
  let key = folderDetails.get('folderId');

  if (!folderDetails.has('folderId')) {
    key = getNextFolderId(folders);
  }

  return makeImmutable({
    title: folderDetails.get('title'),
    folderId: Number(key),
    key: key.toString(),
    parentFolderId: Number(folderDetails.get('parentFolderId', 0)),
    partitionNumber: Number(folderDetails.get('partitionNumber', 0)),
    objectId: folderDetails.get('objectId', null),
    type: siteTags.BOOKMARK_FOLDER,
    skipSync: folderDetails.get('skipSync', null)
  });
};

module.exports = {
  isFolderNameValid,
  getNextFolderId,
  getNextFolderName,
  isFolder,
  getKey,
  isMoveAllowed,
  buildFolder
};

/***/ }),

/***/ 57:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var apply = Function.prototype.apply;

// DOM APIs, for completeness

exports.setTimeout = function() {
  return new Timeout(apply.call(setTimeout, window, arguments), clearTimeout);
};
exports.setInterval = function() {
  return new Timeout(apply.call(setInterval, window, arguments), clearInterval);
};
exports.clearTimeout =
exports.clearInterval = function(timeout) {
  if (timeout) {
    timeout.close();
  }
};

function Timeout(id, clearFn) {
  this._id = id;
  this._clearFn = clearFn;
}
Timeout.prototype.unref = Timeout.prototype.ref = function() {};
Timeout.prototype.close = function() {
  this._clearFn.call(window, this._id);
};

// Does not start the time, just sets up the members needed.
exports.enroll = function(item, msecs) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = msecs;
};

exports.unenroll = function(item) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = -1;
};

exports._unrefActive = exports.active = function(item) {
  clearTimeout(item._idleTimeoutId);

  var msecs = item._idleTimeout;
  if (msecs >= 0) {
    item._idleTimeoutId = setTimeout(function onTimeout() {
      if (item._onTimeout)
        item._onTimeout();
    }, msecs);
  }
};

// setimmediate attaches itself to the global object
__webpack_require__(196);
// On some exotic environments, it's not clear which object `setimmeidate` was
// able to install onto.  Search each possibility in the same order as the
// `setimmediate` library.
exports.setImmediate = (typeof self !== "undefined" && self.setImmediate) ||
                       (typeof global !== "undefined" && global.setImmediate) ||
                       (this && this.setImmediate);
exports.clearImmediate = (typeof self !== "undefined" && self.clearImmediate) ||
                         (typeof global !== "undefined" && global.clearImmediate) ||
                         (this && this.clearImmediate);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(31)))

/***/ }),

/***/ 58:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const mapValuesByKeys = __webpack_require__(35).mapValuesByKeys;

const _ = null;
const dragTypes = {
  TAB: _,
  BOOKMARK: _
};

module.exports = mapValuesByKeys(dragTypes);

/***/ }),

/***/ 63:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const { makeImmutable, isMap, isList } = __webpack_require__(16);
const Immutable = __webpack_require__(1);
const assert = __webpack_require__(25);

// TODO(bridiver) - make these generic validation functions
const validateId = function (propName, id) {
  assert.ok(id, `${propName} cannot be null`);
  id = parseInt(id);
  assert.ok(id === -1 || id >= 1, `${propName} must be positive or -1`);
  return id;
};

const validateState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  assert.ok(isList(state.get('windows')), 'state must contain an Immutable.List of windows');
  return state;
};

const validateWindowValue = function (windowValue) {
  windowValue = makeImmutable(windowValue);
  assert.ok(isMap(windowValue), 'windowValue must be an Immutable.Map');
  assert.ok(windowValue.get('windowId'), 'window must have a windowId');
  return windowValue;
};

const validateAction = function (action) {
  action = makeImmutable(action);
  assert.ok(isMap(action), 'action must be an Immutable.Map');
  return action;
};

const api = {
  WINDOW_ID_NONE: -1,
  WINDOW_ID_CURRENT: -2,

  getWindowIndex: (state, windowValue) => {
    state = validateState(state);

    let windowId = validateId('windowId', windowValue.get('windowId'));
    return api.getWindowIndexByWindowId(state, windowId);
  },

  insertWindow: (state, action) => {
    action = validateAction(action);
    state = validateState(state);
    let windowValue = validateWindowValue(action.get('windowValue'));
    assert.ok(!api.getWindow(state, windowValue), 'Window already exists');
    return state.set('windows', state.get('windows').push(windowValue));
  },

  getWindow: (state, windowValue) => {
    state = validateState(state);
    windowValue = validateWindowValue(windowValue);
    let windowId = windowValue.get('windowId');
    return api.getByWindowId(state, windowId);
  },

  maybeCreateWindow: (state, action) => {
    action = validateAction(action);
    state = validateState(state);
    let windowValue = validateWindowValue(action.get('windowValue'));

    if (api.getWindow(state, windowValue)) {
      return api.updateWindow(state, action);
    } else {
      return api.insertWindow(state, action);
    }
  },

  getActiveWindow: state => {
    state = validateState(state);
    return state.get('windows').find(win => win.get('focused') === true);
  },

  getActiveWindowId: state => {
    const win = api.getActiveWindow(state);
    return win && win.get('windowId') || api.WINDOW_ID_NONE;
  },

  getByWindowId: (state, windowId) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return state.get('windows').find(win => win.get('windowId') === windowId);
  },

  getWindowIndexByWindowId: (state, windowId) => {
    state = validateState(state);
    windowId = validateId('windowId', windowId);
    return state.get('windows').findIndex(win => win.get('windowId') === windowId);
  },

  removeWindowByWindowId: (state, windowId) => {
    windowId = validateId('windowId', windowId);
    state = validateState(state);

    let index = api.getWindowIndexByWindowId(state, windowId);
    if (index === -1) {
      return state;
    }
    return api.removeWindowByIndex(state, index);
  },

  removeWindowByIndex: (state, index) => {
    index = parseInt(index);
    assert.ok(index >= 0, 'index must be positive');
    state = validateState(state);
    return state.set('windows', state.get('windows').delete(index));
  },

  removeWindow: (state, action) => {
    action = validateAction(action);
    state = validateState(state);
    const windowId = action.get('windowId');
    return api.removeWindowByWindowId(state, windowId);
  },

  updateWindow: (state, action) => {
    action = validateAction(action);
    state = validateState(state);
    let windowValue = validateWindowValue(action.get('windowValue'));

    let windows = state.get('windows');
    let index = api.getWindowIndex(state, windowValue);
    if (index === -1) {
      return state;
    }

    let currentWindowValue = windows.get(index);

    let windowId = windowValue.get('windowId');
    if (windowId) {
      windowId = validateId('windowId', windowId);
      let currentWindowId = currentWindowValue.get('windowId');
      if (currentWindowId) {
        assert.ok(windowId === currentWindowId, 'Changing a windowId is not allowed');
      }
    }
    if (!action.get('replace')) {
      windowValue = currentWindowValue.mergeDeep(windowValue);
    }
    return state.set('windows', windows.delete(index).insert(index, windowValue));
  },

  getWindows: state => {
    state = validateState(state);
    return state.get('windows');
  },

  getPersistentState: state => {
    // TODO(bridiver) handle restoring state
    state = makeImmutable(state);
    return state.set('windows', Immutable.List());
  },

  // TODO (nejc) we should only pass in one state
  // refactor when window state is merged into app state
  shouldAllowWindowDrag: (state, windowState, frame, isFocused) => {
    const shieldState = __webpack_require__(135);
    const defaultBrowserState = __webpack_require__(184);
    const braveryPanelIsVisible = shieldState.braveShieldsEnabled(frame) && windowState.get('braveryPanelDetail');
    const checkDefaultBrowserDialogIsVisible = isFocused && defaultBrowserState.shouldDisplayDialog(state);

    return !windowState.has('contextMenuDetail') && !windowState.get('popupWindowDetail') && !windowState.get('bookmarkDetail') && !windowState.getIn(['ui', 'siteInfo', 'isVisible']) && !braveryPanelIsVisible && !windowState.getIn(['ui', 'isClearBrowsingDataPanelVisible']) && !windowState.get('importBrowserDataDetail') && !windowState.getIn(['widevinePanelDetail', 'shown']) && !windowState.get('autofillAddressDetail') && !windowState.get('autofillCreditCardDetail') && !windowState.getIn(['ui', 'releaseNotes', 'isVisible']) && !checkDefaultBrowserDialogIsVisible && !windowState.getIn(['ui', 'noScriptInfo', 'isVisible']) && frame && !frame.getIn(['security', 'loginRequiredDetail']) && !windowState.getIn(['ui', 'menubar', 'selectedIndex']);
  }
};

module.exports = api;

/***/ }),

/***/ 64:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const globalStyles = __webpack_require__(12);

/**
 * Includes color options for theming
 * This should be used as a boilerplate for all
 * future theming, including darkUI.
 * Note: If an element is not color-related, it should go into global.js
 */

module.exports.theme = {
  audio: {
    color: globalStyles.color.audioColor
  },

  filter: {
    makeWhite: 'brightness(0) invert(1)',
    whiteShadow: 'drop-shadow(-10px 0px 12px rgb(255, 255, 255))'
  },

  tabsToolbar: {
    backgroundColor: '#CDD1D5',

    border: {
      color: 'rgb(187, 187, 191)'
    },

    button: {
      backgroundColor: globalStyles.color.buttonColor,

      onHover: {
        backgroundColor: '#000'
      }
    },

    tabs: {
      navigation: {
        borderColor: 'rgb(187, 187, 191)'
      }
    }
  },

  tabPage: {
    backgroundColor: '#fff',
    borderColor: 'rgb(187, 187, 191)',

    hover: {
      backgroundColor: globalStyles.color.braveOrange,
      borderColor: globalStyles.color.braveOrange
    },

    active: {
      backgroundColor: globalStyles.color.braveOrange,
      borderColor: globalStyles.color.braveOrange,

      hover: {
        backgroundColor: globalStyles.color.braveOrange,
        borderColor: globalStyles.color.braveOrange
      }
    }
  },

  tab: {
    transitionDurationOut: '400ms',
    transitionDurationIn: '200ms',
    transitionEasingOut: 'ease-in',
    transitionEasingIn: 'ease-out',
    background: 'rgb(205,209,213)',
    borderColor: 'rgb(187, 187, 191)',
    borderWidth: 1,
    color: '#222',
    identityHeight: globalStyles.spacing.iconSize,
    defaultFaviconColor: globalStyles.color.mediumGray,
    defaultFaviconColorLight: '#fff',

    closeButton: {
      background: 'transparent',
      borderRadius: '2px',
      active: {
        background: '#cb2c00'
      },
      hover: {
        color: 'white',
        background: '#fd4f01'
      }
    },

    hover: {
      background: 'rgb(219,221,223)',
      active: {
        background: 'rgb(243,243,243)'
      },
      private: {
        background: 'rgb(225,223,238)',
        borderColor: 'rgba(75, 60, 110, .7)'
      }
    },

    active: {
      background: 'rgb(233,233,234)',
      colorLight: 'rgb(255, 255, 255)',
      colorDark: '#222',
      private: {
        background: 'rgb(75,60,110)',
        color: '#fff',
        defaultFaviconColor: '#fff'
      }
    },

    private: {
      background: 'rgb(217,213,228)',
      color: '#4b3c6e'
    },

    preview: {
      background: 'rgb(240,240,240)',
      boxShadow: '0 -2px 12px rgba(0, 0, 0, 0.22)',
      scale: '1.06'
    },

    icon: {
      default: {
        primary: '#fff',
        secondary: 'rgb(101, 101, 101)'
      },

      private: {
        background: {
          active: '#fff',
          notActive: '#000'
        }
      },

      audio: {
        color: '#2377bb',
        hoverColor: '#3b566b'
      },

      close: {
        filter: 'invert(100%) grayscale(1) contrast(0.5) brightness(160%)'
      },

      symbol: {
        color: globalStyles.color.black100
      }
    }
  },

  findBar: {
    backgroundColor: globalStyles.color.modalVeryLightGray,
    color: globalStyles.color.highlightBlue,

    border: {
      bottom: {
        color: globalStyles.color.lightGray
      }
    },

    string: {
      icon: {
        color: globalStyles.color.gray
      }
    },

    find: {
      color: 'rgb(85, 85, 90)'
    },

    close: {
      onHover: {
        color: 'inherit'
      }
    }
  },

  frame: {
    defaultBackground: '#fff',
    newTabBackground: '#222',
    privateTabBackground: globalStyles.color.privateTabBackgroundActive,
    privateTabBackground2: '#000'
  },

  preferences: {
    navigationBackground: `linear-gradient(
        rgb(164, 167, 171),
        rgb(94, 96, 99)
      )`,
    navigationSectionSelectedColor: 'rgb(101, 101, 107)'
  }
};

/***/ }),

/***/ 674:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

// Note that these are webpack requires, not CommonJS node requiring requires
const React = __webpack_require__(3);
const Immutable = __webpack_require__(1);
const messages = __webpack_require__(26);
const { ADBLOCK_CUSTOM_RULES } = __webpack_require__(11);
const getSetting = __webpack_require__(13).getSetting;
const aboutActions = __webpack_require__(691);
const ImmutableComponent = __webpack_require__(28);
const SwitchControl = __webpack_require__(99);
const { DefaultTextArea } = __webpack_require__(518);

const { StyleSheet, css } = __webpack_require__(15);

const ipc = window.chrome.ipcRenderer;

// Stylesheets
__webpack_require__(522);
__webpack_require__(704);

class AdBlockItem extends ImmutableComponent {
  constructor(props) {
    super(props);
    this.onClick = this.onClick.bind(this);
  }
  onClick(e) {
    aboutActions.updateAdblockDataFiles(this.props.resource.get('uuid'), e.target.value);
  }
  get prefKey() {
    return `adblock.${this.props.resource.get('uuid')}.enabled`;
  }
  render() {
    return _jsx('div', {}, void 0, _jsx(SwitchControl, {
      id: this.props.resource.get('uuid'),
      rightText: this.props.resource.get('title'),
      className: `switch-${this.props.resource.get('uuid')}`,
      customRightTextClassName: css(styles.adblockLists__adblockItem__switchControl),
      disabled: this.props.disabled,
      onClick: this.onClick,
      checkedOn: getSetting(this.prefKey, this.props.settings)
    }));
  }
}

class AboutAdBlock extends React.Component {
  constructor(props) {
    super(props);
    this.onChangeCustomFilters = this.onChangeCustomFilters.bind(this);
    this.state = {
      adblock: Immutable.Map(),
      resources: Immutable.List()
    };
    ipc.on(messages.ADBLOCK_UPDATED, (e, detail) => {
      if (!detail) {
        return;
      }
      this.setState({
        adblock: Immutable.fromJS(detail.adblock),
        settings: Immutable.fromJS(detail.settings),
        resources: Immutable.fromJS(detail.resources || [])
      });
    });
  }
  render() {
    const lastUpdateDate = new Date(this.state.adblock.get('lastCheckDate'));
    return _jsx('div', {
      className: css(styles.adblockDetailsPage)
    }, void 0, _jsx('h2', {
      className: css(styles.adblockDetailsPage__h2),
      'data-l10n-id': 'adblock'
    }), _jsx('list', {}, void 0, _jsx('div', {
      role: 'listitem'
    }, void 0, _jsx('div', {
      className: css(styles.adblockDetailsPageContent)
    }, void 0, _jsx('div', {}, void 0, _jsx('span', {
      'data-l10n-id': 'blockedCountLabel'
    }), ' ', _jsx('span', {
      'data-test-id': 'blockedCountTotal'
    }, void 0, this.state.adblock.get('count') || 0)), Number.isNaN(lastUpdateDate.getTime()) ? null : _jsx('div', {}, void 0, _jsx('span', {
      'data-l10n-id': 'lastUpdateCheckDateLabel'
    }), ' ', _jsx('span', {}, void 0, lastUpdateDate.toLocaleDateString())), this.state.adblock.get('etag') ? _jsx('div', {}, void 0, _jsx('span', {
      'data-l10n-id': 'lastCheckETagLabel'
    }), ' ', _jsx('span', {}, void 0, this.state.adblock.get('etag'))) : null, _jsx('h3', {
      className: css(styles.adblockDetailsPage__h3),
      'data-l10n-id': 'additionalFilterLists'
    }), _jsx('div', {
      className: css(styles.adblockSubtext),
      'data-l10n-id': 'adblockTooManyListsWarning'
    }), _jsx('div', {
      className: css(styles.adblockLists)
    }, void 0, this.state.resources.map(resource => _jsx(AdBlockItem, {
      resource: resource,
      settings: this.state.settings
    }))), _jsx('h3', {
      className: css(styles.adblockDetailsPage__h3),
      'data-l10n-id': 'customFilters'
    }), _jsx('div', {
      className: css(styles.adblockSubtext),
      'data-l10n-id': 'customFilterDescription'
    }), _jsx(DefaultTextArea, {
      onChange: this.onChangeCustomFilters,
      value: getSetting(ADBLOCK_CUSTOM_RULES, this.state.settings) || '',
      'data-test-id': 'customFiltersInput',
      cols: '100',
      rows: '10',
      spellCheck: 'false'
    })))));
  }
  onChangeCustomFilters(e) {
    this.setState({
      settings: this.state.settings.set(ADBLOCK_CUSTOM_RULES, e.target.value)
    });
    aboutActions.updateCustomAdblockRules(e.target.value);
  }
}

const styles = StyleSheet.create({
  adblockDetailsPage: {
    margin: '20px',
    minWidth: '704px'
  },
  adblockDetailsPage__h2: {
    marginBottom: '10px'
  },
  adblockDetailsPage__h3: {
    marginTop: '20px',
    marginBottom: '10px'
  },
  adblockDetailsPageContent: {
    marginBottom: '10px'
  },

  adblockLists: {
    marginTop: '10px'
  },
  adblockLists__adblockItem__switchControl: {
    // TODO: refactor switchControl to remove !important
    marginLeft: '15px !important'
  },

  adblockSubtext: {
    fontSize: 'smaller',
    fontWeight: 'bold',
    marginBottom: '10px'
  }
});

module.exports = _jsx(AboutAdBlock, {});

/***/ }),

/***/ 691:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const messages = __webpack_require__(26);
const appDispatcher = __webpack_require__(76);
const appConstants = __webpack_require__(97);
const ExtensionConstants = __webpack_require__(510);
const ipc = window.chrome.ipcRenderer;

// aboutActions should only contain actions that are relevant to about pages,
// it should not contain duplicates of actions from appActions, etc... because
// you can just require and call those directly
// using ipc.send for actions is also deprecated and dispatchAction should
// be used along with an appropriate reducer for handling the action
const aboutActions = {
  /**
   * Dispatches a window action
   * @param {string} key - The settings key to change the value on
   * @param {string} value - The value of the setting to set
   */
  dispatchAction: function (action) {
    appDispatcher.dispatch(action);
  },

  /**
   * Dispatches an event to the renderer process to change a setting
   *
   * @param {string} key - The settings key to change the value on
   * @param {string} value - The value of the setting to set
   */
  changeSetting: function (key, value) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_CHANGE_SETTING,
      key,
      value
    });
  },

  /**
   * Dispatches an event to the renderer process to change a site setting
   *
   * @param {string} hostPattern - host pattern of site
   * @param {string} key - The settings key to change the value on
   * @param {string} value - The value of the setting to set
   */
  changeSiteSetting: function (hostPattern, key, value) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_CHANGE_SITE_SETTING,
      hostPattern,
      key,
      value
    });
  },

  /**
   * Dispatches an event to the renderer process to remove a site setting
   *
   * @param {string} hostPattern - host pattern of site
   * @param {string} key - The settings key to change the value on
   */
  removeSiteSetting: function (hostPattern, key) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_REMOVE_SITE_SETTING,
      hostPattern,
      key
    });
  },

  /**
   * Dispatches an event to the renderer process to remove all site settings
   *
   * @param {string} key - The settings key to remove
   */
  clearSiteSettings: function (key) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_CLEAR_SITE_SETTINGS,
      key
    });
  },

  /**
   * Dispatches a message when sync init data needs to be saved
   * @param {Array.<number>|null} seed
   */
  saveSyncInitData: function (seed) {
    ipc.send(messages.SAVE_INIT_DATA, seed);
  },

  /**
   * Dispatches a message when sync needs to be restarted
   * @param {Array.<number>|null} seed
   */
  reloadSyncExtension: function () {
    ipc.send(messages.RELOAD_SYNC_EXTENSION);
  },

  /**
   * Dispatches a message to reset Sync data on this device and the cloud.
   */
  resetSync: function () {
    ipc.send(messages.RESET_SYNC);
  },

  /**
   * Dispatched when an extension has been uninstalled
   *
   * @param {string} extensionId - the extension id
   */
  extensionUninstalled: function (extensionId) {
    aboutActions.dispatchAction({
      actionType: ExtensionConstants.EXTENSION_UNINSTALLED,
      extensionId
    });
  },

  /**
   * Loads a URL in a new frame in a safe way.
   * It is important that it is not a simple anchor because it should not
   * preserve the about preload script. See #672
   * Opens a new tab and loads the specified URL.
   */
  createTabRequested: function (createProperties) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_CREATE_TAB_REQUESTED,
      createProperties
    });
  },

  /**
   * Generates a file with the users backup keys
   */
  ledgerGenerateKeyFile: function (backupAction) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_BACKUP_KEYS,
      backupAction
    });
  },

  /**
   * Recover wallet by merging old wallet into new one
   */
  ledgerRecoverWallet: function (recoveryKey) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_RECOVER_WALLET,
      recoveryKey
    });
  },

  ledgerRecoverWalletFromFile: function () {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_RECOVER_WALLET,
      useRecoveryKeyFile: true
    });
  },

  /**
   * Sets ledger publisher favicon property
   * @param {string} publisherKey
   * @param {string?} blob
   */
  setLedgerFavicon: function (publisherKey, blob) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_ON_FAVICON_RECEIVED,
      publisherKey,
      blob
    });
  },

  /**
   * Click through a certificate error.
   *
   * @param {string} url - The URL with the cert error
   */
  acceptCertError: function (url) {
    ipc.send(messages.CERT_ERROR_ACCEPTED, url);
  },

  /**
   * Get certificate detail when error.
   *
   * @param {string} url - The URL with the cert error
   */
  getCertErrorDetail: function (url) {
    ipc.send(messages.GET_CERT_ERROR_DETAIL, url);
  },

  /**
   * Opens a context menu
   */
  contextMenu: function (nodeProps, contextMenuType, e) {
    e.preventDefault();
    e.stopPropagation();
    ipc.sendToHost(messages.CONTEXT_MENU_OPENED, nodeProps, contextMenuType);
  },

  downloadRevealed: function (downloadId) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_DOWNLOAD_REVEALED,
      downloadId
    });
  },

  setClipboard: function (text) {
    ipc.send(messages.SET_CLIPBOARD, text);
  },

  setNewTabDetail: function (newTabPageDetail, refresh) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_CHANGE_NEW_TAB_DETAIL,
      newTabPageDetail,
      refresh
    });
  },

  deletePassword: function (password) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_REMOVE_PASSWORD,
      passwordDetail: password
    });
  },

  deletePasswordSite: function (password) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_REMOVE_PASSWORD_SITE,
      passwordDetail: password
    });
  },

  clearPasswords: function () {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_CLEAR_PASSWORDS
    });
  },

  setResourceEnabled: function (resourceName, enabled) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_SET_RESOURCE_ENABLED,
      resourceName,
      enabled
    });
  },

  clearBrowsingDataNow: function () {
    ipc.sendToHost(messages.CLEAR_BROWSING_DATA_NOW);
  },

  importBrowserDataNow: function () {
    ipc.send(messages.IMPORT_BROWSER_DATA_NOW);
  },

  /**
   * Export bookmarks
   */
  exportBookmarks: function () {
    ipc.send(messages.EXPORT_BOOKMARKS);
  },

  setLedgerEnabled: function (enabled) {
    ipc.send(messages.LEDGER_ENABLE, enabled);
  },

  /**
   * Open a adding address dialog
   */
  addAutofillAddress: function () {
    ipc.sendToHost(messages.AUTOFILL_SET_ADDRESS, {}, {});
  },

  /**
   * Remove address
   *
   * @param {object} address - address to remove as per doc/state.md's autofillAddressDetail
   */
  removeAutofillAddress: function (address) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_REMOVE_AUTOFILL_ADDRESS,
      detail: address
    });
  },

  /**
   * Open a edit address dialog
   *
   * @param {object} address - address to edit as per doc/state.md's autofillAddressDetail
   */
  editAutofillAddress: function (address) {
    ipc.sendToHost(messages.AUTOFILL_SET_ADDRESS, address.toJS(), address.toJS());
  },

  /**
   * Open a adding credit card dialog
   */
  addAutofillCreditCard: function () {
    ipc.sendToHost(messages.AUTOFILL_SET_CREDIT_CARD, { month: '01', year: new Date().getFullYear().toString() }, {});
  },

  /**
   * Remove credit card
   *
   * @param {object} card - credit card to remove as per doc/state.md's autofillCreditCardDetail
   */
  removeAutofillCreditCard: function (card) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_REMOVE_AUTOFILL_CREDIT_CARD,
      detail: card
    });
  },

  /**
   * Open a editing credit card dialog
   *
   * @param {object} card - credit card to edit as per doc/state.md's autofillCreditCardDetail
   */
  editAutofillCreditCard: function (card) {
    ipc.sendToHost(messages.AUTOFILL_SET_CREDIT_CARD, card.toJS(), card.toJS());
  },

  /**
   * Dispatches an event to the browser process to register or deregister a datafile
   *
   * @param {uuid} The unique ID of the adblock datafile
   * @param {enable} true if the adBlock data file should be used
   */
  updateAdblockDataFiles: function (uuid, enable) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_UPDATE_ADBLOCK_DATAFILES,
      uuid,
      enable
    });
  },

  /**
   * Dispatches an event to the renderer process to update custom adblock rules.
   *
   * @param {rules} ABP filter syntax rule string
   */
  updateCustomAdblockRules: function (rules) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_UPDATE_ADBLOCK_CUSTOM_RULES,
      rules
    });
  },

  /**
   * Dispatch a message to set default browser
   */
  setAsDefaultBrowser: function () {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_DEFAULT_BROWSER_UPDATED,
      useBrave: true
    });
  },

  /**
   * Dispatches a message to render the tab into a PDF file
   */
  renderToPdf: function (savePath) {
    aboutActions.dispatchAction({
      actionType: appConstants.APP_RENDER_TO_PDF,
      savePath: savePath
    });
  }
};
module.exports = aboutActions;

/***/ }),

/***/ 693:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(73)(false);
// imports


// module
exports.push([module.i, "/* This Source Code Form is subject to the terms of the Mozilla Public\n * License, v. 2.0. If a copy of the MPL was not distributed with this file,\n * You can obtain one at http://mozilla.org/MPL/2.0/. */\n:root {\n  --navbar-height: 36px;\n  --downloads-bar-height: 60px;\n}\n/* This Source Code Form is subject to the terms of the Mozilla Public\n * License, v. 2.0. If a copy of the MPL was not distributed with this file,\n * You can obtain one at http://mozilla.org/MPL/2.0/. */\n.normalizeButton {\n  background: none;\n  outline: none;\n  border: none;\n  margin: 0;\n  white-space: nowrap;\n}\nspan.buttonSeparator {\n  width: 1px;\n  border-left: 1px solid #e2e2e2;\n  margin: 4px 3px 4px 3px;\n}\n.browserButton {\n  cursor: default;\n  display: inline-block;\n  line-height: 25px;\n  width: 25px;\n  height: 25px;\n  font-size: 13px;\n  color: #5a5a62;\n  border-radius: 2px;\n  margin: 0 3px;\n  text-align: center;\n  transition: .12s opacity ease, .12s background ease;\n  user-select: none;\n  background: none;\n  outline: none;\n  border: none;\n  margin: 0;\n  white-space: nowrap;\n}\n.browserButton + .browserButton {\n  margin-left: 5px;\n}\n.browserButton:not([disabled]):hover {\n  color: black;\n}\n.browserButton[disabled] {\n  pointer-events: none;\n  animation: none !important;\n  opacity: .25 !important;\n}\n.browserButton.primaryButton,\n.browserButton.subtleButton,\n.browserButton.whiteButton {\n  color: #fff;\n  line-height: 1.25;\n  padding-top: 5px;\n  padding-bottom: 5px;\n  width: auto;\n  height: auto;\n  min-width: calc(78px);\n}\n.browserButton.primaryButton,\n.browserButton.subtleButton,\n.browserButton.whiteButton {\n  padding-right: 16px;\n  padding-left: 16px;\n}\n.browserButton.primaryButton {\n  background: linear-gradient(#FF7A1D, #ff5500);\n  border-left: 2px solid #FF7A1D;\n  border-right: 2px solid #ff5500;\n  border-top: 2px solid #FF7A1D;\n  border-bottom: 2px solid #ff5500;\n  box-shadow: 0px 1px 5px -1px rgba(0, 0, 0, 0.5);\n  font-weight: 500;\n}\n.browserButton.primaryButton:hover {\n  border: 2px solid white;\n  color: white;\n  cursor: pointer;\n}\n.browserButton.whiteButton {\n  background: linear-gradient(white, #ececec);\n  border: 1px solid white;\n  box-shadow: 0px 1px 5px -1px rgba(0, 0, 0, 0.5);\n  cursor: pointer;\n  color: #444444;\n}\n.browserButton.whiteButton:hover {\n  border: 1px solid #999999;\n}\n.browserButton.subtleButton {\n  background-color: #ccc;\n  font-size: 14px;\n}\n.switchControl {\n  display: flex;\n  align-items: center;\n  padding: 5px;\n}\n.switchControl.disabled .switchBackground {\n  opacity: 0.3;\n}\n.switchControl.disabled .switchControlRightText,\n.switchControl.disabled .switchControlLeftText {\n  opacity: 0.3;\n}\n.switchControl:not(.disabled) .switchBackground.switchedOn {\n  background-color: #ff6000;\n}\n.switchControl:not(.disabled) .switchBackground.switchedOn .switchIndicator {\n  right: 2px;\n}\n.switchControl.large .switchBackground {\n  height: 26px;\n  width: 60px;\n  background-color: #adadad;\n}\n.switchControl.large .switchBackground .switchIndicator {\n  height: 22px;\n  width: 22px;\n  right: calc(36px);\n}\n.switchControl.small .switchBackground {\n  height: 12px;\n  width: 30px;\n}\n.switchControl.small .switchBackground .switchIndicator {\n  height: 10px;\n  width: 10px;\n  top: 1px;\n  right: calc(18px);\n}\n.switchControl .switchControlText {\n  margin: auto 0;\n}\n.switchControl .switchControlTopText {\n  margin: 0 auto 5px auto;\n  color: #bbbbbe;\n}\n.switchControl .switchControlRight {\n  display: flex;\n}\n.switchControl .switchMiddle {\n  display: flex;\n  flex-direction: column;\n}\n.switchControl .switchBackground {\n  background-color: #ccc;\n  border-radius: 12px;\n  height: 16px;\n  position: relative;\n  width: 45px;\n  box-shadow: inset 0 1px 4px rgba(0, 0, 0, 0.35);\n  transition: background-color 100ms;\n}\n.switchControl .switchBackground .switchIndicator {\n  background-color: white;\n  border-radius: 100%;\n  height: 12px;\n  right: calc(31px);\n  position: absolute;\n  top: 2px;\n  width: 12px;\n  box-shadow: 1px 1px 5px -2px black;\n  transition: right 100ms;\n}\n/* This Source Code Form is subject to the terms of the Mozilla Public\n * License, v. 2.0. If a copy of the MPL was not distributed with this file,\n * You can obtain one at http://mozilla.org/MPL/2.0/. */\ntable.sort th:hover {\n  color: #000;\n}\ntable.sortableTable tr th[aria-sort=\"ascending\"]:after {\n  content: \"\\F077\";\n}\ntable.sortableTable tr th[aria-sort=\"descending\"]:after {\n  content: \"\\F078\";\n}\ntable.sortableTable tr td {\n  color: #656565;\n  -webkit-font-smoothing: antialiased;\n  position: relative;\n  width: auto;\n}\ntable.sortableTable tr.rowHover:hover {\n  background: #ececec;\n}\ntable.sortableTable tr.rowHover:hover.selected {\n  background: #ff5500;\n}\ntable.sortableTable tr.rowHover:hover.selected td {\n  color: white;\n}\ntable.sortableTable tr.rowHover:hover.selected div {\n  color: white;\n}\ntable.sortableTable tr.selected {\n  background-color: #cccccc;\n}\ntable.sortableTable tr.selected td {\n  color: #5a5a62;\n}\ntable.sortableTable tr.selected div {\n  color: #5a5a62;\n}\ntable.sortableTable:not(.sort) th[aria-sort=\"ascending\"]:after {\n  content: '';\n}\ntable.sortableTable:not(.sort) th[aria-sort=\"descending\"]after {\n  content: '';\n}\n* {\n  color: #3b3b3b;\n  font-family: \"Helvetica Neue\", Arial, sans-serif;\n  font-weight: 400;\n  margin: 0;\n  padding: 0;\n}\nhtml,\nbody,\n#appContainer,\n#appContainer > div {\n  height: 100%;\n}\nbody {\n  font-size: 100%;\n}\n", ""]);

// exports


/***/ }),

/***/ 704:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(693);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(74)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(true) {
	// When the styles change, update the <style> tags
	if(!content.locals) {
		module.hot.accept(693, function() {
			var newContent = __webpack_require__(693);
			if(typeof newContent === 'string') newContent = [[module.i, newContent, '']];
			update(newContent);
		});
	}
	// When the module is disposed, remove the <style> tags
	module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 73:
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),

/***/ 74:
/***/ (function(module, exports, __webpack_require__) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

var stylesInDom = {};

var	memoize = function (fn) {
	var memo;

	return function () {
		if (typeof memo === "undefined") memo = fn.apply(this, arguments);
		return memo;
	};
};

var isOldIE = memoize(function () {
	// Test for IE <= 9 as proposed by Browserhacks
	// @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
	// Tests for existence of standard globals is to allow style-loader
	// to operate correctly into non-standard environments
	// @see https://github.com/webpack-contrib/style-loader/issues/177
	return window && document && document.all && !window.atob;
});

var getElement = (function (fn) {
	var memo = {};

	return function(selector) {
		if (typeof memo[selector] === "undefined") {
			memo[selector] = fn.call(this, selector);
		}

		return memo[selector]
	};
})(function (target) {
	return document.querySelector(target)
});

var singleton = null;
var	singletonCounter = 0;
var	stylesInsertedAtTop = [];

var	fixUrls = __webpack_require__(509);

module.exports = function(list, options) {
	if (typeof DEBUG !== "undefined" && DEBUG) {
		if (typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
	}

	options = options || {};

	options.attrs = typeof options.attrs === "object" ? options.attrs : {};

	// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
	// tags it will allow on a page
	if (!options.singleton) options.singleton = isOldIE();

	// By default, add <style> tags to the <head> element
	if (!options.insertInto) options.insertInto = "head";

	// By default, add <style> tags to the bottom of the target
	if (!options.insertAt) options.insertAt = "bottom";

	var styles = listToStyles(list, options);

	addStylesToDom(styles, options);

	return function update (newList) {
		var mayRemove = [];

		for (var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];

			domStyle.refs--;
			mayRemove.push(domStyle);
		}

		if(newList) {
			var newStyles = listToStyles(newList, options);
			addStylesToDom(newStyles, options);
		}

		for (var i = 0; i < mayRemove.length; i++) {
			var domStyle = mayRemove[i];

			if(domStyle.refs === 0) {
				for (var j = 0; j < domStyle.parts.length; j++) domStyle.parts[j]();

				delete stylesInDom[domStyle.id];
			}
		}
	};
};

function addStylesToDom (styles, options) {
	for (var i = 0; i < styles.length; i++) {
		var item = styles[i];
		var domStyle = stylesInDom[item.id];

		if(domStyle) {
			domStyle.refs++;

			for(var j = 0; j < domStyle.parts.length; j++) {
				domStyle.parts[j](item.parts[j]);
			}

			for(; j < item.parts.length; j++) {
				domStyle.parts.push(addStyle(item.parts[j], options));
			}
		} else {
			var parts = [];

			for(var j = 0; j < item.parts.length; j++) {
				parts.push(addStyle(item.parts[j], options));
			}

			stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
		}
	}
}

function listToStyles (list, options) {
	var styles = [];
	var newStyles = {};

	for (var i = 0; i < list.length; i++) {
		var item = list[i];
		var id = options.base ? item[0] + options.base : item[0];
		var css = item[1];
		var media = item[2];
		var sourceMap = item[3];
		var part = {css: css, media: media, sourceMap: sourceMap};

		if(!newStyles[id]) styles.push(newStyles[id] = {id: id, parts: [part]});
		else newStyles[id].parts.push(part);
	}

	return styles;
}

function insertStyleElement (options, style) {
	var target = getElement(options.insertInto)

	if (!target) {
		throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");
	}

	var lastStyleElementInsertedAtTop = stylesInsertedAtTop[stylesInsertedAtTop.length - 1];

	if (options.insertAt === "top") {
		if (!lastStyleElementInsertedAtTop) {
			target.insertBefore(style, target.firstChild);
		} else if (lastStyleElementInsertedAtTop.nextSibling) {
			target.insertBefore(style, lastStyleElementInsertedAtTop.nextSibling);
		} else {
			target.appendChild(style);
		}
		stylesInsertedAtTop.push(style);
	} else if (options.insertAt === "bottom") {
		target.appendChild(style);
	} else {
		throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");
	}
}

function removeStyleElement (style) {
	if (style.parentNode === null) return false;
	style.parentNode.removeChild(style);

	var idx = stylesInsertedAtTop.indexOf(style);
	if(idx >= 0) {
		stylesInsertedAtTop.splice(idx, 1);
	}
}

function createStyleElement (options) {
	var style = document.createElement("style");

	options.attrs.type = "text/css";

	addAttrs(style, options.attrs);
	insertStyleElement(options, style);

	return style;
}

function createLinkElement (options) {
	var link = document.createElement("link");

	options.attrs.type = "text/css";
	options.attrs.rel = "stylesheet";

	addAttrs(link, options.attrs);
	insertStyleElement(options, link);

	return link;
}

function addAttrs (el, attrs) {
	Object.keys(attrs).forEach(function (key) {
		el.setAttribute(key, attrs[key]);
	});
}

function addStyle (obj, options) {
	var style, update, remove, result;

	// If a transform function was defined, run it on the css
	if (options.transform && obj.css) {
	    result = options.transform(obj.css);

	    if (result) {
	    	// If transform returns a value, use that instead of the original css.
	    	// This allows running runtime transformations on the css.
	    	obj.css = result;
	    } else {
	    	// If the transform function returns a falsy value, don't add this css.
	    	// This allows conditional loading of css
	    	return function() {
	    		// noop
	    	};
	    }
	}

	if (options.singleton) {
		var styleIndex = singletonCounter++;

		style = singleton || (singleton = createStyleElement(options));

		update = applyToSingletonTag.bind(null, style, styleIndex, false);
		remove = applyToSingletonTag.bind(null, style, styleIndex, true);

	} else if (
		obj.sourceMap &&
		typeof URL === "function" &&
		typeof URL.createObjectURL === "function" &&
		typeof URL.revokeObjectURL === "function" &&
		typeof Blob === "function" &&
		typeof btoa === "function"
	) {
		style = createLinkElement(options);
		update = updateLink.bind(null, style, options);
		remove = function () {
			removeStyleElement(style);

			if(style.href) URL.revokeObjectURL(style.href);
		};
	} else {
		style = createStyleElement(options);
		update = applyToTag.bind(null, style);
		remove = function () {
			removeStyleElement(style);
		};
	}

	update(obj);

	return function updateStyle (newObj) {
		if (newObj) {
			if (
				newObj.css === obj.css &&
				newObj.media === obj.media &&
				newObj.sourceMap === obj.sourceMap
			) {
				return;
			}

			update(obj = newObj);
		} else {
			remove();
		}
	};
}

var replaceText = (function () {
	var textStore = [];

	return function (index, replacement) {
		textStore[index] = replacement;

		return textStore.filter(Boolean).join('\n');
	};
})();

function applyToSingletonTag (style, index, remove, obj) {
	var css = remove ? "" : obj.css;

	if (style.styleSheet) {
		style.styleSheet.cssText = replaceText(index, css);
	} else {
		var cssNode = document.createTextNode(css);
		var childNodes = style.childNodes;

		if (childNodes[index]) style.removeChild(childNodes[index]);

		if (childNodes.length) {
			style.insertBefore(cssNode, childNodes[index]);
		} else {
			style.appendChild(cssNode);
		}
	}
}

function applyToTag (style, obj) {
	var css = obj.css;
	var media = obj.media;

	if(media) {
		style.setAttribute("media", media)
	}

	if(style.styleSheet) {
		style.styleSheet.cssText = css;
	} else {
		while(style.firstChild) {
			style.removeChild(style.firstChild);
		}

		style.appendChild(document.createTextNode(css));
	}
}

function updateLink (link, options, obj) {
	var css = obj.css;
	var sourceMap = obj.sourceMap;

	/*
		If convertToAbsoluteUrls isn't defined, but sourcemaps are enabled
		and there is no publicPath defined then lets turn convertToAbsoluteUrls
		on by default.  Otherwise default to the convertToAbsoluteUrls option
		directly
	*/
	var autoFixUrls = options.convertToAbsoluteUrls === undefined && sourceMap;

	if (options.convertToAbsoluteUrls || autoFixUrls) {
		css = fixUrls(css);
	}

	if (sourceMap) {
		// http://stackoverflow.com/a/26603875
		css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
	}

	var blob = new Blob([css], { type: "text/css" });

	var oldSrc = link.href;

	link.href = URL.createObjectURL(blob);

	if(oldSrc) URL.revokeObjectURL(oldSrc);
}


/***/ }),

/***/ 76:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(setImmediate) {/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const async = __webpack_require__(197);
const Serializer = __webpack_require__(198);
const messages = __webpack_require__(26);
let ipc;
let processType;
let currentWindow;
let BrowserWindow;

if (typeof window !== 'undefined' && window.location.protocol === 'chrome-extension:' && typeof chrome !== 'undefined' && typeof chrome.ipcRenderer === 'object') {
  processType = 'extension-page';
  ipc = chrome.ipcRenderer; // eslint-disable-line
} else if (typeof process !== 'undefined') {
  if (process.type === 'renderer') {
    processType = 'renderer';
    ipc = __webpack_require__(18).ipcRenderer;
    currentWindow = __webpack_require__(32);
  } else if (process.type === 'browser') {
    processType = 'browser';
    BrowserWindow = __webpack_require__(18).BrowserWindow;
    ipc = __webpack_require__(18).ipcMain;
  }
} else if (typeof chrome !== 'undefined' && typeof chrome.ipcRenderer === 'object') {
  throw new Error('No ipc available in context');
}

class AppDispatcher {
  constructor() {
    this.callbacks = [];
    this.promises = [];
    this.dispatching = false;
    this.dispatch = this.dispatch.bind(this);
  }

  /**
   * Register a Store's callback so that it may be invoked by an action.
   * If the registrant is a renderer process the callback will be stored
   * locally and an `app-dispatcher-register` message will be sent to the
   * main process using IPC.
   * @param {function} callback The callback to be registered.
   * @return {number} The index of the callback within the _callbacks array.
   */
  register(callback) {
    if (process.type === 'renderer') {
      ipc.send('app-dispatcher-register');
    }
    return this.registerLocalCallback(callback);
  }

  /**
   * Same as above, but registers the specified callback
   * locally only.  This is used by the windowStore since
   * the store process is registered as soon as the window
   * is created.
   */
  registerLocalCallback(callback) {
    this.callbacks.push(callback);
    return this.callbacks.length - 1; // index
  }

  unregister(callback) {
    const index = this.callbacks.indexOf(callback);
    if (index !== -1) {
      this.callbacks.splice(index, 1);
    }
  }

  /**
   * dispatch
   * Dispatches registered callbacks. If `dispatch` is called from the main process
   * it will run all the registered callbacks. If `dispatch` is called from a renderer
   * process it will run any local registered callbacks and then send messages.DISPATCH_ACTION
   * to the main process where the all other registered callbacks will be run. The main
   * process will not run any callbacks for the renderer process that send messages.DISPATCH_ACTION
   * @param  {object} payload The data from the action.
   */
  dispatch(payload) {
    if (payload.actionType === undefined) {
      throw new Error('Dispatcher: Undefined action for payload', payload);
    }

    if (this.dispatching) {
      dispatchCargo.push(payload);
    } else {
      this.dispatching = true;
      setImmediate(this.dispatchInternal.bind(this, payload, doneDispatching));
    }
  }

  dispatchToOwnRegisteredCallbacks(payload) {
    // First create array of promises for callbacks to reference.
    const resolves = [];
    const rejects = [];
    this.promises = this.callbacks.map(function (_, i) {
      return new Promise(function (resolve, reject) {
        resolves[i] = resolve;
        rejects[i] = reject;
      });
    });
    // Dispatch to callbacks and resolve/reject promises.
    this.callbacks.forEach((callback, i) => {
      callback(payload);
      resolves[i](payload);
    });
    this.promises = [];
  }

  dispatchInternal(payload, cb) {
    if (processType === 'extension-page') {
      cb();
      ipcCargo.push(payload);
      return;
    }
    if (processType === 'renderer') {
      // only handle actions that are for this window
      if (!payload.queryInfo || payload.queryInfo.windowId == null || payload.queryInfo.windowId === currentWindow.getCurrentWindowId()) {
        this.dispatchToOwnRegisteredCallbacks(payload);
      }
      // only forward actions that have not been relayed through the browser process
      if (!payload.sentFromBrowser) {
        cb();
        ipcCargo.push(payload);
      }
      return;
    }

    this.dispatchToOwnRegisteredCallbacks(payload);
    cb();
  }

  waitFor(promiseIndexes, callback) {
    var selectedPromises = promiseIndexes.map(index => this.promises[index]);
    return Promise.all(selectedPromises).then(callback);
  }

  shutdown() {
    appDispatcher.dispatch = payload => {};
  }

  registerWindow(registrant, hostWebContents) {
    const win = BrowserWindow.fromWebContents(hostWebContents);
    const windowId = win.id;

    const registrantCargo = async.cargo((tasks, callback) => {
      if (!registrant.isDestroyed()) {
        registrant.send(messages.DISPATCH_ACTION, Serializer.serialize(tasks));
      }
      callback();
    }, 20);

    // If the window isn't ready yet then wait until it is ready before delivering
    // messages to it.
    if (!win.__ready) {
      registrantCargo.pause();
      win.on(messages.WINDOW_RENDERER_READY, () => {
        registrantCargo.resume();
      });
    }

    const callback = function (payload) {
      try {
        if (registrant.isDestroyed()) {
          appDispatcher.unregister(callback);
        } else {
          // don't forward to windows unless queryInfo exists
          if (!payload.queryInfo) {
            return;
          }

          // don't forward messages from other windows unless they have a windowId
          if (payload.queryInfo.windowId == null && payload.senderWindowId != null) {
            return;
          }

          // only forward to the destination windowId and only if it wasn't the sender
          if (payload.queryInfo.windowId != null) {
            if (payload.queryInfo.windowId !== windowId || payload.senderWindowId === windowId) {
              return;
            }
          }
          payload.sentFromBrowser = true;
          registrantCargo.push(payload);
        }
      } catch (e) {
        appDispatcher.unregister(callback);
      }
    };
    registrant.on('crashed', () => {
      appDispatcher.unregister(callback);
    });
    registrant.on('destroyed', () => {
      appDispatcher.unregister(callback);
    });
    appDispatcher.register(callback);
  }
}

const appDispatcher = new AppDispatcher();

const doneDispatching = () => {
  if (dispatchCargo.idle()) {
    appDispatcher.dispatching = false;
  }
};

const dispatchCargo = async.cargo((task, callback) => {
  for (let i = 0; i < task.length; i++) {
    appDispatcher.dispatchInternal(task[i], () => {});
  }
  callback();
  doneDispatching();
}, 200);

const ipcCargo = async.cargo((tasks, callback) => {
  ipc.send(messages.DISPATCH_ACTION, Serializer.serialize(tasks));
  callback();
}, 200);

if (processType === 'browser') {
  ipc.on('app-dispatcher-register', event => {
    const registrant = event.sender;
    const hostWebContents = event.sender.hostWebContents || event.sender;
    appDispatcher.registerWindow(registrant, hostWebContents);
  });

  const dispatchEventPayload = (event, payload) => {
    let queryInfo = payload.queryInfo || payload.frameProps || (payload.queryInfo = {});
    queryInfo = queryInfo.toJS ? queryInfo.toJS() : queryInfo;
    let sender = event.sender;
    if (!sender.isDestroyed()) {
      const hostWebContents = sender.hostWebContents;
      sender = hostWebContents || sender;
      const win = BrowserWindow.fromWebContents(sender);

      if (hostWebContents) {
        // received from an extension
        // only extension messages will have a hostWebContents
        // because other messages come from the main window

        // default to the windowId of the hostWebContents
        if (queryInfo.windowId == null && win) {
          queryInfo.windowId = win.id;
        }
      } else if (win) {
        // don't set the senderWindowId for tabs because it will prevent them
        // from being routed back to the window process
        payload.senderWindowId = win.id;
      }
      payload.queryInfo = queryInfo;
      payload.tabId = payload.tabId == null ? event.sender.getId() : payload.tabId;

      if (queryInfo.windowId === -2) {
        const activeWindow = BrowserWindow.getActiveWindow();
        queryInfo.windowId = activeWindow ? activeWindow.id : undefined;
      }
    }
    appDispatcher.dispatch(payload);
  };

  process.on(messages.DISPATCH_ACTION, action => {
    appDispatcher.dispatch(action);
  });

  ipc.on(messages.DISPATCH_ACTION, (event, payload) => {
    payload = Serializer.deserialize(payload);

    if (payload.forEach === undefined) {
      dispatchEventPayload(event, payload);
    }

    for (var i = 0; i < payload.length; i++) {
      dispatchEventPayload(event, payload[i]);
    }
  });
} else if (processType === 'renderer') {
  ipc.on(messages.DISPATCH_ACTION, (e, serializedPayload) => {
    let payload = Serializer.deserialize(serializedPayload);
    for (var i = 0; i < payload.length; i++) {
      appDispatcher.dispatch(payload[i]);
    }
  });
}

module.exports = appDispatcher;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(57).setImmediate))

/***/ }),

/***/ 77:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const getWebview = key => key ? document.querySelector(`webview[data-frame-key="${key}"]`) : document.querySelector('.frameWrapper.isActive webview');

const webviewActions = {
  /**
   * Puts the webview in focus
   */
  setWebviewFocused: function () {
    const webview = getWebview();
    if (webview) {
      webview.focus();
    }
  },

  /**
   * Shows the certificate infomation
   */
  showCertificate: function () {
    const webview = getWebview();
    if (webview) {
      webview.showCertificate();
    }
  },

  /**
   * Shows the definition of the selected text in a pop-up window (macOS only)
   */
  showDefinitionForSelection: function () {
    const webview = getWebview();
    if (webview) {
      webview.showDefinitionForSelection();
    }
  },

  findInPage: function (searchString, caseSensitivity, forward, findNext, webview) {
    webview = webview || getWebview();
    if (!webview) {
      return;
    }

    if (searchString) {
      webview.findInPage(searchString, {
        matchCase: caseSensitivity,
        forward,
        findNext
      });
    } else {
      webview.stopFindInPage('clearSelection');
    }
  },

  stopFindInPage: function (webview) {
    webview = webview || getWebview();
    if (!webview) {
      return;
    }
    webview.stopFindInPage('keepSelection');
  }
};

module.exports = webviewActions;

/***/ }),

/***/ 8:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/. */

const Immutable = __webpack_require__(1);

// Constants
const config = __webpack_require__(23);
const settings = __webpack_require__(11);

// Actions
const windowActions = __webpack_require__(9);
const webviewActions = __webpack_require__(77);

// State
const { makeImmutable } = __webpack_require__(16);
const tabState = __webpack_require__(21);

// Utils
const { getSetting } = __webpack_require__(13);
const { isIntermediateAboutPage } = __webpack_require__(20);
const urlParse = __webpack_require__(29);

let tabPageHoverTimeout;
let tabHoverTimeout = null;

const comparatorByKeyAsc = (a, b) => a.get('key') > b.get('key') ? 1 : b.get('key') > a.get('key') ? -1 : 0;

const matchFrame = (queryInfo, frame) => {
  queryInfo = queryInfo.toJS ? queryInfo.toJS() : queryInfo;
  return !Object.keys(queryInfo).map(queryKey => frame.get(queryKey) === queryInfo[queryKey]).includes(false);
};

function query(state, queryInfo) {
  return state.get('frames').filter(matchFrame.bind(null, queryInfo));
}

function find(state, queryInfo) {
  return state.get('frames').find(matchFrame.bind(null, queryInfo));
}

function isFrameKeyActive(state, frameKey) {
  return getActiveFrameKey(state) === frameKey;
}

function getFrames(state) {
  return state.get('frames');
}

function getSortedFrames(state) {
  return state.get('frames', Immutable.List()).sort(comparatorByKeyAsc);
}

function getSortedFrameKeys(state) {
  return getSortedFrames(state).map(frame => frame.get('key'));
}

function getPinnedFrames(state) {
  return state.get('frames', Immutable.List()).filter(frame => frame.get('pinnedLocation'));
}

function getNonPinnedFrames(state) {
  return state.get('frames', Immutable.List()).filter(frame => !frame.get('pinnedLocation'));
}

function getFrameIndex(state, frameKey) {
  if (frameKey == null) return -1;

  const index = state.getIn(['framesInternal', 'index', frameKey.toString()]);
  return index == null ? -1 : index;
}

function getActiveFrameIndex(state) {
  return getFrameIndex(state, getActiveFrameKey(state));
}

function getActiveFrameTabId(state) {
  const activeFrame = getActiveFrame(state);
  return activeFrame && activeFrame.get('tabId');
}

function getFrameByIndex(state, i) {
  if (i === -1) {
    return null;
  }
  return state.getIn(['frames', i]);
}

// This will eventually go away fully when we replace frameKey by tabId
function getFrameKeyByTabId(state, tabId) {
  let parentFrameKey = null;
  const openerFrame = getFrameByTabId(state, tabId);
  if (openerFrame) {
    parentFrameKey = openerFrame.get('key');
  }
  return parentFrameKey;
}

function getFrameKeysByDisplayIndex(state) {
  const frames = state.get('frames');
  let framesByDisplayIndex = [[], []];
  frames.forEach(frame => {
    let key = frame.get('key');
    if (frame.get('pinnedLocation')) {
      framesByDisplayIndex[0].push(key);
    } else {
      framesByDisplayIndex[1].push(key);
    }
  });
  return framesByDisplayIndex.reduce(function (a, b) {
    return a.concat(b);
  }, []);
}

function getTabIdsByNonPinnedDisplayIndex(state) {
  return state.get('frames').filter(frame => !frame.get('pinnedLocation')).map(frame => frame.get('tabId'));
}

/**
* Obtains the display index for the specified tab ID excluding pins
*/
function findNonPinnedDisplayIndexForTabId(state, tabId) {
  return getTabIdsByNonPinnedDisplayIndex(state).findIndex(displayKey => displayKey === tabId);
}

function getFrameByDisplayIndex(state, i) {
  let frames = getFrameKeysByDisplayIndex(state);
  let key = frames[i];
  return getFrameByKey(state, key);
}

function getFrameByKey(state, key) {
  const index = getFrameIndex(state, key);
  if (index === -1) {
    return null;
  }
  return state.getIn(['frames', index]);
}

function isFrameSecure(frame) {
  frame = makeImmutable(frame);
  if (frame && typeof frame.getIn(['security', 'isSecure']) === 'boolean') {
    return frame.getIn(['security', 'isSecure']);
  } else {
    return false;
  }
}

function isFrameLoading(frame) {
  frame = makeImmutable(frame);
  return frame && frame.get('loading');
}

function startLoadTime(frame) {
  frame = makeImmutable(frame);
  return frame && frame.get('startLoadTime');
}

function endLoadTime(frame) {
  frame = makeImmutable(frame);
  return frame && frame.get('endLoadTime');
}

function getHistory(frame) {
  frame = makeImmutable(frame);
  return frame && frame.get('history') || Immutable.fromJS([]);
}

function isFrameKeyPinned(state, key) {
  if (typeof key !== 'number') {
    return false;
  }
  const frame = getFrameByKey(state, key);
  return frame ? frame.get('pinnedLocation') : false;
}

function getNonPinnedFrameCount(state) {
  return state.get('frames').filter(frame => !frame.get('pinnedLocation')).size;
}

function getFrameByTabId(state, tabId) {
  return getFrameByIndex(state, getIndexByTabId(state, tabId));
}

function getIndexByTabId(state, tabId) {
  if (tabId == null) return -1;

  const index = state.getIn(['framesInternal', 'tabIndex', tabId.toString()]);
  return index == null ? -1 : index;
}

const getTabIdByFrameKey = (state, frameKey) => {
  const frame = getFrameByKey(state, frameKey);
  return frame && frame.get('tabId', tabState.TAB_ID_NONE);
};

function getActiveFrame(state) {
  const activeFrameIndex = getActiveFrameIndex(state);
  const frames = state.get('frames');
  return frames ? frames.get(activeFrameIndex) : null;
}

// Returns the same as the active frame's location, but returns the requested
// URL if it's safe browsing, a cert error page or an error page.
function getLastCommittedURL(frame) {
  frame = makeImmutable(frame);
  if (!frame) {
    return undefined;
  }

  let location = frame.get('location');
  const history = getHistory(frame);
  if (isIntermediateAboutPage(location)) {
    const parsedUrl = urlParse(location);
    if (parsedUrl.hash) {
      location = parsedUrl.hash.split('#')[1];
    } else if (history.size > 0) {
      location = history.last();
    }
  }
  return location;
}

function getActiveFrameKey(state) {
  return state.get('activeFrameKey');
}

const setActiveFrameKey = (state, frameKey) => {
  return state.set('activeFrameKey', frameKey);
};

const setFrameLastAccessedTime = (state, index) => {
  return state.setIn(['frames', index, 'lastAccessedTime'], new Date().getTime());
};

function getNextFrame(state) {
  const activeFrameIndex = findDisplayIndexForFrameKey(state, getActiveFrameKey(state));
  const index = (activeFrameIndex + 1) % state.get('frames').size;
  return getFrameByDisplayIndex(state, index);
}

function getPreviousFrame(state) {
  const activeFrameIndex = findDisplayIndexForFrameKey(state, getActiveFrameKey(state));
  const index = (state.get('frames').size + activeFrameIndex - 1) % state.get('frames').size;
  return getFrameByDisplayIndex(state, index);
}

/**
* Obtains the display index for the specified frame key
*/
function findDisplayIndexForFrameKey(state, key) {
  return getFrameKeysByDisplayIndex(state).findIndex(displayKey => displayKey === key);
}

/**
* Determines if the specified frame was opened from the specified
* ancestorFrameKey.
*
* For example you may go to google.com and open 3 links in new tabs:
* G g1 g2 g3
* Then you may change to g1 and open another tab:
* G g1 g1.1 g2 g3
* But then you may go back to google.com and open another tab.
* It should go like so:
* G g1 g1.1 g2 g3 g4
*/
function isAncestorFrameKey(state, frame, parentFrameKey) {
  if (!frame || !frame.get('parentFrameKey')) {
    return false;
  }

  if (frame.get('parentFrameKey') === parentFrameKey) {
    return true;
  }

  // So there is a parentFrameKey but it isn't the specified one.
  // Check recursively for each of the parentFrame's ancestors to see
  // if we have a match.
  const parentFrameIndex = getFrameIndex(state, frame.get('parentFrameKey'));
  const parentFrame = state.getIn(['frames', parentFrameIndex]);
  if (parentFrameIndex === -1 || !parentFrame.get('parentFrameKey')) {
    return false;
  }
  return isAncestorFrameKey(state, parentFrame, parentFrameKey);
}

function getPartitionNumber(partition) {
  const regex = /(?:persist:)?partition-(\d+)/;
  const matches = regex.exec(partition);
  return Number(matches && matches[1] || 0);
}

function isPrivatePartition(partition) {
  return partition && !partition.startsWith('persist:');
}

function isSessionPartition(partition) {
  return partition && partition.startsWith('persist:partition-');
}

function getPartition(frameOpts) {
  return getPartitionFromNumber(frameOpts.get('partitionNumber'), frameOpts.get('isPrivate'));
}

function getPartitionFromNumber(partitionNumber, incognito) {
  if (!partitionNumber && !incognito) {
    return 'persist:default';
  } else if (incognito) {
    return 'default';
  }
  return `persist:partition-${partitionNumber}`;
}

const frameOptsFromFrame = frame => {
  return frame.delete('key').delete('parentFrameKey').delete('activeShortcut').delete('activeShortcutDetails').delete('index').deleteIn(['navbar', 'urlbar', 'suggestions']);
};

/**
* Adds a frame specified by frameOpts and newKey and sets the activeFrameKey
* @return Immutable top level application state ready to merge back in
*/
function addFrame(state, frameOpts, newKey, partitionNumber, openInForeground, insertionIndex) {
  const frames = state.get('frames', Immutable.List());

  const location = frameOpts.location; // page url
  const displayURL = frameOpts.displayURL == null ? location : frameOpts.displayURL;
  delete frameOpts.displayURL;

  const rendererInitiated = frameOpts.rendererInitiated;
  delete frameOpts.rendererInitiated;

  // Only add pin requests if it's not already added
  const isPinned = frameOpts.isPinned;
  delete frameOpts.isPinned;

  // TODO: longer term get rid of parentFrameKey completely instead of
  // calculating it here.
  let parentFrameKey = frameOpts.parentFrameKey;
  if (frameOpts.openerTabId) {
    parentFrameKey = getFrameKeyByTabId(state, frameOpts.openerTabId);
  }

  const frame = Immutable.fromJS(Object.assign({
    zoomLevel: config.zoom.defaultValue,
    audioMuted: false, // frame is muted
    location,
    aboutDetails: undefined,
    src: location, // what the iframe src should be
    tabId: frameOpts.tabId == null ? -1 : frameOpts.tabId,
    loading: frameOpts.rendererInitiated,
    startLoadTime: null,
    endLoadTime: null,
    lastAccessedTime: openInForeground ? new Date().getTime() : null,
    isPrivate: false,
    partitionNumber,
    pinnedLocation: isPinned ? location : undefined,
    key: newKey,
    navbar: {
      urlbar: {
        location: rendererInitiated ? location : displayURL,
        suggestions: {
          selectedIndex: 0,
          searchResults: [],
          suggestionList: null
        },
        selected: false,
        // URL load-start will focus the webview if it's not newtab.
        focused: true,
        active: false
      }
    },
    searchDetail: null,
    findDetail: {
      searchString: '',
      caseSensitivity: false
    },
    security: {
      isSecure: null
    },
    unloaded: frameOpts.unloaded,
    parentFrameKey,
    history: []
  }, frameOpts));

  return {
    frames: frames.splice(insertionIndex, 0, frame)
  };
}

/**
* Removes a frame specified by frameProps
* @return Immutable top level application state ready to merge back in
*/
function removeFrame(state, frameProps, framePropsIndex) {
  const frames = state.get('frames');
  let closedFrames = state.get('closedFrames') || Immutable.List();
  const newFrames = frames.splice(framePropsIndex, 1);

  if (isValidClosedFrame(frameProps)) {
    frameProps = frameProps.set('isFullScreen', false);
    closedFrames = closedFrames.push(frameProps);
    if (frameProps.get('thumbnailBlob')) {
      window.URL.revokeObjectURL(frameProps.get('thumbnailBlob'));
    }
    if (closedFrames.size > config.maxClosedFrames) {
      closedFrames = closedFrames.shift();
    }
  }

  return {
    closedFrames,
    frames: newFrames
  };
}

function getFrameTabPageIndex(state, tabId, tabsPerTabPage = getSetting(settings.TABS_PER_PAGE)) {
  const index = findNonPinnedDisplayIndexForTabId(state, tabId);
  if (index === -1) {
    return -1;
  }
  return Math.floor(index / tabsPerTabPage);
}

function onFindBarHide(frameKey) {
  windowActions.setFindbarShown(frameKey, false);
  webviewActions.stopFindInPage();
  windowActions.setFindDetail(frameKey, Immutable.fromJS({
    internalFindStatePresent: false,
    numberOfMatches: -1,
    activeMatchOrdinal: 0
  }));
}

function getTotalBlocks(frame) {
  if (!frame) {
    return false;
  }

  frame = makeImmutable(frame);

  const ads = frame.getIn(['adblock', 'blocked']);
  const trackers = frame.getIn(['trackingProtection', 'blocked']);
  const scripts = frame.getIn(['noScript', 'blocked']);
  const fingerprint = frame.getIn(['fingerprintingProtection', 'blocked']);
  const blocked = (ads && ads.size ? ads.size : 0) + (trackers && trackers.size ? trackers.size : 0) + (scripts && scripts.size ? scripts.size : 0) + (fingerprint && fingerprint.size ? fingerprint.size : 0);

  return blocked === 0 ? false : blocked > 99 ? '99+' : blocked;
}

/**
* Check if frame is pinned or not
*/
function isPinned(state, frameKey) {
  const frame = getFrameByKey(state, frameKey);

  return frame && !!frame.get('pinnedLocation');
}

const isFirstFrameKeyInTabPage = (state, frameKey) => {
  const pageIndex = getTabPageIndex(state);
  const tabsPerTabPage = Number(getSetting(settings.TABS_PER_PAGE));
  const startingFrameIndex = pageIndex * tabsPerTabPage;
  const unpinnedTabs = getNonPinnedFrames(state) || Immutable.List();
  const firstFrame = unpinnedTabs.slice(startingFrameIndex, startingFrameIndex + tabsPerTabPage).first();

  return firstFrame && firstFrame.get('key') === frameKey;
};

const getTabPageIndex = state => {
  const tabPageIndex = state.getIn(['ui', 'tabs', 'tabPageIndex'], 0);
  const previewTabPageIndex = state.getIn(['ui', 'tabs', 'previewTabPageIndex']);

  return previewTabPageIndex != null ? previewTabPageIndex : tabPageIndex;
};

/**
* Updates the tab page index to the specified frameProps
* @param state{Object} - Window state
* @param tabId{number} - Tab id for the frame
* @param tabsPerPage{string} - Current setting for tabs per page, with a default value
*/
function updateTabPageIndex(state, tabId, tabsPerPage = getSetting(settings.TABS_PER_PAGE)) {
  const index = getFrameTabPageIndex(state, tabId, tabsPerPage);

  if (index === -1) {
    return state;
  }

  return state.setIn(['ui', 'tabs', 'tabPageIndex'], index);
}
const frameStatePath = (state, frameKey) => {
  const index = getFrameIndex(state, frameKey);
  if (index === -1) {
    return null;
  }
  return ['frames', index];
};

const frameStatePathByTabId = (state, tabId) => {
  const index = getIndexByTabId(state, tabId);
  if (index === -1) {
    return null;
  }
  return ['frames', index];
};

const activeFrameStatePath = state => frameStatePath(state, getActiveFrameKey(state));

const deleteTabInternalIndex = (state, tabId) => {
  return state.deleteIn(['framesInternal', 'tabIndex', tabId.toString()]);
};

const deleteFrameInternalIndex = (state, frame) => {
  if (!frame) {
    return state;
  }

  state = state.deleteIn(['framesInternal', 'index', frame.get('key').toString()]);
  return deleteTabInternalIndex(state, frame.get('tabId'));
};

const updateFramesInternalIndex = (state, fromIndex) => {
  let framesInternal = state.get('framesInternal') || Immutable.Map();
  state.get('frames').slice(fromIndex).reduceRight((result, frame, idx) => {
    const tabId = frame.get('tabId');
    const frameKey = frame.get('key');
    const realIndex = idx + fromIndex;
    if (frameKey) {
      framesInternal = framesInternal.setIn(['index', frameKey.toString()], realIndex);
    }
    if (tabId != null && tabId !== -1) {
      framesInternal = framesInternal.setIn(['tabIndex', tabId.toString()], realIndex);
    }
  }, 0);
  return state.set('framesInternal', framesInternal);
};

const moveFrame = (state, tabId, index) => {
  let framesInternal = state.get('framesInternal') || Immutable.Map();
  const frame = getFrameByTabId(state, tabId);
  const frameKey = frame.get('key');
  if (frameKey) {
    framesInternal = framesInternal.setIn(['index', frameKey.toString()], index);
  }
  if (tabId != null && tabId !== -1) {
    framesInternal = framesInternal.setIn(['tabIndex', tabId.toString()], index);
  }
  return state.set('framesInternal', framesInternal);
};

const isValidClosedFrame = frame => {
  const location = frame.get('location');
  if (location && (location.indexOf('about:newtab') !== -1 || location.indexOf('about:blank') !== -1)) {
    return false;
  }
  return !frame.get('isPrivate');
};

const getTabPageCount = state => {
  const frames = getNonPinnedFrames(state) || Immutable.List();
  const tabsPerPage = Number(getSetting(settings.TABS_PER_PAGE));

  return Math.ceil(frames.size / tabsPerPage);
};

const getPreviewFrameKey = state => {
  return state.get('previewFrameKey');
};

const setPreviewTabPageIndex = (state, index, immediate = false) => {
  clearTimeout(tabPageHoverTimeout);
  const previewTabs = getSetting(settings.SHOW_TAB_PREVIEWS);
  const isActive = state.getIn(['ui', 'tabs', 'tabPageIndex']) === index;
  let newTabPageIndex = index;

  if (!previewTabs || state.getIn(['ui', 'tabs', 'hoverTabPageIndex']) !== index || isActive) {
    newTabPageIndex = null;
  }

  if (!immediate) {
    // if there is an existing preview tab page index then we're already in preview mode
    // we use actions here because that is the only way to delay updating the state
    const previewMode = state.getIn(['ui', 'tabs', 'previewTabPageIndex']) != null;
    if (previewMode && newTabPageIndex == null) {
      // add a small delay when we are clearing the preview frame key so we don't lose
      // previewMode if the user mouses over another tab - see below
      tabPageHoverTimeout = setTimeout(windowActions.setPreviewTabPageIndex.bind(null, null), 200);
      return state;
    }

    if (!previewMode) {
      // If user isn't in previewMode so we add a bit of delay to avoid tab from flashing out
      // as reported here: https://github.com/brave/browser-laptop/issues/1434
      // using an action here because that is the only way we can do a delayed state update
      tabPageHoverTimeout = setTimeout(windowActions.setPreviewTabPageIndex.bind(null, newTabPageIndex), 200);
      return state;
    }
  }

  return state.setIn(['ui', 'tabs', 'previewTabPageIndex'], newTabPageIndex);
};

/**
* Defines whether or not a tab should be allowed to preview its content
* based on mouse idle time defined by mouse move in tab.js
* @param state {Object} - Application state
* @param previewMode {Boolean} - Whether or not minimium idle time
* has match the criteria
*/
const setPreviewMode = (state, previewMode) => {
  return state.setIn(['ui', 'tabs', 'previewMode'], previewMode);
};

/**
* Gets the previewMode application state
* @param state {Object} - Application state
* @return Immutable top level application state for previewMode
*/
const getPreviewMode = state => {
  return state.getIn(['ui', 'tabs', 'previewMode']);
};

const setPreviewFrameKey = (state, frameKey) => {
  clearTimeout(tabHoverTimeout);
  const frame = getFrameByKey(state, frameKey);
  const isActive = isFrameKeyActive(state, frameKey);
  const previewTabs = getSetting(settings.SHOW_TAB_PREVIEWS);
  const hoverState = getTabHoverState(state, frameKey);
  const previewMode = getPreviewMode(state);
  let newPreviewFrameKey = frameKey;

  if (!previewTabs || !previewMode || frame == null || !hoverState || isActive) {
    newPreviewFrameKey = null;
  }

  // TODO: remove this method to a tabPageIndex-related one
  const index = frame ? getFrameTabPageIndex(state, frame.get('tabId')) : -1;
  if (index !== -1) {
    if (index !== state.getIn(['ui', 'tabs', 'tabPageIndex'])) {
      state = state.setIn(['ui', 'tabs', 'previewTabPageIndex'], index);
    } else {
      state = state.deleteIn(['ui', 'tabs', 'previewTabPageIndex']);
    }
  }
  return state.set('previewFrameKey', newPreviewFrameKey);
};

const setTabPageHoverState = (state, tabPageIndex, hoverState) => {
  const currentHoverIndex = state.getIn(['ui', 'tabs', 'hoverTabPageIndex']);
  if (!hoverState && currentHoverIndex === tabPageIndex) {
    state = state.setIn(['ui', 'tabs', 'hoverTabPageIndex'], null);
  } else if (hoverState) {
    state = state.setIn(['ui', 'tabs', 'hoverTabPageIndex'], tabPageIndex);
  }
  state = setPreviewTabPageIndex(state, tabPageIndex);
  return state;
};

/**
* Checks if the current tab index is being hovered
* @param state {Object} - Application state
* @param frameKey {Number} - The current tab's frameKey
* @return Boolean - wheter or not hoverState is true
*/
const getTabHoverState = (state, frameKey) => {
  const index = getFrameIndex(state, frameKey);
  return getHoverTabIndex(state) === index;
};

/**
* Gets the hovered tab index state
* This check will return null if no tab is being hovered
* and is used getTabHoverState to check if current index is being hovered.
* If the method to apply for does not know the right index
* this should be used instead of getTabHoverState
* @param state {Object} - Application state
* @return Immutable top level application state for hoverTabIndex
*/
const getHoverTabIndex = state => {
  return state.getIn(['ui', 'tabs', 'hoverTabIndex']);
};

/**
* Sets the hover state for current tab index in top level state
* @param state {Object} - Application state
* @param frameKey {Number} - The current tab's frameKey
* @param hoverState {Boolean} - True if the current tab is being hovered.
* @return Immutable top level application state for hoverTabIndex
*/
const setHoverTabIndex = (state, frameKey, hoverState) => {
  const frameIndex = getFrameIndex(state, frameKey);
  if (!hoverState) {
    state = state.setIn(['ui', 'tabs', 'hoverTabIndex'], null);
    return state;
  }
  return state.setIn(['ui', 'tabs', 'hoverTabIndex'], frameIndex);
};

/**
* Gets values from the window setTabHoverState action from the store
* and is used to apply both hoverState and previewFrameKey
* @param state {Object} - Application state
* @param frameKey {Number} - The current tab's frameKey
* @param hoverState {Boolean} - True if the current tab is being hovered.
* @return Immutable top level application state for hoverTabIndex
*/
const setTabHoverState = (state, frameKey, hoverState, enablePreviewMode) => {
  const frameIndex = getFrameIndex(state, frameKey);
  if (frameIndex !== -1) {
    state = setHoverTabIndex(state, frameKey, hoverState);
    state = setPreviewMode(state, enablePreviewMode);
    state = setPreviewFrameKey(state, frameKey);
  }
  return state;
};

const frameLocationMatch = (frame, location) => {
  if (frame == null) {
    return false;
  }
  const validFrame = Immutable.Map.isMap(frame);
  return validFrame && frame.get('location') === location;
};

const hasFrame = (state, frameKey) => {
  const frame = getFrameByKey(state, frameKey);
  return frame && !frame.isEmpty();
};

module.exports = {
  hasFrame,
  setTabPageHoverState,
  setPreviewTabPageIndex,
  getTabHoverState,
  setTabHoverState,
  setPreviewFrameKey,
  getPreviewFrameKey,
  deleteTabInternalIndex,
  deleteFrameInternalIndex,
  updateFramesInternalIndex,
  moveFrame,
  query,
  find,
  isAncestorFrameKey,
  isFrameKeyActive,
  isFrameSecure,
  isFrameLoading,
  startLoadTime,
  endLoadTime,
  getHistory,
  isFrameKeyPinned,
  getNonPinnedFrameCount,
  isPrivatePartition,
  isSessionPartition,
  getFrames,
  getSortedFrames,
  getPinnedFrames,
  getNonPinnedFrames,
  getFrameIndex,
  getActiveFrameIndex,
  getActiveFrameTabId,
  getFrameByIndex,
  getFrameByDisplayIndex,
  getFrameByKey,
  getFrameByTabId,
  getIndexByTabId,
  getTabIdByFrameKey,
  getPartitionNumber,
  setFrameLastAccessedTime,
  setActiveFrameKey,
  getActiveFrame,
  getNextFrame,
  getPreviousFrame,
  findDisplayIndexForFrameKey,
  getFrameKeysByDisplayIndex,
  getPartition,
  getPartitionFromNumber,
  addFrame,
  removeFrame,
  frameOptsFromFrame,
  getFrameKeyByTabId,
  getFrameTabPageIndex,
  frameStatePath,
  activeFrameStatePath,
  getLastCommittedURL,
  onFindBarHide,
  getTotalBlocks,
  isPinned,
  isFirstFrameKeyInTabPage,
  getTabPageIndex,
  updateTabPageIndex,
  isValidClosedFrame,
  getTabPageCount,
  getSortedFrameKeys,
  frameStatePathByTabId,
  frameLocationMatch
};

/***/ }),

/***/ 87:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const mapValuesByKeys = __webpack_require__(35).mapValuesByKeys;

const _ = null;
const windowConstants = {
  WINDOW_SET_NAVBAR_INPUT: _,
  WINDOW_CLOSE_FRAME: _,
  WINDOW_CLOSE_FRAMES: _,
  WINDOW_SET_FOCUSED_FRAME: _,
  WINDOW_SET_PREVIEW_TAB_PAGE_INDEX: _,
  WINDOW_SET_TAB_PAGE_INDEX: _,
  WINDOW_SET_TAB_HOVER_STATE: _,
  WINDOW_SET_TAB_PAGE_HOVER_STATE: _,
  WINDOW_SET_TAB_CONTENT_INTERSECTION_STATE: _,
  WINDOW_TAB_MOVE: _,
  WINDOW_TAB_MOVE_INCREMENTAL_REQUESTED: _,
  WINDOW_SET_THEME_COLOR: _,
  WINDOW_WEBVIEW_LOAD_END: _,
  WINDOW_SET_FULL_SCREEN: _,
  WINDOW_SET_LINK_HOVER_PREVIEW: _,
  WINDOW_SET_RENDER_URL_BAR_SUGGESTIONS: _,
  WINDOW_URL_BAR_AUTOCOMPLETE_ENABLED: _,
  WINDOW_URL_BAR_SUGGESTIONS_CLEARED: _,
  WINDOW_PREVIOUS_URL_BAR_SUGGESTION_SELECTED: _,
  WINDOW_NEXT_URL_BAR_SUGGESTION_SELECTED: _,
  WINDOW_ACTIVE_URL_BAR_SUGGESTION_CLICKED: _,
  WINDOW_WEBVIEW_LOAD_START: _,
  WINDOW_ADD_HISTORY: _,
  WINDOW_SET_FRAME_ERROR: _,
  WINDOW_FRAME_TAB_ID_CHANGED: _,
  WINDOW_FRAME_GUEST_INSTANCE_ID_CHANGED: _,
  WINDOW_SET_NAVIGATED: _,
  WINDOW_SET_URL_BAR_ACTIVE: _, // whether the URL bar is being typed in
  WINDOW_UNDO_CLOSED_FRAME: _,
  WINDOW_CLEAR_CLOSED_FRAMES: _,
  WINDOW_FRAME_SHORTCUT_CHANGED: _,
  WINDOW_URL_BAR_ON_BLUR: _,
  WINDOW_URL_BAR_ON_FOCUS: _,
  WINDOW_TAB_ON_FOCUS: _,
  WINDOW_URL_BAR_SELECTED: _,
  WINDOW_SET_FIND_DETAIL: _,
  WINDOW_SET_BOOKMARK_DETAIL: _, // If set, also indicates that add/edit is shown
  WINDOW_SET_CONTEXT_MENU_DETAIL: _, // If set, also indicates that the context menu is shown
  WINDOW_SET_CONTEXT_MENU_SELECTED_INDEX: _,
  WINDOW_SET_POPUP_WINDOW_DETAIL: _, // If set, also indicates that the popup window is shown
  WINDOW_HIDE_BOOKMARK_HANGER: _,
  WINDOW_SET_AUDIO_MUTED: _,
  WINDOW_SET_FAVICON: _,
  WINDOW_SET_MOUSE_IN_TITLEBAR: _,
  WINDOW_SET_FINDBAR_SHOWN: _, // whether the findbar is shown
  WINDOW_SET_FINDBAR_SELECTED: _, // whether the findbar is active
  WINDOW_SET_SITE_INFO_VISIBLE: _, // Whether or not to show site info like # of blocked ads
  WINDOW_SET_BRAVERY_PANEL_DETAIL: _, // Whether or not to show the Bravery panel and info about how to show it
  WINDOW_SET_DOWNLOADS_TOOLBAR_VISIBLE: _, // Whether or not to show the downloads toolbar
  WINDOW_SET_RELEASE_NOTES_VISIBLE: _, // Whether or not to show release notes
  WINDOW_SET_NOSCRIPT_VISIBLE: _, // Whether or not to show noscript info
  WINDOW_SET_BLOCKED_BY: _, // Whether or not to show site info like # of blocked ads
  WINDOW_SET_REDIRECTED_BY: _, // Whether or not to show site info like redirected resources
  WINDOW_SET_SECURITY_STATE: _,
  WINDOW_SET_STATE: _,
  WINDOW_SET_LAST_ZOOM_PERCENTAGE: _,
  WINDOW_SET_CLEAR_BROWSING_DATA_VISIBLE: _,
  WINDOW_SET_IMPORT_BROWSER_DATA_DETAIL: _,
  WINDOW_SET_IMPORT_BROWSER_DATA_SELECTED: _,
  WINDOW_SET_AUTOFILL_ADDRESS_DETAIL: _,
  WINDOW_SET_AUTOFILL_CREDIT_CARD_DETAIL: _,
  WINDOW_SET_BLOCKED_RUN_INSECURE_CONTENT: _,
  WINDOW_TOGGLE_MENUBAR_VISIBLE: _,
  WINDOW_CLICK_MENUBAR_SUBMENU: _,
  WINDOW_RESET_MENU_STATE: _,
  WINDOW_SET_MENUBAR_SELECTED_INDEX: _,
  WINDOW_SET_LAST_FOCUSED_SELECTOR: _,
  WINDOW_SET_BOOKMARKS_TOOLBAR_SELECTED_FOLDER_ID: _,
  WINDOW_SET_MODAL_DIALOG_DETAIL: _,
  WINDOW_WIDEVINE_SITE_ACCESSED_WITHOUT_INSTALL: _,
  WINDOW_WIDEVINE_PANEL_DETAIL_CHANGED: _,
  WINDOW_AUTOFILL_SELECTION_CLICKED: _,
  WINDOW_AUTOFILL_POPUP_HIDDEN: _,
  WINDOW_TAB_CLOSED_WITH_MOUSE: _,
  WINDOW_TAB_MOUSE_LEAVE: _,
  WINDOW_FRAME_MOUSE_ENTER: _,
  WINDOW_FRAME_MOUSE_LEAVE: _,
  WINDOW_SHOULD_SET_TITLE: _,
  WINDOW_SHOULD_MINIMIZE: _,
  WINDOW_SHOULD_MAXIMIZE: _,
  WINDOW_SHOULD_UNMAXIMIZE: _,
  WINDOW_SHOULD_EXIT_FULL_SCREEN: _,
  WINDOW_SHOULD_OPEN_DEV_TOOLS: _,
  WINDOW_SET_ALL_AUDIO_MUTED: _,
  WINDOW_ON_GO_BACK_LONG: _,
  WINDOW_ON_GO_FORWARD_LONG: _,
  WINDOW_ON_CERT_ERROR: _,
  WINDOW_ON_TAB_PAGE_CONTEXT_MENU: _,
  WINDOW_ON_STOP: _,
  WINDOW_ON_MORE_BOOKMARKS_MENU: _,
  WINDOW_ON_SHOW_BOOKMARK_FOLDER_MENU: _,
  WINDOW_ON_SITE_DETAIL_MENU: _,
  WINDOW_ON_ADD_BOOKMARK: _,
  WINDOW_ON_EDIT_BOOKMARK: _,
  WINDOW_ON_BOOKMARK_CLOSE: _,
  WINDOW_ON_BOOKMARK_ADDED: _,
  WINDOW_ON_ADD_BOOKMARK_FOLDER: _,
  WINDOW_ON_EDIT_BOOKMARK_FOLDER: _,
  WINDOW_ON_BOOKMARK_FOLDER_CLOSE: _
};

module.exports = mapValuesByKeys(windowConstants);

/***/ }),

/***/ 88:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const Immutable = __webpack_require__(1);
const assert = __webpack_require__(25);
const { makeImmutable, isMap } = __webpack_require__(16);
const uuid = __webpack_require__(202);

const validateState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  return state;
};

let contextMenuDetail = Immutable.Map();

const api = {
  setContextMenu: (windowState, detail) => {
    detail = makeImmutable(detail);
    windowState = validateState(windowState);

    if (!detail) {
      if (contextMenuDetail.get('type') === 'hamburgerMenu') {
        windowState = windowState.set('hamburgerMenuWasOpen', true);
      } else {
        windowState = windowState.set('hamburgerMenuWasOpen', false);
      }
      contextMenuDetail = Immutable.Map();
      windowState = windowState.delete('contextMenuDetail');
    } else {
      if (!(detail.get('type') === 'hamburgerMenu' && windowState.get('hamburgerMenuWasOpen'))) {
        contextMenuDetail = detail;
        windowState = windowState.set('contextMenuDetail', uuid());
      }
      windowState = windowState.set('hamburgerMenuWasOpen', false);
    }
    return windowState;
  },

  getContextMenu: windowState => {
    windowState = validateState(windowState);
    return contextMenuDetail;
  },

  selectedIndex: windowState => {
    const selectedIndex = windowState.getIn(['ui', 'contextMenu', 'selectedIndex']);
    return typeof selectedIndex === 'object' && Array.isArray(selectedIndex) && selectedIndex.length > 0 ? selectedIndex : null;
  }
};

module.exports = api;

/***/ }),

/***/ 9:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */



const { dispatch } = __webpack_require__(76);
const windowConstants = __webpack_require__(87);

const windowActions = {
  /**
   * Dispatches an event to the main process to replace the window state
   *
   * @param {object} windowState - Initial window state object
   */
  setState: function (windowState) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_STATE,
      windowState
    });
  },

  /**
   * Dispatches a message to the store to let it know a page has been navigated.
   *
   * @param {string} location - The URL of the page that was navigated to.
   * @param {number} key - The frame key to modify.
   * @param {boolean} isNavigatedInPage - true if it was a navigation within the same page.
   * @param {number} tabId - the tab id
   */
  setNavigated: function (location, key, isNavigatedInPage, tabId) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_NAVIGATED,
      location,
      key,
      isNavigatedInPage,
      tabId
    });
  },

  /**
   * Dispatches a message to set the security state.
   * @param {Object} tabId - Tab id of the frame properties to modify.
   * @param {Object} securityState - The security state properties that have
   *   changed.
   */
  setSecurityState: function (tabId, securityState) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_SECURITY_STATE,
      tabId,
      securityState
    });
  },

  /**
   * Dispatches a message to change the frame tabId
   * @param {Object} frameProps - The frame properties
   * @param {Number} oldTabId - the current tabId
   * @param {Number} newTabId - the new tabId
   */
  frameTabIdChanged: function (frameProps, oldTabId, newTabId) {
    dispatch({
      actionType: windowConstants.WINDOW_FRAME_TAB_ID_CHANGED,
      frameProps,
      oldTabId,
      newTabId
    });
  },

  /**
   * Dispatches a message when the guestInstanceId changes for a frame
   * @param {Object} frameProps - The frame properties
   * @param {Number} oldGuestInstanceId - the current guestInstanceId
   * @param {Number} newGuestInstanceId - the new guestInstanceId
   */
  frameGuestInstanceIdChanged: function (frameProps, oldGuestInstanceId, newGuestInstanceId) {
    dispatch({
      actionType: windowConstants.WINDOW_FRAME_GUEST_INSTANCE_ID_CHANGED,
      frameProps,
      oldGuestInstanceId,
      newGuestInstanceId
    });
  },

  /**
   * Dispatches a message to set the frame error state
   * @param {Object} frameProps - The frame properties
   * @param {Object} errorDetails - The error properties
   *   changed.
   */
  setFrameError: function (frameProps, errorDetails) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FRAME_ERROR,
      frameProps,
      errorDetails
    });
  },

  /**
   * Shows/hides the find-in-page bar.
   * @param {number} frameKey - Key of the frame that we want to modify
   * @param {boolean} shown - Whether to show the find bar
   */
  setFindbarShown: function (frameKey, shown) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FINDBAR_SHOWN,
      frameKey,
      shown
    });
  },

  /**
   * Highlight text in the find bar
   * @param {Object} frameKey - The frame key to modify
   * @param {boolean} selected - Whether to select the find bar search text
   */
  setFindbarSelected: function (frameKey, selected) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FINDBAR_SELECTED,
      frameKey,
      selected
    });
  },

  /**
   * Dispatches a message to the store to indicate that the webview is loading.
   *
   * @param {Object} frameProps - The frame properties for the webview in question.
   * @param {string} location - The location being loaded.
   */
  onWebviewLoadStart: function (frameProps, location) {
    dispatch({
      actionType: windowConstants.WINDOW_WEBVIEW_LOAD_START,
      frameProps,
      location
    });
  },

  /**
   * Dispatches a message to the store to indicate that the webview is done loading.
   *
   * @param {Object} frameProps - The frame properties for the webview in question.
   */
  onWebviewLoadEnd: function (frameProps) {
    dispatch({
      actionType: windowConstants.WINDOW_WEBVIEW_LOAD_END,
      frameProps
    });
  },

  /**
   * Dispatches a message to the store to indicate that the webview entered full screen mode.
   *
   * @param {Object} tabId - Tab id of the frame to put in full screen
   * @param {boolean} isFullScreen - true if the webview is entering full screen mode.
   * @param {boolean} showFullScreenWarning - true if a warning about entering full screen should be shown.
   */
  setFullScreen: function (tabId, isFullScreen, showFullScreenWarning) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FULL_SCREEN,
      tabId,
      isFullScreen,
      showFullScreenWarning
    });
  },

  /**
   * Dispatches a message to close a frame
   *
   * @param {Object} frameKey - Frame key of the frame to close
   */
  closeFrame: function (frameKey) {
    dispatch({
      actionType: windowConstants.WINDOW_CLOSE_FRAME,
      frameKey
    });
  },

  /**
   * Dispatches a message to close multiple frames
   * @param {Object[]} framePropsList - The properties of all frames to close
   */
  closeFrames: function (framePropsList) {
    dispatch({
      actionType: windowConstants.WINDOW_CLOSE_FRAMES,
      framePropsList
    });
  },

  /**
   * Dispatches a message to the store to undo a closed frame
   * The new frame is expected to appear at the index it was last closed at
   */
  undoClosedFrame: function () {
    dispatch({
      actionType: windowConstants.WINDOW_UNDO_CLOSED_FRAME
    });
  },

  /**
   * Dispatches a message to the store to clear closed frames
   * @param {string=} location - only clear frames with this location
   */
  clearClosedFrames: function (location) {
    dispatch({
      actionType: windowConstants.WINDOW_CLEAR_CLOSED_FRAMES,
      location
    });
  },

  /**
   * Dispatches a message to the store when the frame is active and the window is focused
   *
   * @param {Object} location - location for the webview in question.
   * @param {Object} tabId - tabId for the webview in question.
   */
  setFocusedFrame: function (location, tabId) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FOCUSED_FRAME,
      location,
      tabId
    });
  },

  /**
   * Dispatches a message to the store to set the tab page index.
   *
   * @param {number} index - the tab page index to change to
   */
  setTabPageIndex: function (index) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_TAB_PAGE_INDEX,
      index
    });
  },

  setTabIntersectionState: function (frameKey, ratio) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_TAB_CONTENT_INTERSECTION_STATE,
      frameKey,
      ratio
    });
  },

  /**
   * Dispatches a message to the store to set the current tab hover state.
   *
   * @param {Object} frameKey - the frame key for the webview in question.
   * @param {boolean} hoverState - whether or not mouse is over tab
   * @param {boolean} previewMode - whether or not the next tab should be previewed
   * based on mouse idle time
   */
  setTabHoverState: function (frameKey, hoverState, previewMode) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_TAB_HOVER_STATE,
      frameKey,
      hoverState,
      previewMode
    });
  },

  /**
   * Dispatches a message to the store to set the current tab hover state.
   *
   * @param {Object} tabPageIndex - the frame key for the webview in question.
   * @param {boolean} hoverState - whether or not mouse is over tabPage
   */
  setTabPageHoverState: function (tabPageIndex, hoverState) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_TAB_PAGE_HOVER_STATE,
      tabPageIndex,
      hoverState
    });
  },

  /**
   * Dispatches a message to the store to set the tab page index being previewed.
   *
   * @param {number} previewTabPageIndex - The tab page index to preview
   */
  setPreviewTabPageIndex: function (previewTabPageIndex) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_PREVIEW_TAB_PAGE_INDEX,
      previewTabPageIndex
    });
  },

  /**
   * Dispatches a message to the store to set the tab page index.
   *
   * @param {number} frameProps - The frame props to center around
   */
  setTabPageIndexByFrame: function (frameProps) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_TAB_PAGE_INDEX,
      frameProps
    });
  },

  /**
   * Dispatches a message to the store to indicate that the specified frame should move locations.
   *
   * @param {Object} sourceFrameKey - the frame key for the webview to move.
   * @param {Object} destinationFrameKey - the frame key for the webview to move to.
   * @param {boolean} prepend - Whether or not to prepend to the destinationFrameProps
   */
  moveTab: function (sourceFrameKey, destinationFrameKey, prepend) {
    dispatch({
      actionType: windowConstants.WINDOW_TAB_MOVE,
      sourceFrameKey,
      destinationFrameKey,
      prepend
    });
  },

  /**
   * A request to increase or decrease the display order of the active tab relative to other tabs in its window
   * @param {Boolean} moveNext
   */
  tabMoveIncrementalRequested: function (windowId, moveNext = true) {
    dispatch({
      actionType: windowConstants.WINDOW_TAB_MOVE_INCREMENTAL_REQUESTED,
      moveNext,
      queryInfo: {
        windowId
      }
    });
  },

  /**
   * The active URL bar suggestion was clicked
   * @param {boolean} isForSecondaryAction - Whether the secondary action is expected
   *  which happens when a modifier key is pressed.
   * @param {boolean} shiftKey - Whether the shift key is being pressed
   */
  activeSuggestionClicked: function (isForSecondaryAction, shiftKey) {
    dispatch({
      actionType: windowConstants.WINDOW_ACTIVE_URL_BAR_SUGGESTION_CLICKED,
      isForSecondaryAction,
      shiftKey
    });
  },

  /**
   * The previous suggestion is being selected
   */
  previousUrlBarSuggestionSelected: function () {
    dispatch({
      actionType: windowConstants.WINDOW_PREVIOUS_URL_BAR_SUGGESTION_SELECTED
    });
  },

  /**
   * The next suggestion is being selected
   */
  nextUrlBarSuggestionSelected: function () {
    dispatch({
      actionType: windowConstants.WINDOW_NEXT_URL_BAR_SUGGESTION_SELECTED
    });
  },

  /**
   * autocomplete for urlbar is being enabled or disabled.
   * Autocomplete is defined to be the action of inserting text into the urlbar itself
   * to the first item's URL match if possible.  The inserted text is auto selected so
   * that the next character inserted will replace it.
   * This is sometimes only temporarily disabled, e.g. a user is pressing backspace.
   *
   * @param {boolean} enabled - true if the urlbar should autocomplete
   */
  urlBarAutocompleteEnabled: function (enabled) {
    dispatch({
      actionType: windowConstants.WINDOW_URL_BAR_AUTOCOMPLETE_ENABLED,
      enabled
    });
  },

  /*
   * Sets if we should render URL bar suggestions.
   *
   * @param enabled If false URL bar suggestions will not be rendered.
   */
  setRenderUrlBarSuggestions: function (enabled) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_RENDER_URL_BAR_SUGGESTIONS,
      enabled
    });
  },

  /**
   * Indicates the URLbar has been selected
   */
  urlBarSelected: function (selected) {
    dispatch({
      actionType: windowConstants.WINDOW_URL_BAR_SELECTED
    });
  },

  /**
   * Marks the URL bar as active or not.
   * If the URL bar is active that means it's in a position that it should be displaying
   * autocomplete.  It may choose not to display autocomplete and still be active if there
   * are no autocomplete results.
   *
   * @param {boolean} isActive - Whether or not the URL bar should be marked as active
   */
  setUrlBarActive: function (isActive) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_URL_BAR_ACTIVE,
      isActive
    });
  },

  urlBarOnFocus: function (windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_URL_BAR_ON_FOCUS,
      windowId
    });
  },

  urlBarOnBlur: function (windowId, targetValue, locationValue, fromSuggestion) {
    dispatch({
      actionType: windowConstants.WINDOW_URL_BAR_ON_BLUR,
      windowId,
      targetValue,
      locationValue,
      fromSuggestion
    });
  },

  tabOnFocus: function (tabId) {
    dispatch({
      actionType: windowConstants.WINDOW_TAB_ON_FOCUS,
      tabId
    });
  },

  /**
   * Dispatches a message to the store to indicate that the pending frame shortcut info should be updated.
   *
   * @param {Object} frameProps - Properties of the frame in question
   * @param {string} activeShortcut - The text for the new shortcut. Usually this is null to clear info which was previously
   * set from an IPC call.
   * @param {string} activeShortcutDetails - Parameters for the shortcut action
   */
  frameShortcutChanged: function (frameProps, activeShortcut, activeShortcutDetails) {
    dispatch({
      actionType: windowConstants.WINDOW_FRAME_SHORTCUT_CHANGED,
      frameProps,
      activeShortcut,
      activeShortcutDetails
    });
  },

  /**
   * Dispatches a message to set the find-in-page details.
   * @param {Object} frameKey - Frame key of the frame in question
   * @param {Object} findDetail - the find details
   */
  setFindDetail: function (frameKey, findDetail) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FIND_DETAIL,
      frameKey,
      findDetail
    });
  },

  /**
   * Used for displaying bookmark hanger
   * when adding bookmark site or folder
   */
  addBookmark: function (siteDetail, closestKey) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_ADD_BOOKMARK,
      siteDetail,
      closestKey
    });
  },

  /**
   * Used for displaying bookmark hanger
   * when editing bookmark site or folder
   */
  editBookmark: function (editKey, isHanger) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_EDIT_BOOKMARK,
      editKey,
      isHanger
    });
  },

  /**
   * Used for adding bookmark site directly and then allowing to
   * edit it right afterwords
   * @param isHanger
   * @param bookmarkDetail - bookmark data, if empty active frame will be used
   */
  onBookmarkAdded: function (isHanger, bookmarkDetail) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_BOOKMARK_ADDED,
      bookmarkDetail,
      isHanger
    });
  },

  /**
   * Used for closing a bookmark dialog
   */
  onBookmarkClose: function () {
    dispatch({
      actionType: windowConstants.WINDOW_ON_BOOKMARK_CLOSE
    });
  },

  /**
   * Used for displaying bookmark folder dialog
   * when adding bookmark site or folder
   */
  addBookmarkFolder: function (folderDetails, closestKey) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_ADD_BOOKMARK_FOLDER,
      folderDetails,
      closestKey
    });
  },

  /**
   * Used for displaying bookmark folder dialog
   * when editing bookmark site or folder
   */
  editBookmarkFolder: function (editKey) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_EDIT_BOOKMARK_FOLDER,
      editKey
    });
  },

  /**
   * Used for closing a bookmark dialog
   */
  onBookmarkFolderClose: function () {
    dispatch({
      actionType: windowConstants.WINDOW_ON_BOOKMARK_FOLDER_CLOSE
    });
  },

  /**
   * Dispatches a message to set context menu detail.
   * If set, also indicates that the context menu is shown.
   * @param {Object} detail - The context menu detail
   */
  setContextMenuDetail: function (detail) {
    // TODO(darkdh): This is a hack to prevent dispatch from serializing
    // click function in template. `contextMenuDetail` is just a uuid to trigger
    // state update for new menu
    const Immutable = __webpack_require__(1);
    const contextMenuState = __webpack_require__(88);
    let state = contextMenuState.setContextMenu(Immutable.Map(), detail);
    const contextMenuDetail = state.get('contextMenuDetail');
    dispatch({
      actionType: windowConstants.WINDOW_SET_CONTEXT_MENU_DETAIL,
      contextMenuDetail
    });
  },

  /**
   * Dispatches a message to set popup window detail.
   * If set, also indicates that the popup window is shown.
   * @param {Object} detail - The popup window detail
   */
  setPopupWindowDetail: function (detail) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_POPUP_WINDOW_DETAIL,
      detail
    });
  },

  /**
   * Dispatches a message to indicate that the frame should be muted
   *
   * @param {number} frameKey - Key of the frame in question
   * @param {number} tabId - Id of the tab in question
   * @param {boolean} muted - true if the frame is muted
   */
  setAudioMuted: function (frameKey, tabId, muted) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_AUDIO_MUTED,
      frameKey,
      tabId,
      muted
    });
  },

  /**
   * Dispatches a mute/unmute call to all frames in a provided list.
   *
   * @param {Object} frameList - List of frames to consider (frameKey and tabId)
   */
  muteAllAudio: function (frameList) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_ALL_AUDIO_MUTED,
      frameList
    });
  },

  /**
   * Dispatches a message to indicate that the theme color has changed for a page
   *
   * @param {Object} frameProps - Properties of the frame in question
   * @param {string} themeColor - Theme color of the frame
   * @param {string} computedThemeColor - Computed theme color of the
   *   frame which is used if no frame color is present
   */
  setThemeColor: function (frameProps, themeColor, computedThemeColor) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_THEME_COLOR,
      frameProps,
      themeColor,
      computedThemeColor
    });
  },

  /**
   * Dispatches a message to indicate that the favicon has changed
   *
   * @param {Object} frameProps - Properties of the frame in question
   * @param {string} favicon - A url to the favicon to use
   */
  setFavicon: function (frameProps, favicon) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_FAVICON,
      frameProps,
      favicon
    });
  },

  /**
   * Dispatches a message to store the last zoom percentage.
   * This is mainly just used to trigger updates throughout React.
   *
   * @param {object} frameProps - The frame to set blocked info on
   * @param {number} percentage - The new zoom percentage
   */
  setLastZoomPercentage: function (frameProps, percentage) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_LAST_ZOOM_PERCENTAGE,
      frameProps,
      percentage
    });
  },

  /**
   * Saves the position of the window in the window state
   * @param {Array} position - [x, y]
   */
  savePosition: function (position) {
    dispatch({
      actionType: windowConstants.WINDOW_SAVE_POSITION,
      position
    });
  },

  /**
   * Dispatches a message to indicate if the mouse is in the titlebar
   *
   * @param {boolean} mouseInTitlebar - true if the mouse is in the titlebar
   */
  setMouseInTitlebar: function (mouseInTitlebar) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_MOUSE_IN_TITLEBAR,
      mouseInTitlebar
    });
  },

  /**
   * Dispatches a message to indicate the site info, such as # of blocked ads, should be shown
   *
   * @param {boolean} isVisible - true if the site info should be shown
   */
  setSiteInfoVisible: function (isVisible) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_SITE_INFO_VISIBLE,
      isVisible
    });
  },

  /**
   * Dispatches a message to indicate the bravery panel should be shown
   *
   * @param {Object} braveryPanelDetail - Details about how to show the bravery panel.
   *   Set to undefined to hide the panel.  See state documentation for more info.
   */
  setBraveryPanelDetail: function (braveryPanelDetail) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_BRAVERY_PANEL_DETAIL,
      braveryPanelDetail
    });
  },

  /**
   * Dispatches a message to indicate if the downloads toolbar is visible
   *
   * @param {boolean} isVisible - true if the site info should be shown
   */
  setDownloadsToolbarVisible: function (isVisible) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_DOWNLOADS_TOOLBAR_VISIBLE,
      isVisible
    });
  },

  /**
   * Dispatches a message to indicate the release notes should be visible
   *
   * @param {boolean} isVisible - true if the site info should be shown
   */
  setReleaseNotesVisible: function (isVisible) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_RELEASE_NOTES_VISIBLE,
      isVisible
    });
  },

  /**
   * Dispatches a message to indicate the href preview should be shown
   * for a hovered link
   * @param {string} href - the href of the link
   * @param {boolean} showOnRight - display in the right corner
   */
  setLinkHoverPreview: function (href, showOnRight) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_LINK_HOVER_PREVIEW,
      href,
      showOnRight
    });
  },

  /**
   * Dispatches a message to indicate the site info, such as # of blocked ads, should be shown
   *
   * @param {object} tabId - Tab id for the frame to set blocked info on
   * @param {string} blockType - type of the block
   * @param {string} location - URL that was blocked
   */
  setBlockedBy: function (tabId, blockType, location) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_BLOCKED_BY,
      tabId,
      blockType,
      location
    });
  },

  /**
   * Similar to setBlockedBy but for httpse redirects
   * @param {Object} tabId - Tab id of the frame to set blocked info on
   * @param {string} ruleset - Name of the HTTPS Everywhere ruleset XML file
   * @param {string} location - URL that was redirected
   */
  setRedirectedBy: function (tabId, ruleset, location) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_REDIRECTED_BY,
      tabId,
      ruleset,
      location
    });
  },

  /**
   * Sets/toggles whether the noscriptinfo dialog is visible.
   * @param {boolean=} isVisible - if undefined, toggle the current state
   */
  setNoScriptVisible: function (isVisible) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_NOSCRIPT_VISIBLE,
      isVisible
    });
  },

  /**
   * Adds a history entry
   * @param {Object} frameProps - The frame properties to change history for.
   */
  addHistory: function (frameProps) {
    dispatch({
      actionType: windowConstants.WINDOW_ADD_HISTORY,
      frameProps
    });
  },

  /**
   * Sets whether the clear browsing data popup is visible
   * @param {boolean} isVisible
   */
  setClearBrowsingDataPanelVisible: function (isVisible) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_CLEAR_BROWSING_DATA_VISIBLE,
      isVisible
    });
  },

  /**
   * Sets the import browser data popup detail
   * @param {Array} importBrowserDataDetail - list of supported browsers
   */
  setImportBrowserDataDetail: function (importBrowserDataDetail) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_IMPORT_BROWSER_DATA_DETAIL,
      importBrowserDataDetail
    });
  },

  /**
   * Sets the selected import browser data
   * @param {Object} selected - selected browser data to import
   */
  setImportBrowserDataSelected: function (selected) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_IMPORT_BROWSER_DATA_SELECTED,
      selected
    });
  },

  widevineSiteAccessedWithoutInstall: function () {
    dispatch({
      actionType: windowConstants.WINDOW_WIDEVINE_SITE_ACCESSED_WITHOUT_INSTALL
    });
  },

  /**
   * Widevine popup detail changed
   * @param {Object} widevinePanelDetail - detail of the widevine panel
   */
  widevinePanelDetailChanged: function (widevinePanelDetail) {
    dispatch({
      actionType: windowConstants.WINDOW_WIDEVINE_PANEL_DETAIL_CHANGED,
      widevinePanelDetail
    });
  },

  /**
   * Sets the manage autofill address popup detail
   * @param {string} property - Property that we want change
   * @param {string} newValue - New value for this property
   * @param {Object} wholeObject - Whole object of address detail
   */
  setAutofillAddressDetail: function (property, newValue, wholeObject) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_AUTOFILL_ADDRESS_DETAIL,
      property,
      newValue,
      wholeObject
    });
  },

  /**
   * Sets the manage autofill credit card popup detail
   * @param {string} property - Property that we want change
   * @param {string} newValue - New value for this property
   * @param {Object} wholeObject -  Whole object of credit card detail
   */
  setAutofillCreditCardDetail: function (property, newValue, wholeObject) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_AUTOFILL_CREDIT_CARD_DETAIL,
      property,
      newValue,
      wholeObject
    });
  },

  /**
   * Sets source of blocked active mixed content.
   * @param {Object} frameProps - The frame to set source of
   * blocked active mixed content on
   * @param {string} source - Source of blocked active mixed content
   */
  setBlockedRunInsecureContent: function (frameProps, source) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_BLOCKED_RUN_INSECURE_CONTENT,
      frameProps,
      source
    });
  },

  /**
   * (Windows only)
   * Dispatches a message to indicate the custom rendered Menubar should be toggled (shown/hidden)
   * @param {boolean} isVisible (optional)
   */
  toggleMenubarVisible: function (isVisible) {
    dispatch({
      actionType: windowConstants.WINDOW_TOGGLE_MENUBAR_VISIBLE,
      isVisible
    });
  },

  /**
   * (Windows only)
   * Used to trigger the click() action for a menu
   * Called from the Menubar control, handled in menu.js
   * @param {string} label - text of the label that was clicked
   */
  clickMenubarSubmenu: function (label) {
    dispatch({
      actionType: windowConstants.WINDOW_CLICK_MENUBAR_SUBMENU,
      label
    });
  },

  /**
   * Used by `main.js` when click happens on content area (not on a link or react control).
   * - closes context menu
   * - closes popup menu
   * - nulls out menubar item selected (Windows only)
   * - hides menubar if auto-hide preference is set (Windows only)
   */
  resetMenuState: function () {
    dispatch({
      actionType: windowConstants.WINDOW_RESET_MENU_STATE
    });
  },

  /**
   * (Windows only)
   * Used to track selected index of a menu bar
   * Needed because arrow keys can be used to navigate the custom menu
   * @param {number} index - zero based index of the item.
   *   Index excludes menu separators and hidden items.
   */
  setMenuBarSelectedIndex: function (index) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_MENUBAR_SELECTED_INDEX,
      index
    });
  },

  /**
   * Used to track selected index of a context menu
   * Needed because arrow keys can be used to navigate the context menu
   * @param {number} index - zero based index of the item.
   *   Index excludes menu separators and hidden items.
   */
  setContextMenuSelectedIndex: function (index) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_CONTEXT_MENU_SELECTED_INDEX,
      index
    });
  },

  /**
   * (Windows only at the moment)
   * Used to track last selected element (typically the URL bar or the frame)
   * Important because focus is lost when using the custom menu and needs
   * to be returned in order for the cut/copy operation to work
   * @param {string} selector - selector used w/ querySelectorAll to return focus
   *   after a menu item is selected (via the custom titlebar / menubar)
   */
  setLastFocusedSelector: function (selector) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_LAST_FOCUSED_SELECTOR,
      selector
    });
  },

  /**
   * Fired when the mouse clicks or hovers over a bookmark folder in the bookmarks toolbar
   * @param {number} folderId - from the siteDetail for the bookmark folder
   *   If set to null, no menu is open. If set to -1, mouse is over a bookmark, not a folder
   */
  setBookmarksToolbarSelectedFolderId: function (folderId) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_BOOKMARKS_TOOLBAR_SELECTED_FOLDER_ID,
      folderId
    });
  },

  /**
   * Set Modal Dialog detail
   * @param {string} className - name of modal dialog
   * @param {Object} props - properties of the modal dialog
   */
  setModalDialogDetail: function (className, props) {
    dispatch({
      actionType: windowConstants.WINDOW_SET_MODAL_DIALOG_DETAIL,
      className,
      props
    });
  },

  autofillSelectionClicked: function (tabId, value, frontEndId, index) {
    dispatch({
      actionType: windowConstants.WINDOW_AUTOFILL_SELECTION_CLICKED,
      tabId,
      value,
      frontEndId,
      index
    });
  },

  autofillPopupHidden: function (tabId, notify = false) {
    dispatch({
      actionType: windowConstants.WINDOW_AUTOFILL_POPUP_HIDDEN,
      tabId,
      notify
    });
  },

  onTabClosedWithMouse: function (data) {
    dispatch({
      actionType: windowConstants.WINDOW_TAB_CLOSED_WITH_MOUSE,
      data
    });
  },

  onTabMouseLeave: function (data) {
    dispatch({
      actionType: windowConstants.WINDOW_TAB_MOUSE_LEAVE,
      data
    });
  },

  onFrameMouseEnter: function (tabId) {
    dispatch({
      actionType: windowConstants.WINDOW_FRAME_MOUSE_ENTER,
      tabId
    });
  },

  onFrameMouseLeave: function (tabId) {
    dispatch({
      actionType: windowConstants.WINDOW_FRAME_MOUSE_LEAVE,
      tabId
    });
  },

  // TODO(bridiver) - refactor these as declarative
  shouldSetTitle: function (windowId, title) {
    dispatch({
      actionType: windowConstants.WINDOW_SHOULD_SET_TITLE,
      windowId,
      title
    });
  },

  shouldMinimize: function (windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_SHOULD_MINIMIZE,
      windowId
    });
  },

  shouldMaximize: function (windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_SHOULD_MAXIMIZE,
      windowId
    });
  },

  shouldUnmaximize: function (windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_SHOULD_UNMAXIMIZE,
      windowId
    });
  },

  shouldExitFullScreen: function (windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_SHOULD_EXIT_FULL_SCREEN,
      windowId
    });
  },

  shouldOpenDevTools: function (windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_SHOULD_OPEN_DEV_TOOLS,
      windowId
    });
  },

  onLongBackHistory: function (history, left, top, partition, tabId, windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_GO_BACK_LONG,
      queryInfo: {
        windowId
      },
      history,
      left,
      top,
      partition,
      tabId
    });
  },

  onLongForwardHistory: function (history, left, top, partition, tabId, windowId) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_GO_FORWARD_LONG,
      queryInfo: {
        windowId
      },
      history,
      left,
      top,
      partition,
      tabId
    });
  },

  onCertError: function (tabId, url, error) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_CERT_ERROR,
      tabId,
      url,
      error
    });
  },

  onTabPageContextMenu: function (index) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_TAB_PAGE_CONTEXT_MENU,
      index
    });
  },

  onStop: function (isFocused, shouldRender) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_STOP,
      isFocused,
      shouldRender
    });
  },

  onMoreBookmarksMenu: function (bookmarks, top) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_MORE_BOOKMARKS_MENU,
      bookmarks,
      top
    });
  },

  onShowBookmarkFolderMenu: function (bookmarkKey, left, top, submenuIndex) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_SHOW_BOOKMARK_FOLDER_MENU,
      bookmarkKey,
      left,
      top,
      submenuIndex
    });
  },

  onSiteDetailMenu: function (bookmarkKey, type) {
    dispatch({
      actionType: windowConstants.WINDOW_ON_SITE_DETAIL_MENU,
      bookmarkKey,
      type
    });
  }
};

module.exports = windowActions;

/***/ }),

/***/ 95:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const STATE_SITES = {
  BOOKMARKS: 'bookmarks',
  BOOKMARK_FOLDERS: 'bookmarkFolders',
  HISTORY_SITES: 'historySites',
  PINNED_SITES: 'pinnedSites'
};

module.exports = {
  STATE_SITES
};

/***/ }),

/***/ 96:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _generate = __webpack_require__(194);

var _exports2 = __webpack_require__(356);

var _exports3 = _interopRequireDefault(_exports2);

var useImportant = true; // Add !important to all style definitions
exports['default'] = (0, _exports3['default'])(useImportant, _generate.defaultSelectorHandlers);
module.exports = exports['default'];

/***/ }),

/***/ 97:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file, * You can obtain one at http://mozilla.org/MPL/2.0/. */

const mapValuesByKeys = __webpack_require__(35).mapValuesByKeys;

const _ = null;
const appConstants = {
  APP_NEW_WINDOW: _,
  APP_WINDOW_READY: _,
  APP_WINDOW_RENDERED: _,
  APP_CLOSE_WINDOW: _,
  APP_WINDOW_CLOSED: _,
  APP_WINDOW_CREATED: _,
  APP_WINDOW_UPDATED: _,
  APP_TAB_STRIP_EMPTY: _,
  APP_TAB_CLOSED: _,
  APP_TAB_UPDATED: _,
  APP_TAB_REPLACED: _,
  APP_ADD_HISTORY_SITE: _,
  APP_SET_STATE: _,
  APP_REMOVE_HISTORY_SITE: _,
  APP_MERGE_DOWNLOAD_DETAIL: _, // Sets an individual download detail
  APP_CLEAR_COMPLETED_DOWNLOADS: _, // Removes all completed downloads
  APP_SET_DATA_FILE_ETAG: _,
  APP_SET_DATA_FILE_LAST_CHECK: _,
  APP_SET_RESOURCE_ENABLED: _,
  APP_RESOURCE_READY: _,
  APP_ADD_RESOURCE_COUNT: _,
  APP_UPDATE_LAST_CHECK: _,
  APP_SET_UPDATE_STATUS: _,
  APP_CHANGE_SETTING: _,
  APP_CHANGE_SITE_SETTING: _,
  APP_REMOVE_SITE_SETTING: _,
  APP_CLEAR_SITE_SETTINGS: _,
  APP_ON_CLEAR_BROWSING_DATA: _,
  APP_IMPORT_BROWSER_DATA: _,
  APP_SHOW_NOTIFICATION: _, /** @param {Object} detail */
  APP_HIDE_NOTIFICATION: _, /** @param {string} message */
  APP_BACKUP_KEYS: _,
  APP_RECOVER_WALLET: _,
  APP_ADD_AUTOFILL_ADDRESS: _,
  APP_REMOVE_AUTOFILL_ADDRESS: _,
  APP_ADD_AUTOFILL_CREDIT_CARD: _,
  APP_REMOVE_AUTOFILL_CREDIT_CARD: _,
  APP_AUTOFILL_DATA_CHANGED: _,
  APP_SET_LOGIN_REQUIRED_DETAIL: _,
  APP_SET_LOGIN_RESPONSE_DETAIL: _,
  APP_WINDOW_BLURRED: _,
  APP_IDLE_STATE_CHANGED: _,
  APP_NETWORK_CONNECTED: _,
  APP_NETWORK_DISCONNECTED: _,
  APP_CHANGE_NEW_TAB_DETAIL: _,
  APP_FRAME_CHANGED: _,
  APP_TAB_CREATED: _,
  APP_TAB_MOVED: _,
  APP_TAB_DETACH_MENU_ITEM_CLICKED: _,
  APP_TAB_PAGE_CLOSE_MENU_ITEM_CLICKED: _,
  APP_CLOSE_TABS_TO_LEFT_MENU_ITEM_CLICKED: _,
  APP_CLOSE_TABS_TO_RIGHT_MENU_ITEM_CLICKED: _,
  APP_CLOSE_OTHER_TABS_MENU_ITEM_CLICKED: _,
  APP_DISCARD_TAB_REQUESTED: _,
  APP_TAB_ATTACHED: _,
  APP_TAB_WILL_ATTACH: _,
  APP_TAB_ACTIVATE_REQUESTED: _,
  APP_TAB_INDEX_CHANGE_REQUESTED: _,
  APP_TAB_CLOSE_REQUESTED: _,
  APP_CREATE_TAB_REQUESTED: _,
  APP_LOAD_URL_REQUESTED: _,
  APP_LOAD_URL_IN_ACTIVE_TAB_REQUESTED: _,
  APP_SIMPLE_SHARE_ACTIVE_TAB_REQUESTED: _,
  APP_NEW_WEB_CONTENTS_ADDED: _,
  APP_SET_MENUBAR_TEMPLATE: _,
  APP_UPDATE_ADBLOCK_DATAFILES: _,
  APP_UPDATE_ADBLOCK_CUSTOM_RULES: _,
  APP_DEFAULT_BROWSER_UPDATED: _,
  APP_DEFAULT_BROWSER_CHECK_COMPLETE: _,
  APP_POPULATE_HISTORY: _,
  APP_RENDER_TO_PDF: _,
  APP_COPY_IMAGE: _,
  APP_DOWNLOAD_REVEALED: _,
  APP_DOWNLOAD_OPENED: _,
  APP_DOWNLOAD_ACTION_PERFORMED: _,
  APP_DOWNLOAD_COPIED_TO_CLIPBOARD: _,
  APP_DOWNLOAD_DELETED: _,
  APP_DOWNLOAD_CLEARED: _,
  APP_DOWNLOAD_REDOWNLOADED: _,
  APP_SELECT_DEFAULT_DOWNLOAD_PATH: _,
  APP_SHOW_DOWNLOAD_DELETE_CONFIRMATION: _,
  APP_HIDE_DOWNLOAD_DELETE_CONFIRMATION: _,
  APP_ALLOW_FLASH_ONCE: _,
  APP_ALLOW_FLASH_ALWAYS: _,
  APP_FLASH_PERMISSION_REQUESTED: _,
  APP_DAPP_AVAILABLE: _,
  APP_SHUTTING_DOWN: _,
  APP_CLIPBOARD_TEXT_UPDATED: _,
  APP_TAB_TOGGLE_DEV_TOOLS: _,
  APP_TAB_CLONED: _,
  APP_SET_OBJECT_ID: _,
  APP_CREATE_SYNC_CACHE: _,
  APP_PENDING_SYNC_RECORDS_ADDED: _,
  APP_PENDING_SYNC_RECORDS_REMOVED: _,
  APP_SAVE_SYNC_DEVICES: _,
  APP_SAVE_SYNC_INIT_DATA: _,
  APP_RESET_SYNC_DATA: _,
  APP_SET_SYNC_SETUP_ERROR: _,
  APP_ADD_NOSCRIPT_EXCEPTIONS: _,
  APP_TAB_MESSAGE_BOX_SHOWN: _,
  APP_TAB_MESSAGE_BOX_DISMISSED: _,
  APP_TAB_MESSAGE_BOX_UPDATED: _,
  APP_NAVIGATOR_HANDLER_REGISTERED: _,
  APP_NAVIGATOR_HANDLER_UNREGISTERED: _,
  APP_TOP_SITE_DATA_AVAILABLE: _,
  APP_URL_BAR_TEXT_CHANGED: _,
  APP_URL_BAR_SUGGESTIONS_CHANGED: _,
  APP_SEARCH_SUGGESTION_RESULTS_AVAILABLE: _,
  APP_DEFAULT_SEARCH_ENGINE_LOADED: _,
  APP_TAB_PINNED: _,
  APP_DRAG_STARTED: _,
  APP_DRAG_ENDED: _,
  APP_DRAG_CANCELLED: _,
  APP_DATA_DROPPED: _,
  APP_DRAGGED_OVER: _,
  APP_ON_GO_BACK: _,
  APP_ON_GO_FORWARD: _,
  APP_ON_GO_TO_INDEX: _,
  APP_ON_GO_BACK_LONG: _,
  APP_ON_GO_FORWARD_LONG: _,
  APP_AUTOPLAY_BLOCKED: _,
  APP_MEDIA_STARTED_PLAYING: _,
  APP_MEDIA_PAUSED: _,
  APP_SAVE_PASSWORD: _,
  APP_UPDATE_PASSWORD: _,
  APP_ADD_PASSWORD: _, /** @param {Object} passwordDetail */
  APP_REMOVE_PASSWORD: _, /** @param {Object} passwordDetail */
  APP_REMOVE_PASSWORD_SITE: _, /** @param {Object} passwordDetail */
  APP_CLEAR_PASSWORDS: _,
  APP_UPDATE_LOG_OPENED: _,
  APP_URL_BAR_SELECTED_INDEX_CHANGED: _,
  APP_ON_TOGGLE_BROWSING_DATA: _,
  APP_ON_CANCEL_BROWSING_DATA: _,
  APP_SET_SKIP_SYNC: _,
  APP_SWIPE_LEFT: _,
  APP_SWIPE_RIGHT: _,
  APP_ADD_BOOKMARK: _,
  APP_EDIT_BOOKMARK: _,
  APP_DEBUG_NO_REPORT_STATE_MODE_CLICKED: _,
  APP_SPELLING_SUGGESTED: _,
  APP_LEARN_SPELLING: _,
  APP_FORGET_LEARNED_SPELLING: _,
  APP_SET_VERSION_INFO: _,
  APP_ADD_BOOKMARK_FOLDER: _,
  APP_EDIT_BOOKMARK_FOLDER: _,
  APP_REMOVE_BOOKMARK_FOLDER: _,
  APP_REMOVE_BOOKMARK: _,
  APP_MOVE_BOOKMARK_FOLDER: _,
  APP_MOVE_BOOKMARK: _,
  APP_ENABLE_PEPPER_MENU: _,
  APP_INSPECT_ELEMENT: _,
  APP_ON_BOOKMARK_WIDTH_CHANGED: _,
  APP_ON_BOOKMARK_FOLDER_WIDTH_CHANGED: _,
  APP_WINDOW_RESIZED: _,
  APP_ON_FAVICON_RECEIVED: _,
  APP_ON_PUBLISHER_OPTION_UPDATE: _,
  APP_ON_PUBLISHERS_OPTION_UPDATE: _,
  APP_ON_LEDGER_OPTION_UPDATE: _,
  APP_ON_LEDGER_WALLET_CREATE: _,
  APP_ON_BOOT_STATE_FILE: _,
  APP_LEDGER_PAYMENTS_PRESENT: _,
  APP_ON_WALLET_RECOVERY: _,
  APP_ON_BRAVERY_PROPERTIES: _,
  APP_ON_WALLET_PROPERTIES: _,
  APP_ON_ADD_FUNDS_CLOSED: _,
  APP_ON_CHANGE_ADD_FUNDS_DIALOG_STEP: _,
  APP_ON_FIRST_LEDGER_SYNC: _,
  APP_ON_LEDGER_CALLBACK: _,
  APP_ON_TIME_UNTIL_RECONCILE: _,
  APP_ON_LEDGER_RUN: _,
  APP_ON_FILE_RECOVERY_KEYS: _,
  APP_ON_NETWORK_CONNECTED: _,
  APP_ON_RESET_RECOVERY_STATUS: _,
  APP_ON_LEDGER_INIT_READ: _,
  APP_ON_LEDGER_QR_GENERATED: _,
  APP_ON_PUBLISHER_TIMESTAMP: _,
  APP_SAVE_LEDGER_PROMOTION: _,
  APP_ON_PROMOTION_CLAIM: _,
  APP_ON_PROMOTION_RESPONSE: _,
  APP_ON_FETCH_REFERRAL_HEADERS: _,
  APP_ON_PROMOTION_REMIND: _,
  APP_ON_PROMOTION_REMOVAL: _,
  APP_ON_PROMOTION_GET: _,
  APP_ON_PROMOTION_CLOSE: _,
  APP_ON_LEDGER_NOTIFICATION_INTERVAL: _,
  APP_ON_LEDGER_MEDIA_DATA: _,
  APP_ON_PRUNE_SYNOPSIS: _,
  APP_ON_HISTORY_LIMIT: _,
  APP_ON_REFERRAL_CODE_READ: _,
  APP_ON_REFERRAL_CODE_FAIL: _,
  APP_CHECK_REFERRAL_ACTIVITY: _,
  APP_ON_REFERRAL_ACTIVITY: _,
  APP_ON_LEDGER_MEDIA_PUBLISHER: _
};

module.exports = mapValuesByKeys(appConstants);

/***/ }),

/***/ 98:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const assert = __webpack_require__(25);
const Immutable = __webpack_require__(1);

// Actions
const syncActions = __webpack_require__(133);

// Constants
const settings = __webpack_require__(11);
const siteTags = __webpack_require__(38);
const { STATE_SITES } = __webpack_require__(95);

// State
const bookmarkOrderCache = __webpack_require__(132);

// Utils
const bookmarkFoldersUtil = __webpack_require__(56);
const { makeImmutable, isMap } = __webpack_require__(16);
const { getSetting } = __webpack_require__(13);

const validateState = function (state) {
  state = makeImmutable(state);
  assert.ok(isMap(state), 'state must be an Immutable.Map');
  assert.ok(isMap(state.get(STATE_SITES.BOOKMARK_FOLDERS)), 'state must contain an Immutable.Map of bookmarkFolders');
  return state;
};

const bookmarkFoldersState = {
  getFolders: state => {
    state = validateState(state);
    return state.get(STATE_SITES.BOOKMARK_FOLDERS, Immutable.Map());
  },

  getFolder: (state, folderKey) => {
    state = validateState(state);

    if (folderKey == null) {
      return Immutable.Map();
    }

    folderKey = folderKey.toString();
    return state.getIn([STATE_SITES.BOOKMARK_FOLDERS, folderKey], Immutable.Map());
  },

  getFoldersByParentId: (state, parentFolderId) => {
    state = validateState(state);

    if (parentFolderId == null) {
      return Immutable.List();
    }

    const folders = bookmarkOrderCache.getFoldersByParentId(state, parentFolderId);
    return folders.map(folder => bookmarkFoldersState.getFolder(state, folder.get('key')));
  },

  addFolder: (state, folderDetails, destinationKey) => {
    state = validateState(state);

    if (folderDetails == null) {
      return state;
    }

    folderDetails = makeImmutable(folderDetails);

    if (folderDetails.get('key') == null) {
      return state;
    }

    state = state.setIn([STATE_SITES.BOOKMARK_FOLDERS, folderDetails.get('key')], folderDetails);
    state = bookmarkOrderCache.addFolderToCache(state, folderDetails.get('parentFolderId'), folderDetails.get('key'), destinationKey);
    return state;
  },

  editFolder: (state, editKey, oldFolder, folderDetails) => {
    state = validateState(state);

    if (oldFolder == null) {
      return state;
    }

    const newFolder = oldFolder.merge(makeImmutable({
      title: folderDetails.get('title'),
      parentFolderId: Number(folderDetails.get('parentFolderId', 0))
    }));

    if (oldFolder.get('parentFolderId') !== newFolder.get('parentFolderId')) {
      state = bookmarkOrderCache.removeCacheKey(state, oldFolder.get('parentFolderId'), editKey);
      state = bookmarkOrderCache.addFolderToCache(state, newFolder.get('parentFolderId'), editKey);
    }

    state = state.setIn([STATE_SITES.BOOKMARK_FOLDERS, editKey.toString()], newFolder);
    return state;
  },

  removeFolder: (state, folderKey) => {
    state = validateState(state);
    const folder = bookmarkFoldersState.getFolder(state, folderKey);

    if (folder.isEmpty()) {
      return state;
    }

    const bookmarksState = __webpack_require__(39);
    const folders = bookmarkFoldersState.getFolders(state);

    if (getSetting(settings.SYNC_ENABLED) === true) {
      syncActions.removeSites([folder.toJS()]);
    }

    folders.filter(folder => folder.get('parentFolderId') === Number(folderKey)).map(folder => {
      state = bookmarkFoldersState.removeFolder(state, folder.get('folderId'));
    });

    state = bookmarksState.removeBookmarksByParentId(state, folderKey);
    state = bookmarkOrderCache.removeCacheParent(state, folderKey);
    state = bookmarkOrderCache.removeCacheKey(state, folder.get('parentFolderId'), folderKey);
    return state.deleteIn([STATE_SITES.BOOKMARK_FOLDERS, folderKey.toString()]);
  },

  /**
   * Get a list of all folders except provided folder
   * @param state
   * @param {number} folderKey
   * @param parentFolderId
   * @param labelPrefix
   * @returns {Array} - each entry with folder id and label (title)
   */
  getFoldersWithoutKey: (state, folderKey, parentFolderId = 0, labelPrefix = '') => {
    state = validateState(state);
    let folders = [];
    const results = bookmarkFoldersState.getFoldersByParentId(state, parentFolderId);

    const resultSize = results.size;
    for (let i = 0; i < resultSize; i++) {
      const folder = results.get(i);
      if (folder.get('folderId') === folderKey) {
        continue;
      }

      const label = labelPrefix + folder.get('title');
      folders.push({
        folderId: folder.get('folderId'),
        label
      });
      const subFolders = bookmarkFoldersState.getFoldersWithoutKey(state, folderKey, folder.get('folderId'), (label || '') + ' / ');
      folders = folders.concat(subFolders);
    }

    return folders;
  },

  moveFolder: (state, folderKey, destinationKey, append, moveIntoParent) => {
    state = validateState(state);
    let folder = bookmarkFoldersState.getFolder(state, folderKey);
    if (folder.isEmpty()) {
      return state;
    }

    const bookmarksState = __webpack_require__(39);
    let destinationItem = bookmarksState.findBookmark(state, destinationKey);
    const numKey = Number(destinationKey);
    if (destinationItem.isEmpty() && numKey !== -1 && numKey !== 0) {
      return state;
    }

    if (moveIntoParent || destinationItem.get('parentFolderId') !== folder.get('parentFolderId')) {
      let parentFolderId = destinationItem.get('type') === siteTags.BOOKMARK ? destinationItem.get('parentFolderId') : destinationItem.get('folderId');

      // always use parent ID when we are not moving into the folder
      if (!moveIntoParent) {
        parentFolderId = destinationItem.get('parentFolderId');
      }

      if (parentFolderId == null) {
        parentFolderId = destinationKey;
      }

      state = bookmarkOrderCache.removeCacheKey(state, folder.get('parentFolderId'), folderKey);
      folder = folder.set('parentFolderId', Number(parentFolderId));
      const newKey = bookmarkFoldersUtil.getKey(folder);
      state = state.deleteIn([STATE_SITES.BOOKMARK_FOLDERS, folderKey]);
      state = bookmarkOrderCache.addFolderToCache(state, folder.get('parentFolderId'), newKey);
      return state.setIn([STATE_SITES.BOOKMARK_FOLDERS, newKey.toString()], folder);
    }

    state = bookmarkOrderCache.removeCacheKey(state, folder.get('parentFolderId'), folderKey);
    state = bookmarkOrderCache.addFolderToCache(state, folder.get('parentFolderId'), folderKey, destinationKey, append);
    return state;
  },

  setWidth: (state, key, width) => {
    state = validateState(state);
    width = parseFloat(width);

    if (key == null || isNaN(width)) {
      return state;
    }

    return state.setIn([STATE_SITES.BOOKMARK_FOLDERS, key, 'width'], width);
  }
};

module.exports = bookmarkFoldersState;

/***/ }),

/***/ 99:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

const React = __webpack_require__(3);
const ImmutableComponent = __webpack_require__(28);
const cx = __webpack_require__(22);

const { StyleSheet, css } = __webpack_require__(15);

/**
 * Represents an on/off switch control
 */
class SwitchControl extends ImmutableComponent {
  constructor() {
    super();
    this.onClick = this.onClick.bind(this);
  }
  onClick() {
    this.props.onClick({
      target: {
        value: !this.props.checkedOn
      }
    });
  }
  render() {
    return _jsx('div', {
      className: cx({
        switchControl: true,
        [this.props.className]: !!this.props.className,
        disabled: this.props.disabled,
        large: this.props.large,
        small: this.props.small,
        hasTopText: this.props.topl10nId,
        [this.props.customWrapperClassName]: !!this.props.customWrapperClassName
      }),
      'data-switch-status': this.props.checkedOn,
      'data-test-id': this.props.testId
    }, void 0, this.props.leftl10nId && this.props.topl10nId ? _jsx('div', {
      className: 'switchControlText'
    }, void 0, _jsx('div', {
      className: 'switchControlLeftText'
    }, void 0, _jsx('div', {
      className: 'switchSpacer'
    }, void 0, '\xA0'), _jsx('label', {
      className: cx({
        [css(styles.switchControlText__label, styles.switchControlText_left__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customLeftTextClassName]: !!this.props.customLeftTextClassName
      }),
      onClick: this.onClick,
      'data-l10n-id': this.props.leftl10nId
    }))) : this.props.leftl10nId ? _jsx('label', {
      className: cx({
        [css(styles.switchControlText__label, styles.switchControlText_left__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customLeftTextClassName]: !!this.props.customLeftTextClassName
      }),
      onClick: this.onClick,
      'data-l10n-id': this.props.leftl10nId
    }) : null, _jsx('div', {
      className: 'switchMiddle'
    }, void 0, this.props.topl10nId ? _jsx('label', {
      className: cx({
        switchControlTopText: true,
        [css(styles.switchControlText__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customTopTextClassName]: !!this.props.customTopTextClassName
      }),
      onClick: this.onClick,
      'data-l10n-id': this.props.topl10nId
    }) : null, _jsx('div', {
      className: cx({
        switchBackground: true,
        switchedOn: this.props.checkedOn,
        [this.props.backgroundClassName]: !!this.props.backgroundClassName
      }),
      'data-test-id': 'switchBackground',
      onClick: this.onClick
    }, void 0, _jsx('div', {
      className: cx({
        switchIndicator: true,
        [css(this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.indicatorClassName]: !!this.props.indicatorClassName
      })
    }))), (this.props.rightl10nId || this.props.rightText) && this.props.topl10nId ? _jsx('div', {
      className: 'switchControlText'
    }, void 0, _jsx('div', {
      className: 'switchControlRightText'
    }, void 0, _jsx('div', {
      className: 'switchSpacer'
    }, void 0, '\xA0'), _jsx('label', {
      className: cx({
        [css(styles.switchControlText__label, styles.switchControlText_right__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customRightTextClassName]: !!this.props.customRightTextClassName
      }),
      onClick: this.onClick,
      'data-l10n-id': this.props.rightl10nId,
      'data-l10n-args': this.props.rightl10nArgs
    }, void 0, this.props.rightText || ''))) : _jsx('div', {
      className: 'switchControlRight'
    }, void 0, (this.props.rightl10nId || this.props.rightText) && !this.props.onInfoClick ? _jsx('label', {
      className: cx({
        [css(styles.switchControlText__label, styles.switchControlText_right__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customRightTextClassName]: !!this.props.customRightTextClassName
      }),
      onClick: this.onClick,
      'data-l10n-id': this.props.rightl10nId,
      'data-l10n-args': this.props.rightl10nArgs
    }, void 0, this.props.rightText || '') : null, (this.props.rightl10nId || this.props.rightText) && this.props.onInfoClick ? _jsx('div', {
      className: 'switchControlRight'
    }, void 0, _jsx('label', {
      className: cx({
        [css(styles.switchControlText__label, styles.switchControlText_right__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customRightTextClassName]: !!this.props.customRightTextClassName
      }),
      onClick: this.onClick,
      'data-l10n-id': this.props.rightl10nId,
      'data-l10n-args': this.props.rightl10nArgs
    }, void 0, this.props.rightText), _jsx('span', {
      className: cx({
        fa: true,
        'fa-question-circle': true,
        info: true,
        clickable: true,
        [css(styles.switchControlText__label, this.props.small && styles.switchControlText__label_small)]: true,
        [this.props.customInfoButtonClassName]: !!this.props.customInfoButtonClassName
      }),
      onClick: this.props.onInfoClick,
      title: this.props.infoTitle
    })) : null));
  }
}

const styles = StyleSheet.create({
  switchControlText__label: {
    userSelect: 'none'
  },

  switchControlText__label_small: {
    fontSize: 'smaller'
  },

  switchControlText_right__label: {
    paddingLeft: '1ch',
    marginLeft: 0
  },

  switchControlText_left__label: {
    paddingRight: '1ch',
    marginRight: 0
  }
});

module.exports = SwitchControl;

/***/ })

});
//# sourceMappingURL=9.chunk.js.map